﻿using System;
using Verse;
using RimWorld;

namespace CharacterEditor
{
  // Token: 0x0200001F RID: 31
  public static class AgeTool
  {
    // Token: 0x0600012D RID: 301 RVA: 0x00009290 File Offset: 0x00007490
    public static void SetChronoAgeTicks(this Pawn p, long val)
    {
      if (p.HasAgeTracker())
      {
        p.ageTracker.SetMemberValue("birthAbsTicksInt", val);
      }
    }

    // Token: 0x0600012E RID: 302 RVA: 0x000092C4 File Offset: 0x000074C4
    public static long GetAgeTicks(this Pawn p)
    {
      return p.HasAgeTracker() ? p.ageTracker.AgeBiologicalTicks : 0L;
    }

    // Token: 0x0600012F RID: 303 RVA: 0x000092DD File Offset: 0x000074DD
    public static long GetChronoAgeTicks(this Pawn p)
    {
      return p.HasAgeTracker() ? p.ageTracker.BirthAbsTicks : 0L;
    }

    // Token: 0x06000130 RID: 304 RVA: 0x000092F8 File Offset: 0x000074F8
    public static void SetAgeTicks(this Pawn p, long ageTicks)
    {
      if (p.HasAgeTracker())
      {
        // Call on CurLifeStageIndex to initialize cachedLifeStageIndex
        int pop = p.ageTracker.CurLifeStageIndex;
        // AgeBiologicalTicks now calls on CalculateInitialGrowth and RecalculateLifeStageIndex when set
        p.ageTracker.AgeBiologicalTicks = ageTicks;

        //p.ageTracker.SetMemberValue("cachedLifeStageIndex", -1);
        //int pop = p.ageTracker.CurLifeStageIndex;
        //p.ageTracker.GetProperty("LifeStageIndex");
        //p.ageTracker.CallMethod("RecalculateLifeStageIndex", null);
        //CompatibilityTool.UpdateLifestage(p);
      }
    }

    // Token: 0x06000131 RID: 305 RVA: 0x0000933C File Offset: 0x0000753C
    public static void SetBioAge(this Pawn p, float age)
    {
      p.SetAgeTicks((long)(age * GenDate.TicksPerYear));
      //if (p.HasAgeTracker())
      //{
      //	p.ageTracker.AgeBiologicalTicks = (long)(age * GenDate.TicksPerYear);
      //     p.ageTracker.SetMemberValue("cachedLifeStageIndex", -1);
      //	int index = (int)p.ageTracker.GetProperty("LifeStageIndex");
      //     //p.ageTracker.CallMethod("RecalculateLifeStageIndex", null);
      //     //CompatibilityTool.UpdateLifestage(p);
      //}
    }

    // Token: 0x06000132 RID: 306 RVA: 0x00009388 File Offset: 0x00007588
    public static void SetChrAge(this Pawn p, float age)
    {
      if (p.HasAgeTracker())
      {
        p.ageTracker.AgeChronologicalTicks = (long)(age * GenDate.TicksPerYear);
      }
    }

    //public static void SetChronoAgeDay(this Pawn p, int age, int ticks)
    //{
    //	if (p.HasAgeTracker())
    //	{
    //		p.ageTracker.SetMemberValue("birthAbsTicksInt", (long)GenTicks.TicksAbs - (long)age * 3600000L - (long)ticks * 60000L);
    //	}
    //}
  }
}
