﻿using System;
using System.Collections.Generic;
using UnityEngine;

namespace CharacterEditor
{
	// Token: 0x02000028 RID: 40
	public static class ColorTool
	{
		// Token: 0x1700003C RID: 60
		// (get) Token: 0x060001A7 RID: 423 RVA: 0x0000D2FC File Offset: 0x0000B4FC
		public static List<Color> ListOfColors
		{
			get
			{
				bool flag = ColorTool.lcolors == null;
				if (flag)
				{
					ColorTool.lcolors = new List<Color>
					{
						ColorTool.colWhite,
						ColorTool.colLightGray,
						ColorTool.colGray,
						ColorTool.colDarkGray,
						ColorTool.colGraphite,
						ColorTool.colBlack,
						ColorTool.colNavyBlue,
						ColorTool.colDarkBlue,
						ColorTool.colRoyalBlue,
						ColorTool.colBlue,
						ColorTool.colPureBlue,
						ColorTool.colLightBlue,
						ColorTool.colSkyBlue,
						ColorTool.colMaroon,
						ColorTool.colBurgundy,
						ColorTool.colDarkRed,
						ColorTool.colRed,
						ColorTool.colPureRed,
						ColorTool.colLightRed,
						ColorTool.colHotPink,
						ColorTool.colPink,
						ColorTool.colDarkPurple,
						ColorTool.colPurple,
						ColorTool.colLightPurple,
						ColorTool.colTeal,
						ColorTool.colTurquoise,
						ColorTool.colDarkBrown,
						ColorTool.colBrown,
						ColorTool.colLightBrown,
						ColorTool.colTawny,
						ColorTool.colBlaze,
						ColorTool.colOrange,
						ColorTool.colLightOrange,
						ColorTool.colGold,
						ColorTool.colYellowGold,
						ColorTool.colYellow,
						ColorTool.colDarkYellow,
						ColorTool.colChartreuse,
						ColorTool.colLightYellow,
						ColorTool.colDarkGreen,
						ColorTool.colGreen,
						ColorTool.colPureGreen,
						ColorTool.colLimeGreen,
						ColorTool.colLightGreen,
						ColorTool.colDarkOlive,
						ColorTool.colOlive,
						ColorTool.colOliveDrab,
						ColorTool.colFoilageGreen,
						ColorTool.colTan,
						ColorTool.colBeige,
						ColorTool.colKhaki,
						ColorTool.colPeach
					};
				}
				return ColorTool.lcolors;
			}
		}

		// Token: 0x060001A8 RID: 424 RVA: 0x0000D5A0 File Offset: 0x0000B7A0
		public static string ColorHexString(this Color c)
		{
			double num = ColorTool.DMAX / ColorTool.DMAXB;
			int num2 = (int)((double)c.r / num);
			int num3 = (int)((double)c.g / num);
			int num4 = (int)((double)c.b / num);
			int num5 = (int)((double)c.a / num);
			string str = num2.ToString("X2");
			str = str + "-" + num3.ToString("X2");
			str = str + "-" + num4.ToString("X2");
			return str + "-" + num5.ToString("X2");
		}

		// Token: 0x060001A9 RID: 425 RVA: 0x0000D64C File Offset: 0x0000B84C
		public static Color HexStringToColor(this string hex)
		{
			bool flag = string.IsNullOrEmpty(hex);
			Color result;
			if (flag)
			{
				result = Color.white;
			}
			else
			{
				Color color = default(Color);
				string[] array = hex.SplitNo("-");
				bool flag2 = array.Length >= 4;
				if (flag2)
				{
					try
					{
						double num = ColorTool.DMAX / ColorTool.DMAXB;
						int num2 = Convert.ToInt32(array[0], 16);
						int num3 = Convert.ToInt32(array[1], 16);
						int num4 = Convert.ToInt32(array[2], 16);
						int num5 = Convert.ToInt32(array[3], 16);
						color.r = (float)(num * (double)num2);
						color.g = (float)(num * (double)num3);
						color.b = (float)(num * (double)num4);
						color.a = (float)(num * (double)num5);
					}
					catch
					{
					}
				}
				result = color;
			}
			return result;
		}

		// Token: 0x1700003D RID: 61
		// (get) Token: 0x060001AA RID: 426 RVA: 0x0000D72C File Offset: 0x0000B92C
		public static Color RandomColor
		{
			get
			{
				return ColorTool.GetRandomColor(0f, ColorTool.FMAX, false);
			}
		}

		// Token: 0x1700003E RID: 62
		// (get) Token: 0x060001AB RID: 427 RVA: 0x0000D750 File Offset: 0x0000B950
		public static Color RandomAlphaColor
		{
			get
			{
				return ColorTool.GetRandomColor(0f, ColorTool.FMAX, true);
			}
		}

		// Token: 0x060001AC RID: 428 RVA: 0x0000D774 File Offset: 0x0000B974
		public static Color GetDerivedColor(Color color, float offset)
		{
			float num = color.r - offset;
			float num2 = color.g - offset;
			float num3 = color.b - offset;
			num = ((num < 0f) ? 0f : num);
			num2 = ((num2 < 0f) ? 0f : num2);
			num3 = ((num3 < 0f) ? 0f : num3);
			num = ((num > (float)ColorTool.IMAX) ? ((float)ColorTool.IMAX) : num);
			num2 = ((num2 > (float)ColorTool.IMAX) ? ((float)ColorTool.IMAX) : num2);
			num3 = ((num3 > (float)ColorTool.IMAX) ? ((float)ColorTool.IMAX) : num3);
			return new Color(num, num2, num3, color.a);
		}

		// Token: 0x060001AD RID: 429 RVA: 0x0000D81C File Offset: 0x0000BA1C
		public static Color GetRandomColor(float minbright = 0f, float maxbright = 1f, bool andAlpha = false)
		{
			bool flag = maxbright < minbright;
			if (flag)
			{
				maxbright = minbright;
			}
			double num = ColorTool.DMAX / ColorTool.DMAXB;
			int num2 = (int)((double)minbright / num);
			int num3 = (int)((double)maxbright / num);
			int num4 = (int)(0.5 / num);
			int num5 = (int)(1.0 / num);
			bool flag2 = num2 > num3;
			if (flag2)
			{
				num2 = num3 - 1;
			}
			bool flag3 = num2 < 0;
			if (flag3)
			{
				num2 = 0;
			}
			int num6 = (num2 == num3) ? num2 : CEditor.zufallswert.Next(num2, num3);
			int num7 = (num2 == num3) ? num2 : CEditor.zufallswert.Next(num2, num3);
			int num8 = (num2 == num3) ? num2 : CEditor.zufallswert.Next(num2, num3);
			int num9 = (num4 == num5) ? num4 : CEditor.zufallswert.Next(num4, num5);
			float num10 = (float)(num * (double)num9);
			return new Color((float)(num * (double)num6), (float)(num * (double)num7), (float)(num * (double)num8), andAlpha ? num10 : 1f);
		}

		// Token: 0x040000DB RID: 219
		public static readonly Color colWhite = new Color(1f, 1f, 1f);

		// Token: 0x040000DC RID: 220
		public static readonly Color colLightGray = new Color(0.82f, 0.824f, 0.831f);

		// Token: 0x040000DD RID: 221
		public static readonly Color colGray = new Color(0.714f, 0.718f, 0.733f);

		// Token: 0x040000DE RID: 222
		public static readonly Color colDarkGray = new Color(0.506f, 0.51f, 0.525f);

		// Token: 0x040000DF RID: 223
		public static readonly Color colGraphite = new Color(0.345f, 0.345f, 0.353f);

		// Token: 0x040000E0 RID: 224
		public static readonly Color colDimGray = new Color(0.245f, 0.245f, 0.245f);

		// Token: 0x040000E1 RID: 225
		public static readonly Color colDarkDimGray = new Color(0.175f, 0.175f, 0.175f);

		public static readonly Color colAsche = new Color(0.115f, 0.115f, 0.115f);
    //public static readonly Color colAsche = Color.red;

    // Token: 0x040000E3 RID: 227
    public static readonly Color colBlack = new Color(0f, 0f, 0f);

		// Token: 0x040000E4 RID: 228
		public static readonly Color colNavyBlue = new Color(0f, 0.082f, 0.267f);

		// Token: 0x040000E5 RID: 229
		public static readonly Color colDarkBlue = new Color(0.137f, 0.235f, 0.486f);

		// Token: 0x040000E6 RID: 230
		public static readonly Color colRoyalBlue = new Color(0.157f, 0.376f, 0.678f);

		// Token: 0x040000E7 RID: 231
		public static readonly Color colBlue = new Color(0.004f, 0.42f, 0.718f);

		// Token: 0x040000E8 RID: 232
		public static readonly Color colPureBlue = new Color(0f, 0f, 1f);

		// Token: 0x040000E9 RID: 233
		public static readonly Color colLightBlue = new Color(0.129f, 0.569f, 0.816f);

		// Token: 0x040000EA RID: 234
		public static readonly Color colSkyBlue = new Color(0.58f, 0.757f, 0.91f);

		// Token: 0x040000EB RID: 235
		public static readonly Color colMaroon = new Color(0.373f, 0f, 0.125f);

		// Token: 0x040000EC RID: 236
		public static readonly Color colBurgundy = new Color(0.478f, 0.153f, 0.255f);

		// Token: 0x040000ED RID: 237
		public static readonly Color colDarkRed = new Color(0.545f, 0f, 0f);

		// Token: 0x040000EE RID: 238
		public static readonly Color colRed = new Color(0.624f, 0.039f, 0.055f);

		// Token: 0x040000EF RID: 239
		public static readonly Color colPureRed = new Color(1f, 0f, 0f);

		// Token: 0x040000F0 RID: 240
		public static readonly Color colLightRed = new Color(0.784f, 0.106f, 0.216f);

		// Token: 0x040000F1 RID: 241
		public static readonly Color colHotPink = new Color(0.863f, 0.345f, 0.631f);

		// Token: 0x040000F2 RID: 242
		public static readonly Color colPink = new Color(0.969f, 0.678f, 0.808f);

		// Token: 0x040000F3 RID: 243
		public static readonly Color colDarkPurple = new Color(0.251f, 0.157f, 0.384f);

		// Token: 0x040000F4 RID: 244
		public static readonly Color colPurple = new Color(0.341f, 0.176f, 0.561f);

		// Token: 0x040000F5 RID: 245
		public static readonly Color colLightPurple = new Color(0.631f, 0.576f, 0.784f);

		// Token: 0x040000F6 RID: 246
		public static readonly Color colTeal = new Color(0.11f, 0.576f, 0.592f);

		// Token: 0x040000F7 RID: 247
		public static readonly Color colTurquoise = new Color(0.027f, 0.51f, 0.58f);

		// Token: 0x040000F8 RID: 248
		public static readonly Color colDarkBrown = new Color(0.282f, 0.2f, 0.125f);

		// Token: 0x040000F9 RID: 249
		public static readonly Color colBrown = new Color(0.388f, 0.204f, 0.102f);

		// Token: 0x040000FA RID: 250
		public static readonly Color colLightBrown = new Color(0.58f, 0.353f, 0.196f);

		// Token: 0x040000FB RID: 251
		public static readonly Color colTawny = new Color(0.784f, 0.329f, 0.098f);

		// Token: 0x040000FC RID: 252
		public static readonly Color colBlaze = new Color(0.941f, 0.29f, 0.141f);

		// Token: 0x040000FD RID: 253
		public static readonly Color colOrange = new Color(0.949f, 0.369f, 0.133f);

		// Token: 0x040000FE RID: 254
		public static readonly Color colLightOrange = new Color(0.973f, 0.58f, 0.133f);

		// Token: 0x040000FF RID: 255
		public static readonly Color colGold = new Color(0.824f, 0.624f, 0.055f);

		// Token: 0x04000100 RID: 256
		public static readonly Color colYellowGold = new Color(1f, 0.761f, 0.051f);

		// Token: 0x04000101 RID: 257
		public static readonly Color colYellow = new Color(1f, 0.859f, 0.004f);

		// Token: 0x04000102 RID: 258
		public static readonly Color colDarkYellow = new Color(0.953f, 0.886f, 0.227f);

		// Token: 0x04000103 RID: 259
		public static readonly Color colChartreuse = new Color(0.922f, 0.91f, 0.067f);

		// Token: 0x04000104 RID: 260
		public static readonly Color colLightYellow = new Color(1f, 0.91f, 0.51f);

		// Token: 0x04000105 RID: 261
		public static readonly Color colDarkGreen = new Color(0f, 0.345f, 0.149f);

		// Token: 0x04000106 RID: 262
		public static readonly Color colGreen = new Color(0.137f, 0.663f, 0.29f);

		// Token: 0x04000107 RID: 263
		public static readonly Color colPureGreen = new Color(0f, 1f, 0f);

		// Token: 0x04000108 RID: 264
		public static readonly Color colLimeGreen = new Color(0.682f, 0.82f, 0.208f);

		// Token: 0x04000109 RID: 265
		public static readonly Color colLightGreen = new Color(0.541f, 0.769f, 0.537f);

		// Token: 0x0400010A RID: 266
		public static readonly Color colDarkOlive = new Color(0.255f, 0.282f, 0.149f);

		// Token: 0x0400010B RID: 267
		public static readonly Color colOlive = new Color(0.451f, 0.463f, 0.294f);

		// Token: 0x0400010C RID: 268
		public static readonly Color colOliveDrab = new Color(0.357f, 0.337f, 0.263f);

		// Token: 0x0400010D RID: 269
		public static readonly Color colFoilageGreen = new Color(0.482f, 0.498f, 0.443f);

		// Token: 0x0400010E RID: 270
		public static readonly Color colTan = new Color(0.718f, 0.631f, 0.486f);

		// Token: 0x0400010F RID: 271
		public static readonly Color colBeige = new Color(0.827f, 0.741f, 0.545f);

		// Token: 0x04000110 RID: 272
		public static readonly Color colKhaki = new Color(0.933f, 0.835f, 0.678f);

		// Token: 0x04000111 RID: 273
		public static readonly Color colPeach = new Color(0.996f, 0.859f, 0.733f);

		// Token: 0x04000112 RID: 274
		private static List<Color> lcolors;

		// Token: 0x04000113 RID: 275
		public static int IMAX = 1;

		// Token: 0x04000114 RID: 276
		public static int IMAXB = 255;

		// Token: 0x04000115 RID: 277
		public static float FMAX = 1f;

		// Token: 0x04000116 RID: 278
		public static float FMAXB = 255f;

		// Token: 0x04000117 RID: 279
		public static double DMAX = 1.0;

		// Token: 0x04000118 RID: 280
		public static double DMAXB = 255.0;
	}
}
