﻿using System;
using System.Text;
using Verse;

namespace CharacterEditor
{
	// Token: 0x02000017 RID: 23
	public static class CompatibilityTool
	{
		// Token: 0x060000DE RID: 222 RVA: 0x00006DF8 File Offset: 0x00004FF8
		public static string GetRJWTooltip(Pawn pawn)
		{
			string text = "";
			try
			{
				ThingComp rjwcomp = pawn.GetRJWComp();
				Type atype = Reflect.GetAType("rjw", "Orientation");
				string name = Enum.GetName(atype, rjwcomp.GetMemberValue("orientation"));
				text = "{PAWN}".Translate(pawn.Named("PAWN")).AdjustedFor(pawn, "PAWN", true).Resolve();
				text = string.Concat(new string[]
				{
					text,
					" ",
					Label.IS,
					" ",
					name
				});
				object memberValue = rjwcomp.GetMemberValue("quirks");
				bool flag = memberValue != null;
				if (flag)
				{
					string text2 = ((StringBuilder)rjwcomp.GetMemberValue("quirks")).ToString();
					text2 = text2.Replace("None, ", "").Replace("None", "");
					text = text + "\n" + text2;
				}
			}
			catch
			{
			}
			return text;
		}

		// Token: 0x060000DF RID: 223 RVA: 0x00006F14 File Offset: 0x00005114
		public static void OpenRJWDialog(Pawn pawn)
		{
			Type atype = Reflect.GetAType("rjw", "Dialog_Sexcard");
			bool flag = atype != null;
			if (flag)
			{
				object obj = Activator.CreateInstance(atype, new object[]
				{
					pawn
				});
				bool flag2 = obj != null;
				if (flag2)
				{
					WindowTool.Open(obj as Window);
				}
			}
		}

		// Token: 0x060000E0 RID: 224 RVA: 0x00006F64 File Offset: 0x00005164
		public static string GetPersonalitiesTooltip(Pawn pawn)
		{
			string result = "";
			try
			{
				ThingComp persoComp = pawn.GetPersoComp();
				result = (string)persoComp.CallMethod("GetDescription", null);
			}
			catch
			{
			}
			return result;
		}

		// Token: 0x060000E1 RID: 225 RVA: 0x00006FB0 File Offset: 0x000051B0
		public static void OpenPersonalitiesDialog(Pawn pawn)
		{
			Type atype = Reflect.GetAType("SPM1.UI", "Dialog_PersonalityEditor");
			bool flag = atype != null;
			if (flag)
			{
				atype.CallMethod("OpenDialogFor", new object[]
				{
					pawn
				});
			}
		}

		// Token: 0x060000E2 RID: 226 RVA: 0x00006FF0 File Offset: 0x000051F0
		public static string GetPersonality(this Pawn pawn)
		{
			string text = "";
			string result;
			if (pawn == null || !CEditor.IsPersonalitiesActive)
			{
				result = text;
			}
			else
			{
				Type atype = Reflect.GetAType("SPM1", "Extensions");
				bool flag2 = atype != null;
				if (flag2)
				{
					text = (string)atype.CallMethod("ExtractPersonality", new object[]
					{
						pawn
					});
				}
				bool devMode = Prefs.DevMode;
				if (devMode)
				{
					////Log.Message("getting personality of " + pawn.GetPawnName(false) + " =" + text);
				}
				result = text.AsBase64(Encoding.UTF8);
			}
			return result;
		}

		// Token: 0x060000E3 RID: 227 RVA: 0x0000708C File Offset: 0x0000528C
		public static void SetPersonality(this Pawn pawn, string data)
		{
			bool flag = pawn == null || !CEditor.IsPersonalitiesActive;
			if (!flag)
			{
				string text = data.Base64ToString(Encoding.UTF8);
				bool devMode = Prefs.DevMode;
				if (devMode)
				{
					////Log.Message("setting personality of " + pawn.GetPawnName(false) + " =" + text);
				}
				Type atype = Reflect.GetAType("SPM1", "Extensions");
				bool flag2 = atype != null;
				if (flag2)
				{
					atype.CallMethod("IntractPersonality", new object[]
					{
						pawn,
						text
					});
				}
			}
		}

		// Token: 0x060000E4 RID: 228 RVA: 0x00007118 File Offset: 0x00005318
		public static string GetFavoriteColorTooltip(Pawn pawn)
		{
			string result = "";
			try
			{
        string orIdeoColor = string.Empty;
        if (pawn.Ideo != null && !pawn.Ideo.hiddenIdeoMode)
        {
          orIdeoColor = "OrIdeoColor".Translate(pawn.Named("PAWN"));
        }
        //result = "FavoriteColorTooltip".Translate(pawn.Named("PAWN"), 0.6f.ToStringPercent().Named("PERCENTAGE")).AdjustedFor(pawn, "PAWN", true).Resolve();
        result = "FavoriteColorTooltip".Translate(pawn.Named("PAWN"), 0.6f.ToStringPercent().Named("PERCENTAGE"), orIdeoColor.Named("ORIDEO")).AdjustedFor(pawn, "PAWN", true).Resolve();
      }
			catch
			{
			}
			return result;
		}

		// Token: 0x060000E5 RID: 229 RVA: 0x0000718C File Offset: 0x0000538C
		//public static void UpdateLifestage(Pawn p)
		//{
		//	bool flag = !CEditor.IsAgeMattersActive;
		//	if (!flag)
		//	{
		//		HediffComp hediffComp = CompTool.GetHediffComp(p, CEditor.IsAgeMattersActive, "LifeStageHediffAssociation");
		//		bool flag2 = hediffComp != null;
		//		if (flag2)
		//		{
		//			try
		//			{
		//				hediffComp.CallMethod("UpdateHediffDependingOnLifeStage", null);
		//			}
		//			catch
		//			{
		//				Log.Warning("UpdateLifestage, hediffComp.CallMethod(\"UpdateHediffDependingOnLifeStage\", null) failed");
  //        }
		//		}
		//	}
		//}

		public static string GetPsychology(Pawn pawn)
    {
			return "";
    }

    public static void SetPsychology(Pawn pawn, string psychologyDataAsString)
    {
			return;
    }

  }
}
