﻿using System;
using System.Collections.Generic;
using System.Linq;
using RimWorld;
using UnityEngine;
using Verse;

namespace CharacterEditor
{
	// Token: 0x0200000E RID: 14
	public class DialogAddAbility : Window
	{
		// Token: 0x17000027 RID: 39
		// (get) Token: 0x06000074 RID: 116 RVA: 0x000037B0 File Offset: 0x000019B0
		public override Vector2 InitialSize
		{
			get
			{
				return new Vector2(300f, 788f);
			}
		}

		// Token: 0x06000075 RID: 117 RVA: 0x000037D4 File Offset: 0x000019D4
		public DialogAddAbility()
		{
			this.scrollPos = default(Vector2);
			this.doOnce = true;
			this.idxList = 11;
			SearchTool.Update(this.idxList);
			this.selectedModName = null;
			this.selectedStufe = null;
			this.prepend = "Level".Translate() + " ";
			this.alllevels = Label.ALL;
			int num = 6;
			this.lOfStufen = new List<string>();
			this.lOfStufen.Add(this.alllevels);
			for (int i = 0; i <= num; i++)
			{
				this.lOfStufen.Add(this.prepend + i.ToString());
			}
			this.lOfAbilities = DefTool.ListByMod<AbilityDef>(null).ToList<AbilityDef>();
			this.selectedAbility = this.lOfAbilities.FirstOrDefault<AbilityDef>();
			this.oldSelectedAbility = this.selectedAbility;
			this.doCloseX = true;
			this.absorbInputAroundWindow = true;
			this.draggable = true;
			this.layer = CEditor.Layer;
		}

		// Token: 0x06000076 RID: 118 RVA: 0x00003958 File Offset: 0x00001B58
		public override void DoWindowContents(Rect inRect)
		{
			bool flag = this.doOnce;
			if (flag)
			{
				this.doOnce = false;
				this.windowRect.position = new Vector2(this.windowRect.position.x - 380f, this.windowRect.position.y);
			}
			int num = (int)this.InitialSize.x - 40;
			int num2 = (int)this.InitialSize.y - 115;
			int num3 = 0;
			int num4 = 0;
			this.DrawTitle(num4, num3, num, 30);
			num3 += 30;
			SZWidgets.ButtonImage((float)(num - 25), 0f, 25f, 25f, "brandom", new Action(this.ARandomAbility), "");
			this.DrawDropdown(num4, num3, num, 30);
			num3 += 30;
			this.DrawFilter(num4, num3, num, 30);
			num3 += 30;
			Text.Font = GameFont.Small;
			SZWidgets.ListView<AbilityDef>((float)num4, (float)num3, (float)num, (float)(num2 - 64), this.lOfAbilities, this.FAbilityLabel, this.FAbilityTooltip, this.FAbilityComparator, ref this.selectedAbility, ref this.scrollPos, false, null, true, false, false, false);
			bool flag2 = !this.FAbilityComparator(this.oldSelectedAbility, this.selectedAbility);
			if (flag2)
			{
				this.oldSelectedAbility = this.selectedAbility;
				bool devMode = Prefs.DevMode;
				if (devMode)
				{
					MessageTool.Show(this.selectedAbility.defName, null);
				}
			}
			Rect rect = new Rect(this.InitialSize.x - 140f, this.InitialSize.y - 70f, 100f, 30f);
			bool flag3 = Widgets.ButtonText(rect, "OK".Translate(), true, true, true);
			if (flag3)
			{
				this.DoAndClose();
			}
		}

		// Token: 0x06000077 RID: 119 RVA: 0x00003B21 File Offset: 0x00001D21
		private void DrawTitle(int x, int y, int w, int h)
		{
			Text.Font = GameFont.Medium;
			Widgets.Label(new Rect((float)x, (float)y, (float)w, (float)h), Label.PSYTALENTE);
		}

		// Token: 0x06000078 RID: 120 RVA: 0x00003B44 File Offset: 0x00001D44
		private void DrawDropdown(int x, int y, int w, int h)
		{
			Text.Font = GameFont.Small;
			Rect rect = new Rect((float)x, (float)y, (float)w, (float)h);
			SZWidgets.FloatMenuOnButtonText<string>(rect, this.selectedModName ?? Label.ALL, CEditor.API.Get<List<string>>(EType.ModsAbilityDef), (string s) => s ?? Label.ALL, new Action<string>(this.ASelectedModName), "");
		}

		// Token: 0x06000079 RID: 121 RVA: 0x00003BBC File Offset: 0x00001DBC
		private void DrawFilter(int x, int y, int w, int h)
		{
			Text.Font = GameFont.Small;
			Rect rect = new Rect((float)x, (float)y, (float)w, (float)h);
			SZWidgets.FloatMenuOnButtonText<string>(rect, this.selectedStufe ?? Label.ALL, this.lOfStufen, (string s) => s ?? Label.ALL, new Action<string>(this.ASelectedStufe));
		}

		// Token: 0x0600007A RID: 122 RVA: 0x00003C28 File Offset: 0x00001E28
		private void ASelectedModName(string val)
		{
			this.selectedModName = val;
			this.lOfAbilities = DefTool.ListByMod<AbilityDef>(this.selectedModName).ToList<AbilityDef>();
		}

		// Token: 0x0600007B RID: 123 RVA: 0x00003C48 File Offset: 0x00001E48
		private void ASelectedStufe(string val)
		{
			int level = val.Replace(this.alllevels, "").Replace(this.prepend, "").AsInt32();
			this.selectedStufe = val;
			bool bAll = val == null || val == Label.ALL;
			this.lOfAbilities = (from td in DefTool.ListByMod<AbilityDef>(this.selectedModName).ToList<AbilityDef>()
			where bAll || td.level == level
			orderby td.label
			select td).ToList<AbilityDef>();
		}

		// Token: 0x0600007C RID: 124 RVA: 0x00003CF8 File Offset: 0x00001EF8
		private void DoAndClose()
		{
			bool flag = this.selectedAbility != null;
			if (flag)
			{
				CEditor.API.Pawn.CheckAddPsylink(-1);
				CEditor.API.Pawn.abilities.GainAbility(this.selectedAbility);
			}
			SearchTool.Save(this.idxList);
			this.Close(true);
		}

		// Token: 0x0600007D RID: 125 RVA: 0x00003D55 File Offset: 0x00001F55
		public override void OnAcceptKeyPressed()
		{
			base.OnAcceptKeyPressed();
			this.DoAndClose();
		}

		// Token: 0x0600007E RID: 126 RVA: 0x00003D66 File Offset: 0x00001F66
		private void ARandomAbility()
		{
			SZWidgets.sFind = this.FAbilityLabel(this.lOfAbilities.RandomElement<AbilityDef>());
			SZWidgets.sFindTemp = SZWidgets.sFind;
			SZWidgets.waitTimer = 120;
		}

		// Token: 0x0400008D RID: 141
		private int idxList;

		// Token: 0x0400008E RID: 142
		private List<AbilityDef> lOfAbilities;

		// Token: 0x0400008F RID: 143
		private List<string> lOfStufen;

		// Token: 0x04000090 RID: 144
		private Vector2 scrollPos;

		// Token: 0x04000091 RID: 145
		private AbilityDef selectedAbility;

		// Token: 0x04000092 RID: 146
		private AbilityDef oldSelectedAbility;

		// Token: 0x04000093 RID: 147
		private string selectedModName;

		// Token: 0x04000094 RID: 148
		private string selectedStufe;

		// Token: 0x04000095 RID: 149
		private string prepend;

		// Token: 0x04000096 RID: 150
		private string alllevels;

		// Token: 0x04000097 RID: 151
		private bool doOnce;

		// Token: 0x04000098 RID: 152
		private Func<AbilityDef, string> FAbilityLabel = (AbilityDef a) => a.LabelCap.NullOrEmpty() ? (a.label.NullOrEmpty() ? "" : a.label) : a.LabelCap.ToString();

		// Token: 0x04000099 RID: 153
		private Func<AbilityDef, string> FAbilityTooltip = (AbilityDef a) => a.GetTooltip(null);

		// Token: 0x0400009A RID: 154
		private Func<AbilityDef, AbilityDef, bool> FAbilityComparator = (AbilityDef a1, AbilityDef a2) => a1.defName == a2.defName;
	}
}
