﻿using System;
using System.Collections.Generic;
using RimWorld;
using UnityEngine;
using Verse;

namespace CharacterEditor
{
	// Token: 0x02000042 RID: 66
	public class DialogAddStat : Window
	{
		// Token: 0x17000055 RID: 85
		// (get) Token: 0x0600039F RID: 927 RVA: 0x0001DBC0 File Offset: 0x0001BDC0
		public override Vector2 InitialSize
		{
			get
			{
				return new Vector2(600f, 100f);
			}
		}

		// Token: 0x060003A0 RID: 928 RVA: 0x0001DBE4 File Offset: 0x0001BDE4
		private string GetStatLabel(StatDef s)
		{
			return (s == null) ? Label.NONE : s.label;
		}

		// Token: 0x060003A1 RID: 929 RVA: 0x0001DC08 File Offset: 0x0001BE08
		private string GetStatCategoryLabel(StatCategoryDef s)
		{
			return (s == null) ? Label.ALL : s.label;
		}

		// Token: 0x060003A2 RID: 930 RVA: 0x0001DC2C File Offset: 0x0001BE2C
		public DialogAddStat(ThingDef _thingDef, bool _isWeapon, bool _isEquip)
		{
			this.thingDef = _thingDef;
			this.isWeapon = _isWeapon;
			this.isEquip = _isEquip;
			bool flag = this.isWeapon;
			if (flag)
			{
				this.lOfStatCat = CEditor.API.ListOf<StatCategoryDef>(EType.StatCategoryWeapon);
			}
			else
			{
				bool flag2 = this.isEquip;
				if (flag2)
				{
					this.lOfStatCat = CEditor.API.ListOf<StatCategoryDef>(EType.StatCategoryOnEquip);
				}
				else
				{
					this.lOfStatCat = CEditor.API.ListOf<StatCategoryDef>(EType.StatCategoryApparel);
				}
			}
			this.lOfStat = new List<StatDef>();
			this.FGetStatLabel = new Func<StatDef, string>(this.GetStatLabel);
			this.FGetStatCategoryLabel = new Func<StatCategoryDef, string>(this.GetStatCategoryLabel);
			this.doCloseX = true;
			this.absorbInputAroundWindow = true;
			this.draggable = true;
			this.layer = CEditor.Layer;
		}

		// Token: 0x060003A3 RID: 931 RVA: 0x0001DCF4 File Offset: 0x0001BEF4
		public override void DoWindowContents(Rect inRect)
		{
			float w = this.InitialSize.x - 40f;
			float num = this.InitialSize.y - 104f;
			Text.Font = GameFont.Medium;
			SZWidgets.Label(0f, 0f, w, 30f, Label.ADDSTAT, null);
			Text.Font = GameFont.Small;
			SZWidgets.Label(0f, 35f, 100f, 30f, Label.STATTYPE, null);
		}

		// Token: 0x060003A4 RID: 932 RVA: 0x0001DD70 File Offset: 0x0001BF70
		private void ASetStatCategory(StatCategoryDef statCategoryDef)
		{
			this.selectedStatCategoryDef = statCategoryDef;
			this.selectedStatDef = null;
			this.lOfStat = CEditor.API.ListOfStatDef(statCategoryDef, this.isWeapon, this.isEquip);
		}

		// Token: 0x060003A5 RID: 933 RVA: 0x0001DD9E File Offset: 0x0001BF9E
		private void ASetStat(StatDef stat)
		{
			this.selectedStatDef = stat;
		}

		// Token: 0x060003A6 RID: 934 RVA: 0x0001DDA8 File Offset: 0x0001BFA8
		private void AAddStat()
		{
			bool flag = this.thingDef != null;
			if (flag)
			{
				bool flag2 = this.isEquip;
				if (flag2)
				{
					this.thingDef.AddEquipStat(this.selectedStatDef, 0f);
				}
				else
				{
					this.thingDef.AddStat(this.selectedStatDef, 0f);
				}
				bool flag3 = this.selectedStatDef == StatDefOf.EnergyShieldEnergyMax || this.selectedStatDef == StatDefOf.EnergyShieldRechargeRate;
				if (flag3)
				{
					MessageTypeDef mt = this.thingDef.apparel.layers.Contains(ApparelLayerDefOf.Belt) ? MessageTypeDefOf.SilentInput : MessageTypeDefOf.RejectInput;
					MessageTool.Show(Label.ONLYFORSHIELD, mt);
          //this.thingDef.thingClass = typeof(ShieldBelt);
          this.thingDef.comps.AddDistinct(new CompProperties_Shield());
          this.thingDef.ResolveReferences();
					this.thingDef.PostLoad();
				}
				this.Close(true);
			}
		}

		// Token: 0x040001CE RID: 462
		private List<StatCategoryDef> lOfStatCat;

		// Token: 0x040001CF RID: 463
		private List<StatDef> lOfStat;

		// Token: 0x040001D0 RID: 464
		private Func<StatCategoryDef, string> FGetStatCategoryLabel;

		// Token: 0x040001D1 RID: 465
		private Func<StatDef, string> FGetStatLabel;

		// Token: 0x040001D2 RID: 466
		private StatCategoryDef selectedStatCategoryDef;

		// Token: 0x040001D3 RID: 467
		private StatDef selectedStatDef;

		// Token: 0x040001D4 RID: 468
		private ThingDef thingDef;

		// Token: 0x040001D5 RID: 469
		private bool isWeapon;

		// Token: 0x040001D6 RID: 470
		private bool isEquip;
	}
}
