﻿using System;
using System.Collections.Generic;
using System.Linq;
using RimWorld;
using UnityEngine;
using Verse;

namespace CharacterEditor
{
	// Token: 0x02000056 RID: 86
	public class DialogChangeFaction : Window
	{
		// Token: 0x17000065 RID: 101
		// (get) Token: 0x0600052C RID: 1324 RVA: 0x00035BB8 File Offset: 0x00033DB8
		public override Vector2 InitialSize
		{
			get
			{
				return new Vector2(380f, 450f);
			}
		}

		// Token: 0x0600052D RID: 1325 RVA: 0x00035BDC File Offset: 0x00033DDC
		public DialogChangeFaction()
		{
			this.pawn = CEditor.API.Pawn;
			this.lOfFactions = (from td in Find.World.factionManager.AllFactions
			orderby td.def.defName descending
			select td).ToList<Faction>();
			this.lOfFactions.Insert(0, null);
			this.selectedFaction = this.pawn.Faction;
			this.scrollPos = default(Vector2);
			this.iChangeTick = 0;
			this.doCloseX = true;
			this.absorbInputAroundWindow = true;
			this.draggable = true;
			this.layer = CEditor.Layer;
		}

		// Token: 0x0600052E RID: 1326 RVA: 0x00035C91 File Offset: 0x00033E91
		public string Factionlabel(Faction f)
		{
			return (f == null) ? Label.NONE : (string.IsNullOrEmpty(f.GetCallLabel()) ? f.def.label : f.GetCallLabel());
		}

		// Token: 0x0600052F RID: 1327 RVA: 0x00035CBD File Offset: 0x00033EBD
		public string Factiondescr(Faction f)
		{
			return (f == null) ? "" : (f.IsPlayer ? f.def.description : f.GetInfoText());
		}

		// Token: 0x06000530 RID: 1328 RVA: 0x00035CE4 File Offset: 0x00033EE4
		public override void DoWindowContents(Rect inRect)
		{
			float width = this.InitialSize.x - 50f;
			float height = this.InitialSize.y - 220f;
			this.DrawEditLabel(0f, 0f, 340f, 30f);
			Rect butRect = new Rect(10f, 30f, 100f, 100f);
			bool flag = this.selectedFaction != null;
			if (flag)
			{
				Widgets.ButtonImage(butRect, this.selectedFaction.def.FactionIcon, this.selectedFaction.Color, true);
			}
			Text.Font = GameFont.Small;
			Rect outRect = new Rect(0f, 130f, width, height);
			Rect rect = new Rect(0f, 30f, outRect.width - 16f, (float)this.lOfFactions.Count * 35f);
			Widgets.BeginScrollView(outRect, ref this.scrollPos, rect, true);
			Rect rect2 = rect.ContractedBy(4f);
			rect2.height = (float)this.lOfFactions.Count * 35f;
			Listing_Standard listing_Standard = new Listing_Standard();
			listing_Standard.Begin(rect2);
			GUI.color = Color.white;
			Text.Font = GameFont.Small;
			foreach (Faction faction in this.lOfFactions)
			{
				string label = this.Factionlabel(faction);
				string tooltip = this.Factiondescr(faction);
				bool flag2 = listing_Standard.RadioButton(label, faction == this.selectedFaction, 0f, tooltip, null);
				if (flag2)
				{
					this.selectedFaction = faction;
				}
				listing_Standard.Gap(10f);
			}
			listing_Standard.End();
			Widgets.EndScrollView();
			Rect rect3 = new Rect(this.InitialSize.x - 140f, this.InitialSize.y - 70f, 100f, 30f);
			bool flag3 = Widgets.ButtonText(rect3, "OK".Translate(), true, true, true);
			if (flag3)
			{
				bool flag4 = this.pawn.Faction != this.selectedFaction;
				if (flag4)
				{
					bool flag5 = this.pawn.Faction == Faction.OfPlayer;
					if (flag5)
					{
						PawnBanishUtility.Banish(this.pawn, -1);
					}
					this.pawn.SetFaction(this.selectedFaction, null);
				}
				this.Close(true);
			}
		}

		// Token: 0x06000531 RID: 1329 RVA: 0x00035F80 File Offset: 0x00034180
		private void DrawEditLabel(float x, float y, float w, float h)
		{
			Text.Font = GameFont.Medium;
			Rect rect = new Rect(x, y, w, h);
			bool flag = this.iChangeTick <= 0;
			if (flag)
			{
				SZWidgets.Label(rect, this.Factionlabel(CEditor.API.Pawn.Faction), delegate()
				{
					this.iChangeTick = 400;
				}, "");
			}
			else
			{
				string text = this.Factionlabel(CEditor.API.Pawn.Faction);
				string text2 = Widgets.TextField(rect, text);
				bool flag2 = !text.Equals(text2);
				if (flag2)
				{
					CEditor.API.Pawn.Faction.Name = text2;
					this.iChangeTick = 400;
				}
				this.iChangeTick--;
			}
		}

		// Token: 0x040004BF RID: 1215
		private List<Faction> lOfFactions;

		// Token: 0x040004C0 RID: 1216
		private Pawn pawn;

		// Token: 0x040004C1 RID: 1217
		private Vector2 scrollPos;

		// Token: 0x040004C2 RID: 1218
		private Faction selectedFaction;

		// Token: 0x040004C3 RID: 1219
		private int iChangeTick;
	}
}
