﻿using System;
using System.Collections.Generic;
using System.Linq;
using UnityEngine;
using Verse;

namespace CharacterEditor
{
	// Token: 0x02000044 RID: 68
	public class DialogChangeHeadAddons : Window
	{
		// Token: 0x17000057 RID: 87
		// (get) Token: 0x060003F8 RID: 1016 RVA: 0x00020F3C File Offset: 0x0001F13C
		public override Vector2 InitialSize
		{
			get
			{
				return new Vector2(350f, 500f);
			}
		}

		// Token: 0x060003F9 RID: 1017 RVA: 0x00020F60 File Offset: 0x0001F160
		public DialogChangeHeadAddons()
		{
			this.doCloseX = true;
			this.absorbInputAroundWindow = true;
			this.draggable = true;
			this.layer = CEditor.Layer;
			this.lMax = new List<int>();
			this.lPaths = new List<string>();
			this.lHeadAddons = CEditor.API.Pawn.GetListHeadAddons();
			this.lHeadAddonGraphics = CEditor.API.Pawn.GetListHeadAddonGraphics();
			bool flag = !this.lHeadAddonGraphics.NullOrEmpty<Graphic>();
			if (flag)
			{
				for (int i = 0; i < this.lHeadAddonGraphics.Count; i++)
				{
					string text = this.lHeadAddonGraphics[i].path;
					string s = text.Substring(text.Length - 1);
					int num = 0;
					bool flag2 = int.TryParse(s, out num);
					if (flag2)
					{
						text = text.Substring(0, text.Length - 1);
					}
					this.lPaths.Add(text);
					string str;
					do
					{
						num++;
						str = text + num.ToString();
					}
					while (TextureTool.TestTexturePath(str + "_south", false));
					num--;
					this.lMax.Add(num);
				}
			}
			this.aOldAddons = new int[this.lHeadAddons.Count];
			this.lOldAddons = new List<int>();
		}

		// Token: 0x060003FA RID: 1018 RVA: 0x000210CC File Offset: 0x0001F2CC
		public override void DoWindowContents(Rect inRect)
		{
			float x = 0f;
			float num = 0f;
			float num2 = this.InitialSize.x - 16f;
			float height = this.InitialSize.y - 16f;
			Text.Font = GameFont.Medium;
			Widgets.Label(new Rect(x, num, num2, 30f), Label.HEAD_ADDONS);
			num += 30f;
			Text.Font = GameFont.Small;
			Widgets.Label(new Rect(x, num, num2 - 20f, 70f), Label.HA_INFO);
			num += 70f;
			bool flag = !this.lHeadAddons.NullOrEmpty<int>() && !this.lMax.NullOrEmpty<int>();
			if (flag)
			{
				Listing_X listing_X = new Listing_X();
				listing_X.Begin(new Rect(x, num, num2 - 20f, height));
				this.lHeadAddons.CopyTo(this.aOldAddons);
				this.lOldAddons = this.aOldAddons.ToList<int>();
				for (int i = 0; i < this.lHeadAddons.Count; i++)
				{
					this.lHeadAddons[i] = (int)listing_X.Slider((float)this.lHeadAddons[i], 0f, (float)this.lMax[i]);
				}
				listing_X.End();
				bool flag2 = !this.lOldAddons.SequenceEqual(this.lHeadAddons);
				if (flag2)
				{
					CEditor.API.Pawn.SetListHeadAddons(this.lHeadAddons);
					CEditor.API.UpdateGraphics();
				}
			}
			Rect rect = new Rect(this.InitialSize.x - 190f, this.InitialSize.y - 70f, 150f, 30f);
			SZWidgets.ButtonText(rect, Label.REMOVE_ADDONS, new Action(this.ARemoveAddons), Label.TOOLTIP_REMOVE_ADDONS);
		}

		// Token: 0x060003FB RID: 1019 RVA: 0x000212B7 File Offset: 0x0001F4B7
		private void ARemoveAddons()
		{
			CEditor.API.Pawn.RemoveAlienBodyAddons();
			CEditor.API.UpdateGraphics();
		}

		// Token: 0x04000200 RID: 512
		private List<int> lMax;

		// Token: 0x04000201 RID: 513
		private List<string> lPaths;

		// Token: 0x04000202 RID: 514
		private List<int> lOldAddons;

		// Token: 0x04000203 RID: 515
		private List<int> lHeadAddons;

		// Token: 0x04000204 RID: 516
		private List<Graphic> lHeadAddonGraphics;

		// Token: 0x04000205 RID: 517
		private int[] aOldAddons;
	}
}
