﻿using System;
using System.Collections.Generic;
using UnityEngine;
using Verse;
using System.Linq;

namespace CharacterEditor
{
	// Token: 0x0200000F RID: 15
	public class DialogChangeRace : Window
	{
		// Token: 0x0600007F RID: 127 RVA: 0x00003D98 File Offset: 0x00001F98
		public DialogChangeRace(Pawn _pawn)
		{
			this.pawn = _pawn;
			this.humanlike = this.pawn.RaceProps.Humanlike;
			this.scrollPos = default(Vector2);
			this.idxList = 12;
			this.search = SearchTool.Update(this.idxList);
			this.doOnce = true;
			this.selectedPKD = null;
			this.raceDef = this.pawn.def;
			this.search.ofilter1 = (this.search.ofilter1 == null || (bool)this.search.ofilter1);
			Pawn pawn = this.pawn;
			this.selectedPKD = ((pawn != null) ? pawn.kindDef : null);
			this.key = ((this.pawn == null || this.pawn.RaceProps.Humanlike) ? Label.COLONISTS : Label.WILDANIMALS);
			this.UpdateRacesList();
			this.UpdatePKDList();
			this.doCloseX = true;
			this.absorbInputAroundWindow = true;
			this.draggable = true;
			this.layer = CEditor.Layer;
		}

		// Token: 0x17000028 RID: 40
		// (get) Token: 0x06000080 RID: 128 RVA: 0x00003EB0 File Offset: 0x000020B0
		public override Vector2 InitialSize
		{
			get
			{
				return new Vector2(300f, 788f);
			}
		}

		// Token: 0x06000081 RID: 129 RVA: 0x00003ED4 File Offset: 0x000020D4
		private void UpdateRacesList()
		{
			bool nonhumanlike = CEditor.ListName == Label.COLONYANIMALS || CEditor.ListName == Label.WILDANIMALS;
			bool flag = CEditor.ListName == Label.HUMANOID || CEditor.ListName == Label.COLONISTS;
			this.lraces = PawnKindTool.ListOfRaces(flag, nonhumanlike);
		}

		// Token: 0x06000082 RID: 130 RVA: 0x00003F37 File Offset: 0x00002137
		private void UpdatePKDList()
		{
			this.lpkd = PawnKindTool.ListOfPawnKindDefByRace(this.raceDef, this.humanlike, !this.humanlike);
		}

		// Token: 0x06000083 RID: 131 RVA: 0x00003F5C File Offset: 0x0000215C
		public override void DoWindowContents(Rect inRect)
		{
			bool flag = this.doOnce;
			if (flag)
			{
				this.doOnce = false;
				this.windowRect.position = new Vector2(this.windowRect.position.x - 380f, this.windowRect.position.y);
			}
			int h = (int)this.InitialSize.y - 115;
			int num = (int)this.InitialSize.x - 40;
			int x = 0;
			int y = 0;
			y = this.DrawTitle(x, y, num, 30);
			y = this.DrawDropdown(x, y, num);
			y = this.DrawList(x, y, num, h);
			SZWidgets.CheckBoxOnChange(new Rect(0f, this.InitialSize.y - 105f, (float)num, 25f), Label.RACESPECIFICDRESS, (bool)this.search.ofilter1, new Action<bool>(this.ARedress));
			Rect rect = new Rect(this.InitialSize.x - 140f, this.InitialSize.y - 70f, 100f, 30f);
			bool flag2 = Widgets.ButtonText(rect, "OK".Translate(), true, true, true);
			if (flag2)
			{
				RaceTool.ChangeRace(this.pawn, this.selectedPKD, (bool)this.search.ofilter1);
				SearchTool.Save(this.idxList);
				this.Close(true);
			}
		}

		// Token: 0x06000084 RID: 132 RVA: 0x000040CE File Offset: 0x000022CE
		private void ARedress(bool val)
		{
			this.search.ofilter1 = val;
		}

		// Token: 0x06000085 RID: 133 RVA: 0x000040E4 File Offset: 0x000022E4
		private int DrawTitle(int x, int y, int w, int h)
		{
			Text.Font = GameFont.Medium;
			Widgets.Label(new Rect((float)x, (float)y, (float)(w - 40), (float)h), Label.CHANGERACE);
			return h;
		}

		// Token: 0x06000086 RID: 134 RVA: 0x0000411C File Offset: 0x0000231C
		private int DrawDropdown(int x, int y, int w)
		{
			Text.Font = GameFont.Small;
			Rect rect = new Rect((float)x, (float)y, (float)w, 30f);
			SZWidgets.FloatMenuOnButtonText<ThingDef>(rect, CEditor.RACENAME(this.raceDef), this.lraces.ToList(), CEditor.RACENAME, new Action<ThingDef>(this.AChangeRace), "");
			return y + 30;
		}

		// Token: 0x06000087 RID: 135 RVA: 0x00004180 File Offset: 0x00002380
		private int DrawList(int x, int y, int w, int h)
		{
			SZWidgets.ListView<PawnKindDef>(x, y, w, h - y, this.lpkd, CEditor.PKDNAME, CEditor.PKDTOOLTIP, (PawnKindDef pkd1, PawnKindDef pkd2) => pkd1 == pkd2, ref this.selectedPKD, ref this.scrollPos, false, null, true, false, false, false);
			return h - y;
		}

		// Token: 0x06000088 RID: 136 RVA: 0x000041ED File Offset: 0x000023ED
		private void AChangeRace(ThingDef race)
		{
			this.raceDef = race;
			this.UpdatePKDList();
		}

		// Token: 0x0400009B RID: 155
		private bool doOnce;

		// Token: 0x0400009C RID: 156
		private int idxList;

		// Token: 0x0400009D RID: 157
		private HashSet<ThingDef> lraces;

		// Token: 0x0400009E RID: 158
		private List<PawnKindDef> lpkd;

		// Token: 0x0400009F RID: 159
		private Pawn pawn;

		// Token: 0x040000A0 RID: 160
		private PawnKindDef selectedPKD;

		// Token: 0x040000A1 RID: 161
		private ThingDef raceDef;

		// Token: 0x040000A2 RID: 162
		private SearchTool search;

		// Token: 0x040000A3 RID: 163
		private string key;

		// Token: 0x040000A4 RID: 164
		private Vector2 scrollPos;

		// Token: 0x040000A5 RID: 165
		private bool humanlike;
	}
}
