﻿using System;
using System.Collections.Generic;
using UnityEngine;
using Verse;

namespace CharacterEditor
{
	// Token: 0x02000055 RID: 85
	public class DialogChoosePart : Window
	{
		// Token: 0x17000064 RID: 100
		// (get) Token: 0x06000526 RID: 1318 RVA: 0x00035820 File Offset: 0x00033A20
		public override Vector2 InitialSize
		{
			get
			{
				return new Vector2(350f, 750f);
			}
		}

		// Token: 0x06000527 RID: 1319 RVA: 0x00035844 File Offset: 0x00033A44
		public DialogChoosePart(IPartable _callback, HediffDef _hediff)
		{
			this.hediff = _hediff;
			this.scrollPos = default(Vector2);
			this.selectedPart = null;
			this.addWholeBody = false;
			this.callback = _callback;
			this.lOfParts = CEditor.API.Pawn.GetListOfAllowedBodyPartRecords(this.hediff);
			this.countParts = this.lOfParts.CountAllowNull<BodyPartRecord>();
			bool flag = this.countParts == 1;
			if (flag)
			{
				this.selectedPart = this.lOfParts[0];
			}
			this.doCloseX = true;
			this.absorbInputAroundWindow = true;
			this.draggable = true;
			this.layer = CEditor.Layer;
		}

		// Token: 0x06000528 RID: 1320 RVA: 0x000358EC File Offset: 0x00033AEC
		public override void DoWindowContents(Rect inRect)
		{
			float frameW = this.InitialSize.x - 40f;
			float frameH = this.InitialSize.y - 115f;
			Text.Font = GameFont.Medium;
			Widgets.Label(new Rect(0f, 0f, 300f, 30f), Label.SELECT_BODYPART);
			this.DrawPartList(frameW, frameH);
			this.DrawAccept();
		}

		// Token: 0x06000529 RID: 1321 RVA: 0x0003595C File Offset: 0x00033B5C
		private void DrawPartList(float frameW, float frameH)
		{
			Text.Font = GameFont.Small;
			Rect outRect = new Rect(0f, 30f, frameW, frameH);
			Rect rect = new Rect(0f, 30f, outRect.width - 16f, (float)this.countParts * 27f - 25f);
			Widgets.BeginScrollView(outRect, ref this.scrollPos, rect, true);
			Rect rect2 = rect.ContractedBy(4f);
			rect2.height = (float)this.countParts * 27f + (float)(this.addWholeBody ? 27 : 0);
			Listing_Standard listing_Standard = new Listing_Standard();
			listing_Standard.Begin(rect2);
			bool flag = this.addWholeBody && listing_Standard.RadioButton("WholeBody".Translate(), this.selectedPart == null, 0f, null, null);
			if (flag)
			{
				this.selectedPart = null;
			}
			listing_Standard.Gap(2f);
			foreach (BodyPartRecord bodyPartRecord in this.lOfParts)
			{
				Listing_Standard listing_Standard2 = listing_Standard;
				string label = (bodyPartRecord == null) ? "WholeBody".Translate().ToString() : bodyPartRecord.Label.CapitalizeFirst();
				bool active = this.selectedPart == bodyPartRecord;
				float tabIn = 0f;
				string tooltip;
				if (bodyPartRecord == null)
				{
					tooltip = null;
				}
				else
				{
					BodyPartDef def = bodyPartRecord.def;
					tooltip = ((def != null) ? def.description : null);
				}
				bool flag2 = listing_Standard2.RadioButton(label, active, tabIn, tooltip, null);
				if (flag2)
				{
					this.selectedPart = bodyPartRecord;
				}
				listing_Standard.Gap(2f);
			}
			listing_Standard.End();
			Widgets.EndScrollView();
		}

		// Token: 0x0600052A RID: 1322 RVA: 0x00035B30 File Offset: 0x00033D30
		private void DrawAccept()
		{
			Rect rect = new Rect(this.InitialSize.x - 140f, this.InitialSize.y - 70f, 100f, 30f);
			SZWidgets.ButtonText(rect, "OK".Translate(), new Action(this.DoAndClose), "");
		}

		// Token: 0x0600052B RID: 1323 RVA: 0x00035B98 File Offset: 0x00033D98
		private void DoAndClose()
		{
			this.callback.SelectedPart = this.selectedPart;
			this.Close(true);
		}

		// Token: 0x040004B8 RID: 1208
		private Vector2 scrollPos;

		// Token: 0x040004B9 RID: 1209
		private List<BodyPartRecord> lOfParts;

		// Token: 0x040004BA RID: 1210
		private BodyPartRecord selectedPart;

		// Token: 0x040004BB RID: 1211
		private IPartable callback;

		// Token: 0x040004BC RID: 1212
		private bool addWholeBody;

		// Token: 0x040004BD RID: 1213
		private int countParts;

		// Token: 0x040004BE RID: 1214
		private HediffDef hediff;
	}
}
