﻿using System;
using UnityEngine;
using Verse;

namespace CharacterEditor
{
	// Token: 0x02000057 RID: 87
	public class DialogFindPawn : Window
	{
		// Token: 0x17000066 RID: 102
		// (get) Token: 0x06000533 RID: 1331 RVA: 0x00036050 File Offset: 0x00034250
		public override Vector2 InitialSize
		{
			get
			{
				return new Vector2(370f, 786f);
			}
		}

		// Token: 0x06000534 RID: 1332 RVA: 0x00036074 File Offset: 0x00034274
		public DialogFindPawn()
		{
			this.scrollPos = default(Vector2);
			this.selectedPawn = null;
			this.idxList = 3;
			SearchTool.Update(this.idxList);
			this.FGetInfo = new Func<Pawn, string>(this.GetInfo);
			this.doCloseX = true;
			this.absorbInputAroundWindow = true;
			this.draggable = true;
			this.layer = CEditor.Layer;
		}

		// Token: 0x06000535 RID: 1333 RVA: 0x000360E4 File Offset: 0x000342E4
		private string GetInfo(Pawn p)
		{
			string str = string.Concat(new string[]
			{
				p.GetPawnName(false),
				" (",
				p.KindLabel,
				",",
				p.GetGenderLabel()
			});
			bool flag = p.Faction != null;
			if (flag)
			{
				str = str + "," + p.Faction.Name;
			}
			return str + ")";
		}

		// Token: 0x06000536 RID: 1334 RVA: 0x00036160 File Offset: 0x00034360
		public override void DoWindowContents(Rect inRect)
		{
			float num = this.InitialSize.x - 40f;
			float h = this.InitialSize.y - 115f;
			Text.Font = GameFont.Medium;
			Widgets.Label(new Rect(0f, 0f, num, 30f), Label.FIND_PAWN);
			Text.Font = GameFont.Small;
			SZWidgets.ListView<Pawn>(0f, 30f, num, h, CEditor.API.ListOf<Pawn>(EType.Pawns), this.FGetInfo, (Pawn p) => p.MainDesc(true), (Pawn pA, Pawn pB) => pA == pB, ref this.selectedPawn, ref this.scrollPos, false, new Action<Pawn>(this.ASelectPawn), true, false, false, false);
			Rect rect = new Rect(this.InitialSize.x - 140f, this.InitialSize.y - 70f, 100f, 30f);
			bool flag = Widgets.ButtonText(rect, "OK".Translate(), true, true, true);
			if (flag)
			{
				this.DoAndClose();
			}
		}

		// Token: 0x06000537 RID: 1335 RVA: 0x00036297 File Offset: 0x00034497
		private void ASelectPawn(Pawn p)
		{
			this.selectedPawn = p;
			CEditor.API.Pawn = p;
		}

		// Token: 0x06000538 RID: 1336 RVA: 0x000362B0 File Offset: 0x000344B0
		private void DoAndClose()
		{
			bool flag = this.selectedPawn != null;
			if (flag)
			{
				Current.Game.CurrentMap = this.selectedPawn.Map;
				CameraJumper.TryJumpAndSelect(this.selectedPawn);
			}
			SearchTool.Save(this.idxList);
			this.Close(true);
		}

		// Token: 0x06000539 RID: 1337 RVA: 0x00036308 File Offset: 0x00034508
		public override void OnAcceptKeyPressed()
		{
			base.OnAcceptKeyPressed();
			this.DoAndClose();
		}

		// Token: 0x040004C4 RID: 1220
		private int idxList;

		// Token: 0x040004C5 RID: 1221
		private Vector2 scrollPos;

		// Token: 0x040004C6 RID: 1222
		private Pawn selectedPawn;

		// Token: 0x040004C7 RID: 1223
		private Func<Pawn, string> FGetInfo;
	}
}
