﻿using System;
using System.Collections.Generic;
using RimWorld;
using UnityEngine;
using Verse;

namespace CharacterEditor
{
	// Token: 0x02000052 RID: 82
	public class DialogFullheal : Window
	{
		// Token: 0x17000061 RID: 97
		// (get) Token: 0x06000510 RID: 1296 RVA: 0x00034590 File Offset: 0x00032790
		public override Vector2 InitialSize
		{
			get
			{
				return new Vector2(400f, 500f);
			}
		}

		// Token: 0x06000511 RID: 1297 RVA: 0x000345B4 File Offset: 0x000327B4
		public DialogFullheal()
		{
			this.scrollPos = default(Vector2);
			this.lOfHediff = CEditor.API.Pawn.health.hediffSet.hediffs;
			this.dicToRemove = new Dictionary<Hediff, bool>();
			foreach (Hediff hediff in this.lOfHediff)
			{
				bool flag = hediff.Part != null && hediff.def.hediffClass == typeof(Hediff_AddedPart);
				if (flag)
				{
					this.dicToRemove.Add(hediff, false);
				}
				else
				{
					this.dicToRemove.Add(hediff, true);
				}
			}
			this.doCloseX = true;
			this.absorbInputAroundWindow = true;
			this.draggable = true;
			this.layer = CEditor.Layer;
		}

		// Token: 0x06000512 RID: 1298 RVA: 0x000346AC File Offset: 0x000328AC
		public override void DoWindowContents(Rect inRect)
		{
			float num = this.InitialSize.x - 40f;
			float height = this.InitialSize.y - 115f;
			Text.Font = GameFont.Medium;
			Widgets.Label(new Rect(0f, 0f, 350f, 30f), Label.HEAL);
			Text.Font = GameFont.Small;
			Rect outRect = new Rect(0f, 30f, num, height);
			Rect rect = new Rect(0f, 30f, num - 16f, (float)this.lOfHediff.Count * 29f - 5f);
			Widgets.BeginScrollView(outRect, ref this.scrollPos, rect, true);
			Rect rect2 = rect.ContractedBy(4f);
			rect2.height = (float)this.lOfHediff.Count * 29f;
			Listing_Standard listing_Standard = new Listing_Standard();
			listing_Standard.Begin(rect2);
			foreach (Hediff key in this.lOfHediff)
			{
				this.isChecked = this.dicToRemove[key];
				//List<Hediff>.Enumerator enumerator;
				listing_Standard.CheckboxLabeled(key.GetFullLabel(), ref this.isChecked, key.TipStringExtra);
				this.dicToRemove[key] = this.isChecked;
				listing_Standard.Gap(5f);
			}
			listing_Standard.End();
			Widgets.EndScrollView();
			Rect rect3 = new Rect(this.InitialSize.x - 140f, this.InitialSize.y - 70f, 100f, 30f);
			bool flag = Widgets.ButtonText(rect3, "OK".Translate(), true, true, true);
			if (flag)
			{
				foreach (Hediff hediff in this.dicToRemove.Keys)
				{
					try
					{
						bool flag2 = this.dicToRemove[hediff];
						if (flag2)
						{
							CEditor.API.Pawn.RemoveHediff(hediff);
						}
					}
					catch
					{
						bool dead = CEditor.API.Pawn.Dead;
						if (dead)
						{
							ResurrectionUtility.Resurrect(CEditor.API.Pawn);
						}
					}
				}
				CEditor.API.UpdateGraphics();
				this.Close(true);
			}
		}

		// Token: 0x0400049F RID: 1183
		private Dictionary<Hediff, bool> dicToRemove;

		// Token: 0x040004A0 RID: 1184
		private List<Hediff> lOfHediff;

		// Token: 0x040004A1 RID: 1185
		private Vector2 scrollPos;

		// Token: 0x040004A2 RID: 1186
		private bool isChecked;
	}
}
