﻿using System;
using System.Collections.Generic;
using RimWorld;
using Verse;

namespace CharacterEditor
{
	// Token: 0x0200001A RID: 26
	public static class IdeoTool
	{
		// Token: 0x060000F5 RID: 245 RVA: 0x00007B63 File Offset: 0x00005D63
		public static bool HasIdeoTracker(this Pawn p)
		{
			return p != null && p.ideo != null;
		}

		// Token: 0x060000F6 RID: 246 RVA: 0x00007B74 File Offset: 0x00005D74
		public static string GetPawnCultureDefName(this Pawn pawn)
		{
			bool flag = pawn.HasIdeoTracker() && pawn.Ideo != null;
			string result;
			if (flag)
			{
				result = ((pawn.Ideo.culture != null) ? pawn.Ideo.culture.defName : "");
			}
			else
			{
				result = "";
			}
			return result;
		}

		// Token: 0x060000F7 RID: 247 RVA: 0x00007BCC File Offset: 0x00005DCC
		public static string GetPawnIdeoName(this Pawn pawn)
		{
			bool flag = pawn.HasIdeoTracker() && pawn.Ideo != null;
			string result;
			if (flag)
			{
				result = pawn.Ideo.name;
			}
			else
			{
				result = "";
			}
			return result;
		}

		// Token: 0x060000F8 RID: 248 RVA: 0x00007C0C File Offset: 0x00005E0C
		public static void SetPawnIdeo(this Pawn pawn, string cultureDefName, string ideoName)
		{
			bool flag = !pawn.HasIdeoTracker();
			if (!flag)
			{
				List<Ideo> ideosListForReading = Find.IdeoManager.IdeosListForReading;
				foreach (Ideo ideo in ideosListForReading)
				{
					bool flag2 = ideo.culture.defName == cultureDefName;
					if (flag2)
					{
						bool flag3 = ideo.name == ideoName;
						if (flag3)
						{
							pawn.ideo.SetIdeo(ideo);
							return;
						}
					}
				}
				foreach (Ideo ideo2 in ideosListForReading)
				{
					bool flag4 = ideo2.culture.defName == cultureDefName;
					if (flag4)
					{
						pawn.ideo.SetIdeo(ideo2);
					}
				}
			}
		}
	}
}
