﻿using System;
using RimWorld;
using Verse;

namespace CharacterEditor
{
	// Token: 0x0200003B RID: 59
	public static class MessageTool
	{
		// Token: 0x060002DE RID: 734 RVA: 0x000171DC File Offset: 0x000153DC
		public static void Show(string info, MessageTypeDef mt = null)
		{
			Messages.Message(info, mt ?? MessageTypeDefOf.SilentInput, false);
		}

		// Token: 0x060002DF RID: 735 RVA: 0x000171F4 File Offset: 0x000153F4
		public static void ShowInDebug(string info)
		{
			bool devMode = Prefs.DevMode;
			if (devMode)
			{
				MessageTool.Show(info, null);
			}
		}

		// Token: 0x060002E0 RID: 736 RVA: 0x00017214 File Offset: 0x00015414
		public static void ShowDialog(string s, bool doRestart = false)
		{
			if (doRestart)
			{
				WindowTool.Open(Dialog_MessageBox.CreateConfirmation(s, delegate
				{
					GameDataSaveLoader.SaveGame("autosave_last");
					GenCommandLine.Restart();
				}, false, null, WindowLayer.Dialog));
			}
			else
			{
				WindowTool.Open(Dialog_MessageBox.CreateConfirmation(s, null, false, null, WindowLayer.Dialog));
			}
		}

		// Token: 0x060002E1 RID: 737 RVA: 0x00017275 File Offset: 0x00015475
		public static void ShowActionDialog(string s, Action confirmedAction, string title = null)
		{
			WindowTool.Open(Dialog_MessageBox.CreateConfirmation(s, confirmedAction, false, title, CEditor.Layer));
		}

		// Token: 0x060002E2 RID: 738 RVA: 0x00017294 File Offset: 0x00015494
		public static void ShowCustomDialog(string s, string title, Action onAbort, Action onConfirm, Action onNext)
		{
			bool dontAsk = CEditor.DontAsk;
			if (dontAsk)
			{
				bool flag = onNext != null;
				if (flag)
				{
					onNext();
				}
				else
				{
					onConfirm();
				}
			}
			else
			{
				WindowTool.Open(new CustomDialog(s, title, onAbort, onConfirm, onNext));
			}
		}
	}
}
