﻿using System;
using System.Collections.Generic;
using RimWorld;
using Verse;

namespace CharacterEditor
{
	// Token: 0x02000031 RID: 49
	public static class RaceTool
	{
		// Token: 0x06000254 RID: 596 RVA: 0x000113E4 File Offset: 0x0000F5E4
		public static ThingComp GetAlienRaceComp(this Pawn pawn)
		{
			bool flag = pawn.IsAlienRace();
			if (flag)
			{
				object memberValue = pawn.def.GetMemberValue("alienRace");
				bool flag2 = memberValue != null;
				if (flag2)
				{
					foreach (ThingComp thingComp in pawn.GetComps<ThingComp>())
					{
						bool flag3 = thingComp.GetType().Namespace.EqualsIgnoreCase("AlienRace") && thingComp.GetType().Name.EndsWith("AlienComp");
						if (flag3)
						{
							return thingComp;
						}
					}
				}
			}
			return null;
		}

		// Token: 0x06000255 RID: 597 RVA: 0x000114A0 File Offset: 0x0000F6A0
		public static bool IsAlienRace(this Pawn pawn)
		{
			return CEditor.IsAlienRaceActive && pawn != null && pawn.def != null && pawn.def.GetType().ToString().StartsWith("AlienRace");
		}

		//public static List<string> GetAlienCrownTypes(this Pawn pawn)
		//{
		//	bool flag = pawn.IsAlienRace();
		//	if (flag)
		//	{
		//		object memberValue = pawn.def.GetMemberValue("alienRace");
		//		bool flag2 = memberValue != null;
		//		if (flag2)
		//		{
		//			object memberValue2 = memberValue.GetMemberValue("generalSettings");
		//			bool flag3 = memberValue2 != null;
		//			if (flag3)
		//			{
		//				object memberValue3 = memberValue2.GetMemberValue("alienPartGenerator");
		//				bool flag4 = memberValue3 != null;
		//				if (flag4)
		//				{
		//					return (List<string>)memberValue3.GetMemberValue("aliencrowntypes");
		//				}
		//			}
		//		}
		//	}
		//	return new List<string>();
		//}

		// Token: 0x06000257 RID: 599 RVA: 0x0001156C File Offset: 0x0000F76C
		public static void ChangeRace(Pawn pawn, PawnKindDef pkd, bool keepRaceSpecificClothes)
		{
			PresetPawn presetPawn = new PresetPawn();
			presetPawn.SavePawn(pawn, -1);
			presetPawn.dicParams[PresetPawn.Param.P01_pawnkinddef] = pkd.defName;
			presetPawn.GeneratePawn(false, !keepRaceSpecificClothes);
			Pawn pawn2 = presetPawn.pawn;
			pawn2.ChangeKind(pkd);
			IntVec3 position = pawn.Position;
			bool isPrisoner = pawn.IsPrisoner;
			pawn.Delete(true);
			bool flag = !CEditor.InStartingScreen;
			if (flag)
			{
				pawn2.TeleportPawn(position);
			}
			bool flag2 = isPrisoner;
			if (flag2)
			{
				bool flag3 = pawn2.Faction == Faction.OfPlayer;
				if (flag3)
				{
					pawn2.SetFaction(null, null);
				}
				bool released = pawn2.guest.Released;
				if (released)
				{
					pawn2.guest.Released = false;
					pawn2.guest.interactionMode = PrisonerInteractionModeDefOf.NoInteraction;
				}
				bool flag4 = !pawn2.IsPrisonerOfColony;
				if (flag4)
				{
					pawn2.guest.CapturedBy(Faction.OfPlayer, null);
				}
			}
			PawnxTool.PostProcess(pawn2, presetPawn);
		}
	}
}
