﻿using System;
using System.Collections.Generic;
using RimWorld;
using Verse;

namespace CharacterEditor
{
	// Token: 0x02000026 RID: 38
	public static class RecordTool
	{
		// Token: 0x0600019B RID: 411 RVA: 0x0000CCCC File Offset: 0x0000AECC
		public static string GetAsSeparatedString(this RecordDef r, float val)
		{
			bool flag = r == null;
			string result;
			if (flag)
			{
				result = "";
			}
			else
			{
				string text = "";
				text = text + r.defName + "|";
				text += val.ToString();
				result = text;
			}
			return result;
		}

		// Token: 0x0600019C RID: 412 RVA: 0x0000CD18 File Offset: 0x0000AF18
		public static string GetAllRecordsAsSeparatedString(this Pawn p)
		{
			bool flag = !p.HasRecordsTracker() || p.GetPawnRecords().EnumerableNullOrEmpty<KeyValuePair<RecordDef, float>>();
			string result;
			if (flag)
			{
				result = "";
			}
			else
			{
				string text = "";
				foreach (KeyValuePair<RecordDef, float> keyValuePair in p.GetPawnRecords())
				{
					text += keyValuePair.Key.GetAsSeparatedString(keyValuePair.Value);
					text += ":";
				}
				text = text.SubstringRemoveLast();
				result = text;
			}
			return result;
		}

		// Token: 0x0600019D RID: 413 RVA: 0x0000CDC0 File Offset: 0x0000AFC0
		public static void SetRecords(this Pawn p, string s)
		{
			bool flag = s.NullOrEmpty() || !p.HasRecordsTracker();
			if (!flag)
			{
				string[] array = s.SplitNo(":");
				DefMap<RecordDef, float> pawnRecords = p.GetPawnRecords();
				foreach (string s2 in array)
				{
					string[] array3 = s2.SplitNo("|");
					bool flag2 = array3.Length == 2;
					if (flag2)
					{
						RecordDef recordDef = DefTool.RecordDef(array3[0]);
						bool flag3 = recordDef != null;
						if (flag3)
						{
							float value = array3[1].AsFloat();
							pawnRecords[recordDef] = value;
						}
					}
				}
				p.SetPawnRecords(pawnRecords);
				p.records.RecordsTick();
			}
		}

		// Token: 0x0600019E RID: 414 RVA: 0x0000CE7C File Offset: 0x0000B07C
		public static void SetPawnRecords(this Pawn p, DefMap<RecordDef, float> dic)
		{
			bool flag = p.HasRecordsTracker();
			if (flag)
			{
				p.records.SetMemberValue("records", dic);
			}
		}

		// Token: 0x0600019F RID: 415 RVA: 0x0000CEA6 File Offset: 0x0000B0A6
		public static DefMap<RecordDef, float> GetPawnRecords(this Pawn p)
		{
			return p.HasRecordsTracker() ? ((DefMap<RecordDef, float>)p.records.GetMemberValue("records")) : null;
		}
	}
}
