﻿using System;
using System.Collections.Generic;
using Verse;

namespace CharacterEditor
{
	// Token: 0x02000040 RID: 64
	public class SearchTool
	{
		// Token: 0x0600037E RID: 894 RVA: 0x0001D218 File Offset: 0x0001B418
		public static SearchTool GetInstance(int uniqueIdx)
		{
			return CEditor.API.Get<Dictionary<int, SearchTool>>(EType.Search)[uniqueIdx];
		}

		// Token: 0x1700004E RID: 78
		// (get) Token: 0x0600037F RID: 895 RVA: 0x0001D23C File Offset: 0x0001B43C
		// (set) Token: 0x06000380 RID: 896 RVA: 0x0001D268 File Offset: 0x0001B468
		public string SelectedModName
		{
			get
			{
				return this.modName.NullOrEmpty() ? Label.ALL : this.modName;
			}
			set
			{
				this.modName = value;
			}
		}

		// Token: 0x1700004F RID: 79
		// (get) Token: 0x06000381 RID: 897 RVA: 0x0001D274 File Offset: 0x0001B474
		// (set) Token: 0x06000382 RID: 898 RVA: 0x0001D2A0 File Offset: 0x0001B4A0
		public string SelectedFilter1
		{
			get
			{
				return this.filter1.NullOrEmpty() ? Label.ALL : this.filter1;
			}
			set
			{
				this.filter1 = value;
			}
		}

		// Token: 0x17000050 RID: 80
		// (get) Token: 0x06000383 RID: 899 RVA: 0x0001D2AC File Offset: 0x0001B4AC
		// (set) Token: 0x06000384 RID: 900 RVA: 0x0001D2D8 File Offset: 0x0001B4D8
		public string SelectedFilter2
		{
			get
			{
				return this.filter2.NullOrEmpty() ? Label.ALL : this.filter2;
			}
			set
			{
				this.filter2 = value;
			}
		}

		// Token: 0x06000385 RID: 901 RVA: 0x0001D2E2 File Offset: 0x0001B4E2
		public SearchTool(string _find, string _findOld, string _modName, string _filter1, string _filter2, object _ofilter1, object _ofilter2)
		{
			this.find = _find;
			this.findOld = _findOld;
			this.modName = _modName;
			this.filter1 = _filter1;
			this.filter2 = _filter2;
			this.ofilter1 = _ofilter1;
			this.ofilter2 = _ofilter2;
		}

		// Token: 0x06000386 RID: 902 RVA: 0x0001D324 File Offset: 0x0001B524
		public static void ClearSearch(int uniqueIdx)
		{
			Dictionary<int, SearchTool> dictionary = CEditor.API.Get<Dictionary<int, SearchTool>>(EType.Search);
			bool flag = !dictionary.ContainsKey(uniqueIdx);
			if (flag)
			{
				dictionary.Add(uniqueIdx, new SearchTool("", "", null, null, null, null, null));
			}
			//SZWidgets.sFind = "";
			//SZWidgets.sFindOld = "";
			dictionary[uniqueIdx].find = "";
			dictionary[uniqueIdx].findOld = "";
			dictionary[uniqueIdx].modName = "";
		}

		// Token: 0x06000387 RID: 903 RVA: 0x0001D3B0 File Offset: 0x0001B5B0
		public static SearchTool Update(int uniqueIdx)
		{
			Dictionary<int, SearchTool> dictionary = CEditor.API.Get<Dictionary<int, SearchTool>>(EType.Search);
			bool flag = !dictionary.ContainsKey(uniqueIdx);
			if (flag)
			{
				dictionary.Add(uniqueIdx, new SearchTool("", "", null, null, null, null, null));
			}
			SZWidgets.sFind = dictionary[uniqueIdx].find;
      SZWidgets.sFindOld = "";
      SZWidgets.lSimilar = new List<string>();
			return dictionary[uniqueIdx];
		}

		// Token: 0x06000388 RID: 904 RVA: 0x0001D428 File Offset: 0x0001B628
		public static void Save(int uniqueIdx)
		{
			Dictionary<int, SearchTool> dictionary = CEditor.API.Get<Dictionary<int, SearchTool>>(EType.Search);
			dictionary[uniqueIdx].find = SZWidgets.sFind;
      dictionary[uniqueIdx].findOld = SZWidgets.sFindOld;
      SZWidgets.lSimilar.Clear();
		}

		// Token: 0x040001AC RID: 428
		public List<object> list;

		// Token: 0x040001AD RID: 429
		public string find;

		// Token: 0x040001AE RID: 430
		public string findOld;

		// Token: 0x040001AF RID: 431
		public string modName;

		// Token: 0x040001B0 RID: 432
		public object ofilter1;

		// Token: 0x040001B1 RID: 433
		public object ofilter2;

		// Token: 0x040001B2 RID: 434
		public string filter1;

		// Token: 0x040001B3 RID: 435
		public string filter2;
	}
}
