﻿using System;
using UnityEngine;
using Verse;

namespace CharacterEditor
{
	// Token: 0x02000035 RID: 53
	public static class SkinTool
	{
		// Token: 0x06000280 RID: 640 RVA: 0x00012D28 File Offset: 0x00010F28
		public static void SetFavColor(this Pawn pawn, Color col)
		{
			bool flag = !pawn.HasStoryTracker();
			if (!flag)
			{
				pawn.story.favoriteColor = new Color?(col);
			}
		}

		// Token: 0x06000281 RID: 641 RVA: 0x00012D58 File Offset: 0x00010F58
		public static Color GetFavColor(this Pawn pawn)
		{
			bool flag = pawn.HasStoryTracker();
			Color result;
			if (flag)
			{
				result = pawn.story.favoriteColor.GetValueOrDefault();
			}
			else
			{
				result = Color.white;
			}
			return result;
		}

    // Token: 0x06000282 RID: 642 RVA: 0x00012D8D File Offset: 0x00010F8D
    //public static float GetMelanin(this Pawn pawn)
    //{
    //	return (pawn != null && pawn.story != null) ? pawn.story.melanin : 0f;
    //}

    // Token: 0x06000284 RID: 644 RVA: 0x00012DDC File Offset: 0x00010FDC
    public static Color GetSkinColor(this Pawn pawn, bool primary)
    {
			if (primary)
      {
        try
        {
          return pawn.story.SkinColor;
        }
        catch
        {
          string error = "GetSkinColor, pawn.story.SkinColor failed";
          Log.ErrorOnce(error, error.GetHashCode());
        }
      }
			try
			{
				bool flag = pawn.IsAlienRace();
				if (flag)
				{
					ThingComp alienRaceComp = pawn.GetAlienRaceComp();
					object obj = alienRaceComp.CallMethod("GetChannel", new object[]
					{
						"skin"
					});
					return (Color)obj.GetMemberValue(primary ? "first" : "second");
				}
			}
			catch
			{
				try
				{
					bool flag2 = pawn.IsAlienRace();
					if (flag2)
					{
						ThingComp alienRaceComp2 = pawn.GetAlienRaceComp();
						return (Color)alienRaceComp2.GetMemberValue(primary ? "skinColor" : "skinColorSecond");
					}
				}
				catch
				{
				}
			}
			return Color.white;
		}

		public static void SetSkinColor(this Pawn pawn, bool primary, Color color)
    {
      try
      {
				if (primary)
        {
          pawn.story.skinColorOverride = color;
        }
      }
      catch
      {
				string error = "SetSkinColor, pawn.story.SkinColorBase = color failed";
				Log.ErrorOnce(error, error.GetHashCode());
      }

			try
			{
				bool flag = pawn.IsAlienRace();
				if (flag)
				{
					ThingComp alienRaceComp = pawn.GetAlienRaceComp();
					object obj = alienRaceComp.CallMethod("GetChannel", new object[]
					{
						"skin"
					});
					obj.SetMemberValue(primary ? "first" : "second", color);
				}
			}
			catch
			{
				try
				{
					bool flag2 = pawn.IsAlienRace();
					if (flag2)
					{
						ThingComp alienRaceComp2 = pawn.GetAlienRaceComp();
						alienRaceComp2.SetMemberValue(primary ? "skinColor" : "skinColorSecond", color);
					}
				}
				catch
				{
				}
			}
		}
	}
}
