﻿using System;
using System.Collections.Generic;
using System.Linq;
using Verse;

namespace CharacterEditor
{
	// Token: 0x02000025 RID: 37
	public static class WorkTool
	{
		// Token: 0x06000198 RID: 408 RVA: 0x0000CB38 File Offset: 0x0000AD38
		public static List<WorkTypeDef> GetAllWorkTypeDefs()
		{
			return DefDatabase<WorkTypeDef>.AllDefs.ToList<WorkTypeDef>();
		}

		// Token: 0x06000199 RID: 409 RVA: 0x0000CB44 File Offset: 0x0000AD44
		public static string GetWorkPrioritiesAsSeparatedString(this Pawn p)
		{
			bool flag = !p.HasWorkTracker();
			string result;
			if (flag)
			{
				result = "";
			}
			else
			{
				string text = "";
				List<WorkTypeDef> allWorkTypeDefs = WorkTool.GetAllWorkTypeDefs();
				p.workSettings.EnableAndInitializeIfNotAlreadyInitialized();
				foreach (WorkTypeDef workTypeDef in allWorkTypeDefs)
				{
					text = text + workTypeDef.defName + "|";
					text += p.workSettings.GetPriority(workTypeDef).ToString();
					text += ":";
				}
				text = text.SubstringRemoveLast();
				result = text;
			}
			return result;
		}

		// Token: 0x0600019A RID: 410 RVA: 0x0000CC0C File Offset: 0x0000AE0C
		public static void SetWorkPrioritiesFromSeparatedString(this Pawn p, string s)
		{
			bool flag = !p.HasWorkTracker();
			if (!flag)
			{
				p.workSettings.EnableAndInitializeIfNotAlreadyInitialized();
				p.workSettings.DisableAll();
				bool flag2 = s.NullOrEmpty();
				if (!flag2)
				{
					string[] array = s.SplitNo(":");
					foreach (string s2 in array)
					{
						string[] array3 = s2.SplitNo("|");
						bool flag3 = array3.Length == 2;
						if (flag3)
						{
							WorkTypeDef workTypeDef = DefTool.WorkTypeDef(array3[0]);
							bool flag4 = workTypeDef != null;
							if (flag4)
							{
								int priority = array3[1].AsInt32();
								p.workSettings.SetPriority(workTypeDef, priority);
							}
						}
					}
				}
			}
		}
	}
}
