<p align="center">
	“Portions of the materials used to create this content/mod are trademarks and/or copyrighted works of Ludeon Studios Inc. All rights reserved by Ludeon. This content/mod is not official and is not endorsed by Ludeon.”
</p>

# Description
Android Tiers Reforged is a total rework of Atlas' and ARandomKiwi's works with the eventual goal to make mechanical colonists and animals as closely linked to RimWorld's core systems as possible while respecting the original mechanics of the mod. Improved performance, dynamic compatibility, and code formatting are key priorities, and the code has undergone a near complete rewrite across the board to these ends.

Android Tiers itself is a mod that intends to add mechanical colonists, animals, and related mechanics to RimWorld to create a completely new playstyle and bring a very different experience to the table.

## Features

* Introduction of a basic mechanical colonist system.
* Four tiers of craftable and widespread androids to interact, fight, and recruit.
* Mechanical utility and military drones with animalistic intelligence for purely mechanical colonies.
* Two types of massive mechanized warforms to turn the tide of battles and the colony's future.
* A system for emotionless but fully controllable drones.
* Ability to adjust what is and is not considered mechanical, even for other mod-added races.
* Mechanical equivalents of vanilla prosthetics and medicine.
* A new "mechanic" work type that fulfills the role of doctors for mechanical units, using crafting instead of medical skills.
* Special mechanical-only surgeries and operations for resurrecting, converting, and repairing pawns.
* The ability to use surrogate pawns to extend the reach and power of individual pawns.
* The ability to use a SkyMind network to upload, download, permute, or replicate pawn consciousnesses.
* A fully functioning Skill, Security, and Hacking server system and various related tools, incidents, and abilities.
* A full research tree to delve into a more metallic and mechanized future.
* New security options such as launching swarms of microscythers - or laying traps of them for unwary raiders.
* A vast host of new mechanical specific hediffs, body parts, diseases, and implants.

## Links

[Discord] (https://discord.gg/qVJzeB8)

[GitHub] (https://github.com/RWDevathon/Android-Tiers-Reforged)

Special thanks to:
* Atlas - The OG and absolute lad creator
* ARandomKiwi - Creator of the wonderous and incredible AT++ content
* FG_Remastered - Seeming PR overlord, diplomat, and endless source of ideas and support
* lazycooken - Jumpstarter and eager supporter
* Winterbloom - Lord of the graphics and xml
* Android Tiers Discord - The endless whirlpool of ideas, assistance, and the home domain

## Contributions

Contributions of any kind - except donated graphics, name lists, and of course bug/play testing - are not accepted for this project. Enjoy and cherish it, but don't feel compelled to support.