﻿using System;
using System.Collections.Generic;
using System.ComponentModel.Design;
using System.IO;
using System.Linq;
using System.Reflection;
using System.Text;
using System.Text.RegularExpressions;
using HarmonyLib;
using RimWorld;
using RimWorld.Planet;
using UnityEngine;
using UnityEngine.UIElements;
using Verse;
using Verse.AI;

namespace CharacterEditor
{
  // Token: 0x02000002 RID: 2
  internal sealed class CEditor
  {
    // Token: 0x06000001 RID: 1 RVA: 0x00002050 File Offset: 0x00000250
    private CEditor()
    {
      ////Log.Message(Reflect.APP_NAME_AND_VERISON + " initializing...");
      CEditor.zufallswert = new System.Random(50);
      CEditor.IsFacialStuffActive = (ModLister.HasActiveModWithName("Facial Stuff 1.0") || ModLister.HasActiveModWithName("Facial Stuff 1.1") || ModLister.HasActiveModWithName("Facial Stuff 1.2"));
      CEditor.IsFacesOfTheRimActive = Extension.HasMID("Capi.FacesOfTheRim");
      CEditor.IsPsychologyActive = (Extension.HasMID("Community.Psychology.UnofficialUpdate") || ModLister.HasActiveModWithName("Psychology (unofficial 1.1/1.2) ") || ModLister.HasActiveModWithName("Psychology"));
      CEditor.IsPersonalitiesActive = Extension.HasMID("hahkethomemah.simplepersonalities");
      CEditor.IsRJWActive = Extension.HasMID("rim.job.world");
      CEditor.IsDualWieldActive = (Extension.HasMID("Roolo.DualWield") || ModLister.HasActiveModWithName("Dual Wield"));
      CEditor.IsFacialAnimationActive = (Extension.HasMID("Nals.FacialAnimation") || ModLister.HasActiveModWithName("[NL] Facial Animation - WIP"));
      CEditor.IsGradientHairActive = (Extension.HasMID("automatic.gradienthair") || ModLister.HasActiveModWithName("Gradient Hair"));
      CEditor.IsAlienRaceActive = (Extension.HasMID("erdelf.HumanoidAlienRaces") || ModLister.HasActiveModWithName("Humanoid Alien Races 2.0") || ModLister.HasActiveModWithName("Humanoid Alien Races"));
      CEditor.IsAVPActive = (Extension.HasMID("Ogliss.AlienVsPredator") || ModLister.HasActiveModWithName("Alien Vs Predator"));
      CEditor.IsCombatExtendedActive = (Extension.HasMID("CETeam.CombatExtended") || ModLister.HasActiveModWithName("Combat Extended"));
      CEditor.IsTerraformRimworldActive = (Extension.HasMID("void.terraformrimworld") || ModLister.HasActiveModWithName("TerraformRimworld"));
      CEditor.IsAgeMattersActive = Extension.HasMID("Troopersmith1.AgeMatters");
      CEditor.IsExtendedUI = false;
      CEditor.bOnMap = true;
      CEditor.IsRandom = false;
      CEditor.DontAsk = false;
      CEditor.PKD = null;
      CEditor.RACE = null;
      CEditor.ListName = "";
      this.data = new CEditor.ModData();
      ////Log.Message("instance created");
    }

    // Token: 0x17000001 RID: 1
    // (get) Token: 0x06000002 RID: 2 RVA: 0x0000224B File Offset: 0x0000044B
    // (set) Token: 0x06000003 RID: 3 RVA: 0x00002252 File Offset: 0x00000452
    internal static CEditor API { get; private set; }

    // Token: 0x17000002 RID: 2
    // (get) Token: 0x06000004 RID: 4 RVA: 0x0000225A File Offset: 0x0000045A
    internal static WindowLayer Layer
    {
      get
      {
        return WindowLayer.SubSuper;
      }
    }

    // Token: 0x17000003 RID: 3
    // (get) Token: 0x06000005 RID: 5 RVA: 0x0000225D File Offset: 0x0000045D
    // (set) Token: 0x06000006 RID: 6 RVA: 0x00002264 File Offset: 0x00000464
    internal static bool IsFacialStuffActive { get; private set; }

    // Token: 0x17000004 RID: 4
    // (get) Token: 0x06000007 RID: 7 RVA: 0x0000226C File Offset: 0x0000046C
    // (set) Token: 0x06000008 RID: 8 RVA: 0x00002273 File Offset: 0x00000473
    internal static bool IsFacesOfTheRimActive { get; private set; }

    // Token: 0x17000005 RID: 5
    // (get) Token: 0x06000009 RID: 9 RVA: 0x0000227B File Offset: 0x0000047B
    // (set) Token: 0x0600000A RID: 10 RVA: 0x00002282 File Offset: 0x00000482
    internal static bool IsPsychologyActive { get; private set; }

    // Token: 0x17000006 RID: 6
    // (get) Token: 0x0600000B RID: 11 RVA: 0x0000228A File Offset: 0x0000048A
    // (set) Token: 0x0600000C RID: 12 RVA: 0x00002291 File Offset: 0x00000491
    internal static bool IsPersonalitiesActive { get; private set; }

    // Token: 0x17000007 RID: 7
    // (get) Token: 0x0600000D RID: 13 RVA: 0x00002299 File Offset: 0x00000499
    // (set) Token: 0x0600000E RID: 14 RVA: 0x000022A0 File Offset: 0x000004A0
    internal static bool IsRJWActive { get; private set; }

    // Token: 0x17000008 RID: 8
    // (get) Token: 0x0600000F RID: 15 RVA: 0x000022A8 File Offset: 0x000004A8
    // (set) Token: 0x06000010 RID: 16 RVA: 0x000022AF File Offset: 0x000004AF
    internal static bool IsDualWieldActive { get; private set; }

    internal static bool IsFacialAnimationActive { get; private set; }

    internal static bool IsGradientHairActive { get; private set; }

    internal static bool IsAlienRaceActive { get; private set; }

    internal static bool IsAVPActive { get; private set; }

    internal static bool IsCombatExtendedActive { get; private set; }

    // Token: 0x1700000E RID: 14
    // (get) Token: 0x0600001B RID: 27 RVA: 0x00002302 File Offset: 0x00000502
    // (set) Token: 0x0600001C RID: 28 RVA: 0x00002309 File Offset: 0x00000509
    internal static bool IsTerraformRimworldActive { get; private set; }

    // Token: 0x1700000F RID: 15
    // (get) Token: 0x0600001D RID: 29 RVA: 0x00002311 File Offset: 0x00000511
    // (set) Token: 0x0600001E RID: 30 RVA: 0x00002318 File Offset: 0x00000518
    internal static bool IsAgeMattersActive { get; private set; }

    // Token: 0x17000010 RID: 16
    // (get) Token: 0x0600001F RID: 31 RVA: 0x00002320 File Offset: 0x00000520
    // (set) Token: 0x06000020 RID: 32 RVA: 0x00002327 File Offset: 0x00000527
    internal static bool IsExtendedUI { get; set; }

    // Token: 0x17000011 RID: 17
    // (get) Token: 0x06000021 RID: 33 RVA: 0x0000232F File Offset: 0x0000052F
    internal static bool InStartingScreen
    {
      get
      {
        return Current.ProgramState != ProgramState.Playing;
      }
    }

    // Token: 0x17000012 RID: 18
    // (get) Token: 0x06000022 RID: 34 RVA: 0x0000233C File Offset: 0x0000053C
    // (set) Token: 0x06000023 RID: 35 RVA: 0x0000234D File Offset: 0x0000054D
    internal static bool OnMap
    {
      get
      {
        return !CEditor.InStartingScreen && CEditor.bOnMap;
      }
      set
      {
        CEditor.bOnMap = value;
      }
    }

    // Token: 0x17000013 RID: 19
    // (get) Token: 0x06000024 RID: 36 RVA: 0x00002356 File Offset: 0x00000556
    // (set) Token: 0x06000025 RID: 37 RVA: 0x0000235D File Offset: 0x0000055D
    internal static bool IsRandom { get; private set; }

    // Token: 0x17000014 RID: 20
    // (get) Token: 0x06000026 RID: 38 RVA: 0x00002365 File Offset: 0x00000565
    // (set) Token: 0x06000027 RID: 39 RVA: 0x0000236C File Offset: 0x0000056C
    internal static bool DontAsk { get; set; }

    // Token: 0x17000015 RID: 21
    // (get) Token: 0x06000028 RID: 40 RVA: 0x00002374 File Offset: 0x00000574
    // (set) Token: 0x06000029 RID: 41 RVA: 0x0000237B File Offset: 0x0000057B
    internal static PawnKindDef PKD { get; private set; }

    // Token: 0x17000016 RID: 22
    // (get) Token: 0x0600002A RID: 42 RVA: 0x00002383 File Offset: 0x00000583
    // (set) Token: 0x0600002B RID: 43 RVA: 0x0000238A File Offset: 0x0000058A
    internal static ThingDef RACE { get; private set; }

    // Token: 0x17000017 RID: 23
    // (get) Token: 0x0600002C RID: 44 RVA: 0x00002392 File Offset: 0x00000592
    internal static Func<ThingDef, string> RACENAME
    {
      get
      {
        return (ThingDef s) => (s == null) ? Label.ALL : ((s.label == null) ? "" : s.LabelCap.ToString());
      }
    }

    // Token: 0x17000018 RID: 24
    // (get) Token: 0x0600002D RID: 45 RVA: 0x000023B3 File Offset: 0x000005B3
    internal static Func<ThingDef, string> RACEDESC
    {
      get
      {
        return (ThingDef s) => (s != null && s.description != null) ? s.description : "";
      }
    }

    // Token: 0x17000019 RID: 25
    // (get) Token: 0x0600002E RID: 46 RVA: 0x000023D4 File Offset: 0x000005D4
    internal static Func<PawnKindDef, string> PKDNAME
    {
      get
      {
        return (PawnKindDef s) => (s == null) ? Label.ALL : ((s.label == null) ? "" : s.LabelCap.ToString());
      }
    }

    // Token: 0x1700001A RID: 26
    // (get) Token: 0x0600002F RID: 47 RVA: 0x000023F5 File Offset: 0x000005F5
    internal static Func<PawnKindDef, string> PKDTOOLTIP
    {
      get
      {
        return (PawnKindDef s) => (s != null && s.description != null) ? s.description : "";
      }
    }

    // Token: 0x1700001B RID: 27
    // (get) Token: 0x06000030 RID: 48 RVA: 0x00002416 File Offset: 0x00000616
    // (set) Token: 0x06000031 RID: 49 RVA: 0x0000241D File Offset: 0x0000061D
    internal static string ListName { get; set; }

    // Token: 0x1700001C RID: 28
    // (get) Token: 0x06000032 RID: 50 RVA: 0x00002425 File Offset: 0x00000625
    internal int NumSlots
    {
      get
      {
        return this.data.Get<CEditor.ModOptions>(EType.Settings).Get(OptionI.NUMPAWNSLOTS);
      }
    }

    // Token: 0x1700001D RID: 29
    // (get) Token: 0x06000033 RID: 51 RVA: 0x0000243A File Offset: 0x0000063A
    internal int NumCapsuleSlots
    {
      get
      {
        return this.data.Get<CEditor.ModOptions>(EType.Settings).Get(OptionI.NUMCAPSULESETS);
      }
    }

    // Token: 0x1700001E RID: 30
    // (get) Token: 0x06000034 RID: 52 RVA: 0x0000244F File Offset: 0x0000064F
    internal int MaxSliderVal
    {
      get
      {
        return this.data.Get<CEditor.ModOptions>(EType.Settings).Get(OptionI.STACKLIMIT);
      }
    }

    // Token: 0x1700001F RID: 31
    // (get) Token: 0x06000035 RID: 53 RVA: 0x00002464 File Offset: 0x00000664
    // (set) Token: 0x06000036 RID: 54 RVA: 0x00002474 File Offset: 0x00000674
    internal Pawn Pawn
    {
      get
      {
        return this.data.p;
      }
      set
      {
        this.data.p = value;
        bool flag = !CEditor.InStartingScreen;
        if (flag)
        {
          bool flag2 = value != null && value.Spawned;
          if (flag2)
          {
            Selector selector = Find.Selector;
            if (selector != null)
            {
              selector.ClearSelection();
            }
            Selector selector2 = Find.Selector;
            if (selector2 != null)
            {
              selector2.Select(value, true, true);
            }
          }
          else
          {
            Selector selector3 = Find.Selector;
            if (selector3 != null)
            {
              selector3.ClearSelection();
            }
          }
        }
        this.data.UpdateGraphics();
      }
    }

    // Token: 0x06000037 RID: 55 RVA: 0x000024F4 File Offset: 0x000006F4
    internal void UpdateGraphics()
    {
      this.data.UpdateGraphics();
    }

    // Token: 0x17000020 RID: 32
    // (get) Token: 0x06000038 RID: 56 RVA: 0x00002502 File Offset: 0x00000702
    internal int EditorPosX
    {
      get
      {
        return (int)this.data.Get<CEditor.EditorUI>(EType.EditorUI).windowRect.position.x;
      }
    }

    // Token: 0x17000021 RID: 33
    // (get) Token: 0x06000039 RID: 57 RVA: 0x00002520 File Offset: 0x00000720
    internal int EditorPosY
    {
      get
      {
        return (int)this.data.Get<CEditor.EditorUI>(EType.EditorUI).windowRect.position.y;
      }
    }

    // Token: 0x0600003A RID: 58 RVA: 0x00002540 File Offset: 0x00000740
    internal void EditorMoveRight()
    {
      this.data.Get<CEditor.EditorUI>(EType.EditorUI).windowRect.position = new Vector2((float)(UI.screenWidth / 2 + 200), (float)(UI.screenHeight / 2) - this.data.Get<CEditor.EditorUI>(EType.EditorUI).InitialSize.y / 2f);
    }

    // Token: 0x0600003B RID: 59 RVA: 0x0000259C File Offset: 0x0000079C
    internal void OnSettingsChanged(bool updateRender = false, bool updateKeyCode = false)
    {
      this.data.OnSettingsChanged(updateRender, updateKeyCode);
    }

    // Token: 0x0600003C RID: 60 RVA: 0x000025AC File Offset: 0x000007AC
    internal void ConfigEditor()
    {
      this.data.Get<CEditor.ModOptions>(EType.Settings).Configurate();
    }

    // Token: 0x0600003D RID: 61 RVA: 0x000025C1 File Offset: 0x000007C1
    internal void CloseEditor()
    {
      this.data.Get<CEditor.EditorUI>(EType.EditorUI).Close(true);
    }

    // Token: 0x0600003E RID: 62 RVA: 0x000025D6 File Offset: 0x000007D6
    internal void StartEditor(Pawn pawn = null)
    {
      //Log.Message("CEditor, start editor");
      this.data.StartEditor(pawn);
    }

    // Token: 0x0600003F RID: 63 RVA: 0x000025E5 File Offset: 0x000007E5
    internal void Toggle(OptionB b)
    {
      this.data.Get<CEditor.ModOptions>(EType.Settings).Toggle(b);
      this.data.UpdateUIParameter();
    }

    // Token: 0x06000040 RID: 64 RVA: 0x00002608 File Offset: 0x00000808
    internal bool Has(EType t)
    {
      return this.data.Has(t);
    }

    // Token: 0x06000041 RID: 65 RVA: 0x00002616 File Offset: 0x00000816
    internal T Get<T>(EType t)
    {
      return this.data.Get<T>(t);
    }

    // Token: 0x06000042 RID: 66 RVA: 0x00002624 File Offset: 0x00000824
    internal List<T> ListOf<T>(EType t)
    {
      List<T> result = this.data.ListOf<T>(t);
      if (result.NullOrEmpty())
      {
        return result;
      }
      if (typeof(T) == typeof(Def) || typeof(T).IsSubclassOf(typeof(Def)))
      {
        result.OrderBy(t => (t as Def).label ?? "").ThenBy(t => (t as Def).defName);
      }
      else if (typeof(T) == typeof(string))
      {
        result.Sort();
      }
      return result;
    }

    //internal List<T> ListOf<T>(EType t)
    //{
    //  return this.data.ListOf<T>(t);
    //}

    // Token: 0x06000043 RID: 67 RVA: 0x00002632 File Offset: 0x00000832
    internal bool GetO(OptionB b)
    {
      return this.data.Get<CEditor.ModOptions>(EType.Settings).Get(b);
    }

    // Token: 0x06000044 RID: 68 RVA: 0x00002647 File Offset: 0x00000847
    internal string GetSlot(int i)
    {
      return this.data.Get<CEditor.ModOptions>(EType.Settings).GetSlot(i);
    }

    // Token: 0x06000045 RID: 69 RVA: 0x0000265C File Offset: 0x0000085C
    internal void SetSlot(int i, string val, bool andSave)
    {
      this.data.Get<CEditor.ModOptions>(EType.Settings).SetSlot(i, val, andSave);
    }

    // Token: 0x06000046 RID: 70 RVA: 0x00002674 File Offset: 0x00000874
    internal string GetCustom(OptionS s)
    {
      return (s == OptionS.CUSTOMARMOR || s == OptionS.CUSTOMITEM || s == OptionS.CUSTOMWEAPON) ? this.data.Get<CEditor.ModOptions>(EType.Settings).Get(s) : null;
    }

    // Token: 0x06000047 RID: 71 RVA: 0x00002698 File Offset: 0x00000898
    internal void SetCustom(OptionS option, string val, string defName)
    {
      this.data.Get<CEditor.ModOptions>(EType.Settings).SetCustom(option, val, defName);
    }

    // Token: 0x06000048 RID: 72 RVA: 0x000026B0 File Offset: 0x000008B0
    internal List<StatDef> ListOfStatDef(StatCategoryDef s, bool isWeapon, bool isEquip)
    {
      List<StatDef> result;
      if (s == null)
      {
        if (isEquip)
        {
          result = this.data.ListOf<StatDef>(EType.StatDefOnEquip);
        }
        else if (isWeapon)
        {
          result = this.data.ListOf<StatDef>(EType.StatDefWeapon);
        }
        else
        {
          result = this.data.ListOf<StatDef>(EType.StatDefApparel);
        }
      }
      else
      {
        result = new List<StatDef>();
        foreach (StatDef statDef in DefDatabase<StatDef>.AllDefs)
        {
          if (statDef.category == s)
          {
            result.Add(statDef);
          }
        }
      }
      return result;
    }

    // Token: 0x06000049 RID: 73 RVA: 0x0000276C File Offset: 0x0000096C
    internal static void Initialize(Mod mod)
    {
      CEditor.pack = mod.Content;
      Harmony harmony = new Harmony("rimworld.mod.charactereditor");
      harmony.PatchAll(Assembly.GetExecutingAssembly());
      harmony.Patch(AccessTools.Method(typeof(Page_ConfigureStartingPawns), "DrawPortraitArea", null, null), null, new HarmonyMethod(typeof(CEditor), "AddCharacterEditorButton", null), null, null);
      harmony.Patch(AccessTools.Method(typeof(Dialog_AdvancedGameConfig), "DoWindowContents", null, null), null, new HarmonyMethod(typeof(CEditor), "AddMapSizeSlider", null), null, null);
      harmony.Patch(AccessTools.Method(typeof(MainMenuDrawer), "Init", null, null), null, new HarmonyMethod(typeof(CEditor), "OnMainMenuInit", null), null, null);
      harmony.Patch(AccessTools.Method(typeof(UIRoot_Entry), "DoMainMenu", null, null), null, new HarmonyMethod(typeof(CEditor), "OnDoingMainMenu", null), null, null);
      harmony.Patch(AccessTools.Method(typeof(Map), "FinalizeInit", null, null), null, new HarmonyMethod(typeof(CEditor), "OnMapLoaded", null), null, null);
    }

    // Token: 0x0600004A RID: 74 RVA: 0x000028A8 File Offset: 0x00000AA8
    private static void OnDoingMainMenu()
    {
      bool flag = Label.currentLanguage != LanguageDatabase.activeLanguage.FriendlyNameEnglish.ToLower();
      if (flag)
      {
        CEditor.API.data.ReInitSettings();
      }
    }

    // Token: 0x0600004B RID: 75 RVA: 0x000028E4 File Offset: 0x00000AE4
    private static void CheckAddButton()
    {
      try
      {
        object memberValue = Find.MainButtonsRoot.GetMemberValue("allButtonsInOrder");
        bool flag = memberValue != null;
        if (flag)
        {
          List<MainButtonDef> list = memberValue as List<MainButtonDef>;
          MainButtonDef item = CEditor.API.data.Get<MainButtonDef>(EType.MainButton);
          MainButtonDef item2 = CEditor.API.data.Get<MainButtonDef>(EType.TeleButton);
          bool flag2 = !list.Contains(item);
          if (flag2)
          {
            list.Insert(list.Count - 1, item);
          }
          bool flag3 = !list.Contains(item2);
          if (flag3)
          {
            list.Insert(list.Count - 1, item2);
          }
        }
      }
      catch
      {
        Log.Error("could not add character editor button");
      }
    }

    // Token: 0x0600004C RID: 76 RVA: 0x000029A0 File Offset: 0x00000BA0
    private static void OnMapLoaded()
    {
      CEditor.CheckAddButton();
      CEditor.API.OnSettingsChanged(false, true);
    }

    // Token: 0x0600004D RID: 77 RVA: 0x000029B8 File Offset: 0x00000BB8
    private static void OnMainMenuInit()
    {
      bool flag = CEditor.API == null;
      if (flag)
      {
        CEditor.API = new CEditor();
      }
      bool flag2 = CEditor.API == null;
      if (flag2)
      {
        Log.Error("failed to create instance for character editor!");
      }
      else
      {
        ApparelTool.AllowApparelToBeColorable();
        CEditor.API.OnSettingsChanged(false, true);
        ////Log.Message(Reflect.APP_NAME_AND_VERISON + " ...done");
      }
    }

    // Token: 0x0600004E RID: 78 RVA: 0x00002A20 File Offset: 0x00000C20
    private static void AddCharacterEditorButton(Page_ConfigureStartingPawns __instance, Rect rect)
    {
      CEditor.pstartInstance = __instance;
      bool flag = Widgets.ButtonText(new Rect(rect.x + rect.width - 280f, rect.y + 624f, 150f, 38f), Label.O_CHARACTEREDITORUI, true, true, true);
      if (flag)
      {
        //Log.Message("AddCharacterEditorButton, button pressed");
        CEditor.API.StartEditor(null);
      }
    }

    // Token: 0x0600004F RID: 79 RVA: 0x00002A84 File Offset: 0x00000C84
    private static void AddMapSizeSlider(Dialog_AdvancedGameConfig __instance, Rect inRect)
    {
      bool o = CEditor.API.GetO(OptionB.SHOWMAPVARS);
      if (o)
      {
        Listing_X listing_X = new Listing_X();
        listing_X.Begin(new Rect(0f, 280f, 655f, 150f));
        try
        {
          string text = "";
          listing_X.AddIntSection("MapSize".Translate(), "", ref text, ref Find.GameInitData.mapSize, 30, 1000, true, "");
          bool flag = Find.GameInitData.startingTile >= 0;
          if (flag)
          {
            bool flag2 = CEditor.selectedTile != Find.GameInitData.startingTile;
            if (flag2)
            {
              CEditor.selectedTile = Find.GameInitData.startingTile;
              CEditor.pDensity = Find.WorldGrid[Find.GameInitData.startingTile].biome.plantDensity;
              CEditor.aDensity = Find.WorldGrid[Find.GameInitData.startingTile].biome.animalDensity;
            }
            listing_X.AddSection(Label.PLANTDENSITY, "", ref text, ref CEditor.pDensity, 0f, 100f, true, "");
            listing_X.AddSection(Label.ANIMALDENSITY, "", ref text, ref CEditor.aDensity, 0f, 100f, true, "");
            bool flag3 = CEditor.selectedTile == Find.GameInitData.startingTile && CEditor.selectedTile >= 0;
            if (flag3)
            {
              Find.WorldGrid[CEditor.selectedTile].biome.plantDensity = CEditor.pDensity;
              Find.WorldGrid[CEditor.selectedTile].biome.animalDensity = CEditor.aDensity;
            }
          }
        }
        catch
        {
        }
        listing_X.End();
      }
    }

    // Token: 0x04000001 RID: 1
    private static ModContentPack pack;

    // Token: 0x04000002 RID: 2
    private CEditor.ModData data;

    // Token: 0x04000004 RID: 4
    internal static System.Random zufallswert;

    // Token: 0x04000013 RID: 19
    private static bool bOnMap;

    // Token: 0x04000019 RID: 25
    private static float pDensity = 1f;

    // Token: 0x0400001A RID: 26
    private static float aDensity = 1f;

    // Token: 0x0400001B RID: 27
    private static int selectedTile = -1;

    // Token: 0x0400001C RID: 28
    private static Page_ConfigureStartingPawns pstartInstance = null;

    // Token: 0x02000061 RID: 97
    private sealed class ModOptions : ModSettings
    {
      private string PATH_MODDIR { get; set; }

      private string PATH_SETTINGS
      {
        get
        {
          return this.PATH_MODDIR + Path.DirectorySeparatorChar.ToString() + "options.txt";
        }
      }

      // Token: 0x17000077 RID: 119
      // (get) Token: 0x06000682 RID: 1666 RVA: 0x00043430 File Offset: 0x00041630
      private string PATH_PAWNS
      {
        get
        {
          return this.PATH_MODDIR + Path.DirectorySeparatorChar.ToString() + "pawnslots.txt";
        }
      }

      // Token: 0x06000683 RID: 1667 RVA: 0x0004345A File Offset: 0x0004165A
      internal ModOptions()
      {
        this.ReInit();
      }

      // Token: 0x06000684 RID: 1668 RVA: 0x0004346C File Offset: 0x0004166C
      internal void ReInit()
      {
        this.PATH_MODDIR = GenFilePaths.ConfigFolderPath.Replace("Config", "CharacterEditor");
        FileIO.CheckOrCreateDir(this.PATH_MODDIR);
        this.dicSlots = new Dictionary<int, string>();
        this.dicString = new Dictionary<OptionS, CEditor.ModOptions.SData>();
        this.dicInt = new Dictionary<OptionI, CEditor.ModOptions.IData>();
        this.dicBool = new Dictionary<OptionB, CEditor.ModOptions.BData>();
        Label.UpdateLabels();
        this.Load(this.PATH_SETTINGS);
        this.LoadSlots(this.PATH_PAWNS);
        this.UpdateNumSlots();
        this.UpdatingCustoms();
      }

      // Token: 0x06000685 RID: 1669 RVA: 0x000434FC File Offset: 0x000416FC
      private void RescueOldPawns()
      {
        string text = Path.GetDirectoryName(GenFilePaths.ConfigFolderPath.SubstringBackwardTo(Path.DirectorySeparatorChar.ToString(), true) + Path.DirectorySeparatorChar.ToString() + "HugsLib");
        text = text + Path.DirectorySeparatorChar.ToString() + "ModSettings.xml";
        bool flag = !FileIO.Exists(text);
        if (!flag)
        {
          try
          {
            string text2 = FileIO.ReadFile(text).AsString(Encoding.UTF8);
            text2 = text2.SubstringFrom("<P_CE_CustomPawn", true).SubstringTo("</CharacterEditor>", true);
            bool flag2 = !text2.NullOrEmpty();
            if (flag2)
            {
              string[] array = text2.SplitNo("<P_CE_CustomPawn");
              bool flag3 = array.Length != 0;
              if (flag3)
              {
                foreach (string text3 in array)
                {
                  string input = text3.SubstringFrom("CustomPawn", true).SubstringTo(">", true);
                  string val = text3.SubstringFrom(">", true).SubstringTo("<", true);
                  int id = input.AsInt32();
                  this.SetSlot(id, val, false);
                }
                ////Log.Message("old pawn slots imported");
              }
            }
          }
          catch
          {
          }
        }
      }

      // Token: 0x06000686 RID: 1670 RVA: 0x00043654 File Offset: 0x00041854
      private void Load(string filepath)
      {
        bool flag = FileIO.Exists(filepath);
        string text;
        if (flag)
        {
          text = FileIO.ReadFile(filepath).AsString(Encoding.UTF8);
        }
        else
        {
          text = "\n\n\n\n\n\n";
        }
        bool flag2 = text.NullOrEmpty();
        if (flag2)
        {
          text = "\n\n\n\n\n\n";
        }
        string[] array = text.SplitNo("\n");
        for (int i = 0; i < array.Length; i++)
        {
          bool flag3 = i == 0;
          if (flag3)
          {
            this.LoadBoolSettings(array[i]);
          }
          bool flag4 = i == 1;
          if (flag4)
          {
            this.LoadIntSettings(array[i]);
          }
          bool flag5 = i == 2;
          if (flag5)
          {
            this.LoadStringSettings(array[i]);
          }
          bool flag6 = i == 3;
          if (flag6)
          {
            this.dicString.Add(OptionS.CUSTOMARMOR, new CEditor.ModOptions.SData(Label.O_SAVEDARMORCHANGES, Label.O_DESC_SAVEDARMORCHANGES, array[i], ""));
          }
          bool flag7 = i == 4;
          if (flag7)
          {
            this.dicString.Add(OptionS.CUSTOMWEAPON, new CEditor.ModOptions.SData(Label.O_SAVEDWEAPONCHANGES, Label.O_DESC_SAVEDWEAPONCHANGES, array[i], ""));
          }
          bool flag8 = i == 5;
          if (flag8)
          {
            this.dicString.Add(OptionS.CUSTOMITEM, new CEditor.ModOptions.SData(Label.O_SAVEDITEMCHANGES, Label.O_DESC_SAVEDITEMCHANGES, array[i], ""));
          }
        }
        bool flag9 = !FileIO.Exists(filepath);
        if (flag9)
        {
          this.SaveSettings();
        }
      }

      // Token: 0x06000687 RID: 1671 RVA: 0x000437BC File Offset: 0x000419BC
      private void LoadSlots(string filepath)
      {
        string text = "";
        try
        {
          bool flag = FileIO.Exists(filepath);
          if (flag)
          {
            text = FileIO.ReadFile(filepath).AsString(Encoding.UTF8);
          }
        }
        catch
        {
        }
        this.bDoRescue = text.NullOrEmpty();
        bool flag2 = text == null;
        if (flag2)
        {
          text = "";
        }
        string[] array = text.SplitNo("\n");
        this.dicSlots = new Dictionary<int, string>();
        CEditor.ModOptions.IData value = this.dicInt.GetValue(OptionI.NUMPAWNSLOTS);
        int num = (value != null) ? value.Value : 0;
        for (int i = 0; i < num; i++)
        {
          this.dicSlots.Add(i, (!text.NullOrEmpty() && array.Length >= i + 1) ? array[i] : "");
        }
        bool flag3 = this.bDoRescue;
        if (flag3)
        {
          this.RescueOldPawns();
        }
        bool flag4 = !FileIO.Exists(filepath);
        if (flag4)
        {
          this.SaveSlots();
        }
      }

      // Token: 0x06000688 RID: 1672 RVA: 0x000438BC File Offset: 0x00041ABC
      private string PawnSlotsToString()
      {
        string text = "";
        foreach (int key in this.dicSlots.Keys)
        {
          text = text + this.dicSlots[key] + "\n";
        }
        return text;
      }

      // Token: 0x06000689 RID: 1673 RVA: 0x00043934 File Offset: 0x00041B34
      private void LoadStringSettings(string line)
      {
        string[] array = line.SplitNo("|");
        this.dicString = new Dictionary<OptionS, CEditor.ModOptions.SData>();
        this.dicString.Add(OptionS.HOTKEYEDITOR, new CEditor.ModOptions.SData(Label.O_HOTKEYEDITOR, Label.O_DESC_HOTKEYEDITOR, (!line.NullOrEmpty() && array.Length >= 1) ? array[0] : "None", "None"));
        this.dicString.Add(OptionS.HOTKEYTELEPORT, new CEditor.ModOptions.SData(Label.O_HOTKEYTELEPORT, Label.O_DESC_HOTKEYTELEPORT, (array.Length >= 2) ? array[1] : "None", "None"));
      }

      // Token: 0x0600068A RID: 1674 RVA: 0x000439C4 File Offset: 0x00041BC4
      private string StringSettingsToString()
      {
        string text = "";
        int num = 2;
        foreach (OptionS key in this.dicString.Keys)
        {
          bool flag = num > 0;
          if (flag)
          {
            text = text + this.dicString[key].Value + "|";
          }
          num--;
        }
        text += "\n";
        text = text + this.dicString[OptionS.CUSTOMARMOR].Value + "\n";
        text = text + this.dicString[OptionS.CUSTOMWEAPON].Value + "\n";
        text = text + this.dicString[OptionS.CUSTOMITEM].Value + "\n";
        return text;
      }

      // Token: 0x0600068B RID: 1675 RVA: 0x00043AB8 File Offset: 0x00041CB8
      private void LoadIntSettings(string line)
      {
        string[] array = line.SplitNo("|");
        this.dicInt = new Dictionary<OptionI, CEditor.ModOptions.IData>();
        this.dicInt.Add(OptionI.RESOLUTION, new CEditor.ModOptions.IData(Label.O_RESOLUTION, Label.O_DESC_RESOLUTION, (!line.NullOrEmpty() && array.Length >= 1) ? array[0].AsInt32() : 800, 800));
        this.dicInt.Add(OptionI.STACKLIMIT, new CEditor.ModOptions.IData(Label.O_STACKLIMIT, Label.O_DESC_STACKLIMIT, (array.Length >= 2) ? array[1].AsInt32() : 100, 100));
        this.dicInt.Add(OptionI.NUMCAPSULESETS, new CEditor.ModOptions.IData(Label.O_NUMCAPSULE, Label.O_DESC_NUMCAPSULE, (array.Length >= 3) ? array[2].AsInt32() : 10, 10));
        this.dicInt.Add(OptionI.NUMPAWNSLOTS, new CEditor.ModOptions.IData(Label.O_NUMSLOTS, Label.O_DESC_NUMSLOTS, (array.Length >= 4) ? array[3].AsInt32() : 90, 90));
      }

      // Token: 0x0600068C RID: 1676 RVA: 0x00043BAC File Offset: 0x00041DAC
      private string IntSettingsToString()
      {
        string str = "";
        foreach (OptionI key in this.dicInt.Keys)
        {
          str = str + this.dicInt[key].Value.ToString() + "|";
        }
        return str + "\n";
      }

      // Token: 0x0600068D RID: 1677 RVA: 0x00043C38 File Offset: 0x00041E38
      private void LoadBoolSettings(string line)
      {
        string[] array = line.SplitNo("|");
        this.dicBool = new Dictionary<OptionB, CEditor.ModOptions.BData>();
        this.dicBool.Add(OptionB.HDRARGB, new CEditor.ModOptions.BData(Label.O_HDR, Label.O_DESC_HDR, line.NullOrEmpty() || array.Length < 1 || array[0].AsBoolWithDefault(true), true));
        this.dicBool.Add(OptionB.CREATERACESPECIFIC, new CEditor.ModOptions.BData(Label.O_CREATERACESPECIFIC, Label.O_DESC_CREATERACESPECIFIC, array.Length < 2 || array[1].AsBoolWithDefault(true), true));
        this.dicBool.Add(OptionB.CREATENUDE, new CEditor.ModOptions.BData(Label.O_CREATENUDE, Label.O_DESC_CREATENUDE, array.Length >= 3 && array[2].AsBoolWithDefault(false), false));
        this.dicBool.Add(OptionB.CREATENOWEAPON, new CEditor.ModOptions.BData(Label.O_CREATENOWEAPON, Label.O_DESC_CREATENOWEAPON, array.Length >= 4 && array[3].AsBoolWithDefault(false), false));
        this.dicBool.Add(OptionB.CREATENOINV, new CEditor.ModOptions.BData(Label.O_CREATENOINV, Label.O_DESC_CREATENOINV, array.Length >= 5 && array[4].AsBoolWithDefault(false), false));
        this.dicBool.Add(OptionB.PAUSEGAME, new CEditor.ModOptions.BData(Label.O_PAUSEGAME, Label.O_DESC_PAUSEGAME, array.Length < 6 || array[5].AsBoolWithDefault(true), true));
        this.dicBool.Add(OptionB.SHOWTABS, new CEditor.ModOptions.BData(Label.O_EDITTABS, Label.O_DESC_EDITTABS, array.Length < 7 || array[6].AsBoolWithDefault(true), true));
        this.dicBool.Add(OptionB.SHOWPAWNLIST, new CEditor.ModOptions.BData(Label.O_PAWNLIST, Label.O_DESC_PAWNLIST, array.Length < 8 || array[7].AsBoolWithDefault(true), true));
        this.dicBool.Add(OptionB.SHOWMINI, new CEditor.ModOptions.BData(Label.O_MINI, Label.O_DESC_MINI, array.Length >= 9 && array[8].AsBoolWithDefault(false), false));
        this.dicBool.Add(OptionB.SHOWINMENU, new CEditor.ModOptions.BData(Label.O_SHOWINMAINTABS, Label.O_DESC_SHOWINMAINTABS, array.Length < 10 || array[9].AsBoolWithDefault(true), true));
        this.dicBool.Add(OptionB.ZOMBOBJECTS, new CEditor.ModOptions.BData(Label.O_DISABLEOBJ, Label.O_DESC_DISABLEOBJ, array.Length < 11 || array[10].AsBoolWithDefault(true), true));
        this.dicBool.Add(OptionB.SHOWMAPVARS, new CEditor.ModOptions.BData(Label.O_MAPSIZE, Label.O_DESC_MAPSIZE, array.Length >= 12 && array[11].AsBoolWithDefault(false), false));
        this.dicBool.Add(OptionB.DOAPPARELCHECK, new CEditor.ModOptions.BData(Label.O_DOAPPARELCHECK, Label.O_DESC_DOAPPARELCHECK, array.Length < 13 || array[12].AsBoolWithDefault(true), true));
        this.dicBool.Add(OptionB.STAYINCASCET, new CEditor.ModOptions.BData(Label.O_STAYINCASCET, Label.O_DESC_STAYINCASCET, array.Length >= 14 && array[13].AsBoolWithDefault(false), false));
        this.dicBool.Add(OptionB.SHOWDEADLOGO, new CEditor.ModOptions.BData(Label.O_SHOWDEADLOGO, Label.O_DESC_SHOWDEADLOGO, array.Length < 15 || array[14].AsBoolWithDefault(true), true));
        this.dicBool.Add(OptionB.USESORTEDPAWNLIST, new CEditor.ModOptions.BData(Label.O_USESORTEDPAWNLIST, Label.O_DESC_SORTEDPAWNLIST, array.Length < 16 || array[15].AsBoolWithDefault(true), true));
        this.dicBool.Add(OptionB.MOREPAWNNAMES, new CEditor.ModOptions.BData(Label.O_MOREPAWNNAMES, Label.O_DESC_MOREPAWNNAMES, array.Length < 17 || array[16].AsBoolWithDefault(true), true));
        this.dicBool.Add(OptionB.USECHAOSABILITY, new CEditor.ModOptions.BData(Label.O_CHAOSABILITY, Label.O_DESC_CHAOSABILITY, array.Length < 18 || array[17].AsBoolWithDefault(true), true));
      }

      // Token: 0x0600068E RID: 1678 RVA: 0x00043FD0 File Offset: 0x000421D0
      private string BoolSettingsToString()
      {
        string str = "";
        foreach (OptionB key in this.dicBool.Keys)
        {
          str = str + (this.dicBool[key].Value ? "1" : "0") + "|";
        }
        return str + "\n";
      }

      // Token: 0x0600068F RID: 1679 RVA: 0x00044064 File Offset: 0x00042264
      private void UpdatingCustoms()
      {
        try
        {
          ////Log.Message("loading/updating customs...");
          PresetApparel.LoadCustomString(this.dicString[OptionS.CUSTOMARMOR].Value);
          PresetWeapon.LoadCustomString(this.dicString[OptionS.CUSTOMWEAPON].Value);
          PresetItem.LoadCustomString(this.dicString[OptionS.CUSTOMITEM].Value);
        }
        catch (Exception ex)
        {
          Log.Error(ex.StackTrace);
        }
      }

      // Token: 0x06000690 RID: 1680 RVA: 0x000440E8 File Offset: 0x000422E8
      private void UpdateNumSlots()
      {
        try
        {
          ////Log.Message("loading/updating slots...");
          int value = this.dicInt[OptionI.NUMPAWNSLOTS].Value;
          bool flag = this.dicSlots.Count < value;
          if (flag)
          {
            for (int i = 0; i < value; i++)
            {
              bool flag2 = !this.dicSlots.ContainsKey(i);
              if (flag2)
              {
                this.dicSlots.Add(i, "");
              }
            }
          }
          else
          {
            bool flag3 = this.dicSlots.Count > value;
            if (flag3)
            {
              int count = this.dicSlots.Count;
              for (int j = count; j > 0; j--)
              {
                bool flag4 = j > value;
                if (flag4)
                {
                  this.dicSlots.Remove(j);
                }
              }
            }
          }
        }
        catch (Exception ex)
        {
          Log.Error(ex.StackTrace);
        }
      }

      // Token: 0x06000691 RID: 1681 RVA: 0x000441E0 File Offset: 0x000423E0
      private void SaveSettings()
      {
        FileIO.CheckOrCreateDir(this.PATH_MODDIR);
        string text = this.BoolSettingsToString() + this.IntSettingsToString() + this.StringSettingsToString();
        FileIO.WriteFile(this.PATH_SETTINGS, text.AsBytes(Encoding.UTF8));
        this.UpdateNumSlots();
      }

      // Token: 0x06000692 RID: 1682 RVA: 0x00044230 File Offset: 0x00042430
      private void SaveSlots()
      {
        FileIO.CheckOrCreateDir(this.PATH_MODDIR);
        string text = this.PawnSlotsToString();
        FileIO.WriteFile(this.PATH_PAWNS, text.AsBytes(Encoding.UTF8));
      }

      // Token: 0x06000693 RID: 1683 RVA: 0x00044268 File Offset: 0x00042468
      internal void Configurate()
      {
        WindowTool.Open(new CEditor.ModOptions.DialogConfigurate());
      }

      // Token: 0x06000694 RID: 1684 RVA: 0x00044275 File Offset: 0x00042475
      public override void ExposeData()
      {
      }

      // Token: 0x06000695 RID: 1685 RVA: 0x00044278 File Offset: 0x00042478
      internal bool Get(OptionB option)
      {
        return this.dicBool[option].Value;
      }

      // Token: 0x06000696 RID: 1686 RVA: 0x0004428B File Offset: 0x0004248B
      internal int Get(OptionI option)
      {
        return this.dicInt[option].Value;
      }

      // Token: 0x06000697 RID: 1687 RVA: 0x0004429E File Offset: 0x0004249E
      internal string Get(OptionS option)
      {
        return this.dicString[option].Value;
      }

      // Token: 0x06000698 RID: 1688 RVA: 0x000442B1 File Offset: 0x000424B1
      internal string GetSlot(int id)
      {
        return this.dicSlots.GetValue(id);
      }

      // Token: 0x06000699 RID: 1689 RVA: 0x000442C0 File Offset: 0x000424C0
      internal void SetSlot(int id, string val, bool andSave)
      {
        bool flag = this.dicSlots.ContainsKey(id);
        if (flag)
        {
          this.dicSlots[id] = val;
        }
        if (andSave)
        {
          this.SaveSlots();
        }
      }

      // Token: 0x0600069A RID: 1690 RVA: 0x000442F8 File Offset: 0x000424F8
      internal void SetCustom(OptionS option, string val, string defName)
      {
        bool flag = option == OptionS.CUSTOMARMOR || option == OptionS.CUSTOMWEAPON || option == OptionS.CUSTOMITEM;
        if (flag)
        {
          bool flag2 = !defName.NullOrEmpty();
          if (flag2)
          {
            string text = this.Get(option);
            bool flag3 = text.Contains(defName + ",");
            if (flag3)
            {
              string text2 = text.SubstringFrom(defName + ",", false);
              text2.SubstringTo(";", false);
              this.dicString[option].Value = text.Replace(text2, "");
            }
            string value = this.Get(option) + val;
            this.dicString[option].Value = value;
          }
          else
          {
            this.dicString[option].Value = "";
          }
          this.SaveSettings();
        }
      }

      // Token: 0x0600069B RID: 1691 RVA: 0x000443D0 File Offset: 0x000425D0
      internal void Toggle(OptionB option)
      {
        bool flag = option == OptionB.SHOWPAWNLIST || option == OptionB.SHOWTABS || option == OptionB.SHOWMINI;
        if (flag)
        {
          this.dicBool[option].Value = !this.dicBool[option].Value;
        }
      }

      // Token: 0x0400056B RID: 1387
      private Dictionary<int, string> dicSlots;

      // Token: 0x0400056C RID: 1388
      private Dictionary<OptionS, CEditor.ModOptions.SData> dicString;

      // Token: 0x0400056D RID: 1389
      private Dictionary<OptionI, CEditor.ModOptions.IData> dicInt;

      // Token: 0x0400056E RID: 1390
      private Dictionary<OptionB, CEditor.ModOptions.BData> dicBool;

      private bool bDoRescue;

      private class BData
      {
        public BData(string title, string desc, bool val, bool defVal)
        {
          this.Title = title;
          this.Descr = desc;
          this.Value = val;
          this.Default = defVal;
        }

        public string Title;

        public string Descr;

        // Token: 0x040006F3 RID: 1779
        public bool Default;

        // Token: 0x040006F4 RID: 1780
        public bool Value;
      }

      private class IData
      {
        // Token: 0x06000857 RID: 2135 RVA: 0x00048352 File Offset: 0x00046552
        public IData(string title, string desc, int val, int defVal)
        {
          this.Title = title;
          this.Descr = desc;
          this.Value = val;
          this.Default = defVal;
        }

        // Token: 0x040006F5 RID: 1781
        public string Title;

        // Token: 0x040006F6 RID: 1782
        public string Descr;

        // Token: 0x040006F7 RID: 1783
        public int Default;

        // Token: 0x040006F8 RID: 1784
        public int Value;
      }

      private class SData
      {
        // Token: 0x06000858 RID: 2136 RVA: 0x00048379 File Offset: 0x00046579
        public SData(string title, string desc, string val, string defVal)
        {
          this.Title = title;
          this.Descr = desc;
          this.Value = val;
          this.Default = defVal;
        }

        // Token: 0x040006F9 RID: 1785
        public string Title;

        // Token: 0x040006FA RID: 1786
        public string Descr;

        // Token: 0x040006FB RID: 1787
        public string Default;

        // Token: 0x040006FC RID: 1788
        public string Value;
      }

      // Token: 0x020000D4 RID: 212
      private class DialogConfigurate : Window
      {
        // Token: 0x17000088 RID: 136
        // (get) Token: 0x06000859 RID: 2137 RVA: 0x000483A0 File Offset: 0x000465A0
        public override Vector2 InitialSize
        {
          get
          {
            return new Vector2(430f, 800f);
          }
        }

        // Token: 0x0600085A RID: 2138 RVA: 0x000483C4 File Offset: 0x000465C4
        internal DialogConfigurate()
        {
          this.doOnce = true;
          this.framwW = (int)this.InitialSize.x - 40;
          this.frameH = (int)this.InitialSize.y - 70;
          this.mo = CEditor.API.Get<CEditor.ModOptions>(EType.Settings);
          this.doCloseX = true;
          this.absorbInputAroundWindow = false;
          this.draggable = true;
          this.layer = CEditor.Layer;
        }

        // Token: 0x17000089 RID: 137
        // (get) Token: 0x0600085B RID: 2139 RVA: 0x0004845C File Offset: 0x0004665C
        private Rect RectAccept
        {
          get
          {
            return new Rect((float)(this.framwW - 100), (float)this.frameH, 100f, 28f);
          }
        }

        // Token: 0x1700008A RID: 138
        // (get) Token: 0x0600085C RID: 2140 RVA: 0x0004847E File Offset: 0x0004667E
        private Rect RectBottom
        {
          get
          {
            return new Rect((float)this.x, (float)this.frameH, (float)this.buttonWidth, 28f);
          }
        }

        // Token: 0x1700008B RID: 139
        // (get) Token: 0x0600085D RID: 2141 RVA: 0x0004849F File Offset: 0x0004669F
        private Rect RectConfig
        {
          get
          {
            return new Rect((float)(this.x + this.framwW - 42), (float)this.y, 24f, 24f);
          }
        }

        // Token: 0x1700008C RID: 140
        // (get) Token: 0x0600085E RID: 2142 RVA: 0x000484C8 File Offset: 0x000466C8
        private Rect RectFrame
        {
          get
          {
            return new Rect((float)this.x, (float)this.y, (float)this.framwW, 292f);
          }
        }

        // Token: 0x1700008D RID: 141
        // (get) Token: 0x0600085F RID: 2143 RVA: 0x000484E9 File Offset: 0x000466E9
        private Rect RectFullWidth
        {
          get
          {
            return new Rect((float)this.x, (float)this.y, (float)this.framwW, 28f);
          }
        }

        // Token: 0x1700008E RID: 142
        // (get) Token: 0x06000860 RID: 2144 RVA: 0x0004850A File Offset: 0x0004670A
        private Rect RectHalfWidth
        {
          get
          {
            return new Rect((float)this.x, (float)this.y, (float)this.framwW, 24f);
          }
        }

        // Token: 0x1700008F RID: 143
        // (get) Token: 0x06000861 RID: 2145 RVA: 0x0004852B File Offset: 0x0004672B
        private Rect RectHotkey
        {
          get
          {
            return new Rect((float)(this.x + 130), (float)this.y, (float)(this.framwW - 155), 24f);
          }
        }

        // Token: 0x17000090 RID: 144
        // (get) Token: 0x06000862 RID: 2146 RVA: 0x00048558 File Offset: 0x00046758
        private Rect RectHotkeyLabel
        {
          get
          {
            return new Rect((float)this.x, (float)this.y, 130f, 24f);
          }
        }

        // Token: 0x17000091 RID: 145
        // (get) Token: 0x06000863 RID: 2147 RVA: 0x00048577 File Offset: 0x00046777
        private Rect RectImage
        {
          get
          {
            return new Rect((float)this.x, (float)this.y, 64f, 64f);
          }
        }

        // Token: 0x17000092 RID: 146
        // (get) Token: 0x06000864 RID: 2148 RVA: 0x00048596 File Offset: 0x00046796
        private Rect RectNumeric
        {
          get
          {
            return new Rect((float)this.x, (float)this.y, 130f, 24f);
          }
        }

        // Token: 0x17000093 RID: 147
        // (get) Token: 0x06000865 RID: 2149 RVA: 0x000485B5 File Offset: 0x000467B5
        private Rect RectRemoveHotkey
        {
          get
          {
            return new Rect((float)(this.x + this.framwW - 24), (float)this.y, 24f, 24f);
          }
        }

        // Token: 0x17000094 RID: 148
        // (get) Token: 0x06000866 RID: 2150 RVA: 0x000485DE File Offset: 0x000467DE
        private Rect RectSlider
        {
          get
          {
            return new Rect((float)(this.x + 100), (float)this.y, (float)(this.framwW - 100), 24f);
          }
        }

        // Token: 0x17000095 RID: 149
        // (get) Token: 0x06000867 RID: 2151 RVA: 0x00048605 File Offset: 0x00046805
        private Rect RectSliderLabel
        {
          get
          {
            return new Rect((float)this.x, (float)(this.y + 2), 130f, 24f);
          }
        }

        // Token: 0x17000096 RID: 150
        // (get) Token: 0x06000868 RID: 2152 RVA: 0x00048626 File Offset: 0x00046826
        private Rect RectSolid
        {
          get
          {
            return new Rect((float)(this.x + 25), (float)this.y, (float)this.framwW, 24f);
          }
        }

        // Token: 0x06000869 RID: 2153 RVA: 0x0004864C File Offset: 0x0004684C
        public override void DoWindowContents(Rect inRect)
        {
          this.x = 0;
          this.y = 0;
          this.DrawTitle();
          this.DrawBoolean();
          this.DrawHotkey();
          this.DrawHotkeyTeleport();
          this.DrawNumeric();
          this.DrawStrings();
          this.DrawButtons();
        }

        // Token: 0x0600086A RID: 2154 RVA: 0x0004869C File Offset: 0x0004689C
        private void DoOnce()
        {
          bool flag = this.doOnce;
          if (flag)
          {
            this.doOnce = false;
            Vector2 mousePositionOnUI = UI.MousePositionOnUI;
            float num = (float)CEditor.API.EditorPosY;
            this.windowRect.position = new Vector2(mousePositionOnUI.x + 250f, num);
          }
        }

        // Token: 0x0600086B RID: 2155 RVA: 0x000486ED File Offset: 0x000468ED
        private void DoAndClose()
        {
          this.mo.SaveSettings();
          this.mo.SaveSlots();
          this.Close(true);
        }

        // Token: 0x0600086C RID: 2156 RVA: 0x00048710 File Offset: 0x00046910
        private void AConfirmDelete()
        {
          MessageTool.ShowActionDialog(Label.ALLSLOTSWILLBECLEARED, new Action(this.ADeleteSlots), null);
        }

        // Token: 0x0600086D RID: 2157 RVA: 0x0004872B File Offset: 0x0004692B
        private void ADeleteCustoms()
        {
          PresetPawn.ClearAllCustoms();
        }

        // Token: 0x0600086E RID: 2158 RVA: 0x00048733 File Offset: 0x00046933
        private void ADeleteSlots()
        {
          PresetPawn.ClearAllSlots();
        }

        // Token: 0x0600086F RID: 2159 RVA: 0x0004873C File Offset: 0x0004693C
        private void AExportSlots()
        {
          string text = "";
          foreach (int key in this.mo.dicSlots.Keys)
          {
            text = text + this.mo.dicSlots[key] + "\n";
          }
          bool flag = FileIO.WriteFile(FileIO.PATH_PAWNEX, text.AsBytes(Encoding.UTF8));
          if (flag)
          {
            MessageTool.Show("export successful to " + FileIO.PATH_PAWNEX, null);
          }
        }

        // Token: 0x06000870 RID: 2160 RVA: 0x000487EC File Offset: 0x000469EC
        private void AImportSlots()
        {
          string text = FileIO.ReadFile(FileIO.PATH_PAWNEX).AsString(Encoding.UTF8);
          bool flag = !text.NullOrEmpty();
          if (flag)
          {
            string[] array = text.SplitNo("\n");
            int count = this.mo.dicSlots.Keys.Count;
            for (int i = 0; i < count; i++)
            {
              bool flag2 = array.Length > i;
              if (flag2)
              {
                this.mo.dicSlots[i] = array[i];
              }
            }
            MessageTool.Show("import successful from " + FileIO.PATH_PAWNEX, null);
          }
        }

        // Token: 0x06000871 RID: 2161 RVA: 0x00048892 File Offset: 0x00046A92
        private void AMinusInt(int index)
        {
          this.mo.dicInt[(OptionI)index].Value--;
        }

        // Token: 0x06000872 RID: 2162 RVA: 0x000488B2 File Offset: 0x00046AB2
        private void APlusInt(int index)
        {
          this.mo.dicInt[(OptionI)index].Value++;
        }

        // Token: 0x06000873 RID: 2163 RVA: 0x000488D4 File Offset: 0x00046AD4
        private void BoolChanged(OptionB b)
        {
          bool flag = b == OptionB.SHOWINMENU || b == OptionB.ZOMBOBJECTS || b == OptionB.SHOWPAWNLIST || b == OptionB.SHOWTABS || b == OptionB.PAUSEGAME || b == OptionB.SHOWMINI;
          if (flag)
          {
            CEditor.API.OnSettingsChanged(false, false);
          }
          else
          {
            bool flag2 = b == OptionB.HDRARGB;
            if (flag2)
            {
              CEditor.API.OnSettingsChanged(true, false);
            }
          }
        }

        // Token: 0x06000874 RID: 2164 RVA: 0x00048928 File Offset: 0x00046B28
        private void DrawBoolean()
        {
          Text.Font = GameFont.Small;
          float height = (float)(this.mo.dicBool.Keys.Count * 27);
          Rect rectFrame = this.RectFrame;
          Rect rect = new Rect(0f, 0f, rectFrame.width - 16f, height);
          Widgets.BeginScrollView(rectFrame, ref this.scrollPos1, rect, true);
          Rect rect2 = rect.ContractedBy(4f);
          rect2.y -= 4f;
          rect2.height = height;
          Listing_X listing_X = new Listing_X();
          listing_X.Begin(rect2);
          listing_X.verticalSpacing = 5f;
          listing_X.DefSelectionLineHeight = 27f;
          foreach (OptionB optionB in this.mo.dicBool.Keys)
          {
            bool value = this.mo.dicBool[optionB].Value;
            listing_X.CheckboxLabeledWithDefault(this.mo.dicBool[optionB].Title, 2f, rect.width - 20f, ref value, this.mo.dicBool[optionB].Default, this.mo.dicBool[optionB].Descr);
            bool flag = value != this.mo.dicBool[optionB].Value;
            if (flag)
            {
              this.mo.dicBool[optionB].Value = value;
              this.BoolChanged(optionB);
            }
          }
          listing_X.End();
          Widgets.EndScrollView();
          this.y += (int)rectFrame.height + 10;
        }

        // Token: 0x06000875 RID: 2165 RVA: 0x00048B1C File Offset: 0x00046D1C
        private void DrawButtons()
        {
          Text.Font = GameFont.Small;
          SZWidgets.ButtonText(this.RectBottom, "Delete".Translate(), new Action(this.AConfirmDelete), Label.DELETE_SLOTS);
          this.x += this.buttonWidth;
          SZWidgets.ButtonText(this.RectBottom, Label.EXPORT, new Action(this.AExportSlots), Label.EXPORT_SLOTS);
          this.x += this.buttonWidth;
          SZWidgets.ButtonText(this.RectBottom, Label.IMPORT, new Action(this.AImportSlots), Label.IMPORT_SLOTS);
          this.x += this.buttonWidth;
          bool flag = Widgets.ButtonText(this.RectAccept, "Save".Translate(), true, true, true);
          if (flag)
          {
            this.DoAndClose();
          }
        }

        // Token: 0x06000876 RID: 2166 RVA: 0x00048C04 File Offset: 0x00046E04
        private void DrawNumeric()
        {
          int value = this.mo.dicInt[OptionI.RESOLUTION].Value;
          foreach (OptionI optionI in this.mo.dicInt.Keys)
          {
            SZWidgets.Label(this.RectSliderLabel, this.mo.dicInt[optionI].Title, null, this.mo.dicInt[optionI].Descr);
            SZWidgets.ButtonTextVar<int>((float)this.x + this.RectNumeric.width, (float)this.y, 28f, 24f, "+", new Action<int>(this.APlusInt), (int)optionI);
            int max = (optionI == OptionI.RESOLUTION) ? 1600 : ((optionI != OptionI.STACKLIMIT) ? 100 : 9999);
            this.mo.dicInt[optionI].Value = SZWidgets.NumericTextField((float)this.x + this.RectNumeric.width + 10f, (float)this.y, (float)this.framwW - this.RectNumeric.width - 60f, 24f, this.mo.dicInt[optionI].Value, 1, max);
            SZWidgets.ButtonTextVar<int>((float)(this.x + this.framwW - 30), (float)this.y, 28f, 24f, "-", new Action<int>(this.AMinusInt), (int)optionI);
            this.y += 28;
          }
          if (value != this.mo.dicInt[OptionI.RESOLUTION].Value)
          {
            CEditor.API.OnSettingsChanged(true, false);
          }
          this.y += 12;
        }

        // Token: 0x06000877 RID: 2167 RVA: 0x00048E1C File Offset: 0x0004701C
        private void DrawStrings()
        {
          Text.Font = GameFont.Small;
          float height = (float)((this.mo.dicString.Keys.Count + this.mo.dicSlots.Keys.Count - 2) * 27);
          Rect rectFrame = this.RectFrame;
          rectFrame.height = 175f;
          Rect rect = new Rect(0f, 0f, rectFrame.width - 16f, height);
          Widgets.BeginScrollView(rectFrame, ref this.scrollPos2, rect, true);
          Rect rect2 = rect.ContractedBy(4f);
          rect2.y -= 4f;
          rect2.height = height;
          Listing_X listing_X = new Listing_X();
          listing_X.Begin(rect2);
          listing_X.verticalSpacing = 5f;
          listing_X.DefSelectionLineHeight = 27f;
          foreach (OptionS optionS in this.mo.dicString.Keys)
          {
            bool flag = optionS == OptionS.HOTKEYEDITOR || optionS == OptionS.HOTKEYTELEPORT;
            if (!flag)
            {
              string text = this.mo.dicString[optionS].Value;
              text = listing_X.TextEntryLabeledWithDefaultAndCopy(this.mo.dicString[optionS].Title, text, this.mo.dicString[optionS].Default);
              bool flag2 = text != this.mo.dicString[optionS].Value;
              if (flag2)
              {
                this.mo.dicString[optionS].Value = text;
              }
            }
          }
          foreach (int num in this.mo.dicSlots.Keys)
          {
            string text2 = this.mo.dicSlots[num];
            text2 = listing_X.TextEntryLabeledWithDefaultAndCopy(string.Format(Label.O_PAWNSLOT, num.ToString()), text2, "");
            bool flag3 = text2 != this.mo.dicSlots[num];
            if (flag3)
            {
              this.mo.SetSlot(num, text2, false);
            }
          }
          listing_X.End();
          Widgets.EndScrollView();
          this.y += (int)rectFrame.height + 30;
        }

        // Token: 0x06000878 RID: 2168 RVA: 0x000490CC File Offset: 0x000472CC
        private void DrawTitle()
        {
          Text.Font = GameFont.Medium;
          Widgets.Label(this.RectFullWidth, Label.OPTIONS);
          this.y += 30;
        }

        // Token: 0x06000879 RID: 2169 RVA: 0x000490F8 File Offset: 0x000472F8
        private void RemoveHotkey(string kbdName, OptionS s)
        {
          KeyBindingDef keyDef = DefTool.KeyBindingDef(kbdName);
          KeyPrefs.KeyPrefsData.SetBinding(keyDef, KeyPrefs.BindingSlot.A, KeyCode.None);
          this.mo.dicString[s].Value = KeyCode.None.ToStringReadable();
        }

        // Token: 0x0600087A RID: 2170 RVA: 0x00049138 File Offset: 0x00047338
        private void ChangeHotkey(string kbdName)
        {
          Text.Font = GameFont.Medium;
          KeyBindingDef keyDef = DefTool.KeyBindingDef(kbdName);
          WindowTool.Open(new Dialog_DefineBinding(KeyPrefs.KeyPrefsData, keyDef, KeyPrefs.BindingSlot.A));
        }

        // Token: 0x0600087B RID: 2171 RVA: 0x00049168 File Offset: 0x00047368
        private void DrawHotkey(string kbdName, OptionS s, string title, string descr)
        {
          this.y += 5;
          KeyBindingDef keyBindingDef = DefTool.KeyBindingDef(kbdName);
          bool flag = keyBindingDef == null;
          if (flag)
          {
            keyBindingDef = DefTool.TryCreateKeyBinding(kbdName, KeyCode.None.ToStringReadable(), title, descr);
          }
          KeyCode k = (keyBindingDef != null) ? KeyPrefs.KeyPrefsData.GetBoundKeyCode(keyBindingDef, KeyPrefs.BindingSlot.A) : KeyCode.None;
          SZWidgets.Label(this.RectHotkeyLabel, title, null, descr);
          SZWidgets.ButtonText(this.RectHotkey, (keyBindingDef == null) ? Label.NONE : k.ToStringReadable(), delegate ()
          {
            this.ChangeHotkey(kbdName);
          }, descr);
          SZWidgets.ButtonImage(this.RectRemoveHotkey, "UI/Buttons/Delete", delegate ()
          {
            this.RemoveHotkey(kbdName, s);
          }, "");
          bool flag2 = keyBindingDef != null && k.ToStringReadable() != this.mo.dicString[s].Value;
          if (flag2)
          {
            this.mo.dicString[s].Value = k.ToStringReadable();
          }
          this.y += 27;
        }

        // Token: 0x0600087C RID: 2172 RVA: 0x0004929B File Offset: 0x0004749B
        private void DrawHotkey()
        {
          this.DrawHotkey("HotkeyEditor", OptionS.HOTKEYEDITOR, Label.O_HOTKEYEDITOR, Label.O_DESC_HOTKEYEDITOR);
        }

        // Token: 0x0600087D RID: 2173 RVA: 0x000492B4 File Offset: 0x000474B4
        private void DrawHotkeyTeleport()
        {
          this.DrawHotkey("HotkeyTeleport", OptionS.HOTKEYTELEPORT, Label.O_HOTKEYTELEPORT, Label.O_DESC_HOTKEYTELEPORT);
        }

        // Token: 0x040006FD RID: 1789
        private int buttonWidth = 80;

        // Token: 0x040006FE RID: 1790
        private bool doOnce;

        // Token: 0x040006FF RID: 1791
        private int frameH;

        // Token: 0x04000700 RID: 1792
        private int framwW;

        // Token: 0x04000701 RID: 1793
        private Vector2 scrollPos1 = default(Vector2);

        // Token: 0x04000702 RID: 1794
        private Vector2 scrollPos2 = default(Vector2);

        // Token: 0x04000703 RID: 1795
        private int x;

        // Token: 0x04000704 RID: 1796
        private int y;

        // Token: 0x04000705 RID: 1797
        private CEditor.ModOptions mo;
      }
    }

    // Token: 0x02000062 RID: 98
    private sealed class ModData
    {
      // Token: 0x0600069C RID: 1692 RVA: 0x00044418 File Offset: 0x00042618
      internal ModData()
      {
        this.dicData = new Dictionary<EType, ServiceContainer>();
        this.p = null;
        this.useZombrella = false;
        bool flag = this.Get<CEditor.ModOptions>(EType.Settings).Get(OptionB.MOREPAWNNAMES);
        if (flag)
        {
          Label.AddNames(CEditor.pack.RootDir.Replace("\\", "/"));
        }
      }

      // Token: 0x0600069D RID: 1693 RVA: 0x00044478 File Offset: 0x00042678
      // ToDo: bring this back
      //protected override void Finalize()
      //{
      //	try
      //	{
      //		foreach (EType key in this.dicData.Keys)
      //		{
      //			this.dicData[key].Dispose();
      //		}
      //		this.dicData.Clear();
      //	}
      //	finally
      //	{
      //		base.Finalize();
      //	}
      //}

      internal List<T> ListOf<T>(EType eType)
      {
        bool flag = !this.dicData.ContainsKey(eType);
        if (flag)
        {
          this.CreateList(eType);
        }
        else
        {
          bool flag2 = this.dicData[eType] == null;
          if (flag2)
          {
            this.dicData.Remove(eType);
            this.CreateList(eType);
          }
        }
        bool flag3 = this.dicData.ContainsKey(eType);
        List<T> result;
        if (flag3)
        {
          result = (List<T>)this.dicData[eType].GetService(typeof(List<T>));
        }
        else
        {
          result = new List<T>();
        }
        return result;
      }


      //internal List<T> ListOf<T>(EType eType)
      //{
      //  //Log.Message("ListOf, start");
      //  if (!this.dicData.ContainsKey(eType))
      //  {
      //    //Log.Message("ListOf, this.dicData.ContainsKey(eType): false, create list for eType");
      //    this.CreateList(eType);
      //  }
      //  else
      //  {
      //    if (this.dicData[eType] == null)
      //    {
      //      //Log.Message("ListOf, this.dicData[eType] == null, create list for eType");
      //      this.dicData.Remove(eType);
      //      this.CreateList(eType);
      //    }
      //  }
      //  List<T> result = null;
      //  if (this.dicData.ContainsKey(eType))
      //  {
      //    //Log.Message("ListOf, this.dicData.ContainsKey(eType): true, create result");
      //    result = (List<T>)this.dicData[eType].GetService(typeof(List<T>));
      //  }
      //  else
      //  {
      //    Log.Warning("ListOf, still have this.dicData.ContainsKey(eType): false");
      //  }

      //  if (result == null)
      //  {
      //    Log.Warning("CEditor.ModData.ListOf, first approach gave null list");
      //  }
      //  else if (!result.Any())
      //  {
      //    Log.Warning("CEditor.ModData.ListOf, first approach gave empty list");
      //  }
      //  else
      //  {
      //    return result;
      //  }

      //  HashSet<T> hashset = Get<HashSet<T>>(eType);

      //  if (hashset == null)
      //  {
      //    Log.Warning("CEditor.ModData.ListOf, second approach gave null list");
      //  }
      //  else if (!hashset.Any())
      //  {
      //    Log.Warning("CEditor.ModData.ListOf, second approach gave empty list");
      //  }
      //  else
      //  {
      //    return hashset.ToList();
      //  }

      //  result = Get<List<T>>(eType);

      //  if (result == null)
      //  {
      //    Log.Warning("CEditor.ModData.ListOf, third approach gave null list");
      //  }
      //  else if (!result.Any())
      //  {
      //    Log.Warning("CEditor.ModData.ListOf, third approach gave empty list");
      //  }
      //  else
      //  {
      //    return result;
      //  }

      //  return new List<T>();
      //  //List<T> result = Get<List<T>>(eType);
      //  //if (result.NullOrEmpty())
      //  //{
      //  //  Log.Warning("ListOf, ")
      //  //  return new List<T>();
      //  //}
      //  //if (typeof(T) == typeof(Def) || typeof(T).IsSubclassOf(typeof(Def)))
      //  //{
      //  //  result.OrderBy(t => (t as Def).label ?? "").ThenBy(t => (t as Def).defName);
      //  //}
      //  //return result;
      //}

      // Token: 0x0600069F RID: 1695 RVA: 0x00044598 File Offset: 0x00042798
      //internal T Get<T>(EType eType)
      //{
      //  //Log.Message("ModData.Get, start");
      //  bool flag = !this.dicData.ContainsKey(eType);
      //  if (flag)
      //  {
      //    //Log.Message("ModData.Get, this.dicData.ContainsKey(eType): false, CreateType");
      //    this.CreateType(eType);
      //  }
      //  else
      //  {
      //    bool flag2 = this.dicData[eType] == null;
      //    if (flag2)
      //    {
      //      //Log.Message("ModData.Get, this.dicData[eType] == null, CreateType");
      //      this.dicData.Remove(eType);
      //      this.CreateType(eType);
      //    }
      //  }
      //  bool flag3 = this.dicData.ContainsKey(eType);
      //  T result;
      //  if (flag3)
      //  {
      //    //Log.Message("ModData.Get, this.dicData.ContainsKey(eType): true, GetService");
      //    result = (T)((object)this.dicData[eType].GetService(typeof(T)));
      //  }
      //  else
      //  {
      //    //Log.Message("ModData.Get, this.dicData.ContainsKey(eType): false, set to default");
      //    result = default(T);
      //  }
      //  if (result == null)
      //  {
      //    //Log.Message("ModData.Get, result == null");
      //  }
      //  //Log.Message("ModData.Get, end");
      //  return result;
      //}

      internal T Get<T>(EType eType)
      {
        bool flag = !this.dicData.ContainsKey(eType);
        if (flag)
        {
          this.CreateType(eType);
        }
        else
        {
          bool flag2 = this.dicData[eType] == null;
          if (flag2)
          {
            this.dicData.Remove(eType);
            this.CreateType(eType);
          }
        }
        bool flag3 = this.dicData.ContainsKey(eType);
        T result;
        if (flag3)
        {
          result = (T)((object)this.dicData[eType].GetService(typeof(T)));
        }
        else
        {
          result = default(T);
        }
        return result;
      }

      internal bool Has(EType eType)
      {
        return this.dicData.ContainsKey(eType);
      }

      // Token: 0x060006A1 RID: 1697 RVA: 0x00044640 File Offset: 0x00042840
      internal void OnSettingsChanged(bool updateRenderOnly, bool updateKeyCode)
      {
        try
        {
          ////Log.Message("checking editor settings...");
          if (updateRenderOnly)
          {
            this.Get<Capturer>(EType.Capturer).ChangeRenderTextureParamter(this.Get<CEditor.ModOptions>(EType.Settings).Get(OptionI.RESOLUTION), this.Get<CEditor.ModOptions>(EType.Settings).Get(OptionB.HDRARGB));
            this.UpdateGraphics();
          }
          else
          {
            this.UpdateMainButton();
            this.UpdateArchitectObjects();
            this.UpdateUIParameter();
            if (updateKeyCode)
            {
              this.UpdateKeyBindings();
            }
          }
        }
        catch (Exception ex)
        {
          Log.Error(ex.StackTrace);
        }
      }

      // Token: 0x060006A2 RID: 1698 RVA: 0x000446D8 File Offset: 0x000428D8
      internal void UpdateGraphics()
      {
        this.Get<Capturer>(EType.Capturer).UpdatePawnGraphic(this.p);
      }

      // Token: 0x060006A3 RID: 1699 RVA: 0x000446EE File Offset: 0x000428EE
      internal void StartEditor(Pawn pawn)
      {
        //Log.Message("CEditor.ModData.StartEditor");
        this.Get<CEditor.EditorUI>(EType.EditorUI).Start(pawn);
      }

      // Token: 0x060006A4 RID: 1700 RVA: 0x000446FE File Offset: 0x000428FE
      internal void ReInitSettings()
      {
        this.Get<CEditor.ModOptions>(EType.Settings).ReInit();
      }

      // Token: 0x060006A5 RID: 1701 RVA: 0x00044710 File Offset: 0x00042910
      private void CreateType(EType eType)
      {
        if (eType == EType.EditorUI)
        {
          this.Get<Capturer>(EType.Capturer);
          this.Get<ThingDef>(EType.WeaponPreset);
          this.Get<ThingDef>(EType.ApparelPreset);
          this.Get<ThingDef>(EType.ItemPreset);
          this.Get<Dictionary<ApparelLayerDef, List<ThingDef>>>(EType.DicApparel);
          this.Get<HashSet<string>>(EType.GraphicPaths);
          this.AddClassContainer<CEditor.EditorUI>(new CEditor.EditorUI(), eType);
        }
        else
        {
          bool flag2 = eType == EType.Capturer;
          if (flag2)
          {
            this.AddClassContainer<Capturer>(new Capturer(), eType);
          }
          else
          {
            bool flag3 = eType == EType.ModsThingDef;
            if (flag3)
            {
              this.AddClassContainer<HashSet<string>>(DefTool.ListModnamesWithNull<ThingDef>(null).ToHashSet(), eType);
            }
            else
            {
              bool flag4 = eType == EType.ModsWeapons;
              if (flag4)
              {
                this.AddClassContainer<HashSet<string>>(DefTool.ListModnamesWithNull<ThingDef>((ThingDef y) => y.IsWeapon).ToHashSet(), eType);
              }
              else
              {
                bool flag5 = eType == EType.ModsApparel;
                if (flag5)
                {
                  this.AddClassContainer<HashSet<string>>(DefTool.ListModnamesWithNull<ThingDef>((ThingDef y) => y.IsApparel).ToHashSet(), eType);
                }
                else
                {
                  bool flag6 = eType == EType.ModsHediffDef;
                  if (flag6)
                  {
                    this.AddClassContainer<HashSet<string>>(DefTool.ListModnamesWithNull<HediffDef>(null).ToHashSet(), eType);
                  }
                  else
                  {
                    bool flag7 = eType == EType.ModsTraitDef;
                    if (flag7)
                    {
                      this.AddClassContainer<HashSet<string>>(DefTool.ListModnamesWithNull<TraitDef>(null).ToHashSet(), eType);
                    }
                    else
                    {
                      bool flag8 = eType == EType.ModsHairDef;
                      if (flag8)
                      {
                        this.AddClassContainer<HashSet<string>>(DefTool.ListModnamesWithNull<HairDef>(null).ToHashSet(), eType);
                      }
                      else
                      {
                        bool flag9 = eType == EType.ModsBeardDef;
                        if (flag9)
                        {
                          this.AddClassContainer<HashSet<string>>(DefTool.ListModnamesWithNull<BeardDef>(null).ToHashSet(), eType);
                        }
                        else
                        {
                          bool flag10 = eType == EType.ModsAbilityDef;
                          if (flag10)
                          {
                            this.AddClassContainer<HashSet<string>>(DefTool.ListModnamesWithNull<AbilityDef>(null).ToHashSet(), eType);
                          }
                          else
                          {
                            bool flag11 = eType == EType.GraphicPaths;
                            if (flag11)
                            {
                              this.AddClassContainer<HashSet<string>>(ApparelTool.CreateListOfGraphicPaths(), eType);
                            }
                            else
                            {
                              bool flag12 = eType == EType.ThoughtMemory || eType == EType.ThoughtMemorySocial || eType == EType.ThoughtSituational || eType == EType.ThoughtSituationalSocial || eType == EType.ThoughtUnsupported || eType == EType.ThoughtsAll;
                              if (flag12)
                              {
                                Dictionary<EType, HashSet<ThoughtDef>> allThoughtLists = MindTool.GetAllThoughtLists();
                                foreach (EType etype in allThoughtLists.Keys)
                                {
                                  this.AddClassContainer<HashSet<ThoughtDef>>(allThoughtLists[etype], etype);
                                }
                              }
                              else
                              {
                                bool flag13 = eType == EType.DicApparel;
                                if (flag13)
                                {
                                  this.AddClassContainer<Dictionary<ApparelLayerDef, List<ThingDef>>>(ApparelTool.CreateDicOfApparel(), eType);
                                }
                                else
                                {
                                  bool flag14 = eType == EType.Factions;
                                  if (flag14)
                                  {
                                    this.AddClassContainer<Dictionary<string, Faction>>(FactionTool.GetDicOfFactions(true, true, true), eType);
                                  }
                                  else
                                  {
                                    bool flag15 = eType == EType.WeaponPreset;
                                    if (flag15)
                                    {
                                      this.AddClassContainer<Dictionary<string, PresetWeapon>>(PresetWeapon.GetAllPresets(), eType);
                                    }
                                    else
                                    {
                                      bool flag16 = eType == EType.ApparelPreset;
                                      if (flag16)
                                      {
                                        this.AddClassContainer<Dictionary<string, PresetApparel>>(PresetApparel.GetAllPresets(), eType);
                                      }
                                      else
                                      {
                                        bool flag17 = eType == EType.ItemPreset;
                                        if (flag17)
                                        {
                                          this.AddClassContainer<Dictionary<string, PresetItem>>(PresetItem.GetAllPresets(), eType);
                                        }
                                        else
                                        {
                                          bool flag18 = eType == EType.Search;
                                          if (flag18)
                                          {
                                            this.AddClassContainer<Dictionary<int, SearchTool>>(new Dictionary<int, SearchTool>(), eType);
                                          }
                                          else
                                          {
                                            bool flag19 = eType == EType.Settings;
                                            if (flag19)
                                            {
                                              this.AddClassContainer<CEditor.ModOptions>(new CEditor.ModOptions(), eType);
                                            }
                                            else
                                            {
                                              bool flag20 = eType == EType.UIContainers;
                                              if (flag20)
                                              {
                                                this.AddClassContainer<Dictionary<int, Building_CryptosleepCasket>>(new Dictionary<int, Building_CryptosleepCasket>
                                                {
                                                  {
                                                    0,
                                                    null
                                                  }
                                                }, eType);
                                              }
                                              else
                                              {
                                                bool flag21 = eType == EType.MainButton;
                                                if (flag21)
                                                {
                                                  MainButtonDef createMainButton = DefTool.GetCreateMainButton("HotkeyEditor", Label.CHARACTER, Label.MAINBUTTON_DESCR, typeof(MainTabWindow_CharacterEditor), CEditor.pack, this.Get<CEditor.ModOptions>(EType.Settings).Get(OptionS.HOTKEYEDITOR), this.Get<CEditor.ModOptions>(EType.Settings).Get(OptionB.SHOWINMENU));
                                                  this.AddClassContainer<MainButtonDef>(createMainButton, eType);
                                                }
                                                else
                                                {
                                                  bool flag22 = eType == EType.TeleButton;
                                                  if (flag22)
                                                  {
                                                    MainButtonDef createMainButton2 = DefTool.GetCreateMainButton("HotkeyTeleport", Label.TELEPORT, "quick teleport", typeof(Teleport_Character), CEditor.pack, this.Get<CEditor.ModOptions>(EType.Settings).Get(OptionS.HOTKEYTELEPORT), false);
                                                    this.AddClassContainer<MainButtonDef>(createMainButton2, eType);
                                                  }
                                                }
                                              }
                                            }
                                          }
                                        }
                                      }
                                    }
                                  }
                                }
                              }
                            }
                          }
                        }
                      }
                    }
                  }
                }
              }
            }
          }
        }
      }

      // Token: 0x060006A6 RID: 1702 RVA: 0x00044B18 File Offset: 0x00042D18
      private void CreateList(EType eType)
      {
        bool flag = eType == EType.Pawns;
        if (flag)
        {
          this.AddServiceContainer<Pawn>(new List<Pawn>(), eType);
        }
        else
        {
          bool flag2 = eType == EType.PawnKindHuman;
          if (flag2)
          {
            this.AddServiceContainer<PawnKindDef>(PawnKindTool.GetHumanlikes(), eType);
          }
          else
          {
            bool flag3 = eType == EType.PawnKindAnimal;
            if (flag3)
            {
              this.AddServiceContainer<PawnKindDef>(PawnKindTool.GetAnimals(), eType);
            }
            else
            {
              bool flag4 = eType == EType.PawnKindOther;
              if (flag4)
              {
                this.AddServiceContainer<PawnKindDef>(PawnKindTool.GetOther(), eType);
              }
              else
              {
                bool flag5 = eType == EType.PawnKindListed;
                if (flag5)
                {
                  this.AddServiceContainer<PawnKindDef>(PawnKindTool.ListOfPawnKindDef(Faction.OfPlayer, Label.COLONISTS, null), eType);
                }
                else
                {
                  bool flag6 = eType == EType.Bodies;
                  if (flag6)
                  {
                    this.AddServiceContainer<BodyTypeDef>(DefTool.ListAll<BodyTypeDef>(), eType);
                  }
                  else
                  {
                    bool flag7 = eType == EType.MentalStates;
                    if (flag7)
                    {
                      this.AddServiceContainer<MentalStateDef>(MindTool.GetAllMentalStates(), eType);
                    }
                    else
                    {
                      bool flag8 = eType == EType.Inspirations;
                      if (flag8)
                      {
                        this.AddServiceContainer<InspirationDef>(MindTool.GetAllInspirations(), eType);
                      }
                      else
                      {
                        bool flag9 = eType == EType.ApparelTags;
                        if (flag9)
                        {
                          this.AddServiceContainer<string>(ThingTool.GetAllApparelTags(), eType);
                        }
                        else
                        {
                          bool flag10 = eType == EType.OutfitTags;
                          if (flag10)
                          {
                            this.AddServiceContainer<string>(ThingTool.GetAllOutfitTags(), eType);
                          }
                          else
                          {
                            bool flag11 = eType == EType.WeaponTags;
                            if (flag11)
                            {
                              this.AddServiceContainer<string>(ThingTool.GetAllWeaponTags(), eType);
                            }
                            else
                            {
                              bool flag12 = eType == EType.StuffCategory;
                              if (flag12)
                              {
                                this.AddServiceContainer<StuffCategoryDef>(ThingTool.GetAllStuffCategories(), EType.StuffCategory);
                              }
                              else
                              {
                                bool flag13 = eType == EType.TechLevel;
                                if (flag13)
                                {
                                  this.AddServiceContainer<TechLevel>(EnumTool.GetAllEnumsOfType<TechLevel>(), EType.TechLevel);
                                }
                                else
                                {
                                  bool flag14 = eType == EType.Tradeability;
                                  if (flag14)
                                  {
                                    this.AddServiceContainer<Tradeability>(EnumTool.GetAllEnumsOfType<Tradeability>(), EType.Tradeability);
                                  }
                                  else
                                  {
                                    bool flag15 = eType == EType.StatCategoryApparel;
                                    if (flag15)
                                    {
                                      this.AddServiceContainer<StatCategoryDef>(ThingTool.GetAllStatCategoriesApparel(), eType);
                                    }
                                    else
                                    {
                                      bool flag16 = eType == EType.StatCategoryWeapon;
                                      if (flag16)
                                      {
                                        this.AddServiceContainer<StatCategoryDef>(ThingTool.GetAllStatCategoriesWeapon(), eType);
                                      }
                                      else
                                      {
                                        bool flag17 = eType == EType.StatCategoryOnEquip;
                                        if (flag17)
                                        {
                                          this.AddServiceContainer<StatCategoryDef>(ThingTool.GetAllStatCategoriesOnEquip(), eType);
                                        }
                                        else
                                        {
                                          bool flag18 = eType == EType.CostItems;
                                          if (flag18)
                                          {
                                            this.AddServiceContainer<ThingDef>(ThingTool.GetAllCostThingDefs(), EType.CostItems);
                                          }
                                          else
                                          {
                                            bool flag19 = eType == EType.StatDefWeapon;
                                            if (flag19)
                                            {
                                              this.AddServiceContainer<StatDef>(ThingTool.GetAllWeaponStatDefs(), eType);
                                            }
                                            else
                                            {
                                              bool flag20 = eType == EType.StatDefApparel;
                                              if (flag20)
                                              {
                                                this.AddServiceContainer<StatDef>(ThingTool.GetAllApparelStatDefs(), eType);
                                              }
                                              else
                                              {
                                                bool flag21 = eType == EType.StatDefOnEquip;
                                                if (flag21)
                                                {
                                                  this.AddServiceContainer<StatDef>(ThingTool.GetAllOnEquipStatDefs(), eType);
                                                }
                                              }
                                            }
                                          }
                                        }
                                      }
                                    }
                                  }
                                }
                              }
                            }
                          }
                        }
                      }
                    }
                  }
                }
              }
            }
          }
        }
      }

      // Token: 0x060006A7 RID: 1703 RVA: 0x00044DA2 File Offset: 0x00042FA2
      private void AddClassContainer<T>(T t, EType eType)
      {
        this.dicData.Add(eType, new ServiceContainer());
        this.dicData[eType].AddService(typeof(T), t);
      }

      // Token: 0x060006A8 RID: 1704 RVA: 0x00044DD9 File Offset: 0x00042FD9
      private void AddServiceContainer<T>(List<T> l, EType eType)
      {
        this.dicData.Add(eType, new ServiceContainer());
        this.dicData[eType].AddService(l.GetType(), l);
      }

      // Token: 0x060006A9 RID: 1705 RVA: 0x00044E08 File Offset: 0x00043008
      internal void UpdateUIParameter()
      {
        CEditor.EditorUI editorUI = this.Get<CEditor.EditorUI>(EType.EditorUI);
        bool flag = editorUI != null;
        if (flag)
        {
          Rect windowRect = editorUI.windowRect;
          bool flag2 = true;
          if (flag2)
          {
            editorUI.windowRect.width = editorUI.InitialSize.x;
            editorUI.windowRect.height = editorUI.InitialSize.y;
          }
          editorUI.forcePause = this.Get<CEditor.ModOptions>(EType.Settings).Get(OptionB.PAUSEGAME);
        }
      }

      // Token: 0x060006AA RID: 1706 RVA: 0x00044E7C File Offset: 0x0004307C
      internal void UpdateMainButton()
      {
        MainButtonDef mainButtonDef = this.Get<MainButtonDef>(EType.MainButton);
        bool flag = mainButtonDef != null;
        if (flag)
        {
          mainButtonDef.buttonVisible = this.Get<CEditor.ModOptions>(EType.Settings).Get(OptionB.SHOWINMENU);
        }
        this.Get<MainButtonDef>(EType.TeleButton);
      }

      // Token: 0x060006AB RID: 1707 RVA: 0x00044EB8 File Offset: 0x000430B8
      private void UpdateKeyBindings()
      {
        try
        {
          string text = this.Get<CEditor.ModOptions>(EType.Settings).Get(OptionS.HOTKEYTELEPORT);
          string text2 = this.Get<CEditor.ModOptions>(EType.Settings).Get(OptionS.HOTKEYEDITOR);
          KeyBindingDef keyBindingDef = DefTool.KeyBindingDef("HotkeyTeleport");
          KeyBindingDef keyBindingDef2 = DefTool.KeyBindingDef("HotkeyEditor");
          bool flag = keyBindingDef == null;
          if (flag)
          {
            keyBindingDef = DefTool.TryCreateKeyBinding("HotkeyTeleport", text, Label.O_HOTKEYTELEPORT, Label.O_DESC_HOTKEYTELEPORT);
          }
          bool flag2 = keyBindingDef2 == null;
          if (flag2)
          {
            keyBindingDef2 = DefTool.TryCreateKeyBinding("HotkeyEditor", text2, Label.O_HOTKEYEDITOR, Label.O_DESC_HOTKEYEDITOR);
          }
          this.Get<MainButtonDef>(EType.TeleButton).hotKey = keyBindingDef;
          this.Get<MainButtonDef>(EType.MainButton).hotKey = keyBindingDef2;
          KeyCode keyCode;
          bool flag3 = Enum.TryParse<KeyCode>(text, out keyCode);
          if (flag3)
          {
            KeyPrefs.KeyPrefsData.SetBinding(DefTool.KeyBindingDef("HotkeyTeleport"), KeyPrefs.BindingSlot.A, keyCode);
          }
          bool flag4 = Enum.TryParse<KeyCode>(text2, out keyCode);
          if (flag4)
          {
            KeyPrefs.KeyPrefsData.SetBinding(DefTool.KeyBindingDef("HotkeyEditor"), KeyPrefs.BindingSlot.A, keyCode);
          }
        }
        catch
        {
        }
      }

      // Token: 0x060006AC RID: 1708 RVA: 0x00044FBC File Offset: 0x000431BC
      private void UpdateArchitectObjects()
      {
        bool flag = this.Get<CEditor.ModOptions>(EType.Settings).Get(OptionB.ZOMBOBJECTS);
        bool flag2 = this.useZombrella != flag;
        if (flag2)
        {
          this.useZombrella = flag;
          ThingDef thingDef = DefTool.ThingDef("Zombrella");
          ThingDef thingDef2 = DefTool.ThingDef("Zombgrella");
          bool flag3 = this.useZombrella;
          if (flag3)
          {
            bool flag4 = thingDef == null;
            if (flag4)
            {
              ThingTool.CreateBuilding("Zombrella", "Zombrella", Label.DESC_CASCET, typeof(CharacterEditorCascet), "CryptosleepCasket");
            }
            bool flag5 = thingDef2 == null;
            if (flag5)
            {
              ThingTool.CreateBuilding("Zombgrella", "Zombgrella", Label.DESC_GRAVE, typeof(CharacterEditorGrave), "Grave");
            }
          }
          thingDef = DefTool.ThingDef("Zombrella");
          thingDef2 = DefTool.ThingDef("Zombgrella");
          bool flag6 = this.useZombrella;
          if (flag6)
          {
            bool flag7 = thingDef != null;
            if (flag7)
            {
              thingDef.designatorDropdown = DefTool.DesignatorDropdownGroupDef("Zombrella");
              thingDef.designationCategory = DefTool.DesignationCategoryDef("Misc");
            }
            bool flag8 = thingDef2 != null;
            if (flag8)
            {
              thingDef2.designatorDropdown = DefTool.DesignatorDropdownGroupDef("Zombrella");
              thingDef2.designationCategory = DefTool.DesignationCategoryDef("Misc");
            }
          }
          else
          {
            bool flag9 = thingDef != null;
            if (flag9)
            {
              thingDef.designatorDropdown = null;
              thingDef.designationCategory = null;
            }
            bool flag10 = thingDef2 != null;
            if (flag10)
            {
              thingDef2.designatorDropdown = null;
              thingDef2.designationCategory = null;
            }
          }
          DesignatorDropdownGroupDef designatorDropdownGroupDef = DefTool.DesignatorDropdownGroupDef("Zombrella");
          if (designatorDropdownGroupDef != null)
          {
            designatorDropdownGroupDef.ResolveReferences();
          }
          DesignationCategoryDef designationCategoryDef = DefTool.DesignationCategoryDef("Misc");
          if (designationCategoryDef != null)
          {
            designationCategoryDef.ResolveReferences();
          }
          try
          {
            ThingCategoryDef.Named("BuildingsMisc").ResolveReferences();
            ThingCategoryDef.Named("BuildingsMisc").PostLoad();
            ThingCategoryDefOf.Root.ResolveReferences();
            ThingCategoryDefOf.Root.PostLoad();
          }
          catch (Exception ex)
          {
            Log.Error(ex.StackTrace);
          }
        }
      }

      // Token: 0x04000571 RID: 1393
      private bool useZombrella;

      // Token: 0x04000572 RID: 1394
      internal Pawn p;

      // Token: 0x04000573 RID: 1395
      private readonly Dictionary<EType, ServiceContainer> dicData;
    }

    // Token: 0x02000063 RID: 99
    private sealed class EditorUI : Window
    {
      // Token: 0x060006AD RID: 1709 RVA: 0x000451B4 File Offset: 0x000433B4
      private T Get<T>(CEditor.EditorUI.TabType tabType)
      {
        bool flag = !this.dicData.ContainsKey(tabType);
        if (flag)
        {
          this.CreateType(tabType);
        }
        else
        {
          bool flag2 = this.dicData[tabType] == null;
          if (flag2)
          {
            this.dicData.Remove(tabType);
            this.CreateType(tabType);
          }
        }
        bool flag3 = this.dicData.ContainsKey(tabType);
        T result;
        if (flag3)
        {
          result = (T)((object)this.dicData[tabType].GetService(typeof(T)));
        }
        else
        {
          result = default(T);
        }
        return result;
      }

      // Token: 0x060006AE RID: 1710 RVA: 0x0004524C File Offset: 0x0004344C
      private void CreateType(CEditor.EditorUI.TabType tabType)
      {
        bool flag = tabType == CEditor.EditorUI.TabType.BlockBio;
        if (flag)
        {
          this.AddClassContainer<CEditor.EditorUI.BlockBio>(new CEditor.EditorUI.BlockBio(), tabType);
        }
        else
        {
          bool flag2 = tabType == CEditor.EditorUI.TabType.BlockHealth;
          if (flag2)
          {
            this.AddClassContainer<CEditor.EditorUI.BlockHealth>(new CEditor.EditorUI.BlockHealth(), tabType);
          }
          else
          {
            bool flag3 = tabType == CEditor.EditorUI.TabType.BlockInfo;
            if (flag3)
            {
              this.AddClassContainer<CEditor.EditorUI.BlockInfo>(new CEditor.EditorUI.BlockInfo(), tabType);
            }
            else
            {
              bool flag4 = tabType == CEditor.EditorUI.TabType.BlockInventory;
              if (flag4)
              {
                this.AddClassContainer<CEditor.EditorUI.BlockInventory>(new CEditor.EditorUI.BlockInventory(), tabType);
              }
              else
              {
                bool flag5 = tabType == CEditor.EditorUI.TabType.BlockLog;
                if (flag5)
                {
                  this.AddClassContainer<CEditor.EditorUI.BlockLog>(new CEditor.EditorUI.BlockLog(), tabType);
                }
                else
                {
                  bool flag6 = tabType == CEditor.EditorUI.TabType.BlockNeeds;
                  if (flag6)
                  {
                    this.AddClassContainer<CEditor.EditorUI.BlockNeeds>(new CEditor.EditorUI.BlockNeeds(), tabType);
                  }
                  else
                  {
                    bool flag7 = tabType == CEditor.EditorUI.TabType.BlockPawnList;
                    if (flag7)
                    {
                      this.AddClassContainer<CEditor.EditorUI.BlockPawnList>(new CEditor.EditorUI.BlockPawnList(), tabType);
                    }
                    else
                    {
                      bool flag8 = tabType == CEditor.EditorUI.TabType.BlockPerson;
                      if (flag8)
                      {
                        this.AddClassContainer<CEditor.EditorUI.BlockPerson>(new CEditor.EditorUI.BlockPerson(), tabType);
                      }
                      else
                      {
                        bool flag9 = tabType == CEditor.EditorUI.TabType.BlockRecords;
                        if (flag9)
                        {
                          this.AddClassContainer<CEditor.EditorUI.BlockRecords>(new CEditor.EditorUI.BlockRecords(), tabType);
                        }
                        else
                        {
                          bool flag10 = tabType == CEditor.EditorUI.TabType.BlockSocial;
                          if (flag10)
                          {
                            this.AddClassContainer<CEditor.EditorUI.BlockSocial>(new CEditor.EditorUI.BlockSocial(), tabType);
                          }
                        }
                      }
                    }
                  }
                }
              }
            }
          }
        }
      }

      // Token: 0x060006AF RID: 1711 RVA: 0x00045357 File Offset: 0x00043557
      private void AddClassContainer<T>(T t, CEditor.EditorUI.TabType tabType)
      {
        this.dicData.Add(tabType, new ServiceContainer());
        this.dicData[tabType].AddService(typeof(T), t);
      }

      // Token: 0x17000078 RID: 120
      // (get) Token: 0x060006B0 RID: 1712 RVA: 0x00045390 File Offset: 0x00043590
      public override Vector2 InitialSize
      {
        get
        {
          int num = this.SizeRand + this.SizeW0 + this.SizeW1 + this.SizeW2 + this.SizeRand;
          int num2 = CEditor.API.GetO(OptionB.SHOWMINI) ? 320 : 786;
          return new Vector2((float)num, (float)num2);
        }
      }

      // Token: 0x17000079 RID: 121
      // (get) Token: 0x060006B1 RID: 1713 RVA: 0x000453E8 File Offset: 0x000435E8
      public int SizeRand
      {
        get
        {
          return 18;
        }
      }

      // Token: 0x1700007A RID: 122
      // (get) Token: 0x060006B2 RID: 1714 RVA: 0x000453FC File Offset: 0x000435FC
      public int SizeH
      {
        get
        {
          return (int)(this.InitialSize.y - 36f);
        }
      }

      // Token: 0x1700007B RID: 123
      // (get) Token: 0x060006B3 RID: 1715 RVA: 0x00045420 File Offset: 0x00043620
      public int SizeW0
      {
        get
        {
          return CEditor.API.GetO(OptionB.SHOWPAWNLIST) ? 100 : 0;
        }
      }

      // Token: 0x1700007C RID: 124
      // (get) Token: 0x060006B4 RID: 1716 RVA: 0x00045444 File Offset: 0x00043644
      public int SizeW1
      {
        get
        {
          return 250;
        }
      }

      // Token: 0x1700007D RID: 125
      // (get) Token: 0x060006B5 RID: 1717 RVA: 0x0004545C File Offset: 0x0004365C
      public int SizeW2
      {
        get
        {
          return CEditor.API.GetO(OptionB.SHOWTABS) ? 840 : -10;
        }
      }

      // Token: 0x1700007E RID: 126
      // (get) Token: 0x060006B6 RID: 1718 RVA: 0x00045484 File Offset: 0x00043684
      public int PersonX
      {
        get
        {
          return this.SizeW0;
        }
      }

      // Token: 0x1700007F RID: 127
      // (get) Token: 0x060006B7 RID: 1719 RVA: 0x0004549C File Offset: 0x0004369C
      public int PersonY
      {
        get
        {
          return 0;
        }
      }

      // Token: 0x17000080 RID: 128
      // (get) Token: 0x060006B8 RID: 1720 RVA: 0x000454B0 File Offset: 0x000436B0
      public int PersonW
      {
        get
        {
          return this.SizeW1 - 10;
        }
      }

      // Token: 0x17000081 RID: 129
      // (get) Token: 0x060006B9 RID: 1721 RVA: 0x000454CC File Offset: 0x000436CC
      public int PersonH
      {
        get
        {
          return this.SizeH;
        }
      }

      // Token: 0x17000082 RID: 130
      // (get) Token: 0x060006BA RID: 1722 RVA: 0x000454E4 File Offset: 0x000436E4
      public int TabX
      {
        get
        {
          return this.SizeW0 + this.SizeW1;
        }
      }

      // Token: 0x17000083 RID: 131
      // (get) Token: 0x060006BB RID: 1723 RVA: 0x00045504 File Offset: 0x00043704
      public int TabY
      {
        get
        {
          return 30;
        }
      }

      // Token: 0x17000084 RID: 132
      // (get) Token: 0x060006BC RID: 1724 RVA: 0x00045518 File Offset: 0x00043718
      public int TabW
      {
        get
        {
          return this.SizeW2;
        }
      }

      // Token: 0x17000085 RID: 133
      // (get) Token: 0x060006BD RID: 1725 RVA: 0x00045530 File Offset: 0x00043730
      public int TabH
      {
        get
        {
          return this.SizeH - this.TabY;
        }
      }

      // Token: 0x060006BE RID: 1726 RVA: 0x00045550 File Offset: 0x00043750
      internal EditorUI()
      {
        this.dicData = new Dictionary<CEditor.EditorUI.TabType, ServiceContainer>();
        this.currentTab = CEditor.EditorUI.TabType.BlockBio;
        this.doCloseX = true;
        this.forcePause = CEditor.API.GetO(OptionB.PAUSEGAME);
        this.onlyOneOfTypeAllowed = true;
        this.resizeable = false;
        this.preventCameraMotion = false;
        this.closeOnAccept = false;
        this.draggable = true;
        this.layer = CEditor.Layer;
        SoundTool.PlayThis(SoundDefOf.Tick_Low);
      }

      // Token: 0x060006BF RID: 1727 RVA: 0x000455CC File Offset: 0x000437CC
      // ToDo: bring this back
      //protected override void Finalize()
      //{
      //  try
      //  {
      //    foreach (CEditor.EditorUI.TabType key in this.dicData.Keys)
      //    {
      //      this.dicData[key].Dispose();
      //    }
      //    this.dicData.Clear();
      //  }
      //  finally
      //  {
      //    base.Finalize();
      //  }
      //}

      // Token: 0x060006C0 RID: 1728 RVA: 0x00045658 File Offset: 0x00043858
      private void PreselectPawn(Pawn pawn)
      {
        bool flag = pawn == null;
        if (flag)
        {
          object obj;
          if (!CEditor.InStartingScreen)
          {
            Selector selector = Find.Selector;
            obj = ((selector != null) ? selector.FirstSelectedObject : null);
          }
          else
          {
            obj = null;
          }
          object obj2 = obj;
          bool flag2 = obj2 != null;
          if (flag2)
          {
            Pawn pawn2 = (obj2.GetType() == typeof(Pawn)) ? (obj2 as Pawn) : null;
            Corpse corpse = (obj2.GetType() == typeof(Corpse)) ? (obj2 as Corpse) : null;
            Building_AncientCryptosleepCasket building_AncientCryptosleepCasket = (obj2.GetType() == typeof(Building_AncientCryptosleepCasket)) ? (obj2 as Building_AncientCryptosleepCasket) : null;
            Building_CryptosleepCasket building_CryptosleepCasket = (obj2.GetType() == typeof(Building_CryptosleepCasket)) ? (obj2 as Building_CryptosleepCasket) : null;
            CharacterEditorCascet characterEditorCascet = (obj2.GetType() == typeof(CharacterEditorCascet)) ? (obj2 as CharacterEditorCascet) : null;
            CharacterEditorGrave characterEditorGrave = (obj2.GetType() == typeof(CharacterEditorGrave)) ? (obj2 as CharacterEditorGrave) : null;
            bool flag3 = pawn2 != null;
            if (flag3)
            {
              CEditor.API.Pawn = pawn2;
            }
            else
            {
              bool flag4 = corpse != null;
              if (flag4)
              {
                CEditor.API.Pawn = corpse.InnerPawn;
              }
              else
              {
                bool flag5 = characterEditorCascet != null && characterEditorCascet.ContainedThing != null;
                if (flag5)
                {
                  CEditor.API.Pawn = ((characterEditorCascet.ContainedThing.GetType() == typeof(Pawn)) ? (characterEditorCascet.ContainedThing as Pawn) : null);
                  CEditor.API.Get<Dictionary<int, Building_CryptosleepCasket>>(EType.UIContainers)[0] = characterEditorCascet;
                }
                else
                {
                  bool flag6 = characterEditorGrave != null && characterEditorGrave.ContainedThing != null;
                  if (flag6)
                  {
                    CEditor.API.Pawn = ((characterEditorGrave.ContainedThing.GetType() == typeof(Pawn)) ? (characterEditorGrave.ContainedThing as Pawn) : null);
                    CEditor.API.Get<Dictionary<int, Building_CryptosleepCasket>>(EType.UIContainers)[0] = characterEditorGrave;
                  }
                  else
                  {
                    bool flag7 = building_AncientCryptosleepCasket != null && building_AncientCryptosleepCasket.ContainedThing != null;
                    if (flag7)
                    {
                      CEditor.API.Pawn = ((building_AncientCryptosleepCasket.ContainedThing.GetType() == typeof(Pawn)) ? (building_AncientCryptosleepCasket.ContainedThing as Pawn) : null);
                    }
                    else
                    {
                      bool flag8 = building_CryptosleepCasket != null && building_CryptosleepCasket.ContainedThing != null;
                      if (flag8)
                      {
                        CEditor.API.Pawn = ((building_CryptosleepCasket.ContainedThing.GetType() == typeof(Pawn)) ? (building_CryptosleepCasket.ContainedThing as Pawn) : null);
                      }
                    }
                  }
                }
              }
            }
          }
        }
        else
        {
          CEditor.API.Pawn = pawn;
        }
        this.Get<CEditor.EditorUI.BlockPawnList>(CEditor.EditorUI.TabType.BlockPawnList).ReloadList();
      }

      // Token: 0x060006C1 RID: 1729 RVA: 0x00045934 File Offset: 0x00043B34
      internal void Start(Pawn pawn)
      {
        bool flag = WindowTool.IsOpen<CEditor.EditorUI>();
        if (!flag)
        {
          this.PreselectPawn(pawn);
          this.currentTab = CEditor.EditorUI.TabType.BlockBio;
          WindowTool.Open(this);
        }
      }

      // Token: 0x060006C2 RID: 1730 RVA: 0x00045964 File Offset: 0x00043B64
      public override void Close(bool doCloseSound = true)
      {
        this.currentTab = CEditor.EditorUI.TabType.None;
        CEditor.API.Pawn = null;
        bool flag = !CEditor.InStartingScreen && !CEditor.API.GetO(OptionB.STAYINCASCET);
        if (flag)
        {
          try
          {
            Building_CryptosleepCasket building_CryptosleepCasket = CEditor.API.Get<Dictionary<int, Building_CryptosleepCasket>>(EType.UIContainers)[0];
            if (building_CryptosleepCasket != null)
            {
              building_CryptosleepCasket.EjectContents();
            }
          }
          catch
          {
          }
        }
        WindowTool.TryRemove<DialogColorPicker>();
        bool inStartingScreen = CEditor.InStartingScreen;
        if (inStartingScreen)
        {
          try
          {
            CEditor.pstartInstance.SetMemberValue("curPawn", Find.GameInitData.startingAndOptionalPawns.FirstOrFallback(null));
          }
          catch
          {
          }
        }
        base.Close(doCloseSound);
      }

      // Token: 0x060006C3 RID: 1731 RVA: 0x00045A2C File Offset: 0x00043C2C
      private void DrawTabs(int x, int y, int w, int h)
      {
        bool flag = w <= 0 || CEditor.API.Pawn == null;
        if (!flag)
        {
          int num = w / 8;
          GUI.color = ((this.currentTab == CEditor.EditorUI.TabType.BlockBio) ? Color.yellow : Color.white);
          SZWidgets.ButtonTextVar<CEditor.EditorUI.TabType>((float)x, (float)y, (float)num, (float)h, "TabCharacter".Translate(), new Action<CEditor.EditorUI.TabType>(this.ATabwechsel), CEditor.EditorUI.TabType.BlockBio);
          x += num;
          GUI.color = ((this.currentTab == CEditor.EditorUI.TabType.BlockInventory) ? Color.yellow : Color.white);
          SZWidgets.ButtonTextVar<CEditor.EditorUI.TabType>((float)x, (float)y, (float)num, (float)h, "Inventory".Translate(), new Action<CEditor.EditorUI.TabType>(this.ATabwechsel), CEditor.EditorUI.TabType.BlockInventory);
          x += num;
          GUI.color = ((this.currentTab == CEditor.EditorUI.TabType.BlockHealth) ? Color.yellow : Color.white);
          SZWidgets.ButtonTextVar<CEditor.EditorUI.TabType>((float)x, (float)y, (float)num, (float)h, "Health".Translate(), new Action<CEditor.EditorUI.TabType>(this.ATabwechsel), CEditor.EditorUI.TabType.BlockHealth);
          x += num;
          GUI.color = ((this.currentTab == CEditor.EditorUI.TabType.BlockNeeds) ? Color.yellow : Color.white);
          SZWidgets.ButtonTextVar<CEditor.EditorUI.TabType>((float)x, (float)y, (float)num, (float)h, "TabNeeds".Translate(), new Action<CEditor.EditorUI.TabType>(this.ATabwechsel), CEditor.EditorUI.TabType.BlockNeeds);
          x += num;
          GUI.color = ((this.currentTab == CEditor.EditorUI.TabType.BlockSocial) ? Color.yellow : Color.white);
          SZWidgets.ButtonTextVar<CEditor.EditorUI.TabType>((float)x, (float)y, (float)num, (float)h, "TabSocial".Translate(), new Action<CEditor.EditorUI.TabType>(this.ATabwechsel), CEditor.EditorUI.TabType.BlockSocial);
          x += num;
          GUI.color = ((this.currentTab == CEditor.EditorUI.TabType.BlockLog) ? Color.yellow : Color.white);
          SZWidgets.ButtonTextVar<CEditor.EditorUI.TabType>((float)x, (float)y, (float)num, (float)h, "TabLog".Translate(), new Action<CEditor.EditorUI.TabType>(this.ATabwechsel), CEditor.EditorUI.TabType.BlockLog);
          x += num;
          GUI.color = ((this.currentTab == CEditor.EditorUI.TabType.BlockInfo) ? Color.yellow : Color.white);
          SZWidgets.ButtonTextVar<CEditor.EditorUI.TabType>((float)x, (float)y, (float)num, (float)h, Label.INFO, new Action<CEditor.EditorUI.TabType>(this.ATabwechsel), CEditor.EditorUI.TabType.BlockInfo);
          x += num;
          GUI.color = ((this.currentTab == CEditor.EditorUI.TabType.BlockRecords) ? Color.yellow : Color.white);
          SZWidgets.ButtonTextVar<CEditor.EditorUI.TabType>((float)x, (float)y, (float)num, (float)h, "TabRecords".Translate(), new Action<CEditor.EditorUI.TabType>(this.ATabwechsel), CEditor.EditorUI.TabType.BlockRecords);
        }
      }

      // Token: 0x060006C4 RID: 1732 RVA: 0x00045CA8 File Offset: 0x00043EA8
      private void DrawSelectedTab(int x, int y, int w, int h)
      {
        bool flag = w <= 0;
        if (!flag)
        {
          bool flag2 = CEditor.API.Pawn == null;
          if (!flag2)
          {
            Rect rect = new Rect((float)x, (float)y, (float)w, (float)h);
            CEditor.EditorUI.coord c;
            c.x = x;
            c.y = y;
            c.w = w;
            c.h = h;
            GUI.color = Color.white;
            bool flag3 = this.currentTab == CEditor.EditorUI.TabType.BlockBio;
            if (flag3)
            {
              this.Get<CEditor.EditorUI.BlockBio>(CEditor.EditorUI.TabType.BlockBio).Draw(c);
            }
            else
            {
              bool flag4 = this.currentTab == CEditor.EditorUI.TabType.BlockInventory;
              if (flag4)
              {
                this.Get<CEditor.EditorUI.BlockInventory>(CEditor.EditorUI.TabType.BlockInventory).Draw(c);
              }
              else
              {
                bool flag5 = this.currentTab == CEditor.EditorUI.TabType.BlockHealth;
                if (flag5)
                {
                  this.Get<CEditor.EditorUI.BlockHealth>(CEditor.EditorUI.TabType.BlockHealth).Draw(c);
                }
                else
                {
                  bool flag6 = this.currentTab == CEditor.EditorUI.TabType.BlockNeeds;
                  if (flag6)
                  {
                    this.Get<CEditor.EditorUI.BlockNeeds>(CEditor.EditorUI.TabType.BlockNeeds).Draw(c);
                  }
                  else
                  {
                    bool flag7 = this.currentTab == CEditor.EditorUI.TabType.BlockSocial;
                    if (flag7)
                    {
                      this.Get<CEditor.EditorUI.BlockSocial>(CEditor.EditorUI.TabType.BlockSocial).Draw(c);
                    }
                    else
                    {
                      bool flag8 = this.currentTab == CEditor.EditorUI.TabType.BlockLog;
                      if (flag8)
                      {
                        this.Get<CEditor.EditorUI.BlockLog>(CEditor.EditorUI.TabType.BlockLog).Draw(c);
                      }
                      else
                      {
                        bool flag9 = this.currentTab == CEditor.EditorUI.TabType.BlockInfo;
                        if (flag9)
                        {
                          this.Get<CEditor.EditorUI.BlockInfo>(CEditor.EditorUI.TabType.BlockInfo).Draw(c);
                        }
                        else
                        {
                          bool flag10 = this.currentTab == CEditor.EditorUI.TabType.BlockRecords;
                          if (flag10)
                          {
                            this.Get<CEditor.EditorUI.BlockRecords>(CEditor.EditorUI.TabType.BlockRecords).Draw(c);
                          }
                        }
                      }
                    }
                  }
                }
              }
            }
          }
        }
      }

      // Token: 0x060006C5 RID: 1733 RVA: 0x00045E1C File Offset: 0x0004401C
      public override void DoWindowContents(Rect inRect)
      {
        bool flag = this.currentTab == CEditor.EditorUI.TabType.None;
        if (!flag)
        {
          bool flag2 = this.windowRect.height > 320f;
          if (flag2)
          {
            SZWidgets.ButtonImage((float)this.PersonX, (float)(this.PersonH - 22), 22f, 22f, CEditor.API.GetO(OptionB.SHOWPAWNLIST) ? "bforward" : "bbackward", new Action(this.AShowList), "");
            SZWidgets.ButtonImage((float)(this.PersonX + this.SizeW1 - 32), (float)(this.PersonH - 22), 22f, 22f, CEditor.API.GetO(OptionB.SHOWTABS) ? "bbackward" : "bforward", new Action(this.AShowTabs), "");
          }
          CEditor.EditorUI.coord c;
          c.x = 0;
          c.y = 0;
          c.w = this.SizeW0;
          c.h = this.SizeH;
          this.Get<CEditor.EditorUI.BlockPawnList>(CEditor.EditorUI.TabType.BlockPawnList).Draw(c);
          CEditor.EditorUI.coord c2;
          c2.x = this.PersonX;
          c2.y = this.PersonY;
          c2.w = this.PersonW;
          c2.h = this.PersonH;
          this.Get<CEditor.EditorUI.BlockPerson>(CEditor.EditorUI.TabType.BlockPerson).Draw(c2);
          this.DrawTabs(this.TabX, 0, this.TabW, this.TabY);
          this.DrawSelectedTab(this.TabX, this.TabY, this.TabW, this.TabH);
        }
      }

      // Token: 0x060006C6 RID: 1734 RVA: 0x00045FAB File Offset: 0x000441AB
      private void AShowList()
      {
        CEditor.API.Toggle(OptionB.SHOWPAWNLIST);
      }

      // Token: 0x060006C7 RID: 1735 RVA: 0x00045FBA File Offset: 0x000441BA
      private void AShowTabs()
      {
        CEditor.API.Toggle(OptionB.SHOWTABS);
      }

      // Token: 0x060006C8 RID: 1736 RVA: 0x00045FCC File Offset: 0x000441CC
      private void ATabwechsel(CEditor.EditorUI.TabType tab)
      {
        this.currentTab = tab;
        bool flag = this.currentTab == CEditor.EditorUI.TabType.BlockInfo;
        if (flag)
        {
          StatsReportUtility.Notify_QuickSearchChanged();
        }
      }

      // Token: 0x04000574 RID: 1396
      private CEditor.EditorUI.TabType currentTab;

      // Token: 0x04000575 RID: 1397
      private readonly Dictionary<CEditor.EditorUI.TabType, ServiceContainer> dicData;

      // Token: 0x020000D6 RID: 214
      private enum TabType
      {
        // Token: 0x0400070A RID: 1802
        BlockBio,
        // Token: 0x0400070B RID: 1803
        BlockHealth,
        // Token: 0x0400070C RID: 1804
        BlockInfo,
        // Token: 0x0400070D RID: 1805
        BlockInventory,
        // Token: 0x0400070E RID: 1806
        BlockLog,
        // Token: 0x0400070F RID: 1807
        BlockNeeds,
        // Token: 0x04000710 RID: 1808
        BlockPawnList,
        // Token: 0x04000711 RID: 1809
        BlockPerson,
        // Token: 0x04000712 RID: 1810
        BlockRecords,
        // Token: 0x04000713 RID: 1811
        BlockSocial,
        // Token: 0x04000714 RID: 1812
        None
      }

      // Token: 0x020000D7 RID: 215
      private struct coord
      {
        // Token: 0x04000715 RID: 1813
        internal int x;

        // Token: 0x04000716 RID: 1814
        internal int y;

        // Token: 0x04000717 RID: 1815
        internal int w;

        // Token: 0x04000718 RID: 1816
        internal int h;
      }

      // Token: 0x020000D8 RID: 216
      private class BlockBio
      {
        private int iTickInputName;
        //private Name nameCached;
        private string nameFirstBuffer;
        private string nameNickBuffer;
        private string nameLastBuffer;
        private string nameSingleBuffer;
        //private int iTickInputAge;
        //private int iTickInputSkill;
        private bool bAgeInputOpen = false;
        private const int iTickMax = 5;
        private EntryFloat entryChrAge = new EntryFloat(customRounding: 2);
        private EntryFloat entryBioAge = new EntryFloat(customRounding: 2);
        private string ttip;
        private string selectedParamName = "";
        private Regex regexInt;
        private Vector2 scrollPosParam = default(Vector2);
        private bool bRemoveAbility;
        private bool bRemoveTrait;
        private bool bShowPsyValues = false;
        private Vector2 scrollTraits;
        private List<Trait> lCopyTraits;
        private List<Ability> lCopyAbilities;
        private List<SkillRecord> lOfCopySkills;
        private List<Pawn> lOfColonists;
        private RoyalTitle currentTitle;
        private BackstoryDef oBackAdult;
        private BackstoryDef oBackChild;
        private List<RoyalTitleDef> lOfRoyalTitles;
        private Pawn selectedTrainer;
        private Ideo selectedIdeo = null;
        private string uniqueID;
        private Func<Trait, string> FTraitLabel = delegate (Trait t)
        {
          string result;
          if ((result = t.LabelCap) == null)
          {
            result = (t.Label ?? t.def.label);
          }
          return result;
        };
        private Func<Trait, Trait, bool> FTraitComparator = (Trait tA, Trait tB) => tA == tB;
        private Func<Trait, string> FTraitTooltip;
        private string tooltip1 = "";
        private string tooltip2 = "";
        private Dictionary<SkillDef, EntryInt> skillEntryDict = new Dictionary<SkillDef, EntryInt>();



        // Token: 0x06000883 RID: 2179 RVA: 0x00049334 File Offset: 0x00047534
        internal BlockBio()
        {
          this.iTickInputName = 0;
          this.bAgeInputOpen = false;
          //this.iTickInputAge = 0;
          //this.iTickInputSkill = 0;
          //this.iChronoAge = 0;
          //this.chronoAgeBuffer = "";
          //this.iAge = 0;
          //this.ageBuffer = "";
          this.uniqueID = null;
          this.FTraitTooltip = new Func<Trait, string>(this.GetTraitTooltip);
          this.bRemoveTrait = false;
          this.bRemoveAbility = false;
          this.scrollTraits = default(Vector2);
          this.lCopyTraits = new List<Trait>();
          this.lCopyAbilities = new List<Ability>();
          this.lOfCopySkills = new List<SkillRecord>();
          Game game = Current.Game;
          World world = (game != null) ? game.World : null;
          this.lOfColonists = ((world == null) ? null : PawnxTool.GetPawnList(Label.COLONISTS, true, Faction.OfPlayer));
          this.lOfRoyalTitles = DefTool.ListBy<RoyalTitleDef>((RoyalTitleDef title) => true).ToList<RoyalTitleDef>();
          this.lOfRoyalTitles.Insert(0, null);
          this.selectedTrainer = null;
          this.currentTitle = null;
          this.regexInt = new Regex("^[0-9]*");
        }

        // Token: 0x06000884 RID: 2180 RVA: 0x000494E4 File Offset: 0x000476E4
        internal void Draw(CEditor.EditorUI.coord c)
        {
          int x = c.x;
          int y = c.y;
          int w = c.w;
          int h = c.h;
          if (CEditor.API.Pawn != null)
          {
            this.CheckCachedPawnID();
            this.DrawName(x + 20, y + 30, w, 30);
            this.DrawDesc(x + 20, y + 60, w, 30);
            this.DrawBackstory(x + 20, y + 100);
            this.DrawIncapableOf(x + 20, y + 205);
            this.DrawTraits(x + 20, y + 305, h);
            this.DrawSkills(x + 330, y + 100);
            this.DrawAbilities(x + 330, y + 500);
            this.DrawPsycasts(x + 590, y + 380);
            this.DrawTraining(x + 20, y + 100, w, h - 100);
            this.DrawFaction(x + 600, y + 30, 250);
            this.DrawIdeo(x + 600, y + 60, 250);
            this.DrawTitle(x + 600, y + 90, 250);
            this.DrawExtendables(x + 600, y + 120, 30);
            this.DrawCapsule(x + 590, y + 200, 200, 144);
            this.DrawLowerButtons(x, y, w, h);
          }
        }

        private void CheckCachedPawnID()
        {
          Pawn pawn = CEditor.API.Pawn;
          if (pawn == null)
          {
            return;
          }
          if (this.uniqueID == pawn.ThingID)
          {
            return;
          }
          //Log.Message("CheckCachedPawnID, setting for pawn " + pawn);
          this.uniqueID = pawn.ThingID;
          if (pawn.Name is NameTriple triple)
          {
            this.nameFirstBuffer = triple.First;
            this.nameNickBuffer = triple.Nick;
            this.nameLastBuffer = triple.Last;
          }
          else if (pawn.Name is NameSingle single)
          {
            this.nameSingleBuffer = single.Name;
          }
          if (pawn.HasAgeTracker())
          {
            ////Log.Message("CheckCachedPawnID, bio age = " + pawn.ageTracker.AgeBiologicalYearsFloat);
            ////Log.Message("CheckCachedPawnID, chr age = " + pawn.ageTracker.AgeChronologicalYearsFloat);
            this.entryBioAge.UpdateValueAndBuffer(pawn.ageTracker.AgeBiologicalYearsFloat);
            this.entryChrAge.UpdateValueAndBuffer(pawn.ageTracker.AgeChronologicalYearsFloat);
            ////Log.Message("CheckCachedPawnID, entryBioAge: " + entryBioAge.valFloat + ", buffer: " + entryBioAge.buffer);
            ////Log.Message("CheckCachedPawnID, entryChrAge: " + entryChrAge.valFloat + ", buffer: " + entryChrAge.buffer);
          }
          if (pawn.HasSkillTracker())
          {
            foreach (SkillRecord s in pawn.skills.skills)
            {
              if (!this.skillEntryDict.TryGetValue(s.def, out EntryInt entry))
              {
                entry = new EntryInt(customControlName: "EntryIntTextField_SkillDef_" + s.def.defName);
                this.skillEntryDict[s.def] = entry;
              }
              entry.UpdateValueAndBuffer(s.levelInt);
            }
          }
        }

        private string GetTraitTooltip(Trait t)
        {
          string result;
          try
          {
            result = t.TipString(CEditor.API.Pawn);
          }
          catch
          {
            result = "";
          }
          return result;
        }

        private void DrawLowerButtons(int x, int y, int w, int h)
        {
          try
          {
            bool flag = CEditor.API.Pawn.Faction != Faction.OfPlayer && CEditor.API.Pawn.Faction != Faction.OfMechanoids && !CEditor.API.Pawn.Dead;
            if (flag)
            {
              GUI.color = Color.white;
              SZWidgets.ButtonText(new Rect((float)(x + w - 120), (float)(y + h - 30), 120f, 30f), Label.RECRUIT, new Action(this.ARecruit), "");
              SZWidgets.ButtonText(new Rect((float)(x + w - 240), (float)(y + h - 30), 120f, 30f), Label.ENSLAVE, new Action(this.AEnslave), "");
            }
          }
          catch (Exception ex)
          {
            bool devMode = Prefs.DevMode;
            if (devMode)
            {
              Log.Error(ex.Message + "\n" + ex.StackTrace);
            }
          }
        }

        // Token: 0x06000886 RID: 2182 RVA: 0x0004976C File Offset: 0x0004796C
        private void ARecruit()
        {
          CEditor.API.Pawn.RecruitPawn();
        }

        // Token: 0x06000887 RID: 2183 RVA: 0x0004977F File Offset: 0x0004797F
        private void AEnslave()
        {
          CEditor.API.Pawn.EnslavePawn();
        }

        // Token: 0x06000888 RID: 2184 RVA: 0x00049794 File Offset: 0x00047994
        private void DrawBiologicalAge(float x, float y)
        {
          if (DrawEntryAge(x, y, entryBioAge, "AgeBiological".Translate().ToString().SubstringTo(":", false), 150f))
          {
            CEditor.API.Pawn.SetBioAge(this.entryBioAge.valFloat);
            if (this.entryChrAge.valFloat < this.entryBioAge.valFloat)
            {
              CEditor.API.Pawn.SetChrAge(entryBioAge.valFloat);
            }
          }
        }

        private void DrawChronologicalAge(float x, float y)
        {
          if (DrawEntryAge(x, y, entryChrAge, "AgeChronological".Translate().ToString().SubstringTo(":", false), 165f))
          {
            CEditor.API.Pawn.SetChrAge(entryChrAge.valFloat);
            if (this.entryChrAge.valFloat < this.entryBioAge.valFloat)
            {
              CEditor.API.Pawn.SetBioAge(entryChrAge.valFloat);
            }
          }
        }

        private bool DrawEntryAge(float x, float y, EntryFloat entryAge, string label, float labelWidth)
        {
          float ageCached = entryAge.valFloat;
          Text.WordWrap = false;
          Widgets.Label(new Rect(x + 25f, y + 1f, labelWidth, 24f), label);
          Text.WordWrap = true;
          x += labelWidth;
          entryAge.NumericTextField(x, y, 50f, 24f, 0f, 15500f, true, false);
          return ageCached != entryAge.valFloat;
        }

        // Token: 0x0600088A RID: 2186 RVA: 0x00049A5C File Offset: 0x00047C5C
        private void DrawDesc(int x, int y, int w, int h)
        {
          try
          {
            Text.Font = GameFont.Small;
            Rect rect = new Rect(x, y, w - 200, h);
            Rect rect2 = new Rect(rect.x + 100f, rect.y, rect.width - 300f, rect.height);
            Rect rect3 = new Rect(x, y, 100f, 25f);
            //bool flag = this.iTickInputAge > 0;
            //if (flag)
            //{
            //  bool flag2 = this.uniqueID != CEditor.API.Pawn.ThingID;
            //  if (flag2)
            //  {
            //    this.iTickInputAge = 0;
            //  }
            //  else
            //  {
            //    this.DrawBiologicalAge((int)rect.x - 25, (int)rect.y);
            //    this.DrawChronologicalAge((int)rect.x + 250, (int)rect.y);
            //    this.iTickInputAge--;
            //  }
            //}



            if (this.bAgeInputOpen)
            {
              if (Mouse.IsOver(new Rect(x, y - 30f, w + 40f, h + 40f)))
              {
                this.entryBioAge.Open = true;
                this.entryChrAge.Open = true;
              }
              int maxTicker = Math.Max(this.entryBioAge.ticker, this.entryChrAge.ticker);
              this.bAgeInputOpen = maxTicker > 0;

              this.entryBioAge.ticker = maxTicker;
              this.entryChrAge.ticker = maxTicker;
              this.DrawBiologicalAge(rect.x - 25f, rect.y);
              this.DrawChronologicalAge(rect.x + 250f, rect.y);
              SZWidgets.ButtonImage(rect.x + 250f - 25f, rect.y, 24f, 24f, "bstar", new Action(this.AAddBirthdayTick), "Set date and hour of birth.");
            }
            else
            {
              // ToDo: translate tooltip
              SZWidgets.ButtonInvisible(rect3, new Action(this.AConfirmRaceChange), "Click to change class and race.");
              SZWidgets.ButtonInvisible(rect2, new Action(this.ABeginAgeChange), "Click to change age.");
              Widgets.Label(rect, CEditor.API.Pawn.GetPawnDescription(null));
            }
            TooltipHandler.TipRegion(rect3, CEditor.RACEDESC(CEditor.API.Pawn.def));
            TooltipHandler.TipRegion(rect2, () => CEditor.API.Pawn.ageTracker.AgeTooltipString, 6873641);

          }
          catch (Exception ex)
          {
            if (Prefs.DevMode)
            {
              Log.Error(ex.Message + "\n" + ex.StackTrace);
            }
          }
        }

        // Token: 0x0600088B RID: 2187 RVA: 0x00049C48 File Offset: 0x00047E48
        private void DrawNameTriple(Rect rName)
        {
          string[] controlNames = { "TextFieldFirstName", "TextFieldNickName", "TextFieldLastName" };

          GUI.BeginGroup(rName);
          //NameTriple nameTriple = CEditor.API.Pawn.Name as NameTriple;

          //GUI.color = Color.white;
          //GUI.SetNextControlName(controlNames[0]);
          //string text = Widgets.TextField(new Rect(0f, 0f, 100f, 28f), nameTriple.First, 17, CharacterCardUtility.ValidNameRegex);
          //if (nameTriple.Nick == text || nameTriple.Nick == nameTriple.Last)
          //{
          //  GUI.color = new Color(1f, 1f, 1f, 0.5f);
          //}
          //if (nameTriple.Nick == text || nameTriple.Nick == this.nameLastBuffer)
          //{
          //  GUI.color = new Color(1f, 1f, 1f, 0.5f);
          //}
          //GUI.SetNextControlName(controlNames[1]);
          //string text2 = Widgets.TextField(new Rect(105f, 0f, 100f, 28f), nameTriple.Nick, 17, CharacterCardUtility.ValidNameRegex);
          //GUI.color = Color.white;
          //GUI.SetNextControlName(controlNames[2]);
          //string text3 = Widgets.TextField(new Rect(210f, 0f, 100f, 28f), nameTriple.Last, 17, CharacterCardUtility.ValidNameRegex);
          //if (nameTriple.First != text || nameTriple.Nick != text2 || nameTriple.Last != text3)
          //{
          //  this.nameCached = new NameTriple(text, text2, text3);
          //  this.iTickInputName = iTickMax;
          //}

          GUI.color = Color.white;
          GUI.SetNextControlName(controlNames[0]);
          this.nameFirstBuffer = Widgets.TextField(new Rect(0f, 0f, 100f, 28f), this.nameFirstBuffer, 17, CharacterCardUtility.ValidNameRegex);
          GUI.SetNextControlName(controlNames[2]);
          this.nameLastBuffer = Widgets.TextField(new Rect(210f, 0f, 100f, 28f), this.nameLastBuffer, 17, CharacterCardUtility.ValidNameRegex);
          if (this.nameNickBuffer == this.nameFirstBuffer || this.nameNickBuffer == this.nameLastBuffer)
          {
            GUI.color = new Color(1f, 1f, 1f, 0.5f);
          }
          GUI.SetNextControlName(controlNames[1]);
          this.nameNickBuffer = Widgets.TextField(new Rect(105f, 0f, 100f, 28f), this.nameNickBuffer, 17, CharacterCardUtility.ValidNameRegex);
          GUI.color = Color.white;

          string first = this.nameFirstBuffer.NullOrEmpty() ? " " : this.nameFirstBuffer;
          string last = this.nameLastBuffer.NullOrEmpty() ? " " : this.nameLastBuffer;

          CEditor.API.Pawn.Name = new NameTriple(first, this.nameNickBuffer, last);

          if (controlNames.Contains(GUI.GetNameOfFocusedControl()))
          {
            this.iTickInputName = iTickMax;
          }

          SZWidgets.ButtonImageCol(new Rect(320f, 2f, 25f, 25f), "brandom", new Action(this.AChangeNameTriple), Color.white, Label.TIP_CHANGE_NAME);
          SZWidgets.ButtonImageCol(new Rect(350f, 2f, 25f, 25f), "brandom", new Action(this.AChangeNameTripleAll), ColorLibrary.Beige, Label.TIP_CHANGE_NAME_ALL);

          TooltipHandler.TipRegion(new Rect(0f, 0f, 100f, 30f), "FirstNameDesc".Translate());
          TooltipHandler.TipRegion(new Rect(105f, 0f, 100f, 30f), "ShortIdentifierDesc".Translate());
          TooltipHandler.TipRegion(new Rect(210f, 0f, 100f, 30f), "LastNameDesc".Translate());
          GUI.EndGroup();
          GUI.color = Color.white;
        }

        // Token: 0x0600088C RID: 2188 RVA: 0x00049EB8 File Offset: 0x000480B8
        //private void ResetTickInput()
        //{
        //  this.iTickInputName = 5;
        //}

        // Token: 0x0600088D RID: 2189 RVA: 0x00049EC5 File Offset: 0x000480C5
        private void AChangeNameTriple()
        {
          CEditor.API.Pawn.Name = PawnBioAndNameGenerator.GeneratePawnName(CEditor.API.Pawn, NameStyle.Full, null);
          //this.ResetTickInput();
        }

        // Token: 0x0600088E RID: 2190 RVA: 0x00049EF0 File Offset: 0x000480F0
        private void AChangeNameTripleAll()
        {
          GenderPossibility gp = (CEditor.API.Pawn.gender == Gender.Male) ? GenderPossibility.Male : ((CEditor.API.Pawn.gender == Gender.Female) ? GenderPossibility.Female : GenderPossibility.Either);
          CEditor.API.Pawn.Name = PawnNameDatabaseSolid.GetListForGender(gp).RandomElement<NameTriple>();


          //this.ResetTickInput();
        }

        // Token: 0x0600088F RID: 2191 RVA: 0x00049F4C File Offset: 0x0004814C
        private void DrawNameSingle(Rect rName)
        {
          GUI.BeginGroup(rName);
          if (CEditor.API.Pawn.Name == null)
          {
            CEditor.API.Pawn.Name = new NameSingle(CEditor.API.Pawn.kindDef.label, false);
            this.nameSingleBuffer = (CEditor.API.Pawn.Name as NameSingle).Name;
          }
          //NameSingle nameSingle = CEditor.API.Pawn.Name as NameSingle;
          //string text = nameSingle.Name ?? CEditor.API.Pawn.kindDef.label;
          //GUI.color = Color.white;
          //Rect rect = new Rect(0f, 0f, 200f, 28f);
          //string controlName = "TextFieldNameSingle";
          //GUI.SetNextControlName(controlName);
          //text = Widgets.TextField(rect, text, 64, CharacterCardUtility.ValidNameRegex);
          //if (GUI.GetNameOfFocusedControl() == controlName)
          //{
          //  this.iTickInputName = iTickMax;
          //}
          //if (nameSingle.Name != text)
          //{
          //  CEditor.API.Pawn.Name = new NameSingle(text, false);
          //  this.iTickInputName = iTickMax;
          //}

          Rect rect = new Rect(0f, 0f, 200f, 28f);
          string controlName = "TextFieldNameSingle";
          GUI.SetNextControlName(controlName);
          this.nameSingleBuffer = Widgets.TextField(rect, this.nameSingleBuffer, 64, CharacterCardUtility.ValidNameRegex);
          if (GUI.GetNameOfFocusedControl() == controlName)
          {
            this.iTickInputName = iTickMax;
          }

          Rect butRect = new Rect(rect.x + rect.width + 10f, rect.y, rect.height, rect.height);
          if (Widgets.ButtonImage(butRect, ContentFinder<Texture2D>.Get("brandom", true), true))
          {
            CEditor.API.Pawn.Name = PawnBioAndNameGenerator.GeneratePawnName(CEditor.API.Pawn, NameStyle.Full, null);
          }
          else
          {
            string name = this.nameSingleBuffer.NullOrEmpty() ? CEditor.API.Pawn.kindDef.label : this.nameSingleBuffer;
            CEditor.API.Pawn.Name = new NameSingle(name, false);
          }
          TooltipHandler.TipRegion(rect, "FirstNameDesc".Translate());
          GUI.EndGroup();
        }

        // Token: 0x06000890 RID: 2192 RVA: 0x0004A0C8 File Offset: 0x000482C8
        private void DrawName(float x, float y, float w, float h)
        {
          try
          {
            Rect rect = new Rect(x, y, w, h);
            if (OriginalEventUtility.EventType == EventType.MouseDown && !Mouse.IsOver(rect))
            {
              this.iTickInputName = 0;
            }
            bool keyDown = Event.current.type == EventType.KeyDown;
            bool enter = Event.current.keyCode == KeyCode.KeypadEnter;
            if (keyDown || enter)
            {
              //Log.Message("KeyDown: " + keyDown + ", enter: " + enter);
            }
            if (this.iTickInputName > 0 && keyDown && enter)
            {
              //Log.Message("DrawName, pressing enter set iTickInputName = 0");
              this.iTickInputName = 0;
              Event.current.Use();
            }
            if (Mouse.IsOver(new Rect(x, y - 20f, w, h + 40f)) && this.iTickInputName > 0)
            {
              this.iTickInputName = iTickMax;
            }
            if (this.iTickInputName > 0)
            {
              Name name = CEditor.API.Pawn.Name;
              bool flag2 = ((name != null) ? name.GetType() : null) == typeof(NameTriple);
              if (flag2)
              {
                this.DrawNameTriple(rect);
                //CEditor.API.Pawn.Name = new NameTriple(this.nameFirstBuffer, this.nameNickBuffer, this.nameLastBuffer);
              }
              else
              {
                this.DrawNameSingle(rect);
                //CEditor.API.Pawn.Name = new NameSingle(this.nameSingleBuffer, false);
              }
              this.iTickInputName--;

            }
            else
            {
              Text.Font = GameFont.Medium;
              this.currentTitle = (CEditor.API.Pawn.HasRoyalTitle() ? CEditor.API.Pawn.royalty.AllTitlesForReading.First<RoyalTitle>() : null);
              if (this.currentTitle != null)
              {
                int num = this.currentTitle.def.LabelCap.Length * 12;
                string toolTip = (string)typeof(CharacterCardUtility).CallMethod("GetTitleTipString", new object[]
                {
                  CEditor.API.Pawn,
                  this.currentTitle.faction,
                  this.currentTitle,
                  CEditor.API.Pawn.royalty.GetFavor(this.currentTitle.faction)
                });
                SZWidgets.Label(rect, this.currentTitle.def.GetLabelCapFor(CEditor.API.Pawn) + " " + CEditor.API.Pawn.GetPawnNameColored(true), null, "");
                SZWidgets.ButtonInvisibleVar<RoyalTitle>(new Rect(x, y, num, h), new Action<RoyalTitle>(this.AShowTitle), this.currentTitle, toolTip);
                //SZWidgets.ButtonInvisible(new Rect((float)(x + num), (float)y, 300f, (float)h), null, "Rename".Translate());
                //TooltipHandler.TipRegion(new Rect(x + num, y, 300f, h), () => "Rename".Translate(), 238951);
              }
              else
              {
                SZWidgets.Label(rect, CEditor.API.Pawn.GetPawnNameColored(true), null, "");
                SZWidgets.ButtonInvisible(new Rect(x, y - 20f, 300f, h + 20f), new Action(this.ABeginEditName), "Rename".Translate());
                //SZWidgets.ButtonInvisible(new Rect(x, y, 300f, h), new Action(this.ABeginEditName), "Rename".Translate());
                //TooltipHandler.TipRegion(new Rect(x, y, 300f, h), () => "Rename".Translate(), 3292024);
              }
            }
          }
          catch (Exception ex)
          {
            bool devMode = Prefs.DevMode;
            if (devMode)
            {
              Log.Error(ex.Message + "\n" + ex.StackTrace);
            }
          }
        }

        // Token: 0x06000891 RID: 2193 RVA: 0x0004A368 File Offset: 0x00048568
        private void ARemoveTitle()
        {
          bool flag = this.currentTitle != null;
          if (flag)
          {
            CEditor.API.Pawn.RemoveTitle(this.currentTitle);
          }
        }

        // Token: 0x06000892 RID: 2194 RVA: 0x0004A399 File Offset: 0x00048599
        private void ABeginEditName()
        {
          this.iTickInputName = iTickMax;
        }

        // Token: 0x06000893 RID: 2195 RVA: 0x0004A3A7 File Offset: 0x000485A7
        private void AShowTitle(RoyalTitle r)
        {
          WindowTool.Open(new Dialog_InfoCard(r.def, r.faction, null));
        }

        // Token: 0x06000894 RID: 2196 RVA: 0x0004A3C4 File Offset: 0x000485C4
        private void ASetTitle(RoyalTitleDef r)
        {
          bool flag = r == null;
          if (flag)
          {
            this.ARemoveTitle();
          }
          else
          {
            CEditor.API.Pawn.SetTitle(r.defName);
          }
        }

        private void AConfirmRaceChange()
        {
          WindowTool.Open(new DialogChangeRace(CEditor.API.Pawn));
        }

        private void ABeginAgeChange()
        {
          ////Log.Message("ABeginAgeChange, bio age = " + CEditor.API.Pawn.ageTracker.AgeBiologicalYearsFloat);
          ////Log.Message("ABeginAgeChange, chr age = " + CEditor.API.Pawn.ageTracker.AgeChronologicalYearsFloat);
          this.entryBioAge.UpdateValueAndBuffer(CEditor.API.Pawn.ageTracker.AgeBiologicalYearsFloat);
          this.entryChrAge.UpdateValueAndBuffer(CEditor.API.Pawn.ageTracker.AgeChronologicalYearsFloat);
          ////Log.Message("ABeginAgeChange, entryBioAge: " + entryBioAge.valFloat + ", buffer: " + entryBioAge.buffer);
          ////Log.Message("ABeginAgeChange, entryChrAge: " + entryChrAge.valFloat + ", buffer: " + entryChrAge.buffer);
          this.entryBioAge.Open = true;
          this.entryChrAge.Open = true;
          this.bAgeInputOpen = true;
        }

        //private void AAddAge()
        //{
        //  this.iAge++;
        //  CEditor.API.Pawn.SetAge(this.iAge);
        //  //this.ageBuffer = this.iAge.ToString();
        //  //this.iTickInputAge = iTickMax;
        //}

        //private void ASubAge()
        //{
        //  if (this.iAge > 0)
        //  {
        //    this.iAge--;
        //  }
        //  CEditor.API.Pawn.SetAge(this.iAge);
        //  //this.ageBuffer = this.iAge.ToString();
        //  //this.iTickInputAge = iTickMax;
        //}

        //private void AAddChronoAge()
        //{
        //  if (this.iChronoAge < 15500)
        //  {
        //    this.iChronoAge++;
        //  }
        //  CEditor.API.Pawn.SetChrAge(this.iChronoAge);
        //  this.chronoAgeBuffer = this.iChronoAge.ToString();
        //  //this.iTickInputAge = iTickMax;
        //}

        //private void ASubChronoAge()
        //{
        //  bool flag = this.iChronoAge > 0;
        //  if (flag)
        //  {
        //    this.iChronoAge--;
        //  }
        //  CEditor.API.Pawn.SetChrAge(this.iChronoAge);
        //  //this.chronoAgeBuffer = this.iChronoAge.ToString();
        //  //this.iTickInputAge = iTickMax;
        //}

        // Token: 0x0600089B RID: 2203 RVA: 0x0004A5FF File Offset: 0x000487FF
        private void AAddBirthdayTick()
        {
          //this.iTickInputAge = 0;
          WindowTool.Open(new DialogChangeBirthday(CEditor.API.Pawn));
        }

        // Token: 0x0600089C RID: 2204 RVA: 0x0004A620 File Offset: 0x00048820
        private void DrawBackstory(int x, int y)
        {
          try
          {
            bool flag = CEditor.API.Pawn.story != null;
            if (flag)
            {
              Text.Font = GameFont.Medium;
              Widgets.Label(new Rect((float)x, (float)y, 250f, 30f), "Backstory".Translate());
              y += 35;
              Rect rect = new Rect((float)(x - 24), (float)y, 320f, 30f);
              bool flag2 = Mouse.IsOver(rect);
              if (flag2)
              {
                BackstoryDef childhood = CEditor.API.Pawn.story.Childhood;
                this.tooltip1 = ((childhood != null) ? childhood.FullDescriptionFor(CEditor.API.Pawn).Resolve() : null);
              }
              Rect rect2 = rect;
              Action onClicked = new Action(this.AChangeChildhoodUI);
              Action onRandom = new Action(this.ARandomChildhood);
              Action onPrev = new Action(this.ASetPrevChildhood);
              Action onNext = new Action(this.ASetNextChildhood);
              Action onTextureClick = null;
              Action onToggle = null;
              TaggedString t = "Childhood".Translate() + ": ";
              BackstoryDef childhood2 = CEditor.API.Pawn.story.Childhood;
              SZWidgets.NavSelectorImageBox(rect2, onClicked, onRandom, onPrev, onNext, onTextureClick, onToggle, t + ((childhood2 != null) ? childhood2.TitleCapFor(CEditor.API.Pawn.gender) : null), this.tooltip1, null, null, null, default(Color));
              y += 30;
              Rect rect3 = new Rect((float)(x - 24), (float)y, 320f, 30f);
              bool flag3 = Mouse.IsOver(rect3);
              if (flag3)
              {
                BackstoryDef adulthood = CEditor.API.Pawn.story.Adulthood;
                this.tooltip2 = ((adulthood != null) ? adulthood.FullDescriptionFor(CEditor.API.Pawn).Resolve() : null);
              }
              Rect rect4 = rect3;
              Action onClicked2 = new Action(this.AChangeAdulthoodUI);
              Action onRandom2 = new Action(this.ARandomAdulthood);
              Action onPrev2 = new Action(this.ASetPrevAdulthood);
              Action onNext2 = new Action(this.ASetNextAdulthood);
              Action onTextureClick2 = null;
              Action onToggle2 = null;
              TaggedString t2 = "Adulthood".Translate() + ": ";
              BackstoryDef adulthood2 = CEditor.API.Pawn.story.Adulthood;
              SZWidgets.NavSelectorImageBox(rect4, onClicked2, onRandom2, onPrev2, onNext2, onTextureClick2, onToggle2, t2 + ((adulthood2 != null) ? adulthood2.TitleCapFor(CEditor.API.Pawn.gender) : null), this.tooltip2, null, null, null, default(Color));
            }
          }
          catch (Exception ex)
          {
            bool devMode = Prefs.DevMode;
            if (devMode)
            {
              Log.Error(ex.Message + "\n" + ex.StackTrace);
            }
          }
        }

        // Token: 0x0600089D RID: 2205 RVA: 0x0004A8B8 File Offset: 0x00048AB8
        private void ARandomChildhood()
        {
          this.RememberOldBackstory();
          CEditor.API.Pawn.SetBackstory(true, true, true, false);
          this.RecalcSkills();
        }

        // Token: 0x0600089E RID: 2206 RVA: 0x0004A8DD File Offset: 0x00048ADD
        private void ARandomAdulthood()
        {
          this.RememberOldBackstory();
          CEditor.API.Pawn.SetBackstory(true, true, false, false);
          this.RecalcSkills();
        }

        // Token: 0x0600089F RID: 2207 RVA: 0x0004A902 File Offset: 0x00048B02
        private void ASetNextChildhood()
        {
          this.RememberOldBackstory();
          CEditor.API.Pawn.SetBackstory(true, false, true, false);
          this.RecalcSkills();
        }

        // Token: 0x060008A0 RID: 2208 RVA: 0x0004A927 File Offset: 0x00048B27
        private void ASetPrevChildhood()
        {
          this.RememberOldBackstory();
          CEditor.API.Pawn.SetBackstory(false, false, true, false);
          this.RecalcSkills();
        }

        // Token: 0x060008A1 RID: 2209 RVA: 0x0004A94C File Offset: 0x00048B4C
        private void AChangeChildhoodUI()
        {
          WindowTool.Open(new DialogChangeBackstory(true));
        }

        // Token: 0x060008A2 RID: 2210 RVA: 0x0004A95B File Offset: 0x00048B5B
        private void AChangeAdulthoodUI()
        {
          WindowTool.Open(new DialogChangeBackstory(false));
        }

        // Token: 0x060008A3 RID: 2211 RVA: 0x0004A96A File Offset: 0x00048B6A
        private void ASetNextAdulthood()
        {
          this.RememberOldBackstory();
          CEditor.API.Pawn.SetBackstory(true, false, false, false);
          this.RecalcSkills();
        }

        // Token: 0x060008A4 RID: 2212 RVA: 0x0004A98F File Offset: 0x00048B8F
        private void ASetPrevAdulthood()
        {
          this.RememberOldBackstory();
          CEditor.API.Pawn.SetBackstory(false, false, false, false);
          this.RecalcSkills();
        }

        // Token: 0x060008A5 RID: 2213 RVA: 0x0004A9B4 File Offset: 0x00048BB4
        public void RememberOldBackstory()
        {
          this.oBackAdult = CEditor.API.Pawn.story.GetBackstory(BackstorySlot.Adulthood);
          this.oBackChild = CEditor.API.Pawn.story.GetBackstory(BackstorySlot.Childhood);
        }

        // Token: 0x060008A6 RID: 2214 RVA: 0x0004A9F0 File Offset: 0x00048BF0
        public void RecalcSkills()
        {
          BackstoryDef backstory = CEditor.API.Pawn.story.GetBackstory(BackstorySlot.Adulthood);
          BackstoryDef backstory2 = CEditor.API.Pawn.story.GetBackstory(BackstorySlot.Childhood);
          foreach (SkillRecord skillRecord in CEditor.API.Pawn.skills.skills)
          {
            skillRecord.Level -= ((this.oBackAdult == null) ? 0 : this.oBackAdult.skillGains.TryGetValue(skillRecord.def, 0));
            skillRecord.Level -= ((this.oBackChild == null) ? 0 : this.oBackChild.skillGains.TryGetValue(skillRecord.def, 0));
            skillRecord.Level += ((backstory == null) ? 0 : backstory.skillGains.TryGetValue(skillRecord.def, 0));
            skillRecord.Level += ((backstory2 == null) ? 0 : backstory2.skillGains.TryGetValue(skillRecord.def, 0));
          }
        }

        // Token: 0x060008A7 RID: 2215 RVA: 0x0004AB30 File Offset: 0x00048D30
        private void DrawIncapableOf(int x, int y)
        {
          try
          {
            bool flag = CEditor.API.Pawn.story != null;
            if (flag)
            {
              Text.Font = GameFont.Medium;
              Widgets.Label(new Rect((float)x, (float)y, 270f, 30f), "IncapableOf".Translate(CEditor.API.Pawn));
              y += 30;
              Text.Font = GameFont.Small;
              Widgets.Label(new Rect((float)x, (float)y, 270f, 60f), CEditor.API.Pawn.GetIncapableOf(out this.ttip));
              SZWidgets.ButtonInvisible(new Rect((float)x, (float)y, 270f, 60f), null, this.ttip);
            }
          }
          catch (Exception ex)
          {
            bool devMode = Prefs.DevMode;
            if (devMode)
            {
              Log.Error(ex.Message + "\n" + ex.StackTrace);
            }
          }
        }

        // Token: 0x060008A8 RID: 2216 RVA: 0x0004AC2C File Offset: 0x00048E2C
        private void DrawFaction(int x, int y, int w)
        {
          GUI.color = Color.white;
          bool flag = CEditor.API.Pawn.Faction != null;
          if (flag)
          {
            try
            {
              string text = CEditor.API.Pawn.Faction.Name.CapitalizeFirst().Colorize(CEditor.API.Pawn.Faction.Color);
              Faction faction = CEditor.API.Pawn.Faction;
              string text2;
              if (faction == null)
              {
                text2 = null;
              }
              else
              {
                FactionDef def = faction.def;
                text2 = ((def != null) ? def.factionIconPath : null);
              }
              string texPath = text2 ?? "bwhite";
              Color facionColor = CEditor.API.Pawn.GetFacionColor();
              string factionFullDesc = CEditor.API.Pawn.GetFactionFullDesc(null);
              SZWidgets.ButtonTextureTextHighlight2(new Rect((float)x, (float)y, (float)w, 30f), text, texPath, facionColor, new Action(this.AChangeFaction), factionFullDesc, true);
            }
            catch (Exception ex)
            {
              bool devMode = Prefs.DevMode;
              if (devMode)
              {
                Log.Error(ex.Message + "\n" + ex.StackTrace);
              }
            }
          }
          else
          {
            SZWidgets.ButtonTextureTextHighlight2(new Rect((float)x, (float)y, (float)w, 30f), Label.NONE, "bwhite", Color.white, new Action(this.AChangeFaction), "", true);
          }
        }

        // Token: 0x060008A9 RID: 2217 RVA: 0x0004AD8C File Offset: 0x00048F8C
        private void DrawIdeo(int x, int y, int w)
        {
          Pawn pawn = CEditor.API.Pawn;
          bool flag = ModsConfig.IdeologyActive && pawn.ideo != null;
          if (flag)
          {
            Window windowOf = WindowTool.GetWindowOf<Dialog_ConfigureIdeo>();
            bool flag2 = windowOf != null;
            if (flag2)
            {
              this.selectedIdeo = IdeoUIUtility.selected;
            }
            string text = (pawn.Ideo != null) ? pawn.Ideo.name : "";
            Texture2D icon = (pawn.Ideo != null) ? pawn.Ideo.Icon : Texture2D.whiteTexture;
            Color color = (pawn.Ideo != null) ? pawn.Ideo.Color : Color.white;
            Precept_Role precept_Role = (pawn.Ideo != null) ? pawn.Ideo.GetRole(CEditor.API.Pawn) : null;
            string text2 = (precept_Role != null) ? precept_Role.GetTip() : ((pawn.Ideo != null) ? pawn.Ideo.description : "");
            string pawnName = pawn.GetPawnName(false);
            bool flag3 = !pawnName.NullOrEmpty() && pawn.ideo != null && pawn.Ideo != null && !pawn.Dead;
            if (flag3)
            {
              string text3 = "CertaintyInIdeo".Translate(pawn.Named("PAWN"), pawn.Ideo.Named("IDEO")) + ": " + pawn.ideo.Certainty.ToStringPercent() + "\n\n" + "CertaintyChangePerDay".Translate() + ": " + pawn.ideo.CertaintyChangePerDay.ToStringPercent() + "\n\n";
              bool flag4 = !text3.NullOrEmpty();
              if (flag4)
              {
                text2 = text2 + "\n\n" + pawnName.Colorize(ColorTool.colBeige) + text3.Replace(pawnName, "");
              }
            }
            SZWidgets.ButtonTextureTextHighlight(new Rect((float)x, (float)y, (float)(w + 100), 30f), text, icon, color, new Action(this.AChangeIdeo), text2);
          }
        }

        // Token: 0x060008AA RID: 2218 RVA: 0x0004AFA4 File Offset: 0x000491A4
        private void DrawTitle(int x, int y, int w)
        {
          bool flag = ModsConfig.RoyaltyActive && CEditor.API.Pawn.HasRoyaltyTracker();
          if (flag)
          {
            try
            {
              SZWidgets.ButtonTextureTextHighlight2(new Rect((float)x, (float)y, (float)w, 30f), (this.currentTitle != null) ? this.currentTitle.Label : "", "UI/Buttons/Renounce", ColorTool.colBeige, null, Label.SETROYALTITLE, false);
              SZWidgets.FloatMenuOnButtonInvisible<RoyalTitleDef>(new Rect((float)x, (float)y, (float)w, 30f), this.lOfRoyalTitles, (RoyalTitleDef rtitle) => (rtitle == null) ? Label.NONE : rtitle.LabelCap.ToString(), new Action<RoyalTitleDef>(this.ASetTitle), Label.SETROYALTITLE);
            }
            catch (Exception ex)
            {
              bool devMode = Prefs.DevMode;
              if (devMode)
              {
                Log.Error(ex.Message + "\n" + ex.StackTrace);
              }
            }
          }
        }

        // Token: 0x060008AB RID: 2219 RVA: 0x0004B0A0 File Offset: 0x000492A0
        private void DrawExtendables(int x, int y, int w)
        {
          int x2 = this.DrawFavorite(x, y, w);
          try
          {
            x2 = this.DrawPersonality(x2, y, w);
            x2 = this.DrawRJW(x2, y, w);
          }
          catch
          {
          }
        }

        // Token: 0x060008AC RID: 2220 RVA: 0x0004B0E8 File Offset: 0x000492E8
        private int DrawFavorite(int x, int y, int w)
        {
          bool flag = !CEditor.API.Pawn.HasStoryTracker() || CEditor.API.Pawn.story.favoriteColor == null;
          int result;
          if (flag)
          {
            result = x;
          }
          else
          {
            SZWidgets.ButtonTextureTextHighlight2(new Rect((float)x, (float)y, (float)w, (float)w), "", "bfavcolor", CEditor.API.Pawn.story.favoriteColor.GetValueOrDefault(), new Action(this.AChangeFavColorUI), CompatibilityTool.GetFavoriteColorTooltip(CEditor.API.Pawn), true);
            result = x + w + 2;
          }
          return result;
        }

        // Token: 0x060008AD RID: 2221 RVA: 0x0004B18C File Offset: 0x0004938C
        private int DrawRJW(int x, int y, int w)
        {
          bool flag = !CEditor.IsRJWActive;
          int result;
          if (flag)
          {
            result = x;
          }
          else
          {
            ThingComp rjwcomp = CEditor.API.Pawn.GetRJWComp();
            bool flag2 = rjwcomp == null;
            if (flag2)
            {
              result = x;
            }
            else
            {
              SZWidgets.ButtonImage(new Rect((float)x, (float)y, (float)w, (float)w), "RJW-LOGO", new Action(this.AChangeRJW), CompatibilityTool.GetRJWTooltip(CEditor.API.Pawn));
              result = x + w + 2;
            }
          }
          return result;
        }

        // Token: 0x060008AE RID: 2222 RVA: 0x0004B202 File Offset: 0x00049402
        private void AChangeRJW()
        {
          CompatibilityTool.OpenRJWDialog(CEditor.API.Pawn);
        }

        // Token: 0x060008AF RID: 2223 RVA: 0x0004B218 File Offset: 0x00049418
        private int DrawPersonality(int x, int y, int w)
        {
          bool flag = !CEditor.IsPersonalitiesActive;
          int result;
          if (flag)
          {
            result = x;
          }
          else
          {
            ThingComp persoComp = CEditor.API.Pawn.GetPersoComp();
            bool flag2 = persoComp == null;
            if (flag2)
            {
              result = x;
            }
            else
            {
              SZWidgets.ButtonImage(new Rect((float)x, (float)y, (float)(w - 2), (float)(w - 2)), "bmemory", new Action(this.AChangePersonality), CompatibilityTool.GetPersonalitiesTooltip(CEditor.API.Pawn));
              result = x + w + 2;
            }
          }
          return result;
        }

        // Token: 0x060008B0 RID: 2224 RVA: 0x0004B292 File Offset: 0x00049492
        private void AChangePersonality()
        {
          CompatibilityTool.OpenPersonalitiesDialog(CEditor.API.Pawn);
        }

        // Token: 0x060008B1 RID: 2225 RVA: 0x0004B2A5 File Offset: 0x000494A5
        private void AChangeFaction()
        {
          WindowTool.Open(new DialogChangeFaction());
        }

        // Token: 0x060008B2 RID: 2226 RVA: 0x0004B2B4 File Offset: 0x000494B4
        private void AChangeIdeo()
        {
          Type atype = Reflect.GetAType("RimWorld", "IdeoUIUtility");
          atype.SetMemberValue("showAll", true);
          atype.SetMemberValue("devEditMode", true);
          CEditor.API.Get<CEditor.EditorUI>(EType.EditorUI).layer = WindowLayer.Dialog;
          bool flag = CEditor.InStartingScreen && CEditor.API.Pawn.Ideo != null && CEditor.API.Pawn.Ideo.Fluid;
          if (flag)
          {
            MessageTool.Show("Do not click on back button or you will need to restart your game. This is not a bug from the Editor, but because of the fluid ideo.", MessageTypeDefOf.CautionInput);
          }
          WindowTool.Open(new Dialog_ConfigureIdeo(new List<Pawn>
          {
            CEditor.API.Pawn
          }, new Action(this.AOpenIdeoConfig), false));
          IdeoUIUtility.SetSelected(CEditor.API.Pawn.Ideo);
        }

        // Token: 0x060008B3 RID: 2227 RVA: 0x0004B390 File Offset: 0x00049590
        private void AOpenIdeoConfig()
        {
          bool flag = this.selectedIdeo != null;
          if (flag)
          {
            CEditor.API.Pawn.ideo.SetIdeo(this.selectedIdeo);
          }
          Type atype = Reflect.GetAType("RimWorld", "IdeoUIUtility");
          try
          {
            atype.SetMemberValue("showAll", false);
            atype.SetMemberValue("devEditMode", false);
          }
          catch
          {
          }
          CEditor.API.Get<CEditor.EditorUI>(EType.EditorUI).layer = CEditor.Layer;
          MeditationFocusTypeAvailabilityCache.ClearFor(CEditor.API.Pawn);
        }

        // Token: 0x060008B4 RID: 2228 RVA: 0x0004B438 File Offset: 0x00049638
        private void AChangeFavColorUI()
        {
          WindowTool.Open(new DialogColorPicker(ColorType.FavColor, true, null, null));
        }

        // Token: 0x060008B5 RID: 2229 RVA: 0x0004B44C File Offset: 0x0004964C
        private void DrawTraits(int x, int y, int h)
        {
          try
          {
            bool flag = CEditor.API.Pawn.story != null;
            if (flag)
            {
              Text.Font = GameFont.Medium;
              Widgets.Label(new Rect((float)x, (float)y, 200f, 30f), "Traits".Translate());
              y += 3;
              SZWidgets.ButtonImage((float)(x + 250), (float)y, 24f, 24f, "UI/Buttons/Dev/Add", new Action(this.AAddTrait), "");
              SZWidgets.ButtonImageCol((float)(x + 225), (float)y, 24f, 24f, "bminus", new Action<Color>(this.AToggleRemoveTrait), this.bRemoveTrait ? Color.red : Color.white, "");
              SZWidgets.ButtonImage((float)(x + 200), (float)y, 18f, 24f, "UI/Buttons/Copy", new Action(this.ACopyTraits), "");
              bool flag2 = !this.lCopyTraits.NullOrEmpty<Trait>();
              if (flag2)
              {
                SZWidgets.ButtonImage((float)(x + 180), (float)y, 18f, 24f, "UI/Buttons/Paste", new Action(this.APasteTraits), "");
              }
              bool isRandom = CEditor.IsRandom;
              if (isRandom)
              {
                SZWidgets.ButtonImage((float)(x + 153), (float)y, 25f, 25f, "brandom", new Action(this.ARandomTraits), "");
              }
              y += 25;
              bool flag3 = CEditor.API.Pawn.story.traits != null;
              if (flag3)
              {
                SZWidgets.TraitListView((float)x, (float)y, 280f, (float)(h - y), CEditor.API.Pawn.story.traits.allTraits, ref this.scrollTraits, 25, new Action<Trait>(this.AOnTraitClick), new Action<Trait>(this.ARandomTrait), new Action<Trait>(this.APrevTrait), new Action<Trait>(this.ANextTrait), this.FTraitLabel, this.FTraitTooltip);
              }
            }
          }
          catch (Exception ex)
          {
            bool devMode = Prefs.DevMode;
            if (devMode)
            {
              Log.Error(ex.Message + "\n" + ex.StackTrace);
            }
          }
        }

        // Token: 0x060008B6 RID: 2230 RVA: 0x0004B6A8 File Offset: 0x000498A8
        private void AOnTraitClick(Trait val)
        {
          bool flag = this.bRemoveTrait;
          if (flag)
          {
            CEditor.API.Pawn.RemoveTrait(val);
          }
          else
          {
            WindowTool.Open(new DialogAddTrait(val));
          }
        }

        // Token: 0x060008B7 RID: 2231 RVA: 0x0004B6E0 File Offset: 0x000498E0
        private void ARandomTrait(Trait val)
        {
          List<KeyValuePair<TraitDef, TraitDegreeData>> list = TraitTool.ListOfTraitsKeyValuePair(null, null, null);
          int index = list.IndexOf(new KeyValuePair<TraitDef, TraitDegreeData>(val.def, val.CurrentData));
          index = list.NextOrPrevIndex(index, true, true);
          KeyValuePair<TraitDef, TraitDegreeData> keyValuePair = list[index];
          CEditor.API.Pawn.AddTrait(keyValuePair.Key, keyValuePair.Value, false, true, val);
        }

        // Token: 0x060008B8 RID: 2232 RVA: 0x0004B744 File Offset: 0x00049944
        private void ANextTrait(Trait val)
        {
          List<KeyValuePair<TraitDef, TraitDegreeData>> list = TraitTool.ListOfTraitsKeyValuePair(null, null, null);
          int index = list.IndexOf(new KeyValuePair<TraitDef, TraitDegreeData>(val.def, val.CurrentData));
          index = list.NextOrPrevIndex(index, true, false);
          KeyValuePair<TraitDef, TraitDegreeData> keyValuePair = list[index];
          CEditor.API.Pawn.AddTrait(keyValuePair.Key, keyValuePair.Value, false, true, val);
        }

        // Token: 0x060008B9 RID: 2233 RVA: 0x0004B7A8 File Offset: 0x000499A8
        private void APrevTrait(Trait val)
        {
          List<KeyValuePair<TraitDef, TraitDegreeData>> list = TraitTool.ListOfTraitsKeyValuePair(null, null, null);
          int index = list.IndexOf(new KeyValuePair<TraitDef, TraitDegreeData>(val.def, val.CurrentData));
          index = list.NextOrPrevIndex(index, false, false);
          KeyValuePair<TraitDef, TraitDegreeData> keyValuePair = list[index];
          CEditor.API.Pawn.AddTrait(keyValuePair.Key, keyValuePair.Value, false, true, val);
        }

        // Token: 0x060008BA RID: 2234 RVA: 0x0004B80C File Offset: 0x00049A0C
        private void ARandomTraits()
        {
          CEditor.API.Pawn.story.traits.allTraits.Clear();
          int num = CEditor.zufallswert.Next(0, 11);
          for (int i = 0; i < num; i++)
          {
            CEditor.API.Pawn.AddTrait(null, null, true, true, null);
          }
        }

        // Token: 0x060008BB RID: 2235 RVA: 0x0004B86E File Offset: 0x00049A6E
        private void AAddTrait()
        {
          WindowTool.Open(new DialogAddTrait(null));
        }

        // Token: 0x060008BC RID: 2236 RVA: 0x0004B87D File Offset: 0x00049A7D
        private void AToggleRemoveTrait(Color col)
        {
          this.bRemoveTrait = !this.bRemoveTrait;
        }

        // Token: 0x060008BD RID: 2237 RVA: 0x0004B890 File Offset: 0x00049A90
        private void ACopyTraits()
        {
          this.lCopyTraits = new List<Trait>();
          foreach (Trait item in CEditor.API.Pawn.story.traits.allTraits)
          {
            this.lCopyTraits.Add(item);
          }
        }

        // Token: 0x060008BE RID: 2238 RVA: 0x0004B90C File Offset: 0x00049B0C
        private void APasteTraits()
        {
          bool flag = !this.lCopyTraits.NullOrEmpty<Trait>();
          if (flag)
          {
            foreach (Trait trait in this.lCopyTraits)
            {
              CEditor.API.Pawn.story.traits.allTraits.Add(new Trait(trait.def, trait.Degree, false));
            }
            MeditationFocusTypeAvailabilityCache.ClearFor(CEditor.API.Pawn);
          }
        }

        // Token: 0x060008BF RID: 2239 RVA: 0x0004B9B4 File Offset: 0x00049BB4
        private void DrawSkills(int x, int y)
        {
          try
          {
            if (CEditor.API.Pawn.skills != null)
            {
              //this.iTickInputSkill--;
              Text.Font = GameFont.Medium;
              Widgets.Label(new Rect((float)x, (float)y, 200f, 30f), "Skills".Translate());
              y += 35;
              BackstoryDef backstory = CEditor.API.Pawn.story.GetBackstory(BackstorySlot.Adulthood);
              BackstoryDef backstory2 = CEditor.API.Pawn.story.GetBackstory(BackstorySlot.Childhood);
              float num = (float)Reflect.GetAType("RimWorld", "SkillUI").GetMemberValue("levelLabelWidth");
              float num2 = (234f - num - 35f) / 20f;
              foreach (SkillRecord skillRecord in CEditor.API.Pawn.skills.skills)
              {
                int num3 = (backstory == null) ? 0 : backstory.skillGains.TryGetValue(skillRecord.def, 0);
                int num4 = (backstory2 == null) ? 0 : backstory2.skillGains.TryGetValue(skillRecord.def, 0);
                int traitOffsetForSkill = CEditor.API.Pawn.GetTraitOffsetForSkill(skillRecord.def);
                int num5 = num3 + num4 + traitOffsetForSkill;
                float y2 = (float)(y + skillRecord.def.GetSkillIndex() * 27);
                SZWidgets.LabelBackground(new Rect(x + num + 35f, y2, num2 * num5, 24f), "", num5 < 0 ? new Color(0.5f, 0f, 0f, 0.25f) : new Color(0f, 0.5f, 0f, 0.15f));
              }
              //SkillUI.DrawSkillsOf(CEditor.API.Pawn, new Vector2(x, y), SkillUI.SkillDrawMode.Menu);
              SkillUI.DrawSkillsOf(CEditor.API.Pawn, new Vector2(x, y), SkillUI.SkillDrawMode.Menu, new Rect(0f, 0f, 300f, 300f));
              foreach (SkillRecord skillRecord2 in CEditor.API.Pawn.skills.skills)
              {
                float y2 = (float)(y + skillRecord2.def.GetSkillIndex() * 27);
                SZWidgets.ButtonInvisibleVar<SkillRecord>(new Rect(x, y2, num + 35f, 24f), new Action<SkillRecord>(this.ATogglePassion), skillRecord2, "");
                if (!skillEntryDict.TryGetValue(skillRecord2.def, out EntryInt entryInt))
                {
                  entryInt = new EntryInt(skillRecord2.levelInt);
                }
                //if (!entryInt.Open)
                //{
                //  entryInt.UpdateValueAndBuffer(skillRecord2.levelInt);
                //}
                entryInt.NumericTextField(x + num + 18f + 20f, y2, 40f, 24f, 0, 20, false, false);
                skillRecord2.levelInt = entryInt.valInt;

                //if (this.iTickInputSkill > 0)
                //{
                //  //skillRecord2.Level = SZWidgets.NumericTextField(x + num + 18f, y2, 40f, 24f, skillRecord2.Level, 0, 9999);
                //  // ToDo: check if these limits of 0 to 9999 are correct
                //  if (skillEntryDict.TryGetValue(skillRecord2, out EntryInt entryInt))
                //  {
                //    entryInt.NumericIntBox(x + num + 18f, y2, 40f, 24f, 0, 20, true, false);
                //  }
                //}
                //else
                //{
                //  SZWidgets.ButtonInvisibleVar<SkillRecord>(new Rect((float)x + num + 40f, y2, (float)(x + 180) - ((float)x + num + 40f), 24f), new Action<SkillRecord>(this.ASetSkillNumeric), skillRecord2, "");
                //}

                SZWidgets.ButtonImageVar<SkillRecord>(x + 210, y2, 24f, 24f, "UI/Buttons/Dev/Add", new Action<SkillRecord>(this.AAddSkillLevel), skillRecord2, "");
                SZWidgets.ButtonImageVar<SkillRecord>(x + 185, y2, 24f, 24f, "bminus", new Action<SkillRecord>(this.ASubSkillLevel), skillRecord2, "");
                TooltipHandler.TipRegion(new Rect((float)x, y2, num + 80f, 24f), CEditor.API.Pawn.GetTooltipForSkillpoints(skillRecord2.def));


              }
              SZWidgets.ButtonImage((float)(x + 210), (float)(y - 32), 18f, 24f, "UI/Buttons/Copy", new Action(this.ACopySkills), "");
              bool flag3 = !this.lOfCopySkills.NullOrEmpty<SkillRecord>();
              if (flag3)
              {
                SZWidgets.ButtonImage((float)(x + 190), (float)(y - 32), 18f, 24f, "UI/Buttons/Paste", new Action(this.APasteSkills), "");
              }
              bool isRandom = CEditor.IsRandom;
              if (isRandom)
              {
                SZWidgets.ButtonImage((float)(x + 163), (float)(y - 32), 25f, 25f, "brandom", new Action(this.ARandomSkills), "");
              }
            }
          }
          catch (Exception ex)
          {
            bool devMode = Prefs.DevMode;
            if (devMode)
            {
              Log.Error(ex.Message + "\n" + ex.StackTrace);
            }
          }
        }

        // Token: 0x060008C0 RID: 2240 RVA: 0x0004BE9C File Offset: 0x0004A09C
        private void ACopySkills()
        {
          this.lOfCopySkills = new List<SkillRecord>();
          foreach (SkillRecord item in CEditor.API.Pawn.skills.skills)
          {
            this.lOfCopySkills.Add(item);
          }
        }

        // Token: 0x060008C1 RID: 2241 RVA: 0x0004BF14 File Offset: 0x0004A114
        private void APasteSkills()
        {
          CEditor.API.Pawn.PasteSkills(this.lOfCopySkills);
        }

        // Token: 0x060008C2 RID: 2242 RVA: 0x0004BF30 File Offset: 0x0004A130
        private void ARandomSkills()
        {
          foreach (SkillRecord skillRecord in CEditor.API.Pawn.skills.skills)
          {
            bool flag = !skillRecord.TotallyDisabled;
            if (flag)
            {
              int maxValue = CEditor.zufallswert.Next(0, 21);
              skillRecord.Level = CEditor.zufallswert.Next(0, maxValue);
              skillRecord.passion = (Passion)CEditor.zufallswert.Next(0, 3);
            }
          }
        }

        // Token: 0x060008C3 RID: 2243 RVA: 0x0004BFD4 File Offset: 0x0004A1D4
        private void ATogglePassion(SkillRecord record)
        {
          bool flag = record.passion == Passion.None;
          if (flag)
          {
            record.passion = Passion.Minor;
          }
          else
          {
            bool flag2 = record.passion == Passion.Minor;
            if (flag2)
            {
              record.passion = Passion.Major;
            }
            else
            {
              bool flag3 = record.passion == Passion.Major;
              if (flag3)
              {
                record.passion = Passion.None;
              }
            }
          }
        }



        //private void ASetSkillNumeric(SkillRecord record)
        //{
        //  this.iTickInputSkill = iTickMax;
        //  skillEntryDict = new Dictionary<SkillRecord, EntryInt>();
        //  foreach (SkillRecord s in CEditor.API.Pawn.skills.skills)
        //  {
        //    skillEntryDict[s] = new EntryInt(s.levelInt, "EntryIntTextField_Skills_" + s.def.defName, iTickMax, true);
        //  }
        //}

        // Token: 0x060008C5 RID: 2245 RVA: 0x0004C030 File Offset: 0x0004A230
        private void AAddSkillLevel(SkillRecord record)
        {
          int level = record.Level;
          record.Level = level + 1;
        }

        // Token: 0x060008C6 RID: 2246 RVA: 0x0004C050 File Offset: 0x0004A250
        private void ASubSkillLevel(SkillRecord record)
        {
          int level = record.Level;
          record.Level = level - 1;
        }

        // Token: 0x060008C7 RID: 2247 RVA: 0x0004C070 File Offset: 0x0004A270
        private void DrawAbilities(int x, int y)
        {
          try
          {
            bool flag = CEditor.API.Pawn.abilities != null;
            if (flag)
            {
              Text.Font = GameFont.Medium;
              Widgets.Label(new Rect((float)x, (float)(y - 2), 200f, 30f), Label.PSYTALENTE);
              SZWidgets.ButtonImage((float)(x + 210), (float)y, 24f, 24f, "UI/Buttons/Dev/Add", new Action(this.AAddAbility), "");
              SZWidgets.ButtonImageCol((float)(x + 185), (float)y, 24f, 24f, "bminus", new Action<Color>(this.AToggleRemoveAbility), this.bRemoveAbility ? Color.red : Color.white, "");
              SZWidgets.ButtonImage((float)(x + 165), (float)y, 18f, 24f, "UI/Buttons/Copy", new Action(this.ACopyAbilities), "");
              bool flag2 = !this.lCopyAbilities.NullOrEmpty<Ability>();
              if (flag2)
              {
                SZWidgets.ButtonImage((float)(x + 145), (float)y, 18f, 24f, "UI/Buttons/Paste", new Action(this.APasteAbilities), "");
              }
              bool isRandom = CEditor.IsRandom;
              if (isRandom)
              {
                SZWidgets.ButtonImage((float)(x + 117), (float)y, 25f, 25f, "brandom", new Action(this.ARandomAbilities), "");
              }
              else
              {
                bool flag3 = !CEditor.InStartingScreen && CEditor.API.Pawn.HasPsylink;
                if (flag3)
                {
                  SZWidgets.ButtonImage((float)(x + 117), (float)y, 25f, 25f, "UI/Buttons/DragHash", new Action(this.ATogglePsyvalues), "", this.bShowPsyValues);
                }
              }
              y += 30;
              Text.Font = GameFont.Small;
              GUI.color = Color.white;
              List<Ability> abilities = CEditor.API.Pawn.abilities.abilities;
              try
              {
                GenUI.DrawElementStack<Ability>(new Rect((float)x, (float)y, 500f, 50f), 32f, abilities, delegate (Rect r, Ability abil)
                {
                  GUI.DrawTexture(r, BaseContent.ClearTex);
                  bool flag4 = Mouse.IsOver(r);
                  if (flag4)
                  {
                    Widgets.DrawHighlight(r);
                  }
                  bool flag5 = Widgets.ButtonImage(r, abil.def.uiIcon, false);
                  if (flag5)
                  {
                    bool flag6 = this.bRemoveAbility;
                    if (flag6)
                    {
                      CEditor.API.Pawn.abilities.RemoveAbility(abil.def);
                      return;
                    }
                    WindowTool.Open(new Dialog_InfoCard(abil.def, null));
                  }
                  bool flag7 = !Mouse.IsOver(r);
                  if (!flag7)
                  {
                    Ability abilCapture = abil;
                    TipSignal tip = new TipSignal(() => abilCapture.Tooltip + "\n\n" + "ClickToLearnMore".Translate(), y * 37);
                    TooltipHandler.TipRegion(r, tip);
                  }
                }, (Ability abil) => 32f, 4f, 5f, false);
              }
              catch
              {
              }
              WindowTool.TopLayerForWindowOf<Dialog_InfoCard>();
            }
          }
          catch (Exception ex)
          {
            bool devMode = Prefs.DevMode;
            if (devMode)
            {
              Log.Error(ex.Message + "\n" + ex.StackTrace);
            }
          }
        }

        // Token: 0x060008C8 RID: 2248 RVA: 0x0004C36C File Offset: 0x0004A56C
        private void ATogglePsyvalues()
        {
          this.bShowPsyValues = !this.bShowPsyValues;
        }

        // Token: 0x060008C9 RID: 2249 RVA: 0x0004C380 File Offset: 0x0004A580
        private void ARandomAbilities()
        {
          CEditor.API.Pawn.abilities.abilities.Clear();
          int num = CEditor.zufallswert.Next(0, 11);
          List<AbilityDef> source = DefTool.ListByMod<AbilityDef>(null).ToList<AbilityDef>();
          for (int i = 0; i < num; i++)
          {
            CEditor.API.Pawn.abilities.GainAbility(source.RandomElement<AbilityDef>());
          }
          CEditor.API.Pawn.abilities.Notify_TemporaryAbilitiesChanged();
        }

        // Token: 0x060008CA RID: 2250 RVA: 0x0004C404 File Offset: 0x0004A604
        private void AAddAbility()
        {
          WindowTool.Open(new DialogAddAbility());
        }

        // Token: 0x060008CB RID: 2251 RVA: 0x0004C412 File Offset: 0x0004A612
        private void AToggleRemoveAbility(Color col)
        {
          this.bRemoveAbility = !this.bRemoveAbility;
        }

        // Token: 0x060008CC RID: 2252 RVA: 0x0004C424 File Offset: 0x0004A624
        private void ACopyAbilities()
        {
          this.lCopyAbilities = new List<Ability>();
          foreach (Ability item in CEditor.API.Pawn.abilities.abilities)
          {
            this.lCopyAbilities.Add(item);
          }
        }

        // Token: 0x060008CD RID: 2253 RVA: 0x0004C49C File Offset: 0x0004A69C
        private void APasteAbilities()
        {
          bool flag = !this.lCopyAbilities.NullOrEmpty<Ability>();
          if (flag)
          {
            foreach (Ability ability in this.lCopyAbilities)
            {
              CEditor.API.Pawn.abilities.GainAbility(ability.def);
            }
          }
        }

        // Token: 0x060008CE RID: 2254 RVA: 0x0004C51C File Offset: 0x0004A71C
        private void DrawPsycasts(int x, int y)
        {
          bool flag = !this.bShowPsyValues || CEditor.API.Pawn.psychicEntropy == null || CEditor.API.Pawn.psychicEntropy.Psylink == null;
          if (!flag)
          {
            float entropyValue = CEditor.API.Pawn.psychicEntropy.EntropyValue;
            float currentPsyfocus = CEditor.API.Pawn.psychicEntropy.CurrentPsyfocus;
            float height = 100f;
            Rect outRect = new Rect((float)x, (float)y, 250f, 100f);
            Rect rect = new Rect(0f, 0f, outRect.width - 16f, height);
            Widgets.BeginScrollView(outRect, ref this.scrollPosParam, rect, true);
            Rect rect2 = rect.ContractedBy(4f);
            rect2.y -= 4f;
            rect2.height = height;
            Listing_X listing_X = new Listing_X();
            listing_X.Begin(rect2);
            listing_X.verticalSpacing = 30f;
            listing_X.AddSection(Label.ENTROPY, "", ref this.selectedParamName, ref entropyValue, 0f, (float)Math.Round((double)CEditor.API.Pawn.psychicEntropy.MaxEntropy), true, "");
            listing_X.AddSection(Label.PSYFOCUS, "%", ref this.selectedParamName, ref currentPsyfocus, 0f, 1f, true, "");
            listing_X.End();
            Widgets.EndScrollView();
            bool flag2 = entropyValue != CEditor.API.Pawn.psychicEntropy.EntropyValue;
            if (flag2)
            {
              CEditor.API.Pawn.SetEntropy(entropyValue);
            }
            bool flag3 = currentPsyfocus != CEditor.API.Pawn.psychicEntropy.CurrentPsyfocus;
            if (flag3)
            {
              CEditor.API.Pawn.SetPsyfocus(currentPsyfocus);
            }
          }
        }

        // Token: 0x060008CF RID: 2255 RVA: 0x0004C700 File Offset: 0x0004A900
        private void DrawTraining(int x, int y, int w, int h)
        {
          try
          {
            bool flag = !CEditor.API.Pawn.RaceProps.Animal || CEditor.API.Pawn.Faction == null || CEditor.API.Pawn.training == null;
            if (!flag)
            {
              GUI.color = Color.white;
              bool flag2 = CEditor.API.Pawn.training.HasLearned(TrainableDefOf.Obedience);
              if (flag2)
              {
                Widgets.Label(new Rect((float)x, (float)y, 100f, (float)h), "Master".Translate() + ":");
                SZWidgets.FloatMenuOnButtonText<Pawn>(new Rect((float)(x + 80), (float)(y - 5), 120f, 30f), this.selectedTrainer.GetPawnName(false), this.lOfColonists, (Pawn p) => p.GetPawnName(false), new Action<Pawn>(this.ASelectMaster));
              }
              y += 30;
              Widgets.Label(new Rect((float)x, (float)y, 300f, 30f), CEditor.API.Pawn.GetTrainabilityLabel());
              y += 30;
              Widgets.Label(new Rect((float)x, (float)y, 300f, 30f), CEditor.API.Pawn.GetWildnessLabel());
              y += 30;
              foreach (TrainableDef trainableDef in DefDatabase<TrainableDef>.AllDefs)
              {
                bool wanted = CEditor.API.Pawn.training.GetWanted(trainableDef);
                bool flag3 = wanted;
                Rect rect = new Rect((float)x, (float)y, 150f, 30f);
                Widgets.DrawHighlightIfMouseover(rect);
                AcceptanceReport canTrain = CEditor.API.Pawn.training.CanAssignToTrain(trainableDef);
                this.DoTrainableTooltip(rect, CEditor.API.Pawn, trainableDef, canTrain);
                GUI.color = (canTrain.Accepted ? Color.white : Color.gray);
                Widgets.CheckboxLabeled(rect, trainableDef.label, ref flag3, false, null, null, false);
                bool flag4 = flag3 != wanted;
                if (flag4)
                {
                  CEditor.API.Pawn.training.SetWantedRecursive(trainableDef, flag3);
                }
                int trainingSteps = this.GetTrainingSteps(trainableDef);
                Widgets.Label(new Rect((float)(x + 160), (float)y, 30f, 30f), trainingSteps.ToString() + " / " + trainableDef.steps.ToString());
                bool flag5 = trainingSteps < trainableDef.steps;
                if (flag5)
                {
                  SZWidgets.ButtonImageVar<TrainableDef>((float)(x + 200), (float)y, 24f, 24f, "UI/Buttons/Dev/Add", new Action<TrainableDef>(this.ATrain), trainableDef, "");
                }
                y += 30;
              }
            }
          }
          catch (Exception ex)
          {
            bool devMode = Prefs.DevMode;
            if (devMode)
            {
              Log.Error(ex.Message + "\n" + ex.StackTrace);
            }
          }
        }

        // Token: 0x060008D0 RID: 2256 RVA: 0x0004CA48 File Offset: 0x0004AC48
        private void DoTrainableTooltip(Rect rect, Pawn pawn, TrainableDef td, AcceptanceReport canTrain)
        {
          TooltipHandler.TipRegion(rect, delegate ()
          {
            string text = td.LabelCap + "\n\n" + td.description;
            bool flag = !canTrain.Accepted;
            if (flag)
            {
              text = text + "\n\n" + canTrain.Reason;
            }
            else
            {
              bool flag2 = !td.prerequisites.NullOrEmpty<TrainableDef>();
              if (flag2)
              {
                text += "\n";
                for (int i = 0; i < td.prerequisites.Count; i++)
                {
                  bool flag3 = !pawn.training.HasLearned(td.prerequisites[i]);
                  if (flag3)
                  {
                    text = text + "\n" + "TrainingNeedsPrerequisite".Translate().Formatted(td.prerequisites[i].LabelCap);
                  }
                }
              }
            }
            return text;
          }, (int)(rect.y * 612f + rect.x));
        }

        // Token: 0x060008D1 RID: 2257 RVA: 0x0004CA9C File Offset: 0x0004AC9C
        private int GetTrainingSteps(TrainableDef td)
        {
          return (int)CEditor.API.Pawn.training.CallMethod("GetSteps", new object[] { td });
        }

        // Token: 0x060008D2 RID: 2258 RVA: 0x0004CAD6 File Offset: 0x0004ACD6
        private void ASelectMaster(Pawn p)
        {
          this.selectedTrainer = p;
          CEditor.API.Pawn.playerSettings.Master = p;
        }

        // Token: 0x060008D3 RID: 2259 RVA: 0x0004CAF6 File Offset: 0x0004ACF6
        private void ATrain(TrainableDef trainableDef)
        {
          CEditor.API.Pawn.training.Train(trainableDef, null, false);
        }

        // Token: 0x060008D4 RID: 2260 RVA: 0x0004CB14 File Offset: 0x0004AD14
        private void DrawCapsule(int x, int y, int w, int h)
        {
          if (CEditor.InStartingScreen)
          {
            Rect texRect = new Rect(x, y, w, h);
            //SZWidgets.ButtonImage(x, y, w, h, "bcapsule", new Action(this.ACapsuleUI), capsuleTooltip);

            string label = "Edit equipment"; // ToDo: translate this

            //GUIStyle style = Text.fontStyles[2];
            //int oldFontSize = style.fontSize;
            GameFont oldGameFont = Text.Font;
            TextAnchor oldAnchor = Text.Anchor;
            Color oldColor = GUI.color;

            //style.fontSize = 30;
            Text.Font = GameFont.Small;
            Text.Anchor = TextAnchor.MiddleCenter;
            float labelHeight = Text.CalcHeight(label, w);
            Rect labelRect = new Rect(x, texRect.yMax + 8f, w, labelHeight);
            Widgets.Label(labelRect, label);

            Text.Font = oldGameFont;
            Text.Anchor = oldAnchor;
            //style.fontSize = oldFontSize;


            Rect totalRect = new Rect(x, y, w, labelRect.yMax - y);

            if (Mouse.IsOver(totalRect))
            {
              GUI.color = GenUI.MouseoverColor;
            }
            GUI.DrawTexture(texRect, ContentFinder<Texture2D>.Get("bcapsule", true));
            GUI.color = oldColor;
            if (Widgets.ButtonInvisible(totalRect))
            {
              this.ACapsuleUI();
            }
            string capsuleTooltip = "Click here to edit starting equipment."; // ToDo: translate this
            TooltipHandler.TipRegion(totalRect, capsuleTooltip);

            //////Log.Message("Drawing capsule in xrange: " + x + ", " + (x + w) + " and yrange: " + y + ", " + (y + h + labelHeight));
          }
        }

        // Token: 0x060008D5 RID: 2261 RVA: 0x0004CB50 File Offset: 0x0004AD50
        private void ACapsuleUI()
        {
          WindowTool.Open(new DialogCapsuleUI());
        }


      }

      // Token: 0x020000D9 RID: 217
      private class BlockHealth
      {
        // Token: 0x17000097 RID: 151
        // (get) Token: 0x060008D6 RID: 2262 RVA: 0x0004CB60 File Offset: 0x0004AD60
        // (set) Token: 0x060008D7 RID: 2263 RVA: 0x0004CB8B File Offset: 0x0004AD8B
        private bool ShowHidden
        {
          get
          {
            return (bool)typeof(HealthCardUtility).GetMemberValue("showAllHediffs");
          }
          set
          {
            typeof(HealthCardUtility).SetMemberValue("showAllHediffs", value);
            this.bShowHidden = value;
          }
        }

        // Token: 0x060008D8 RID: 2264 RVA: 0x0004CBB0 File Offset: 0x0004ADB0
        internal BlockHealth()
        {
          this.scrollH = 0f;
          this.bShowHidden = false;
          this.bHighlight = true;
          this.bShowRemove = false;
          this.lCopyHealth = new List<Hediff>();
          this.texBleeding = ContentFinder<Texture2D>.Get("UI/Icons/Medical/Bleeding", false);
        }

        // Token: 0x060008D9 RID: 2265 RVA: 0x0004CC0C File Offset: 0x0004AE0C
        internal void Draw(CEditor.EditorUI.coord c)
        {
          int x = c.x;
          int y = c.y;
          int w = c.w;
          int h = c.h;
          bool flag = CEditor.API.Pawn == null;
          if (!flag)
          {
            this.DrawHealth(new Rect((float)(x + 5), (float)(y + 25), (float)w, (float)(h - 60)));
            this.DrawUpper(x, y, w, h);
            this.DrawLower(x + w, y + h - 30, w, h);
            WindowTool.TopLayerForWindowOf<Dialog_InfoCard>();
          }
        }

        // Token: 0x060008DA RID: 2266 RVA: 0x0004CC8C File Offset: 0x0004AE8C
        private void DrawHealth(Rect outRect)
        {
          outRect = outRect.Rounded();
          Rect rect = new Rect(outRect.x, outRect.y, outRect.width * 0.375f, outRect.height).Rounded();
          Rect rect2 = new Rect(rect.xMax, outRect.y, outRect.width - rect.width, outRect.height);
          rect.yMin += 11f;
          try
          {
            HealthCardUtility.DrawHealthSummary(rect, CEditor.API.Pawn, false, CEditor.API.Pawn);
          }
          catch
          {
          }
          this.DrawHediffListing(rect2.ContractedBy(10f), CEditor.API.Pawn, true);
        }

        // Token: 0x060008DB RID: 2267 RVA: 0x0004CD60 File Offset: 0x0004AF60
        private void DrawHediffListing(Rect rect, Pawn pawn, bool showBloodLoss)
        {
          GUI.color = Color.white;
          GUI.BeginGroup(rect);
          float lineHeight = Text.LineHeight;
          Rect outRect = new Rect(0f, 0f, rect.width, rect.height - lineHeight);
          Rect viewRect = new Rect(0f, 0f, rect.width - 16f, this.scrollH);
          Rect rect2 = rect;
          bool flag = viewRect.height > outRect.height;
          if (flag)
          {
            rect2.width -= 16f;
          }
          Widgets.BeginScrollView(outRect, ref this.scrollPos, viewRect, true);
          try
          {
            GUI.color = Color.white;
            float num = 0f;
            this.bHighlight = true;
            bool flag2 = false;
            foreach (IGrouping<BodyPartRecord, Hediff> diffs in this.VisibleHediffGroupsInOrder(pawn, showBloodLoss))
            {
              try
              {
                flag2 = true;
                this.DrawHediffRow(rect2, pawn, diffs, ref num);
              }
              catch
              {
              }
            }
            bool flag3 = !flag2;
            if (flag3)
            {
              Widgets.NoneLabelCenteredVertically(new Rect(0f, 0f, viewRect.width, outRect.height), "(" + "NoHealthConditions".Translate() + ")");
              num = outRect.height - 1f;
            }
            bool flag4 = Event.current.type == EventType.Layout;
            if (flag4)
            {
              this.scrollH = num;
            }
          }
          catch
          {
            MessageTool.Show("health conditions are malformed -> consider to use 'full heal'", null);
          }
          Widgets.EndScrollView();
          try
          {
            float bleedRateTotal = pawn.health.hediffSet.BleedRateTotal;
            bool flag5 = bleedRateTotal > 0.01f;
            if (flag5)
            {
              Rect rect3 = new Rect(0f, rect.height - lineHeight, rect.width, lineHeight);
              string text = string.Concat(new string[]
              {
                "BleedingRate".Translate(),
                ": ",
                bleedRateTotal.ToStringPercent(),
                " / ",
                "Day".Translate()
              });
              int num2 = HealthUtility.TicksUntilDeathDueToBloodLoss(pawn);
              string str = "TimeToDeath".Translate().Formatted(GenDate.ToStringTicksToPeriod(num2, true, false, true, true));
              bool flag6 = num2 < 60000;
              if (flag6)
              {
                text = text + " (" + str + ")";
              }
              else
              {
                text = text + " (" + "WontBleedOutSoon".Translate() + ")";
              }
              Widgets.Label(rect3, text);
            }
            GUI.EndGroup();
          }
          catch
          {
            pawn.health.hediffSet.Clear();
          }
          GUI.color = Color.white;
        }

        // Token: 0x060008DC RID: 2268 RVA: 0x0004D0B8 File Offset: 0x0004B2B8
        private IEnumerable<IGrouping<BodyPartRecord, Hediff>> VisibleHediffGroupsInOrder(Pawn pawn, bool showBloodLoss)
        {
          foreach (IGrouping<BodyPartRecord, Hediff> group in from x in this.VisibleHediffs(pawn, showBloodLoss)
                                                              group x by x.Part into x
                                                              orderby this.GetListPriority(x.First<Hediff>().Part) descending
                                                              select x)
          {
            yield return group;
            //group = null;
          }
          //IEnumerator<IGrouping<BodyPartRecord, Hediff>> enumerator = null;
          //yield break;
          //yield break;
        }

        // Token: 0x060008DD RID: 2269 RVA: 0x0004D0D6 File Offset: 0x0004B2D6
        private IEnumerable<Hediff> VisibleHediffs(Pawn pawn, bool showBloodLoss)
        {
          bool flag = !this.bShowHidden;
          if (flag)
          {
            List<Hediff_MissingPart> mpca = pawn.health.hediffSet.GetMissingPartsCommonAncestors();
            int num;
            for (int i = 0; i < mpca.Count; i = num + 1)
            {
              yield return mpca[i];
              num = i;
            }
            IEnumerable<Hediff> visibleDiffs = from d in pawn.health.hediffSet.hediffs
                                               where !(d is Hediff_MissingPart) && d.Visible && (showBloodLoss || d.def != HediffDefOf.BloodLoss)
                                               select d;
            foreach (Hediff diff in visibleDiffs)
            {
              yield return diff;
              //diff = null;
            }
            //IEnumerator<Hediff> enumerator = null;
            //mpca = null;
            //visibleDiffs = null;
          }
          else
          {
            foreach (Hediff diff2 in pawn.health.hediffSet.hediffs)
            {
              yield return diff2;
              //diff2 = null;
            }
            //List<Hediff>.Enumerator enumerator2 = default(List<Hediff>.Enumerator);
          }
          yield break;
          //yield break;
        }

        // Token: 0x060008DE RID: 2270 RVA: 0x0004D0F4 File Offset: 0x0004B2F4
        private float GetListPriority(BodyPartRecord rec)
        {
          bool flag = rec == null;
          float result;
          if (flag)
          {
            result = 9999999f;
          }
          else
          {
            result = (float)((int)rec.height * 10000) + rec.coverageAbsWithChildren;
          }
          return result;
        }

        // Token: 0x060008DF RID: 2271 RVA: 0x0004D12C File Offset: 0x0004B32C
        private void DrawHediffRow(Rect rect, Pawn pawn, IEnumerable<Hediff> diffs, ref float curY)
        {
          float num = rect.width * 0.375f;
          float width = rect.width - num - this.lastMaxIconsTotalWidth;
          BodyPartRecord part = diffs.First<Hediff>().Part;
          float a = (part != null) ? Text.CalcHeight(part.LabelCap, num) : Text.CalcHeight("WholeBody".Translate(), num);
          float b = 0f;
          float num2 = curY;
          float num3 = 0f;
          foreach (IGrouping<int, Hediff> source in from x in diffs
                                                    group x by x.UIGroupKey)
          {
            int num4 = source.Count<Hediff>();
            string text = source.First<Hediff>().LabelCap;
            bool flag = num4 != 1;
            if (flag)
            {
              text = text + " x" + num4.ToString();
            }
            num3 += Text.CalcHeight(text, width);
          }
          b = num3;
          Rect rect2 = new Rect(0f, curY, rect.width, Mathf.Max(a, b));
          this.DoRightRowHighlight(rect2);
          bool flag2 = part != null;
          if (flag2)
          {
            GUI.color = HealthUtility.GetPartConditionLabel(pawn, part).Second;
            Widgets.Label(new Rect(0f, curY, num, 100f), part.LabelCap);
          }
          else
          {
            GUI.color = HealthUtility.RedColor;
            Widgets.Label(new Rect(0f, curY, num, 100f), "WholeBody".Translate());
          }
          GUI.color = Color.white;
          foreach (IGrouping<int, Hediff> grouping in from x in diffs
                                                      group x by x.UIGroupKey)
          {
            int num5 = 0;
            Hediff hediff4 = null;
            Texture2D bleedingIcon = null;
            TextureAndColor stateIcon = null;
            float totalBleedRate = 0f;
            foreach (Hediff hediff2 in grouping)
            {
              bool flag3 = num5 == 0;
              if (flag3)
              {
                hediff4 = hediff2;
              }
              stateIcon = hediff2.StateIcon;
              bool bleeding = hediff2.Bleeding;
              if (bleeding)
              {
                bleedingIcon = ContentFinder<Texture2D>.Get("UI/Icons/Medical/Bleeding", true);
              }
              totalBleedRate += hediff2.BleedRate;
              num5++;
            }
            string text2 = hediff4.LabelCap;
            bool flag4 = num5 != 1;
            if (flag4)
            {
              text2 = text2 + " x" + num5.ToStringCached();
            }
            float num6 = Text.CalcHeight(text2, width);
            Rect rect3 = new Rect(num, curY, width, num6);
            Rect rect4 = new Rect(rect3.x, rect3.y, rect3.width - 30f, rect3.height);
            Widgets.DrawHighlightIfMouseover(rect4);
            GUI.color = hediff4.LabelColor;
            Widgets.Label(rect3, text2);
            SZWidgets.ButtonInvisibleVar<Hediff>(rect4, new Action<Hediff>(this.AEditHediff), hediff4, "");
            GUI.color = Color.white;
            Rect iconsRect = new Rect(rect3.x + 10f, rect3.y, (float)((double)rect.width - (double)num - 10.0), rect3.height);
            bool flag5 = this.bShowRemove;
            if (flag5)
            {
              SZWidgets.ButtonImageVar<Hediff>(rect3.x + rect3.width - 30f, rect3.y, 24f, 24f, "UI/Buttons/Delete", new Action<Hediff>(this.BRemoveHediff), hediff4, "");
            }
            List<GenUI.AnonymousStackElement> list = new List<GenUI.AnonymousStackElement>();
            Hediff localHediff = hediff4;
            list.Add(new GenUI.AnonymousStackElement
            {
              drawer = delegate (Rect r)
              {
                r = new Rect(iconsRect.x + (float)((double)iconsRect.width - ((double)r.x - (double)iconsRect.x) - 20.0), r.y, 20f, 20f);
                Widgets.InfoCardButton(r, localHediff.def);
              },
              width = 20f
            });
            bool flag6 = bleedingIcon;
            if (flag6)
            {
              list.Add(new GenUI.AnonymousStackElement
              {
                drawer = delegate (Rect r)
                {
                  r = new Rect(iconsRect.x + (float)((double)iconsRect.width - ((double)r.x - (double)iconsRect.x) - 20.0), r.y, 20f, 20f);
                  GUI.DrawTexture(r.ContractedBy(GenMath.LerpDouble(0f, 0.6f, 5f, 0f, Mathf.Min(totalBleedRate, 1f))), bleedingIcon);
                },
                width = 20f
              });
            }
            bool hasValue = stateIcon.HasValue;
            if (hasValue)
            {
              list.Add(new GenUI.AnonymousStackElement
              {
                drawer = delegate (Rect r)
                {
                  r = new Rect(iconsRect.x + (float)((double)iconsRect.width - ((double)r.x - (double)iconsRect.x) - 20.0), r.y, 20f, 20f);
                  GUI.color = stateIcon.Color;
                  GUI.DrawTexture(r, stateIcon.Texture);
                  GUI.color = Color.white;
                },
                width = 20f
              });
            }
            GenUI.DrawElementStack<GenUI.AnonymousStackElement>(iconsRect, num6, list, delegate (Rect r, GenUI.AnonymousStackElement obj)
            {
              obj.drawer(r);
            }, (GenUI.AnonymousStackElement obj) => obj.width, 4f, 5f, true);
            this.lastMaxIconsTotalWidth = Mathf.Max(this.lastMaxIconsTotalWidth, list.Sum((GenUI.AnonymousStackElement x) => x.width + 5f) - 5f);
            bool flag7 = Mouse.IsOver(rect3);
            if (flag7)
            {
              int num7 = 0;
              foreach (Hediff hediff3 in grouping)
              {
                Hediff hediff = hediff3;
                TooltipHandler.TipRegion(rect3, new TipSignal(() => hediff.GetTooltip(pawn, Prefs.DevMode), (int)curY + 7857 + num7++, TooltipPriority.Default));
              }
              bool flag8 = part != null;
              if (flag8)
              {
                string str = (string)typeof(HealthCardUtility).CallMethod("GetTooltip", new object[] { pawn, part });
                TooltipHandler.TipRegion(rect3, str);
              }
            }
            bool flag9 = Widgets.ButtonInvisible(rect3, false);
            if (flag9)
            {
              typeof(HealthCardUtility).CallMethod("EntryClicked", new object[] { diffs, pawn });
            }
            curY += num6;
          }
          GUI.color = Color.white;
          curY = num2 + Mathf.Max(a, b);
          this.OnClickOrHover(rect2, diffs, pawn, part);
        }

        // Token: 0x060008E0 RID: 2272 RVA: 0x0004D844 File Offset: 0x0004BA44
        private void OnClickOrHover(Rect rect, IEnumerable<Hediff> diffs, Pawn pawn, BodyPartRecord part)
        {
          bool flag = Widgets.ButtonInvisible(rect, false);
          if (flag)
          {
            typeof(HealthCardUtility).CallMethod("EntryClicked", new object[]
            {
              diffs,
              pawn
            });
          }
          string str = (string)typeof(HealthCardUtility).CallMethod("GetTooltip", new object[]
          {
            pawn,
            part
          });
          TooltipHandler.TipRegion(rect, str);
        }

        // Token: 0x060008E1 RID: 2273 RVA: 0x0004D8B8 File Offset: 0x0004BAB8
        private void DoRightRowHighlight(Rect rowRect)
        {
          bool flag = this.bHighlight;
          if (flag)
          {
            GUI.color = CEditor.EditorUI.BlockHealth.StaticHighlightColor;
            GUI.DrawTexture(rowRect, TexUI.HighlightTex);
          }
          this.bHighlight = !this.bHighlight;
        }

        // Token: 0x060008E2 RID: 2274 RVA: 0x0004D8F8 File Offset: 0x0004BAF8
        private void DrawUpper(int x, int y, int w, int h)
        {
          y += 5;
          Widgets.DrawBoxSolid(new Rect((float)(x + 5), (float)y, 850f, 31f), CEditor.EditorUI.BlockHealth.backgr);
          Widgets.DrawBoxSolid(new Rect((float)(x + 5), (float)(y + 31), 250f, 1f), Color.gray);
          SZWidgets.CheckBoxOnChange(new Rect((float)(x + 176), (float)y, 135f, 25f), Label.SHOW_HIDDEN, this.bShowHidden, new Action<bool>(this.AHiddenChanged));
          SZWidgets.ButtonImage((float)(x + w - 30), (float)y, 24f, 24f, "UI/Buttons/Dev/Add", new Action(this.AAddHediff), "");
          SZWidgets.ButtonImage((float)(x + w - 55), (float)y, 24f, 24f, "bminus", new Action(this.ARemoveHediff), "");
          SZWidgets.ButtonImage((float)(x + w - 80), (float)y, 18f, 24f, "UI/Buttons/Copy", new Action(this.ACopyHealth), "");
          bool flag = !this.lCopyHealth.NullOrEmpty<Hediff>();
          if (flag)
          {
            SZWidgets.ButtonImage((float)(x + w - 100), (float)y, 18f, 24f, "UI/Buttons/Paste", new Action(this.APasteHealth), "");
          }
          bool isRandom = CEditor.IsRandom;
          if (isRandom)
          {
            SZWidgets.ButtonImage((float)(x + w - 130), (float)y, 25f, 25f, "brandom", new Action(this.ARandomHealth), "");
          }
        }

        // Token: 0x060008E3 RID: 2275 RVA: 0x0004DA8D File Offset: 0x0004BC8D
        private void BRemoveHediff(Hediff hediff)
        {
          CEditor.API.Pawn.RemoveHediff(hediff);
          CEditor.API.UpdateGraphics();
        }

        // Token: 0x060008E4 RID: 2276 RVA: 0x0004DAAC File Offset: 0x0004BCAC
        private void ARandomHealth()
        {
          int num = CEditor.zufallswert.Next(1, 11);
          for (int i = 0; i < num; i++)
          {
            CEditor.API.Pawn.AddHediff2(true, null, 1f, null, false, -1, -1, -1, null);
          }
        }

        // Token: 0x060008E5 RID: 2277 RVA: 0x0004DAF7 File Offset: 0x0004BCF7
        private void AHiddenChanged(bool val)
        {
          this.ShowHidden = val;
        }

        // Token: 0x060008E6 RID: 2278 RVA: 0x0004DB02 File Offset: 0x0004BD02
        private void AEditHediff(Hediff val)
        {
          WindowTool.Open(new DialogAddHediff(val));
        }

        // Token: 0x060008E7 RID: 2279 RVA: 0x0004DB11 File Offset: 0x0004BD11
        private void AAddHediff()
        {
          WindowTool.Open(new DialogAddHediff(null));
        }

        // Token: 0x060008E8 RID: 2280 RVA: 0x0004DB20 File Offset: 0x0004BD20
        private void ARemoveHediff()
        {
          this.bShowRemove = !this.bShowRemove;
        }

        // Token: 0x060008E9 RID: 2281 RVA: 0x0004DB34 File Offset: 0x0004BD34
        private void ACopyHealth()
        {
          this.lCopyHealth = new List<Hediff>();
          foreach (Hediff item in CEditor.API.Pawn.health.hediffSet.hediffs)
          {
            this.lCopyHealth.Add(item);
          }
        }

        // Token: 0x060008EA RID: 2282 RVA: 0x0004DBB0 File Offset: 0x0004BDB0
        private void APasteHealth()
        {
          bool flag = !this.lCopyHealth.NullOrEmpty<Hediff>();
          if (flag)
          {
            foreach (Hediff hediff in this.lCopyHealth)
            {
              BodyPartRecord bodyPart = HealthTool.GetBodyPart(CEditor.API.Pawn, hediff);
              bool flag2 = (hediff.Part != null && bodyPart != null) || (hediff.Part == null && bodyPart == null);
              if (flag2)
              {
                CEditor.API.Pawn.AddHediff2(false, hediff.def, hediff.Severity, bodyPart, hediff.IsPermanent(), hediff.GetLevel(), hediff.GetPainValue(), hediff.GetDuration(), hediff.GetOtherPawn());
              }
            }
            CEditor.API.UpdateGraphics();
          }
        }

        // Token: 0x060008EB RID: 2283 RVA: 0x0004DC98 File Offset: 0x0004BE98
        private void DrawLower(int x, int y, int w, int h)
        {
          bool dead = CEditor.API.Pawn.Dead;
          if (dead)
          {
            SZWidgets.ButtonText((float)(x - 130), (float)y, 130f, 30f, Label.RESURRECT, new Action(this.ARessurect), "");
          }
          else
          {
            SZWidgets.ButtonText((float)(x - 130), (float)y, 130f, 30f, Label.FULLHEAL, new Action(this.AFullHeal), Label.TIP_HEAL);
            SZWidgets.ButtonText((float)(x - 260), (float)y, 130f, 30f, Label.MEDICATE, new Action(this.AMedicate), "");
            SZWidgets.ButtonText((float)(x - 390), (float)y, 130f, 30f, Label.ANAESTHETIZE, new Action(this.AAnaesthetize), "");
            SZWidgets.ButtonText((float)(x - 520), (float)y, 130f, 30f, Label.HURT, new Action(this.AHurt), Label.TIP_HURT);
          }
        }

        // Token: 0x060008EC RID: 2284 RVA: 0x0004DDB4 File Offset: 0x0004BFB4
        private void ARessurect()
        {
          ResurrectionUtility.Resurrect(CEditor.API.Pawn);
          bool flag = !CEditor.API.Pawn.Spawned;
          if (flag)
          {
            CEditor.API.Pawn.SpawnPawn(null, CEditor.API.Pawn.Position);
          }
          CEditor.API.UpdateGraphics();
        }

        // Token: 0x060008ED RID: 2285 RVA: 0x0004DE14 File Offset: 0x0004C014
        private void AFullHeal()
        {
          bool alt = Event.current.alt;
          if (alt)
          {
            HealthUtility.HealNonPermanentInjuriesAndRestoreLegs(CEditor.API.Pawn);
          }
          else
          {
            WindowTool.Open(new DialogFullheal());
          }
          CEditor.API.UpdateGraphics();
        }

        // Token: 0x060008EE RID: 2286 RVA: 0x0004DE58 File Offset: 0x0004C058
        private void AMedicate()
        {
          CEditor.API.Pawn.Medicate();
          CEditor.API.UpdateGraphics();
        }

        // Token: 0x060008EF RID: 2287 RVA: 0x0004DE76 File Offset: 0x0004C076
        private void AAnaesthetize()
        {
          CEditor.API.Pawn.Anaesthetize();
          CEditor.API.UpdateGraphics();
        }

        // Token: 0x060008F0 RID: 2288 RVA: 0x0004DE94 File Offset: 0x0004C094
        private void AHurt()
        {
          bool flag = Event.current.alt || CEditor.InStartingScreen;
          if (flag)
          {
            CEditor.API.Pawn.Hurt();
          }
          else
          {
            CEditor.API.Pawn.DamageUntilDeath();
          }
          CEditor.API.UpdateGraphics();
        }

        // Token: 0x04000738 RID: 1848
        private static readonly Color StaticHighlightColor = new Color(0.75f, 0.75f, 0.85f, 1f);

        // Token: 0x04000739 RID: 1849
        private static readonly Color HighlightColor = new Color(0.5f, 0.5f, 0.5f, 1f);

        // Token: 0x0400073A RID: 1850
        private static readonly Color backgr = new Color(0.0823f, 0.098f, 0.113f);

        // Token: 0x0400073B RID: 1851
        private Vector2 scrollPos;

        // Token: 0x0400073C RID: 1852
        private float scrollH;

        // Token: 0x0400073D RID: 1853
        private bool bShowHidden;

        // Token: 0x0400073E RID: 1854
        private bool bHighlight;

        // Token: 0x0400073F RID: 1855
        private bool bShowRemove;

        // Token: 0x04000740 RID: 1856
        private List<Hediff> lCopyHealth;

        // Token: 0x04000741 RID: 1857
        private Texture2D texBleeding;

        // Token: 0x04000742 RID: 1858
        private float lastMaxIconsTotalWidth = 20f;
      }

      // Token: 0x020000DA RID: 218
      private class BlockInfo
      {
        // Token: 0x060008F3 RID: 2291 RVA: 0x0004DF5D File Offset: 0x0004C15D
        internal BlockInfo()
        {
          this.uniqueID = null;
          this.lfe = new List<Faction>();
        }

        // Token: 0x060008F4 RID: 2292 RVA: 0x0004DF7C File Offset: 0x0004C17C
        internal void Draw(CEditor.EditorUI.coord c)
        {
          int x = c.x;
          int y = c.y;
          int w = c.w;
          int h = c.h;
          bool flag = CEditor.API.Pawn == null;
          if (!flag)
          {
            bool flag2 = this.uniqueID != CEditor.API.Pawn.ThingID;
            if (flag2)
            {
              this.uniqueID = CEditor.API.Pawn.ThingID;
              this.lfe = CEditor.API.Pawn.FactionEnemies();
              bool flag3 = CEditor.API.Pawn.Dead && (CEditor.API.Pawn.Corpse == null || !CEditor.API.Pawn.Corpse.Spawned || CEditor.API.Pawn.Corpse.Discarded);
              if (flag3)
              {
                return;
              }
              StatsReportUtility.Notify_QuickSearchChanged();
            }
            try
            {
              bool dead = CEditor.API.Pawn.Dead;
              if (dead)
              {
                StatsReportUtility.DrawStatsReport(new Rect((float)(x + 10), (float)y, (float)(w - 10), (float)(h - 30)), CEditor.API.Pawn.Corpse);
              }
              else
              {
                StatsReportUtility.DrawStatsReport(new Rect((float)(x + 10), (float)y, (float)(w - 10), (float)(h - 30)), CEditor.API.Pawn);
              }
            }
            catch
            {
            }
            this.DrawEnemies(x, y, w, h);
          }
        }

        // Token: 0x060008F5 RID: 2293 RVA: 0x0004E100 File Offset: 0x0004C300
        private void DrawEnemies(int x, int y, int w, int h)
        {
          bool flag = CEditor.API.Pawn == null;
          if (!flag)
          {
            try
            {
              int num = this.lfe.CountAllowNull<Faction>();
              int num2 = x + w;
              int num3 = x + w - 80 - this.lfe.Count * 22;
              num3 = ((num3 < x) ? x : num3);
              y = h;
              Widgets.Label(new Rect((float)num3, (float)y, 80f, 30f), "EnemyOf".Translate());
              SZWidgets.ButtonInvisible(new Rect((float)num3, (float)y, (float)w, 20f), new Action(this.AOpenFactionCard), "");
              num3 += 80;
              foreach (Faction faction in this.lfe)
              {
                Rect rect = new Rect((float)num3, (float)y, 20f, 20f);
                bool flag2 = Mouse.IsOver(rect);
                string toolTip;
                if (flag2)
                {
                  toolTip = CEditor.API.Pawn.GetFactionFullDesc(faction);
                }
                else
                {
                  toolTip = "";
                }
                SZWidgets.ButtonImageCol2<Faction>(rect, faction.def.factionIconPath ?? "bwhite", new Action<Faction>(this.ASetRelation), faction, faction.GetFacionColor(), toolTip);
                num3 += 22;
                bool flag3 = num3 > num2;
                if (flag3)
                {
                  break;
                }
              }
            }
            catch
            {
            }
          }
        }

        // Token: 0x060008F6 RID: 2294 RVA: 0x0004E2BC File Offset: 0x0004C4BC
        private void ASetRelation(Faction f)
        {
        }

        // Token: 0x060008F7 RID: 2295 RVA: 0x0004E2BF File Offset: 0x0004C4BF
        private void AOpenFactionCard()
        {
        }

        // Token: 0x04000743 RID: 1859
        private string uniqueID;

        // Token: 0x04000744 RID: 1860
        private List<Faction> lfe;
      }

      // Token: 0x020000DB RID: 219
      private class BlockInventory
      {
        // Token: 0x060008F8 RID: 2296 RVA: 0x0004E2C2 File Offset: 0x0004C4C2
        private Rect GetCopyRect(Rect rBase, float y)
        {
          return new Rect(rBase.x + rBase.width - 20f, rBase.y + y, 18f, 24f);
        }

        // Token: 0x060008F9 RID: 2297 RVA: 0x0004E2F1 File Offset: 0x0004C4F1
        private Rect GetPasteRect(Rect rBase, float y)
        {
          return new Rect(rBase.x + rBase.width - 43f, rBase.y + y, 18f, 24f);
        }

        // Token: 0x060008FA RID: 2298 RVA: 0x0004E320 File Offset: 0x0004C520
        internal BlockInventory()
        {
          this.fCount = 0f;
          this.scrollH = 0f;
          this.workingInvList = new List<Thing>();
          this.lOfCopyOutfits = new List<Apparel>();
          this.lOfCopyItems = new List<Thing>();
          this.lOfCopyWeapons = new List<ThingWithComps>();
        }

        // Token: 0x060008FB RID: 2299 RVA: 0x0004E378 File Offset: 0x0004C578
        internal void Draw(CEditor.EditorUI.coord c)
        {
          int x = c.x;
          int y = c.y;
          int w = c.w;
          int h = c.h;
          bool flag = CEditor.API.Pawn == null;
          if (!flag)
          {
            this.DrawInvData(new Rect((float)(x + 10), (float)(y + 10), (float)(w - 10), (float)(h - 40)));
            this.DrawLowerButtons(x + w, y + h - 30);
          }
        }

        // Token: 0x060008FC RID: 2300 RVA: 0x0004E3E8 File Offset: 0x0004C5E8
        private void DrawInventory(Rect rView)
        {
          this.fCount += 20f;
          SZWidgets.ButtonImage(this.GetCopyRect(rView, this.fCount), "UI/Buttons/Copy", new Action(this.ACopyInv), "");
          bool flag = !this.lOfCopyItems.NullOrEmpty<Thing>();
          if (flag)
          {
            SZWidgets.ButtonImage(this.GetPasteRect(rView, this.fCount), "UI/Buttons/Paste", new Action(this.APasteInv), "");
          }
          Widgets.ListSeparator(ref this.fCount, rView.width, "Inventory".Translate());
          this.workingInvList.Clear();
          this.workingInvList.AddRange(CEditor.API.Pawn.inventory.innerContainer);
          for (int i = 0; i < this.workingInvList.Count; i++)
          {
            this.DrawThingRow(ref this.fCount, rView.width, this.workingInvList[i], 2);
          }
          this.workingInvList.Clear();
          bool flag2 = Event.current.type == EventType.Layout;
          if (flag2)
          {
            this.scrollH = this.fCount + 30f;
          }
        }

        // Token: 0x060008FD RID: 2301 RVA: 0x0004E524 File Offset: 0x0004C724
        private void DrawApparel(Rect rView)
        {
          this.fCount += 20f;
          SZWidgets.ButtonImage(this.GetCopyRect(rView, this.fCount), "UI/Buttons/Copy", new Action(this.ACopyApparel), "");
          bool flag = !this.lOfCopyOutfits.NullOrEmpty<Apparel>();
          if (flag)
          {
            SZWidgets.ButtonImage(this.GetPasteRect(rView, this.fCount), "UI/Buttons/Paste", new Action(this.APasteApparel), "");
          }
          Widgets.ListSeparator(ref this.fCount, rView.width, "Apparel".Translate());
          Pawn_ApparelTracker apparel = CEditor.API.Pawn.apparel;
          bool flag2 = apparel != null && apparel.WornApparelCount > 0;
          if (flag2)
          {
            try
            {
              List<Apparel> list = (from ap in CEditor.API.Pawn.apparel.WornApparel
                                    orderby ap.def.apparel.bodyPartGroups[0].listOrder descending
                                    select ap).ToList<Apparel>();
              for (int i = 0; i < list.Count; i++)
              {
                this.DrawThingRow(ref this.fCount, rView.width, list[i], 1);
              }
            }
            catch
            {
              List<Apparel> list2 = CEditor.API.Pawn.apparel.WornApparel.ToList<Apparel>();
              foreach (Apparel apparel2 in list2)
              {
                bool flag3 = !CEditor.API.Pawn.ApparelGraphicTest(apparel2, true, true);
                if (flag3)
                {
                  CEditor.API.Pawn.TransferToInventory(apparel2);
                }
              }
              CEditor.API.UpdateGraphics();
            }
          }
        }

        // Token: 0x060008FE RID: 2302 RVA: 0x0004E710 File Offset: 0x0004C910
        private void ARandomThing(Thing t, int type)
        {
          bool flag = type == 1;
          if (flag)
          {
            CEditor.API.Pawn.ReplaceAndWearRandomApparel(t as Apparel, null, false);
          }
          else
          {
            bool flag2 = type == 0;
            if (flag2)
            {
              CEditor.API.Pawn.Reequip(null, CEditor.API.Pawn.IsPrimaryWeapon(t as ThingWithComps) ? 0 : 1, false);
            }
            else
            {
              CEditor.API.Pawn.ReplaceItem(t);
            }
          }
          CEditor.API.UpdateGraphics();
        }

        // Token: 0x060008FF RID: 2303 RVA: 0x0004E794 File Offset: 0x0004C994
        private void DrawEquipment(Rect rView)
        {
          this.fCount += 20f;
          SZWidgets.ButtonImage(this.GetCopyRect(rView, this.fCount), "UI/Buttons/Copy", new Action(this.ACopyWeapon), "");
          bool flag = !this.lOfCopyWeapons.NullOrEmpty<ThingWithComps>();
          if (flag)
          {
            SZWidgets.ButtonImage(this.GetPasteRect(rView, this.fCount), "UI/Buttons/Paste", new Action(this.APasteWeapon), "");
          }
          Widgets.ListSeparator(ref this.fCount, rView.width, "Equipment".Translate());
          Pawn pawn = CEditor.API.Pawn;
          bool flag2;
          if (pawn == null)
          {
            flag2 = false;
          }
          else
          {
            Pawn_EquipmentTracker equipment = pawn.equipment;
            bool? flag3 = (equipment != null) ? new bool?(equipment.AllEquipmentListForReading.NullOrEmpty<ThingWithComps>()) : null;
            bool flag4 = false;
            flag2 = (flag3.GetValueOrDefault() == flag4 & flag3 != null);
          }
          bool flag5 = flag2;
          if (flag5)
          {
            List<ThingWithComps> allEquipmentListForReading = CEditor.API.Pawn.equipment.AllEquipmentListForReading;
            for (int i = 0; i < allEquipmentListForReading.Count; i++)
            {
              this.DrawThingRow(ref this.fCount, rView.width, CEditor.API.Pawn.equipment.AllEquipmentListForReading[i], 0);
            }
          }
        }

        // Token: 0x06000900 RID: 2304 RVA: 0x0004E8EC File Offset: 0x0004CAEC
        private void ARandomWeapon(int i)
        {
          CEditor.API.Pawn.Reequip(null, i, false);
        }

        // Token: 0x06000901 RID: 2305 RVA: 0x0004E904 File Offset: 0x0004CB04
        private void DrawArmorRating(Rect rView)
        {
          this.fCount += 20f;
          SZWidgets.ButtonImage(this.GetCopyRect(rView, this.fCount), "UI/Buttons/Copy", new Action(this.ACopyAll), "");
          bool flag = !this.lOfCopyOutfits.NullOrEmpty<Apparel>();
          if (flag)
          {
            SZWidgets.ButtonImage(this.GetPasteRect(rView, this.fCount), "UI/Buttons/Paste", new Action(this.APasteAll), "");
          }
          Widgets.ListSeparator(ref this.fCount, rView.width, "OverallArmor".Translate());
          this.TryDrawOverallArmor(ref this.fCount, rView.width, StatDefOf.ArmorRating_Sharp, "ArmorSharp".Translate());
          this.TryDrawOverallArmor(ref this.fCount, rView.width, StatDefOf.ArmorRating_Blunt, "ArmorBlunt".Translate());
          this.TryDrawOverallArmor(ref this.fCount, rView.width, StatDefOf.ArmorRating_Heat, "ArmorHeat".Translate());
        }

        // Token: 0x06000902 RID: 2306 RVA: 0x0004EA22 File Offset: 0x0004CC22
        private void DrawCarryAndComfy(Rect rView)
        {
          this.fCount = 0f;
          this.TryDrawMassInfo(ref this.fCount, rView.width);
          this.TryDrawComfyTemperatureRange(ref this.fCount, rView.width);
        }

        // Token: 0x06000903 RID: 2307 RVA: 0x0004EA58 File Offset: 0x0004CC58
        private void DrawInvData(Rect rect)
        {
          GUI.BeginGroup(rect);
          Text.Font = GameFont.Small;
          GUI.color = Color.white;
          Rect outRect = new Rect(0f, 0f, rect.width, rect.height);
          Rect rect2 = new Rect(0f, 0f, rect.width - 16f, this.scrollH);
          Widgets.BeginScrollView(outRect, ref this.scrollPos, rect2, true);
          this.DrawCarryAndComfy(rect2);
          this.DrawArmorRating(rect2);
          this.DrawEquipment(rect2);
          this.DrawApparel(rect2);
          this.DrawInventory(rect2);
          Widgets.EndScrollView();
          GUI.EndGroup();
          Text.Anchor = TextAnchor.UpperLeft;
        }

        // Token: 0x06000904 RID: 2308 RVA: 0x0004EB0C File Offset: 0x0004CD0C
        private void ACopyAll()
        {
          this.lOfCopyOutfits = CEditor.API.Pawn.ListOfCopyOutfits();
          this.lOfCopyItems = CEditor.API.Pawn.ListOfCopyItems();
          this.lOfCopyWeapons = CEditor.API.Pawn.ListOfCopyWeapons();
        }

        // Token: 0x06000905 RID: 2309 RVA: 0x0004EB5C File Offset: 0x0004CD5C
        private void APasteAll()
        {
          CEditor.API.Pawn.PasteCopyOutfits(this.lOfCopyOutfits);
          CEditor.API.Pawn.PasteCopyItems(this.lOfCopyItems);
          CEditor.API.Pawn.PasteCopyWeapons(this.lOfCopyWeapons);
        }

        // Token: 0x06000906 RID: 2310 RVA: 0x0004EBAC File Offset: 0x0004CDAC
        private void ACopyWeapon()
        {
          this.lOfCopyWeapons = CEditor.API.Pawn.ListOfCopyWeapons();
        }

        // Token: 0x06000907 RID: 2311 RVA: 0x0004EBC4 File Offset: 0x0004CDC4
        private void APasteWeapon()
        {
          CEditor.API.Pawn.PasteCopyWeapons(this.lOfCopyWeapons);
        }

        // Token: 0x06000908 RID: 2312 RVA: 0x0004EBDD File Offset: 0x0004CDDD
        private void ACopyApparel()
        {
          this.lOfCopyOutfits = CEditor.API.Pawn.ListOfCopyOutfits();
        }

        // Token: 0x06000909 RID: 2313 RVA: 0x0004EBF5 File Offset: 0x0004CDF5
        private void APasteApparel()
        {
          CEditor.API.Pawn.PasteCopyOutfits(this.lOfCopyOutfits);
        }

        // Token: 0x0600090A RID: 2314 RVA: 0x0004EC0E File Offset: 0x0004CE0E
        private void ACopyInv()
        {
          this.lOfCopyItems = CEditor.API.Pawn.ListOfCopyItems();
        }

        // Token: 0x0600090B RID: 2315 RVA: 0x0004EC26 File Offset: 0x0004CE26
        private void APasteInv()
        {
          CEditor.API.Pawn.PasteCopyItems(this.lOfCopyItems);
        }

        // Token: 0x0600090C RID: 2316 RVA: 0x0004EC40 File Offset: 0x0004CE40
        private void DrawLowerButtons(int x, int y)
        {
          int num = 120;
          SZWidgets.ButtonText((float)(x - num), (float)y, 120f, 30f, Label.UNDRESS, new Action(this.AUndress), Label.TIP_UNDRESS);
          num += 120;
          SZWidgets.ButtonText((float)(x - num), (float)y, 120f, 30f, Label.REDRESS, new Action(this.ARedress), Label.TIP_REDRESS);
          num += 120;
          SZWidgets.ButtonText((float)(x - num), (float)y, 120f, 30f, Label.REEQUIP, new Action(this.AReequip), Label.TIP_REEQUIP);
          num += 120;
          SZWidgets.ButtonText((float)(x - num), (float)y, 120f, 30f, Label.REINVENT, new Action(this.AReinvent), Label.TIP_REINVENT);
          num += 120;
          SZWidgets.ButtonText((float)(x - num), (float)y, 120f, 30f, "Equipment".Translate() + " +", new Action(this.AAddGun), Label.TIP_ADD_EQUIP);
          num += 120;
          SZWidgets.ButtonText((float)(x - num), (float)y, 120f, 30f, "Apparel".Translate() + " +", new Action(this.AAddApparel), Label.TIP_ADD_APPAREL);
          num += 120;
          SZWidgets.ButtonText((float)(x - num), (float)y, 120f, 30f, "Inventory".Translate() + " +", new Action(this.AAddItem), Label.TIP_ADD_ITEM);
        }

        // Token: 0x0600090D RID: 2317 RVA: 0x0004EDE0 File Offset: 0x0004CFE0
        private void AUndress()
        {
          Pawn pawn = CEditor.API.Pawn;
          List<Apparel> list;
          if (pawn == null)
          {
            list = null;
          }
          else
          {
            Pawn_ApparelTracker apparel = pawn.apparel;
            list = ((apparel != null) ? apparel.WornApparel : null);
          }
          List<Apparel> list2 = list;
          bool flag = !list2.NullOrEmpty<Apparel>();
          if (flag)
          {
            int index = list2.IndexOf(list2.RandomElement<Apparel>());
            bool flag2 = CEditor.InStartingScreen || Event.current.alt;
            if (flag2)
            {
              CEditor.API.Pawn.apparel.WornApparel[index].Destroy(DestroyMode.Vanish);
            }
            else
            {
              CEditor.API.Pawn.apparel.TryDrop(list2[index]);
            }
            CEditor.API.UpdateGraphics();
          }
        }

        // Token: 0x0600090E RID: 2318 RVA: 0x0004EE8F File Offset: 0x0004D08F
        private void ARedress()
        {
          CEditor.API.Pawn.Redress(null, true, -1, true);
          CEditor.API.UpdateGraphics();
        }

        // Token: 0x0600090F RID: 2319 RVA: 0x0004EEB1 File Offset: 0x0004D0B1
        private void AReequip()
        {
          CEditor.API.Pawn.Reequip(null, -1, false);
          CEditor.API.UpdateGraphics();
        }

        // Token: 0x06000910 RID: 2320 RVA: 0x0004EED2 File Offset: 0x0004D0D2
        private void AReinvent()
        {
          CEditor.API.Pawn.Reinvent(null, CEditor.zufallswert.Next(1, 10));
          CEditor.API.UpdateGraphics();
        }

        // Token: 0x06000911 RID: 2321 RVA: 0x0004EEFE File Offset: 0x0004D0FE
        private void AAddGun()
        {
          WindowTool.Open(new DialogWeaponry(null));
        }

        // Token: 0x06000912 RID: 2322 RVA: 0x0004EF0D File Offset: 0x0004D10D
        private void AAddApparel()
        {
          WindowTool.Open(new DialogArmory(null));
        }

        // Token: 0x06000913 RID: 2323 RVA: 0x0004EF1C File Offset: 0x0004D11C
        private void AAddItem()
        {
          WindowTool.Open(new DialogItemry(null, null));
        }

        // Token: 0x06000914 RID: 2324 RVA: 0x0004EF2C File Offset: 0x0004D12C
        private void InterfaceDrop(Thing t, bool shift)
        {
          ThingWithComps thingWithComps = t as ThingWithComps;
          Apparel apparel = t as Apparel;
          bool flag = apparel != null && CEditor.API.Pawn.apparel != null && CEditor.API.Pawn.apparel.WornApparel.Contains(apparel);
          if (flag)
          {
            if (shift)
            {
              CEditor.API.Pawn.TransferToInventory(apparel);
            }
            else
            {
              bool flag2 = CEditor.InStartingScreen || Event.current.alt;
              if (flag2)
              {
                CEditor.API.Pawn.TransferToInventory(apparel);
                CEditor.API.Pawn.DestroyApparel(apparel);
              }
              else
              {
                CEditor.API.Pawn.jobs.TryTakeOrderedJob(new Job(JobDefOf.RemoveApparel, apparel), new JobTag?(JobTag.Misc), false);
              }
            }
          }
          else
          {
            bool flag3 = thingWithComps != null && CEditor.API.Pawn.equipment != null && CEditor.API.Pawn.IsEquippedByPawn(thingWithComps);
            if (flag3)
            {
              if (shift)
              {
                CEditor.API.Pawn.TransferToInventory(thingWithComps);
              }
              else
              {
                bool flag4 = CEditor.InStartingScreen || Event.current.alt;
                if (flag4)
                {
                  CEditor.API.Pawn.TransferToInventory(thingWithComps);
                  CEditor.API.Pawn.DestroyEquipment(thingWithComps);
                }
                else
                {
                  CEditor.API.Pawn.jobs.TryTakeOrderedJob(new Job(JobDefOf.DropEquipment, thingWithComps), new JobTag?(JobTag.Misc), false);
                }
              }
            }
            else if (shift)
            {
              bool isApparel = t.def.IsApparel;
              if (isApparel)
              {
                bool flag5 = !CEditor.API.Pawn.apparel.CanWearWithoutDroppingAnything(t.def);
                if (flag5)
                {
                  CEditor.API.Pawn.MoveDressToInv(t.def.apparel.LastLayer);
                }
              }
              CEditor.API.Pawn.TransferFromInventory(t);
            }
            else
            {
              bool flag6 = CEditor.InStartingScreen || Event.current.alt;
              if (flag6)
              {
                CEditor.API.Pawn.DestroyItem(t);
              }
              else
              {
                bool destroyOnDrop = t.def.destroyOnDrop;
                if (destroyOnDrop)
                {
                  CEditor.API.Pawn.inventory.innerContainer.Remove(t);
                }
                else
                {
                  Thing thing;
                  CEditor.API.Pawn.inventory.innerContainer.TryDrop(t, CEditor.API.Pawn.Position, CEditor.API.Pawn.Map, ThingPlaceMode.Near, out thing, null, null);
                }
              }
            }
          }
        }

        // Token: 0x06000915 RID: 2325 RVA: 0x0004F1E0 File Offset: 0x0004D3E0
        private void InterfaceIngest(Thing t)
        {
          Job job = new Job(JobDefOf.Ingest, t);
          job.count = Mathf.Min(t.stackCount, t.def.ingestible.maxNumToIngestAtOnce);
          job.count = Mathf.Min(job.count, FoodUtility.WillIngestStackCountOf(CEditor.API.Pawn, t.def, StatExtension.GetStatValue(t, StatDefOf.Nutrition, true)));
          CEditor.API.Pawn.jobs.TryTakeOrderedJob(job, new JobTag?(JobTag.Misc), false);
        }

        // Token: 0x06000916 RID: 2326 RVA: 0x0004F26F File Offset: 0x0004D46F
        private void AShowInfo(Thing thing)
        {
          WindowTool.Open(new Dialog_InfoCard(thing, null));
        }

        // Token: 0x06000917 RID: 2327 RVA: 0x0004F27F File Offset: 0x0004D47F
        private void ADropOrDestroy(Thing thing)
        {
          SoundTool.PlayThis(SoundDefOf.Tick_High);
          this.InterfaceDrop(thing, false);
          CEditor.API.UpdateGraphics();
        }

        // Token: 0x06000918 RID: 2328 RVA: 0x0004F2A1 File Offset: 0x0004D4A1
        private void AShift(Thing thing)
        {
          SoundTool.PlayThis(SoundDefOf.Tick_High);
          this.InterfaceDrop(thing, true);
          CEditor.API.UpdateGraphics();
        }

        // Token: 0x06000919 RID: 2329 RVA: 0x0004F2C3 File Offset: 0x0004D4C3
        private void AIngestThing(Thing thing)
        {
          SoundTool.PlayThis(SoundDefOf.Tick_High);
          this.InterfaceIngest(thing);
          CEditor.API.UpdateGraphics();
        }

        // Token: 0x0600091A RID: 2330 RVA: 0x0004F2E4 File Offset: 0x0004D4E4
        private string GetThingLabel(Thing thing)
        {
          string text = thing.Label;
          Apparel apparel = thing as Apparel;
          bool flag = apparel != null && CEditor.API.Pawn.outfits != null && CEditor.API.Pawn.outfits.forcedHandler.IsForced(apparel);
          if (flag)
          {
            text += ", " + "ApparelForcedLower".Translate();
          }
          return text;
        }

        // Token: 0x0600091B RID: 2331 RVA: 0x0004F35C File Offset: 0x0004D55C
        private void DrawThingRow(ref float y, float width, Thing thing, int type)
        {
          try
          {
            Rect rect = new Rect(0f, y, width, 28f);
            Text.Anchor = TextAnchor.MiddleLeft;
            GUI.color = ITab_Pawn_Gear.ThingLabelColor;
            Text.WordWrap = false;
            Widgets.Label(new Rect(36f, y, rect.width - 36f, rect.height), this.GetThingLabel(thing));
            Text.WordWrap = true;
            SZWidgets.ButtonImageVar<Thing>(rect.width - 28f, y, 28f, 28f, "UI/Buttons/InfoButton", new Action<Thing>(this.AShowInfo), thing, "DefInfoTip".Translate());
            rect.width -= 28f;
            SZWidgets.ButtonImageVar<Thing>(rect.width - 28f, y, 28f, 28f, "UI/Buttons/Drop", new Action<Thing>(this.ADropOrDestroy), thing, "DropThing".Translate() + Label.TIP_DESTROYDROP);
            rect.width -= 28f;
            SZWidgets.ButtonImageVar<Thing>(rect.width - 28f, y, 28f, 28f, "bpfeil", new Action<Thing>(this.AShift), thing, "");
            rect.width -= 28f;
            bool isRandom = CEditor.IsRandom;
            if (isRandom)
            {
              bool flag = Widgets.ButtonImage(new Rect(rect.width - 28f, y, 28f, 28f), ContentFinder<Texture2D>.Get("brandom", true), true);
              if (flag)
              {
                this.ARandomThing(thing, type);
              }
              rect.width -= 28f;
            }
            bool flag2 = (thing.def.IsNutritionGivingIngestible || thing.def.IsNonMedicalDrug) && thing.IngestibleNow && CEditor.API.Pawn.RaceProps.CanEverEat(thing);
            if (flag2)
            {
              SZWidgets.ButtonImageVar<Thing>(rect.width - 28f, y, 28f, 28f, "UI/Buttons/Ingest", new Action<Thing>(this.AIngestThing), thing, "");
              rect.width -= 28f;
            }
            Rect rect2 = rect;
            rect2.xMin = rect2.xMax - 60f;
            CaravanThingsTabUtility.DrawMass(thing, rect2);
            rect.width -= 60f;
            bool flag3 = Mouse.IsOver(rect);
            if (flag3)
            {
              GUI.color = ITab_Pawn_Gear.HighlightColor;
              GUI.DrawTexture(rect, TexUI.HighlightTex);
              SZWidgets.ButtonInvisible(rect, delegate
              {
                this.OpenEditDialog(thing, type);
              }, "");
            }
            Widgets.ThingIcon(new Rect(4f, y, 32f, 32f), thing, 1f, null);
            this.DoThingToolTip(rect, thing);
            y += 32f;
          }
          catch
          {
          }
        }

        // Token: 0x0600091C RID: 2332 RVA: 0x0004F6E8 File Offset: 0x0004D8E8
        private void OpenEditDialog(Thing thing, int type)
        {
          bool flag = type == 0;
          if (flag)
          {
            WindowTool.Open(new DialogWeaponry((ThingWithComps)thing));
          }
          else
          {
            bool flag2 = type == 1;
            if (flag2)
            {
              WindowTool.Open(new DialogArmory(thing));
            }
            else
            {
              WindowTool.Open(new DialogItemry(null, thing));
            }
          }
        }

        // Token: 0x0600091D RID: 2333 RVA: 0x0004F734 File Offset: 0x0004D934
        private void DoThingToolTip(Rect rect, Thing thing)
        {
          string text = thing.DescriptionDetailed;
          bool useHitPoints = thing.def.useHitPoints;
          if (useHitPoints)
          {
            text = string.Concat(new string[]
            {
              text,
              "\n",
              thing.HitPoints.ToString(),
              " / ",
              thing.MaxHitPoints.ToString()
            });
          }
          TooltipHandler.TipRegion(rect, text);
        }

        // Token: 0x0600091E RID: 2334 RVA: 0x0004F7A8 File Offset: 0x0004D9A8
        private void TryDrawComfyTemperatureRange(ref float curY, float width)
        {
          bool dead = CEditor.API.Pawn.Dead;
          if (!dead)
          {
            Rect rect = new Rect(0f, curY, width, 22f);
            float statValue = StatExtension.GetStatValue(CEditor.API.Pawn, StatDefOf.ComfyTemperatureMin, true);
            float statValue2 = StatExtension.GetStatValue(CEditor.API.Pawn, StatDefOf.ComfyTemperatureMax, true);
            Widgets.Label(rect, string.Concat(new string[]
            {
              "ComfyTemperatureRange".Translate(),
              ": ",
              statValue.ToStringTemperature("F0"),
              " ~ ",
              statValue2.ToStringTemperature("F0")
            }));
            curY += 22f;
          }
        }

        // Token: 0x0600091F RID: 2335 RVA: 0x0004F86C File Offset: 0x0004DA6C
        private void TryDrawMassInfo(ref float curY, float width)
        {
          bool dead = CEditor.API.Pawn.Dead;
          if (!dead)
          {
            Rect rect = new Rect(0f, curY, width, 22f);
            float num = (float)Math.Round((double)MassUtility.GearAndInventoryMass(CEditor.API.Pawn), 2);
            float num2 = (float)Math.Round((double)MassUtility.Capacity(CEditor.API.Pawn, null), 2);
            string label = "MassCarried".Translate(new NamedArgument(num, "0.##"), new NamedArgument(num2, "0.##"));
            Widgets.Label(rect, label);
            curY += 22f;
          }
        }

        // Token: 0x06000920 RID: 2336 RVA: 0x0004F91C File Offset: 0x0004DB1C
        private void TryDrawOverallArmor(ref float curY, float width, StatDef stat, string label)
        {
          float num = 0f;
          float num2 = Mathf.Clamp01(StatExtension.GetStatValue(CEditor.API.Pawn, stat, true) / 2f);
          List<BodyPartRecord> allParts = CEditor.API.Pawn.RaceProps.body.AllParts;
          Pawn_ApparelTracker apparel = CEditor.API.Pawn.apparel;
          List<Apparel> list = (apparel != null) ? apparel.WornApparel : null;
          for (int i = 0; i < allParts.Count; i++)
          {
            float num3 = 1f - num2;
            bool flag = list != null;
            if (flag)
            {
              for (int j = 0; j < list.Count; j++)
              {
                bool flag2 = list[j].def.apparel.CoversBodyPart(allParts[i]);
                if (flag2)
                {
                  float num4 = Mathf.Clamp01(StatExtension.GetStatValue(list[j], stat, true) / 2f);
                  num3 *= 1f - num4;
                }
              }
            }
            num += allParts[i].coverageAbs * (1f - num3);
          }
          num = Mathf.Clamp(num * 2f, 0f, 2f);
          Rect rect = new Rect(0f, curY, width, 100f);
          Widgets.Label(rect, label.Truncate(120f, null));
          rect.xMin += 120f;
          Widgets.Label(rect, num.ToStringPercent());
          curY += 22f;
        }

        // Token: 0x04000745 RID: 1861
        private Vector2 scrollPos;

        // Token: 0x04000746 RID: 1862
        private float fCount;

        // Token: 0x04000747 RID: 1863
        private float scrollH;

        // Token: 0x04000748 RID: 1864
        private const float ICONH = 32f;

        // Token: 0x04000749 RID: 1865
        private const float BUTTONH = 28f;

        // Token: 0x0400074A RID: 1866
        private List<Thing> workingInvList;

        // Token: 0x0400074B RID: 1867
        private List<Apparel> lOfCopyOutfits;

        // Token: 0x0400074C RID: 1868
        private List<Thing> lOfCopyItems;

        // Token: 0x0400074D RID: 1869
        private List<ThingWithComps> lOfCopyWeapons;
      }

      // Token: 0x020000DC RID: 220
      private class BlockLog
      {
        // Token: 0x06000921 RID: 2337 RVA: 0x0004FAAD File Offset: 0x0004DCAD
        internal BlockLog()
        {
          this.wLog = 0f;
          this.hLog = 0f;
          this.yLine = 0f;
          this.LogInit();
        }

        // Token: 0x06000922 RID: 2338 RVA: 0x0004FAE0 File Offset: 0x0004DCE0
        private void LogInit()
        {
          this.logCachedDisplayLastTick = -1;
          this.logCachedPlayLastTick = -1;
          this.logCachedDisplay = null;
          this.logData = new ITab_Pawn_Log_Utility.LogDrawData();
          this.logSeek = null;
          Pawn pawn = CEditor.API.Pawn;
          this.uniqueID = ((pawn != null) ? pawn.ThingID : null);
        }

        // Token: 0x06000923 RID: 2339 RVA: 0x0004FB34 File Offset: 0x0004DD34
        internal void Draw(CEditor.EditorUI.coord c)
        {
          ////Log.Message("BlockLog.Draw, start");
          int x = c.x;
          int y = c.y;
          int w = c.w;
          int h = c.h;
          ////Log.Message("BlockLog.Draw, step 1");
          bool flag = CEditor.API.Pawn == null;
          if (!flag)
          {
            ////Log.Message("BlockLog.Draw, step 2");
            bool flag2 = this.uniqueID != CEditor.API.Pawn.ThingID;
            if (flag2)
            {
              this.LogInit();
            }
            ////Log.Message("BlockLog.Draw, step 3");
            bool flag3 = this.logCachedDisplay == null || this.logCachedDisplayLastTick != CEditor.API.Pawn.records.LastBattleTick || this.logCachedPlayLastTick != Find.PlayLog.LastTick;
            if (flag3)
            {
              this.logCachedDisplay = ITab_Pawn_Log_Utility.GenerateLogLinesFor(CEditor.API.Pawn, true, true, true, 100).ToList<ITab_Pawn_Log_Utility.LogLineDisplayable>();
              this.logCachedDisplayLastTick = CEditor.API.Pawn.records.LastBattleTick;
              this.logCachedPlayLastTick = Find.PlayLog.LastTick;
            }
            ////Log.Message("BlockLog.Draw, step 4");
            Rect outRect = new Rect((float)(x + 10), (float)(y + 5), (float)(w - 10), (float)(h - 5));
            this.wLog = outRect.width - 26f;
            this.hLog = 0f;
            ////Log.Message("BlockLog.Draw, step 5");
            foreach (ITab_Pawn_Log_Utility.LogLineDisplayable logLineDisplayable in this.logCachedDisplay)
            {
              ////Log.Message("BlockLog.Draw, step 5a");
              if (logLineDisplayable.Matches(this.logSeek))
              {
                ////Log.Message("BlockLog.Draw, step 5b");
                this.scrollPos.y = this.hLog - (logLineDisplayable.GetHeight(this.wLog) + outRect.height) / 2f;
              }
              ////Log.Message("BlockLog.Draw, step 5c");
              this.hLog += logLineDisplayable.GetHeight(this.wLog);
              ////Log.Message("BlockLog.Draw, step 5d");
            }
            ////Log.Message("BlockLog.Draw, step 6");
            this.logSeek = null;
            if (this.hLog > 0f)
            {
              ////Log.Message("BlockLog.Draw, step 7");
              Rect viewRect = new Rect(0f, 0f, outRect.width - 16f, this.hLog);
              this.logData.StartNewDraw();
              Widgets.BeginScrollView(outRect, ref this.scrollPos, viewRect, true);
              this.yLine = 0f;
              foreach (ITab_Pawn_Log_Utility.LogLineDisplayable logLineDisplayable2 in this.logCachedDisplay)
              {
                logLineDisplayable2.Draw(this.yLine, this.wLog, this.logData);
                this.yLine += logLineDisplayable2.GetHeight(this.wLog);
              }
              Widgets.EndScrollView();
              ////Log.Message("BlockLog.Draw, step 8");
            }
            else
            {
              ////Log.Message("BlockLog.Draw, step 7");
              Text.Anchor = TextAnchor.MiddleCenter;
              Text.Font = GameFont.Medium;
              GUI.color = Color.grey;
              Widgets.Label(new Rect(outRect.x, 0f, outRect.width, outRect.height), "(" + "NoRecentEntries".Translate() + ")");
              Text.Anchor = TextAnchor.UpperLeft;
              GUI.color = Color.white;
              ////Log.Message("BlockLog.Draw, step 8");
            }
          }
          ////Log.Message("BlockLog.Draw, end");
        }

        // Token: 0x0400074E RID: 1870
        private Vector2 scrollPos;

        // Token: 0x0400074F RID: 1871
        private float wLog;

        // Token: 0x04000750 RID: 1872
        private float hLog;

        // Token: 0x04000751 RID: 1873
        private float yLine;

        // Token: 0x04000752 RID: 1874
        private int logCachedDisplayLastTick;

        // Token: 0x04000753 RID: 1875
        private int logCachedPlayLastTick;

        // Token: 0x04000754 RID: 1876
        private List<ITab_Pawn_Log_Utility.LogLineDisplayable> logCachedDisplay;

        // Token: 0x04000755 RID: 1877
        private ITab_Pawn_Log_Utility.LogDrawData logData;

        // Token: 0x04000756 RID: 1878
        private LogEntry logSeek;

        // Token: 0x04000757 RID: 1879
        private string uniqueID;
      }

      // Token: 0x020000DD RID: 221
      private class BlockNeeds
      {
        // Token: 0x06000924 RID: 2340 RVA: 0x0004FE58 File Offset: 0x0004E058
        internal BlockNeeds()
        {
          this.wNeedBar = 0;
          this.hNeedBar = 0;
          this.yStartMemories = 0;
        }

        // Token: 0x06000925 RID: 2341 RVA: 0x0004FE80 File Offset: 0x0004E080
        internal void Draw(CEditor.EditorUI.coord c)
        {
          int x = c.x;
          int y = c.y;
          int w = c.w;
          int h = c.h;
          bool flag = !CEditor.API.Pawn.HasNeedsTracker() || CEditor.API.Pawn.Dead;
          if (!flag)
          {
            this.yStartMemories = this.DrawNeedBars(x, y, w, h);
            this.yStartMemories = ((CEditor.API.Pawn.needs.AllNeeds.Count > 12) ? this.yStartMemories : (y + 80));
            this.DrawMemories(x + this.wNeedBar + 30, this.yStartMemories, this.wNeedBar + 225, h - this.yStartMemories - 36);
            this.DrawThoughtButtons(x + w - 50, this.yStartMemories, w, h);
            this.DrawLowerButtons(x, y + h - 30, w, h);
          }
        }

        // Token: 0x06000926 RID: 2342 RVA: 0x0004FF6C File Offset: 0x0004E16C
        private int DrawNeedBars(int x, int y, int w, int h)
        {
          this.wNeedBar = w / 3;
          this.hNeedBar = h / 11;
          bool flag = !CEditor.InStartingScreen || !CEditor.IsAVPActive;
          if (flag)
          {
            foreach (Need need in CEditor.API.Pawn.needs.AllNeeds)
            {
              bool flag2 = need.def.defName == "Mood";
              if (flag2)
              {
                GUI.color = (((double)need.CurLevelPercentage < 0.2) ? (GUI.color = Color.red) : Color.white);
                try
                {
                  need.DrawOnGUI(new Rect((float)(x + this.wNeedBar), (float)y, (float)(this.wNeedBar * 2), (float)this.hNeedBar), int.MaxValue, -1f, true, true, null);
                }
                catch
                {
                }
                SZWidgets.ButtonImageVar<Need>((float)(x + this.wNeedBar + 11), (float)(y + 30), 24f, 24f, "bbackward", new Action<Need>(this.ASubNeed), need, "");
                SZWidgets.ButtonImageVar<Need>((float)(x + this.wNeedBar * 3 - 36), (float)(y + 30), 24f, 24f, "bforward", new Action<Need>(this.AAddNeed), need, "");
              }
            }
          }
          int num = 0;
          foreach (Need need2 in CEditor.API.Pawn.needs.AllNeeds)
          {
            bool flag3 = need2.def.defName != "Mood";
            if (flag3)
            {
              bool flag4 = num == 11;
              if (flag4)
              {
                x += this.wNeedBar;
                y = 80;
              }
              GUI.color = (((double)need2.CurLevelPercentage < 0.2) ? (GUI.color = Color.red) : Color.white);
              need2.DrawOnGUI(new Rect((float)x, (float)y, (float)this.wNeedBar, (float)this.hNeedBar), int.MaxValue, -1f, true, true, null);
              SZWidgets.ButtonImageVar<Need>((float)(x + 11), (float)(y + 30), 24f, 24f, "bbackward", new Action<Need>(this.ASubNeed), need2, "");
              SZWidgets.ButtonImageVar<Need>((float)(x + this.wNeedBar - 36), (float)(y + 30), 24f, 24f, "bforward", new Action<Need>(this.AAddNeed), need2, "");
              y += 60;
              num++;
            }
          }
          return y;
        }

        // Token: 0x06000927 RID: 2343 RVA: 0x000502A4 File Offset: 0x0004E4A4
        private void AAddNeed(Need need)
        {
          need.CurLevelPercentage += 0.05f;
        }

        // Token: 0x06000928 RID: 2344 RVA: 0x000502BA File Offset: 0x0004E4BA
        private void ASubNeed(Need need)
        {
          need.CurLevelPercentage -= 0.05f;
        }

        // Token: 0x06000929 RID: 2345 RVA: 0x000502D0 File Offset: 0x0004E4D0
        private void DrawMemories(int x, int y, int w, int h)
        {
          List<Thought> thoughtsSorted = CEditor.API.Pawn.GetThoughtsSorted();
          Text.Font = GameFont.Small;
          GUI.color = Color.white;
          SZWidgets.Label(new Rect((float)x, (float)y, (float)w, 30f), "MemoryLower".Translate() + ": " + thoughtsSorted.Count.ToString(), null, "");
          y += 30;
          Thought thought = null;
          int num = ThoughtTool.CountOfDefs<Thought_MemorySocial>(thoughtsSorted, out thought, "AteNon");
          this.listH = (thoughtsSorted.Count - num + 1) * 22;
          Rect outRect = new Rect((float)x, (float)y, (float)w, (float)h);
          Rect rect = new Rect(0f, 0f, outRect.width - 16f, (float)this.listH);
          Widgets.BeginScrollView(outRect, ref this.scrollPos, rect, true);
          Rect rect2 = rect.ContractedBy(0f);
          rect2.height = (float)this.listH;
          Listing_X listing_X = new Listing_X();
          listing_X.Begin(rect2);
          foreach (Thought thought2 in thoughtsSorted)
          {
            bool flag = thought2.def.IsClassOf<Thought_MemorySocial>();
            if (flag)
            {
              bool flag2 = thought2.def.defName.StartsWith("AteNon");
              if (flag2)
              {
                continue;
              }
            }
            string name;
            string text;
            string pName;
            string tooltip;
            this.LabelHelper(thought2, out name, out text, out pName, out tooltip, 0);
            float valopin;
            float valmood;
            Texture2D icon;
            Color iconColor;
            this.IconAndOffsetHelper(thought2, out valopin, out valmood, out icon, out iconColor);
            bool flag3 = listing_X.SelectableThought(name, icon, iconColor, valopin, valmood, tooltip, pName, this.bToggleShowRemoveThought);
            if (flag3)
            {
              //List<Thought>.Enumerator enumerator;
              CEditor.API.Pawn.RemoveThought(thought2);
            }
          }
          bool flag4 = thought != null;
          if (flag4)
          {
            string name2;
            string text2;
            string pName2;
            string tooltip2;
            this.LabelHelper(thought, out name2, out text2, out pName2, out tooltip2, num);
            float valopin2;
            float valmood2;
            Texture2D icon2;
            Color iconColor2;
            this.IconAndOffsetHelper(thought, out valopin2, out valmood2, out icon2, out iconColor2);
            bool flag5 = listing_X.SelectableThought(name2, icon2, iconColor2, valopin2, valmood2, tooltip2, pName2, this.bToggleShowRemoveThought);
            if (flag5)
            {
              CEditor.API.Pawn.RemoveThought(thought);
            }
          }
          listing_X.End();
          Widgets.EndScrollView();
        }

        // Token: 0x0600092A RID: 2346 RVA: 0x00050530 File Offset: 0x0004E730
        private void LabelHelper(Thought t, out string label, out string desc, out string otherPawnName, out string tooltip, int count = 0)
        {
          label = t.GetThoughtLabel();
          desc = ((t.CurStageIndex < 0) ? t.GetThoughtDescription() : t.Description);
          tooltip = desc;
          bool devMode = Prefs.DevMode;
          if (devMode)
          {
            tooltip = ((desc == null) ? "\n\n" : (desc + "\n\n"));
            tooltip = string.Concat(new string[]
            {
              tooltip,
              t.def.defName,
              "\n",
              t.def.ThoughtClass.ToString(),
              "\n"
            });
            bool flag = t.CurStageIndex >= 0;
            if (flag)
            {
              try
              {
                int num = (int)t.def.stages[t.CurStageIndex].baseMoodEffect;
                int num2 = (int)t.def.stages[t.CurStageIndex].baseOpinionOffset;
                tooltip = string.Concat(new string[]
                {
                  tooltip,
                  "Stage ",
                  t.CurStageIndex.ToString(),
                  "\nBaseMood: ",
                  num.ToString().Colorize((num == 0) ? ColorLibrary.Grey : ((num > 0) ? ColorLibrary.Green : ColorLibrary.Red))
                });
                tooltip = tooltip + " BaseOpinion: " + num2.ToString().Colorize((num2 == 0) ? ColorLibrary.Grey : ((num2 > 0) ? ColorLibrary.Green : ColorLibrary.Red));
              }
              catch
              {
              }
            }
            else
            {
              tooltip = tooltip + "Stage " + t.CurStageIndex.ToString();
            }
          }
          string arg;
          Pawn otherPawn = t.GetOtherPawn(out arg);
          otherPawnName = otherPawn.GetPawnName(false);
          try
          {
            bool flag2 = t.def.defName == "WrongApparelGender";
            if (flag2)
            {
              label = string.Format(label, t.pawn.GetOppositeGender().ToString().Translate());
            }
            bool flag3 = t.def.defName == "DeadMansApparel";
            if (flag3)
            {
              label = t.LabelCap.CapitalizeFirst();
            }
            bool flag4 = label.Contains("{0}");
            if (flag4)
            {
              bool flag5 = !otherPawnName.NullOrEmpty();
              if (flag5)
              {
                bool flag6 = label.Contains("{1}");
                if (flag6)
                {
                  label = string.Format(label, arg, otherPawnName);
                }
                else
                {
                  label = string.Format(label, otherPawnName);
                }
              }
            }
            bool flag7 = label.Contains("{TITLE}") || label.Contains("{TITLE_label}");
            if (flag7)
            {
              bool flag8 = t.def.IsClassOf<Thought_MemoryRoyalTitle>();
              if (flag8)
              {
                Thought_MemoryRoyalTitle thought_MemoryRoyalTitle = (Thought_MemoryRoyalTitle)t;
                string newValue = (CEditor.API.Pawn.gender == Gender.Female) ? thought_MemoryRoyalTitle.titleDef.labelFemale : thought_MemoryRoyalTitle.titleDef.label;
                label = label.Replace("{TITLE}", newValue).Replace("{TITLE_label}", newValue);
              }
              else
              {
                label = label.Replace("{TITLE}", CEditor.API.Pawn.GetMainTitle()).Replace("{TITLE_label}", CEditor.API.Pawn.GetMainTitle());
              }
            }
            else
            {
              bool flag9 = t.def.IsClassOf<Thought_IdeoRoleEmpty>();
              if (flag9)
              {
                Thought_IdeoRoleEmpty thought_IdeoRoleEmpty = (Thought_IdeoRoleEmpty)t;
                label = label.Replace("{ROLE}", thought_IdeoRoleEmpty.Role.LabelCap).Replace("{ROLE_label}", thought_IdeoRoleEmpty.Role.LabelCap);
              }
              else
              {
                bool flag10 = t.def.IsClassOf<Thought_IdeoRoleLost>();
                if (flag10)
                {
                  Thought_IdeoRoleLost thought_IdeoRoleLost = (Thought_IdeoRoleLost)t;
                  label = label.Replace("{ROLE}", thought_IdeoRoleLost.Role.LabelCap).Replace("{ROLE_label}", thought_IdeoRoleLost.Role.LabelCap);
                }
                else
                {
                  bool flag11 = t.def.IsClassOf<Thought_IdeoRoleApparelRequirementNotMet>();
                  if (flag11)
                  {
                    Thought_IdeoRoleApparelRequirementNotMet thought_IdeoRoleApparelRequirementNotMet = (Thought_IdeoRoleApparelRequirementNotMet)t;
                    label = label.Replace("{ROLE}", thought_IdeoRoleApparelRequirementNotMet.Role.LabelCap).Replace("{ROLE_label}", thought_IdeoRoleApparelRequirementNotMet.Role.LabelCap);
                  }
                  else
                  {
                    bool flag12 = t.def.IsClassOf<Thought_Situational_WearingDesiredApparel>();
                    if (flag12)
                    {
                      Thought_Situational_WearingDesiredApparel thought_Situational_WearingDesiredApparel = (Thought_Situational_WearingDesiredApparel)t;
                      Precept_Apparel precept_Apparel = (Precept_Apparel)thought_Situational_WearingDesiredApparel.sourcePrecept;
                      label = label.Replace("{APPAREL}", precept_Apparel.apparelDef.LabelCap).Replace("{APPAREL_label}", precept_Apparel.apparelDef.LabelCap);
                    }
                    else
                    {
                      bool flag13 = t.def.IsClassOf<Thought_PsychicHarmonizer>();
                      if (flag13)
                      {
                        Thought_PsychicHarmonizer thought_PsychicHarmonizer = (Thought_PsychicHarmonizer)t;
                        label = thought_PsychicHarmonizer.LabelCap;
                      }
                      else
                      {
                        bool flag14 = t.def.IsClassOf<Thought_RelicAtRitual>();
                        if (flag14)
                        {
                          Thought_RelicAtRitual thought_RelicAtRitual = (Thought_RelicAtRitual)t;
                          label = label.Replace("{RELICNAME}", thought_RelicAtRitual.relicName).Replace("{RELICNAME_label}", thought_RelicAtRitual.relicName);
                        }
                      }
                    }
                  }
                }
              }
            }
            bool flag15 = count > 0;
            if (flag15)
            {
              label = label + " x" + count.ToString();
            }
          }
          catch
          {
          }
        }

        // Token: 0x0600092B RID: 2347 RVA: 0x00050AA4 File Offset: 0x0004ECA4
        private void IconAndOffsetHelper(Thought t, out float opinionOffset, out float moodOffset, out Texture2D icon, out Color iconColor)
        {
          bool flag = t.def.IsSocial && t.def.IsSituational;
          opinionOffset = t.GetOpinionOffset();
          moodOffset = t.TryGetMoodOffset();
          object memberValue = t.def.GetMemberValue("iconInt");
          icon = ((memberValue != null) ? ((Texture2D)memberValue) : ((opinionOffset != float.MinValue || flag) ? ContentFinder<Texture2D>.Get("bsocial", true) : ((t.def.Icon != null) ? t.def.Icon : ((moodOffset > 0f) ? ContentFinder<Texture2D>.Get("Things/Mote/ThoughtSymbol/GenericGood", true) : ContentFinder<Texture2D>.Get("Things/Mote/ThoughtSymbol/GenericBad", true)))));
          iconColor = (flag ? ColorLibrary.Aquamarine : Color.white);
        }

        // Token: 0x0600092C RID: 2348 RVA: 0x00050B74 File Offset: 0x0004ED74
        private void DrawThoughtButtons(int x, int y, int w, int h)
        {
          SZWidgets.ButtonImage((float)x, (float)y, 24f, 24f, "UI/Buttons/Dev/Add", new Action(this.ADoAddThought), "");
          SZWidgets.ButtonImage((float)(x - 25), (float)y, 24f, 24f, "bminus", new Action(this.ADoRemoveThought), "");
        }

        // Token: 0x0600092D RID: 2349 RVA: 0x00050BD9 File Offset: 0x0004EDD9
        private void ADoAddThought()
        {
          WindowTool.Open(new DialogAddThought(null));
        }

        // Token: 0x0600092E RID: 2350 RVA: 0x00050BE8 File Offset: 0x0004EDE8
        private void ADoRemoveThought()
        {
          this.bToggleShowRemoveThought = !this.bToggleShowRemoveThought;
        }

        // Token: 0x0600092F RID: 2351 RVA: 0x00050BFC File Offset: 0x0004EDFC
        private void DrawLowerButtons(int x, int y, int w, int h)
        {
          GUI.color = Color.white;
          SZWidgets.ButtonText((float)(x + w - 120), (float)y, 120f, 30f, Label.FULLNEEDS, new Action(this.AFullNeeds), "");
          SZWidgets.ButtonText((float)(x + w - 230), (float)y, 110f, 30f, Label.NOMEMORIES, new Action(this.AClearAllMemory), "");
        }

        // Token: 0x06000930 RID: 2352 RVA: 0x00050C76 File Offset: 0x0004EE76
        private void AClearAllMemory()
        {
          CEditor.API.Pawn.ClearAllThoughts();
        }

        // Token: 0x06000931 RID: 2353 RVA: 0x00050C8C File Offset: 0x0004EE8C
        private void AFullNeeds()
        {
          foreach (Need need in CEditor.API.Pawn.needs.AllNeeds)
          {
            need.CurLevelPercentage = 1f;
          }
        }

        // Token: 0x04000758 RID: 1880
        private Vector2 scrollPos;

        // Token: 0x04000759 RID: 1881
        private int wNeedBar;

        // Token: 0x0400075A RID: 1882
        private int hNeedBar;

        // Token: 0x0400075B RID: 1883
        private int yStartMemories;

        // Token: 0x0400075C RID: 1884
        private int listH;

        // Token: 0x0400075D RID: 1885
        private bool bToggleShowRemoveThought = false;
      }

      // Token: 0x020000DE RID: 222
      private class BlockRecords
      {
        // Token: 0x06000932 RID: 2354 RVA: 0x00050CF8 File Offset: 0x0004EEF8
        internal BlockRecords()
        {
        }

        // Token: 0x06000933 RID: 2355 RVA: 0x00050D04 File Offset: 0x0004EF04
        internal void Draw(CEditor.EditorUI.coord c)
        {
          int x = c.x;
          int y = c.y;
          int w = c.w;
          int h = c.h;
          bool flag = CEditor.API.Pawn == null;
          if (!flag)
          {
            RecordsCardUtility.DrawRecordsCard(new Rect((float)(x + 10), (float)y, (float)(w - 10), (float)h), CEditor.API.Pawn);
            this.DrawMiniCapsule(x + 110, y + h - 160);
          }
        }

        // Token: 0x06000934 RID: 2356 RVA: 0x00050D7C File Offset: 0x0004EF7C
        private void DrawMiniCapsule(int x, int y)
        {
          if (!CEditor.InStartingScreen)
          {
            SZWidgets.ButtonImage((float)x, (float)y, 200f, 144f, "bcapsule", delegate ()
            {
              WindowTool.Open(new DialogCapsuleUI());
            }, "");
          }
        }
      }

      // Token: 0x020000DF RID: 223
      private class BlockSocial : IPawnable
      {
        // Token: 0x06000935 RID: 2357 RVA: 0x00050DD4 File Offset: 0x0004EFD4
        internal BlockSocial()
        {
          this.bShowRemove = false;
          this.dpr = null;
          this.selectedInspiration = null;
          this.selectedMentalState = null;
          this.selectedIndirectRelationDef = null;
          this.selectedPawnToSwap = null;
          this.SelectedPawn = null;
          this.SelectedPawn2 = null;
          this.SelectedPawn3 = null;
          this.SelectedPawn4 = null;
          this.selectedGender = Gender.Male;
          this.selectedGender2 = Gender.Male;
          this.selectedGender3 = Gender.Female;
          this.selectedGender4 = Gender.Male;
          this.selRelation1 = PawnRelationDefOf.Parent;
          this.selRelation2 = null;
          this.selRelation3 = null;
          this.selRelation4 = null;
          this.imgSize = new Vector2(140f, 196f);
          Type atype = Reflect.GetAType("RimWorld", "SocialCardUtility");
          bool flag = atype != null;
          if (flag)
          {
            atype.SetMemberValue("showAllRelations", true);
          }
          this.lOfRelations = DefTool.ListBy<PawnRelationDef>((PawnRelationDef r) => !r.implied).ToList<PawnRelationDef>();
          this.lOfRelations.Add(PawnRelationDefOf.Grandparent);
          this.lOfRelations.Add(PawnRelationDefOf.Sibling);
          this.lOfRelations.Add(PawnRelationDefOf.HalfSibling);
          this.lOfRelations.Add(PawnRelationDefOf.Child);
          this.lOfRelations.Add(PawnRelationDefOf.UncleOrAunt);
          this.lOfIndirectRelations = null;
          this.lOfMentalStates = CEditor.API.ListOf<MentalStateDef>(EType.MentalStates);
          this.lOfInspirations = CEditor.API.ListOf<InspirationDef>(EType.Inspirations);
          this.lOfRelatedPawns = null;
        }

        // Token: 0x17000098 RID: 152
        // (get) Token: 0x06000936 RID: 2358 RVA: 0x00050FAA File Offset: 0x0004F1AA
        // (set) Token: 0x06000937 RID: 2359 RVA: 0x00050FB2 File Offset: 0x0004F1B2
        public Pawn SelectedPawn { get; set; }

        // Token: 0x17000099 RID: 153
        // (get) Token: 0x06000938 RID: 2360 RVA: 0x00050FBB File Offset: 0x0004F1BB
        // (set) Token: 0x06000939 RID: 2361 RVA: 0x00050FC3 File Offset: 0x0004F1C3
        public Pawn SelectedPawn2 { get; set; }

        // Token: 0x1700009A RID: 154
        // (get) Token: 0x0600093A RID: 2362 RVA: 0x00050FCC File Offset: 0x0004F1CC
        // (set) Token: 0x0600093B RID: 2363 RVA: 0x00050FD4 File Offset: 0x0004F1D4
        public Pawn SelectedPawn3 { get; set; }

        // Token: 0x1700009B RID: 155
        // (get) Token: 0x0600093C RID: 2364 RVA: 0x00050FDD File Offset: 0x0004F1DD
        // (set) Token: 0x0600093D RID: 2365 RVA: 0x00050FE5 File Offset: 0x0004F1E5
        public Pawn SelectedPawn4 { get; set; }

        // Token: 0x1700009C RID: 156
        // (get) Token: 0x0600093E RID: 2366 RVA: 0x00050FEE File Offset: 0x0004F1EE
        private Func<InspirationDef, string> FGetInspirationLabel
        {
          get
          {
            return (InspirationDef i) => (i == null) ? Label.NONE : i.LabelCap;
          }
        }

        // Token: 0x1700009D RID: 157
        // (get) Token: 0x0600093F RID: 2367 RVA: 0x0005100F File Offset: 0x0004F20F
        private Func<MentalStateDef, string> FGetMentalLabel
        {
          get
          {
            return (MentalStateDef m) => (m == null) ? Label.NONE : m.LabelCap;
          }
        }

        // Token: 0x1700009E RID: 158
        // (get) Token: 0x06000940 RID: 2368 RVA: 0x00051030 File Offset: 0x0004F230
        private Func<ThoughtDef, string> FGetThoughtLabel
        {
          get
          {
            return (ThoughtDef t) => (t == null) ? Label.NONE : t.GetThoughtLabel(0, null);
          }
        }

        // Token: 0x1700009F RID: 159
        // (get) Token: 0x06000941 RID: 2369 RVA: 0x00051051 File Offset: 0x0004F251
        private Func<PawnRelationDef, string> FGetRelationLabel
        {
          get
          {
            return (PawnRelationDef r) => this.GetLabelSelectedPawn(r);
          }
        }

        // Token: 0x170000A0 RID: 160
        // (get) Token: 0x06000942 RID: 2370 RVA: 0x0005105F File Offset: 0x0004F25F
        private Func<PawnRelationDef, string> FGetRelationLabel2
        {
          get
          {
            return (PawnRelationDef r) => this.GetLabelSelectedPawn2(r);
          }
        }

        // Token: 0x170000A1 RID: 161
        // (get) Token: 0x06000943 RID: 2371 RVA: 0x0005106D File Offset: 0x0004F26D
        private Func<PawnRelationDef, string> FGetRelationLabel3
        {
          get
          {
            return (PawnRelationDef r) => this.GetLabelSelectedPawn3(r);
          }
        }

        // Token: 0x170000A2 RID: 162
        // (get) Token: 0x06000944 RID: 2372 RVA: 0x0005107B File Offset: 0x0004F27B
        private Func<PawnRelationDef, string> FGetRelationLabel4
        {
          get
          {
            return (PawnRelationDef r) => this.GetLabelSelectedPawn4(r);
          }
        }

        // Token: 0x06000945 RID: 2373 RVA: 0x00051089 File Offset: 0x0004F289
        private string GetLabelSelectedPawn(PawnRelationDef r)
        {
          return (this.selectedGender == Gender.Male) ? r.label : (r.labelFemale.NullOrEmpty() ? r.label : r.labelFemale);
        }

        // Token: 0x06000946 RID: 2374 RVA: 0x000510B8 File Offset: 0x0004F2B8
        private string GetLabelSelectedPawn2(PawnRelationDef r)
        {
          bool flag = this.selRelation1 == PawnRelationDefOf.Child;
          string result;
          if (flag)
          {
            result = ((this.selectedGender2 == Gender.Male) ? r.label : (r.labelFemale.NullOrEmpty() ? r.label : r.labelFemale)) + "(" + this.SelectedPawn.GetPawnName(false) + ")";
          }
          else
          {
            result = ((this.selectedGender2 == Gender.Male) ? r.label : (r.labelFemale.NullOrEmpty() ? r.label : r.labelFemale)) + "(" + CEditor.API.Pawn.GetPawnName(false) + ")";
          }
          return result;
        }

        // Token: 0x06000947 RID: 2375 RVA: 0x00051170 File Offset: 0x0004F370
        private string GetLabelSelectedPawn3(PawnRelationDef r)
        {
          bool flag = this.selRelation1 == PawnRelationDefOf.UncleOrAunt || this.selRelation1 == PawnRelationDefOf.Child;
          string result;
          if (flag)
          {
            result = ((this.selectedGender3 == Gender.Male) ? r.label : (r.labelFemale.NullOrEmpty() ? r.label : r.labelFemale)) + "(" + ((this.SelectedPawn != null) ? this.SelectedPawn.GetPawnName(false) : "") + ")";
          }
          else
          {
            result = ((this.selectedGender3 == Gender.Male) ? r.label : (r.labelFemale.NullOrEmpty() ? r.label : r.labelFemale)) + "(" + CEditor.API.Pawn.GetPawnName(false) + ")";
          }
          return result;
        }

        // Token: 0x06000948 RID: 2376 RVA: 0x00051248 File Offset: 0x0004F448
        private string GetLabelSelectedPawn4(PawnRelationDef r)
        {
          bool flag = this.selRelation1 == PawnRelationDefOf.UncleOrAunt;
          string result;
          if (flag)
          {
            result = ((this.selectedGender4 == Gender.Male) ? r.label : (r.labelFemale.NullOrEmpty() ? r.label : r.labelFemale)) + "(" + ((this.SelectedPawn != null) ? this.SelectedPawn.GetPawnName(false) : "") + ")";
          }
          else
          {
            result = ((this.selectedGender4 == Gender.Male) ? r.label : (r.labelFemale.NullOrEmpty() ? r.label : r.labelFemale)) + "(" + ((this.SelectedPawn != null) ? this.SelectedPawn.GetPawnName(false) : "") + ")";
          }
          return result;
        }

        // Token: 0x06000949 RID: 2377 RVA: 0x0005131C File Offset: 0x0004F51C
        internal void Draw(CEditor.EditorUI.coord c)
        {
          int x = c.x;
          int num = c.y;
          int w = c.w;
          int h = c.h;
          bool flag = !CEditor.API.Pawn.HasRelationTracker();
          if (!flag)
          {
            num += 20;
            this.DrawRelations(x, ref num, w, h);
            this.DrawCard(x, ref num, w, h);
          }
        }

        // Token: 0x0600094A RID: 2378 RVA: 0x00051380 File Offset: 0x0004F580
        private void AAddIndirectRelation()
        {
          bool flag = this.selRelation1 == PawnRelationDefOf.Child;
          if (flag)
          {
            this.SelectedPawn.relations.AddDirectRelation(PawnRelationDefOf.Parent, this.SelectedPawn2);
            this.SelectedPawn.relations.AddDirectRelation(PawnRelationDefOf.Parent, this.SelectedPawn3);
          }
          else
          {
            bool flag2 = this.selRelation1 == PawnRelationDefOf.HalfSibling;
            if (flag2)
            {
              CEditor.API.Pawn.relations.AddDirectRelation(PawnRelationDefOf.Parent, this.SelectedPawn2);
              CEditor.API.Pawn.relations.AddDirectRelation(PawnRelationDefOf.Parent, this.SelectedPawn3);
              this.SelectedPawn.relations.AddDirectRelation(PawnRelationDefOf.Parent, this.SelectedPawn3);
              this.SelectedPawn.relations.AddDirectRelation(PawnRelationDefOf.Parent, this.SelectedPawn4);
            }
            else
            {
              bool flag3 = this.selRelation1 == PawnRelationDefOf.Sibling;
              if (flag3)
              {
                this.SelectedPawn.relations.AddDirectRelation(PawnRelationDefOf.Parent, this.SelectedPawn2);
                this.SelectedPawn.relations.AddDirectRelation(PawnRelationDefOf.Parent, this.SelectedPawn3);
                CEditor.API.Pawn.relations.AddDirectRelation(PawnRelationDefOf.Parent, this.SelectedPawn2);
                CEditor.API.Pawn.relations.AddDirectRelation(PawnRelationDefOf.Parent, this.SelectedPawn3);
              }
              else
              {
                bool flag4 = this.selRelation1 == PawnRelationDefOf.Grandparent;
                if (flag4)
                {
                  this.SelectedPawn2.relations.AddDirectRelation(PawnRelationDefOf.Parent, this.SelectedPawn);
                  bool flag5 = CEditor.API.Pawn.GetFirstParentForPawn(this.selectedGender2) == null;
                  if (flag5)
                  {
                    CEditor.API.Pawn.relations.AddDirectRelation(PawnRelationDefOf.Parent, this.SelectedPawn2);
                  }
                }
                else
                {
                  bool flag6 = this.selRelation1 == PawnRelationDefOf.UncleOrAunt;
                  if (flag6)
                  {
                    this.SelectedPawn.relations.AddDirectRelation(PawnRelationDefOf.Parent, this.SelectedPawn3);
                    this.SelectedPawn.relations.AddDirectRelation(PawnRelationDefOf.Parent, this.SelectedPawn4);
                    this.SelectedPawn2.relations.AddDirectRelation(PawnRelationDefOf.Parent, this.SelectedPawn3);
                    this.SelectedPawn2.relations.AddDirectRelation(PawnRelationDefOf.Parent, this.SelectedPawn4);
                    CEditor.API.Pawn.relations.AddDirectRelation(PawnRelationDefOf.Parent, this.SelectedPawn2);
                  }
                }
              }
            }
          }
          this.SelectedPawn = null;
          this.SelectedPawn2 = null;
          this.SelectedPawn3 = null;
          this.SelectedPawn4 = null;
          this.selRelation1 = PawnRelationDefOf.Parent;
        }

        // Token: 0x0600094B RID: 2379 RVA: 0x00051644 File Offset: 0x0004F844
        private void AAddRelation()
        {
          CEditor.API.Pawn.relations.AddDirectRelation(this.selRelation1, this.SelectedPawn);
          this.SelectedPawn = null;
          this.SelectedPawn2 = null;
          this.SelectedPawn3 = null;
          this.SelectedPawn4 = null;
        }

        // Token: 0x0600094C RID: 2380 RVA: 0x00051693 File Offset: 0x0004F893
        private void AAddThought()
        {
          WindowTool.Open(new DialogAddThought(Label.TH_SOCIAL));
        }

        // Token: 0x0600094D RID: 2381 RVA: 0x000516A8 File Offset: 0x0004F8A8
        private void AChangeInspiration(InspirationDef i)
        {
          this.selectedInspiration = i;
          bool flag = CEditor.API.Pawn.Inspiration != null;
          if (flag)
          {
            CEditor.API.Pawn.Inspiration.PostEnd();
            CEditor.API.Pawn.mindState.inspirationHandler.EndInspiration(CEditor.API.Pawn.Inspiration);
          }
          bool flag2 = i != null;
          if (flag2)
          {
            CEditor.API.Pawn.mindState.inspirationHandler.TryStartInspiration(i, null, true);
          }
        }

        // Token: 0x0600094E RID: 2382 RVA: 0x00051738 File Offset: 0x0004F938
        private void AChangeMentalState(MentalStateDef m)
        {
          this.selectedMentalState = m;
          CEditor.API.Pawn.Notify_Teleported(true, true);
          bool flag = CEditor.API.Pawn.MentalState != null;
          if (flag)
          {
            CEditor.API.Pawn.MentalState.PostEnd();
            CEditor.API.Pawn.mindState.mentalStateHandler.Reset();
          }
          bool flag2 = m == MentalStateDefOf.SocialFighting;
          if (flag2)
          {
            List<Pawn> source = (from td in Find.CurrentMap.mapPawns.FreeColonists
                                 where td != CEditor.API.Pawn
                                 select td).ToList<Pawn>();
            Pawn otherPawn = source.RandomElement<Pawn>();
            CEditor.API.Pawn.interactions.StartSocialFight(otherPawn, "MessageSocialFight");
          }
          else
          {
            CEditor.API.Pawn.mindState.mentalStateHandler.TryStartMentalState(m, null, false, false, null, false, false, false);
          }
        }

        // Token: 0x0600094F RID: 2383 RVA: 0x00051835 File Offset: 0x0004FA35
        private void AOnGenderChange()
        {
          this.selectedGender = ((this.selectedGender == Gender.Female) ? Gender.Male : Gender.Female);
          this.SelectedPawn = null;
        }

        // Token: 0x06000950 RID: 2384 RVA: 0x00051853 File Offset: 0x0004FA53
        private void AOnGenderChange2()
        {
          this.selectedGender2 = ((this.selectedGender2 == Gender.Female) ? Gender.Male : Gender.Female);
          this.SelectedPawn2 = null;
        }

        // Token: 0x06000951 RID: 2385 RVA: 0x00051871 File Offset: 0x0004FA71
        private void AOnGenderChange3()
        {
          this.selectedGender3 = ((this.selectedGender3 == Gender.Female) ? Gender.Male : Gender.Female);
          this.SelectedPawn3 = null;
        }

        // Token: 0x06000952 RID: 2386 RVA: 0x0005188F File Offset: 0x0004FA8F
        private void AOnGenderChange4()
        {
          this.selectedGender4 = ((this.selectedGender4 == Gender.Female) ? Gender.Male : Gender.Female);
          this.SelectedPawn4 = null;
        }

        // Token: 0x06000953 RID: 2387 RVA: 0x000518AD File Offset: 0x0004FAAD
        private void AOnImgAction()
        {
          WindowTool.Open(new DialogChoosePawn(this, 1, this.selectedGender));
        }

        // Token: 0x06000954 RID: 2388 RVA: 0x000518C4 File Offset: 0x0004FAC4
        private void AOnRelationSelected(PawnRelationDef pr)
        {
          this.selRelation1 = pr;
          bool flag = Prefs.DevMode && this.selRelation1 != null;
          if (flag)
          {
            MessageTool.Show(this.selRelation1.defName + " " + ((this.selectedGender == Gender.Male) ? this.selRelation1.label : this.selRelation1.labelFemale), null);
          }
          this.selectedGender2 = Gender.Male;
          this.selectedGender3 = Gender.Female;
          this.selectedGender4 = Gender.Male;
          this.SelectedPawn = null;
          this.SelectedPawn2 = null;
          this.SelectedPawn3 = null;
          this.SelectedPawn4 = null;
        }

        // Token: 0x06000955 RID: 2389 RVA: 0x00051962 File Offset: 0x0004FB62
        private void ASelectOtherPawn()
        {
          CEditor.API.Pawn = this.selectedPawnToSwap;
        }

        // Token: 0x06000956 RID: 2390 RVA: 0x00051976 File Offset: 0x0004FB76
        private void AToggleRemove()
        {
          this.bShowRemove = !this.bShowRemove;
        }

        // Token: 0x06000957 RID: 2391 RVA: 0x00051988 File Offset: 0x0004FB88
        private void CreateDirect(int x, int y, int w, int h)
        {
          bool flag = !CEditor.API.Pawn.HasRelationTracker() || CEditor.API.Pawn.relations.DirectRelations.NullOrEmpty<DirectPawnRelation>();
          if (!flag)
          {
            SZWidgets.ScrollView(x, y, w, h, CEditor.API.Pawn.relations.DirectRelations.Count, 196, ref this.scrollDirectRelated, new Action<Listing_X>(this.DrawDirect));
          }
        }

        // Token: 0x06000958 RID: 2392 RVA: 0x00051A04 File Offset: 0x0004FC04
        private void CreateIndirect(int x, int y, int w, int h)
        {
          bool flag = !CEditor.API.Pawn.HasRelationTracker();
          if (!flag)
          {
            int objCount;
            this.lOfRelatedPawns = CEditor.API.Pawn.GetRelatedPawns(out objCount);
            SZWidgets.ScrollView(x, y, w, h, objCount, 196, ref this.scrollIndirectRelated, new Action<Listing_X>(this.DrawIndirect));
          }
        }

        // Token: 0x06000959 RID: 2393 RVA: 0x00051A64 File Offset: 0x0004FC64
        private void DrawCard(int x, ref int y, int w, int h)
        {
          Rect rect = new Rect((float)(x + 400), (float)y, (float)(w - 400), (float)h);
          Widgets.DrawBoxSolid(rect, ColorTool.colDarkDimGray);
          SocialCardUtility.DrawRelationsAndOpinions(rect, CEditor.API.Pawn);
          y += h - y;
        }

        // Token: 0x0600095A RID: 2394 RVA: 0x00051AB8 File Offset: 0x0004FCB8
        private void DrawDirect(Listing_X view)
        {
          try
          {
            foreach (DirectPawnRelation directPawnRelation in CEditor.API.Pawn.relations.DirectRelations)
            {
              Pawn otherPawn = directPawnRelation.otherPawn;
              RenderTexture image = PortraitsCache.Get(otherPawn, this.imgSize, Rot4.South, default(Vector3), 1f, true, true, true, true, null, null, false);
              //List<DirectPawnRelation>.Enumerator enumerator;
              string name = directPawnRelation.RelationLabelDirect();
              string tooltip = CEditor.API.Pawn.RelationTooltip(otherPawn);
              bool selected = this.dpr == directPawnRelation;
              int num = view.Selectable(name, selected, tooltip, image, null, null, this.imgSize, this.bShowRemove, 180f, Color.white, ColorTool.colLightGray, true);
              bool flag = num == 1;
              if (flag)
              {
                this.selectedPawnToSwap = otherPawn;
                this.dpr = directPawnRelation;
              }
              else
              {
                bool flag2 = num == 2;
                if (flag2)
                {
                  CEditor.API.Pawn.relations.RemoveDirectRelation(directPawnRelation);
                  this.dpr = null;
                }
              }
            }
          }
          catch
          {
          }
        }

        // Token: 0x0600095B RID: 2395 RVA: 0x00051C34 File Offset: 0x0004FE34
        private void DrawIndirect(Listing_X view)
        {
          try
          {
            foreach (Pawn pawn in this.lOfRelatedPawns)
            {
              this.lOfIndirectRelations = CEditor.API.Pawn.GetRelations(pawn).ToList<PawnRelationDef>();
              foreach (PawnRelationDef pawnRelationDef in this.lOfIndirectRelations)
              {
                bool flag = !pawnRelationDef.implied;
                if (!flag)
                {
                  RenderTexture image = PortraitsCache.Get(pawn, this.imgSize, Rot4.South, default(Vector3), 1f, true, true, true, true, null, null, false);
                  string name = pawnRelationDef.RelationLabelIndirect(pawn);
                  string tooltip = CEditor.API.Pawn.RelationTooltip(pawn);
                  bool selected = this.selectedPawnToSwap == pawn && this.selectedIndirectRelationDef == pawnRelationDef;
                  int num = view.Selectable(name, selected, tooltip, image, null, null, this.imgSize, false, 180f, Color.white, ColorTool.colLightGray, true);
                  bool flag2 = num == 1;
                  if (flag2)
                  {
                    this.selectedPawnToSwap = pawn;
                    this.selectedIndirectRelationDef = pawnRelationDef;
                    this.dpr = null;
                  }
                }
              }
            }
          }
          catch
          {
          }
        }

        // Token: 0x0600095C RID: 2396 RVA: 0x00051DEC File Offset: 0x0004FFEC
        private void HandleChild()
        {
          this.showPawn3 = true;
          this.showPawn4 = false;
          this.allowGender2 = false;
          this.allowGender3 = false;
          this.allowGender4 = false;
          this.selRelation2 = PawnRelationDefOf.Parent;
          this.selRelation3 = PawnRelationDefOf.Parent;
          bool flag = CEditor.API.Pawn.gender == Gender.Male;
          if (flag)
          {
            this.SelectedPawn2 = CEditor.API.Pawn;
          }
          else
          {
            this.SelectedPawn3 = CEditor.API.Pawn;
          }
          this.selectedGender2 = Gender.Male;
          this.selectedGender3 = Gender.Female;
          bool flag2 = this.SelectedPawn == CEditor.API.Pawn || this.SelectedPawn == this.SelectedPawn2 || this.SelectedPawn == this.SelectedPawn3;
          if (flag2)
          {
            this.SelectedPawn = null;
          }
          bool flag3 = this.SelectedPawn2 == this.SelectedPawn;
          if (flag3)
          {
            this.SelectedPawn2 = null;
          }
          bool flag4 = this.SelectedPawn3 == this.SelectedPawn;
          if (flag4)
          {
            this.SelectedPawn3 = null;
          }
          this.canAddRelation = (this.SelectedPawn != null && this.SelectedPawn2 != null && this.SelectedPawn3 != null);
        }

        // Token: 0x0600095D RID: 2397 RVA: 0x00051F10 File Offset: 0x00050110
        private void HandleUncle()
        {
          this.showPawn3 = true;
          this.showPawn4 = true;
          this.allowGender2 = true;
          this.allowGender3 = false;
          this.allowGender4 = false;
          this.selRelation2 = PawnRelationDefOf.Parent;
          this.selRelation3 = PawnRelationDefOf.Parent;
          this.selRelation4 = PawnRelationDefOf.Parent;
          Pawn firstParentForPawn = CEditor.API.Pawn.GetFirstParentForPawn(this.selectedGender2);
          bool flag = firstParentForPawn != null;
          if (flag)
          {
            this.SelectedPawn2 = firstParentForPawn;
          }
          Pawn firstParentForPawn2 = this.SelectedPawn.GetFirstParentForPawn(this.selectedGender3);
          bool flag2 = firstParentForPawn2 != null;
          if (flag2)
          {
            this.SelectedPawn3 = firstParentForPawn2;
          }
          Pawn firstParentForPawn3 = this.SelectedPawn.GetFirstParentForPawn(this.selectedGender4);
          bool flag3 = firstParentForPawn3 != null;
          if (flag3)
          {
            this.SelectedPawn4 = firstParentForPawn3;
          }
          bool flag4 = this.SelectedPawn == CEditor.API.Pawn || this.SelectedPawn == this.SelectedPawn2 || this.SelectedPawn == this.SelectedPawn3 || this.SelectedPawn == this.SelectedPawn4;
          if (flag4)
          {
            this.SelectedPawn = null;
          }
          bool flag5 = this.SelectedPawn3 == CEditor.API.Pawn || this.SelectedPawn3 == this.SelectedPawn || this.SelectedPawn3 == this.SelectedPawn2 || this.SelectedPawn3 == this.SelectedPawn4;
          if (flag5)
          {
            this.SelectedPawn3 = null;
          }
          bool flag6 = this.SelectedPawn4 == CEditor.API.Pawn || this.SelectedPawn4 == this.SelectedPawn || this.SelectedPawn4 == this.SelectedPawn2 || this.SelectedPawn4 == this.SelectedPawn3;
          if (flag6)
          {
            this.SelectedPawn4 = null;
          }
          this.canAddRelation = (this.SelectedPawn != null && this.SelectedPawn2 != null && this.SelectedPawn3 != null && this.SelectedPawn4 != null);
        }

        // Token: 0x0600095E RID: 2398 RVA: 0x000520E4 File Offset: 0x000502E4
        private void HandleSibling()
        {
          this.showPawn3 = true;
          this.showPawn4 = false;
          this.allowGender2 = true;
          this.allowGender3 = true;
          this.allowGender4 = false;
          this.selRelation2 = PawnRelationDefOf.Parent;
          this.selRelation3 = PawnRelationDefOf.Parent;
          bool flag = this.selectedGender2 == Gender.Male;
          if (flag)
          {
            this.selectedGender3 = Gender.Female;
          }
          else
          {
            this.selectedGender3 = Gender.Male;
          }
          Pawn firstParentForPawn = CEditor.API.Pawn.GetFirstParentForPawn(this.selectedGender2);
          bool flag2 = firstParentForPawn != null;
          if (flag2)
          {
            this.SelectedPawn2 = firstParentForPawn;
          }
          Pawn firstParentForPawn2 = CEditor.API.Pawn.GetFirstParentForPawn(this.selectedGender3);
          bool flag3 = firstParentForPawn2 != null;
          if (flag3)
          {
            this.SelectedPawn3 = firstParentForPawn2;
          }
          bool flag4 = this.SelectedPawn3 == null;
          if (flag4)
          {
            firstParentForPawn2 = this.SelectedPawn.GetFirstParentForPawn(this.selectedGender3);
            bool flag5 = firstParentForPawn2 != null;
            if (flag5)
            {
              this.SelectedPawn3 = firstParentForPawn2;
            }
          }
          bool flag6 = this.SelectedPawn2 == null;
          if (flag6)
          {
            firstParentForPawn = this.SelectedPawn.GetFirstParentForPawn(this.selectedGender2);
            bool flag7 = firstParentForPawn != null;
            if (flag7)
            {
              this.SelectedPawn2 = firstParentForPawn;
            }
          }
          bool flag8 = this.SelectedPawn == CEditor.API.Pawn || this.SelectedPawn == this.SelectedPawn2 || this.SelectedPawn == this.SelectedPawn3;
          if (flag8)
          {
            this.SelectedPawn = null;
          }
          bool flag9 = this.SelectedPawn3 == this.SelectedPawn2;
          if (flag9)
          {
            this.SelectedPawn3 = null;
          }
          this.canAddRelation = (this.SelectedPawn != null && this.SelectedPawn2 != null && this.SelectedPawn3 != null);
        }

        // Token: 0x0600095F RID: 2399 RVA: 0x00052280 File Offset: 0x00050480
        private void HandleHalfSibling()
        {
          this.showPawn3 = true;
          this.showPawn4 = true;
          this.allowGender2 = false;
          this.allowGender3 = true;
          this.allowGender4 = false;
          this.selRelation2 = PawnRelationDefOf.Parent;
          this.selRelation3 = PawnRelationDefOf.Parent;
          this.selRelation4 = PawnRelationDefOf.Parent;
          bool flag = this.selectedGender3 == Gender.Male;
          if (flag)
          {
            this.selectedGender2 = Gender.Female;
            this.selectedGender4 = Gender.Female;
          }
          else
          {
            this.selectedGender2 = Gender.Male;
            this.selectedGender4 = Gender.Male;
          }
          Pawn commonParent = RelationTool.GetCommonParent(CEditor.API.Pawn, this.SelectedPawn, this.selectedGender3);
          bool flag2 = commonParent != null;
          if (flag2)
          {
            this.SelectedPawn3 = commonParent;
          }
          bool flag3 = commonParent == null;
          if (flag3)
          {
            Pawn firstParentForPawn = CEditor.API.Pawn.GetFirstParentForPawn(this.selectedGender3);
            bool flag4 = firstParentForPawn != null;
            if (flag4)
            {
              this.SelectedPawn3 = firstParentForPawn;
            }
            bool flag5 = this.SelectedPawn3 == null;
            if (flag5)
            {
              firstParentForPawn = this.SelectedPawn.GetFirstParentForPawn(this.selectedGender3);
              bool flag6 = firstParentForPawn != null;
              if (flag6)
              {
                this.SelectedPawn3 = firstParentForPawn;
              }
            }
          }
          Pawn firstParentForPawn2 = CEditor.API.Pawn.GetFirstParentForPawn(this.selectedGender2);
          bool flag7 = firstParentForPawn2 != null;
          if (flag7)
          {
            this.SelectedPawn2 = firstParentForPawn2;
          }
          Pawn firstParentForPawn3 = this.SelectedPawn.GetFirstParentForPawn(this.selectedGender4);
          bool flag8 = firstParentForPawn3 != null;
          if (flag8)
          {
            this.SelectedPawn4 = firstParentForPawn3;
          }
          bool flag9 = this.SelectedPawn == CEditor.API.Pawn || this.SelectedPawn == this.SelectedPawn2 || this.SelectedPawn == this.SelectedPawn3 || this.SelectedPawn == this.SelectedPawn4;
          if (flag9)
          {
            this.SelectedPawn = null;
          }
          bool flag10 = RelationTool.AreThosePawnSisBro(CEditor.API.Pawn, this.SelectedPawn);
          if (flag10)
          {
            this.SelectedPawn = null;
          }
          bool flag11 = this.SelectedPawn2 == this.SelectedPawn4;
          if (flag11)
          {
            this.SelectedPawn4 = null;
          }
          this.canAddRelation = (this.SelectedPawn != null && this.SelectedPawn2 != null && this.SelectedPawn3 != null && this.SelectedPawn4 != null);
        }

        // Token: 0x06000960 RID: 2400 RVA: 0x000524A0 File Offset: 0x000506A0
        private void HandleGrandparent()
        {
          this.showPawn3 = false;
          this.showPawn4 = false;
          this.allowGender2 = true;
          this.allowGender3 = false;
          this.allowGender4 = false;
          this.selRelation2 = PawnRelationDefOf.Parent;
          Pawn firstParentForPawn = CEditor.API.Pawn.GetFirstParentForPawn(this.selectedGender2);
          bool flag = firstParentForPawn != null;
          if (flag)
          {
            this.SelectedPawn2 = firstParentForPawn;
          }
          bool flag2 = this.SelectedPawn == CEditor.API.Pawn || this.SelectedPawn == this.SelectedPawn2;
          if (flag2)
          {
            this.SelectedPawn = null;
          }
          this.canAddRelation = (this.SelectedPawn != null && this.SelectedPawn2 != null);
        }

        // Token: 0x06000961 RID: 2401 RVA: 0x0005254C File Offset: 0x0005074C
        private void DrawRelations(int x, ref int y, int w, int h)
        {
          Widgets.DrawBoxSolid(new Rect((float)x, (float)y, 400f, (float)h), ColorTool.colAsche);
          this.DrawUpper(x, y, w, h);
          SZWidgets.FloatMenuOnLabelAndImage<PawnRelationDef>(new Rect((float)(x + 10), (float)y, 110f, 100f), ColorTool.colDarkDimGray, "bplus2", this.SelectedPawn, ColorTool.colDimGray, this.lOfRelations, this.FGetRelationLabel, this.selRelation1, new Action<PawnRelationDef>(this.AOnRelationSelected), new Action(this.AOnImgAction), true);
          SZWidgets.ButtonImage(new Rect((float)(x + 100), (float)(y - 20), 20f, 20f), (this.selectedGender == Gender.Female) ? "bfemale" : "bmale", new Action(this.AOnGenderChange), "");
          int num = 0;
          bool flag = this.selRelation1 != null;
          if (flag)
          {
            bool implied = this.selRelation1.implied;
            if (implied)
            {
              bool flag2 = this.selRelation1 == PawnRelationDefOf.Child;
              if (flag2)
              {
                this.HandleChild();
              }
              else
              {
                bool flag3 = this.selRelation1 == PawnRelationDefOf.Sibling;
                if (flag3)
                {
                  this.HandleSibling();
                }
                else
                {
                  bool flag4 = this.selRelation1 == PawnRelationDefOf.HalfSibling;
                  if (flag4)
                  {
                    this.HandleHalfSibling();
                  }
                  else
                  {
                    bool flag5 = this.selRelation1 == PawnRelationDefOf.Grandparent;
                    if (flag5)
                    {
                      this.HandleGrandparent();
                    }
                    else
                    {
                      bool flag6 = this.selRelation1 == PawnRelationDefOf.UncleOrAunt;
                      if (flag6)
                      {
                        this.HandleUncle();
                      }
                    }
                  }
                }
              }
              num += 130;
              Text.WordWrap = true;
              SZWidgets.LabelBackground(new Rect((float)(x + 10), (float)(y + num - 20), 110f, 20f), this.GetLabelSelectedPawn2(this.selRelation2), ColorTool.colDarkDimGray, 0, "");
              SZWidgets.FloatMenuOnLabelAndImage<PawnRelationDef>(new Rect((float)(x + 10), (float)(y + num), 110f, 100f), ColorTool.colDarkDimGray, "bplus2", this.SelectedPawn2, ColorTool.colDimGray, this.lOfRelations, this.FGetRelationLabel2, this.selRelation2, null, new Action(this.AOnParent2Selected), this.allowGender2);
              bool flag7 = this.allowGender2;
              if (flag7)
              {
                SZWidgets.ButtonImage(new Rect((float)(x + 100), (float)(y - 20 + num), 20f, 20f), (this.selectedGender2 == Gender.Female) ? "bfemale" : "bmale", new Action(this.AOnGenderChange2), "");
              }
              bool flag8 = this.showPawn3;
              if (flag8)
              {
                SZWidgets.LabelBackground(new Rect((float)(x + 150), (float)(y + num - 20), 110f, 20f), this.GetLabelSelectedPawn3(this.selRelation3), ColorTool.colDarkDimGray, 0, "");
                SZWidgets.FloatMenuOnLabelAndImage<PawnRelationDef>(new Rect((float)(x + 150), (float)(y + num), 110f, 100f), ColorTool.colDarkDimGray, "bplus2", this.SelectedPawn3, ColorTool.colDimGray, this.lOfRelations, this.FGetRelationLabel3, this.selRelation3, null, new Action(this.AOnParent3Selected), this.allowGender3);
                bool flag9 = this.allowGender3;
                if (flag9)
                {
                  SZWidgets.ButtonImage(new Rect((float)(x + 240), (float)(y - 20 + num), 20f, 20f), (this.selectedGender3 == Gender.Female) ? "bfemale" : "bmale", new Action(this.AOnGenderChange3), "");
                }
              }
              bool flag10 = this.showPawn4;
              if (flag10)
              {
                SZWidgets.LabelBackground(new Rect((float)(x + 290), (float)(y + num - 20), 110f, 20f), this.GetLabelSelectedPawn4(this.selRelation4), ColorTool.colDarkDimGray, 0, "");
                SZWidgets.FloatMenuOnLabelAndImage<PawnRelationDef>(new Rect((float)(x + 290), (float)(y + num), 110f, 100f), ColorTool.colDarkDimGray, "bplus2", this.SelectedPawn4, ColorTool.colDimGray, this.lOfRelations, this.FGetRelationLabel4, this.selRelation4, null, new Action(this.AOnParent4Selected), this.allowGender4);
                bool flag11 = this.allowGender4;
                if (flag11)
                {
                  SZWidgets.ButtonImage(new Rect((float)(x + 380), (float)(y - 20 + num), 20f, 20f), (this.selectedGender4 == Gender.Female) ? "bfemale" : "bmale", new Action(this.AOnGenderChange4), "");
                }
              }
              bool flag12 = this.canAddRelation;
              if (flag12)
              {
                SZWidgets.ButtonImage(new Rect((float)(x + 120), (float)(y + 35), 20f, 20f), "bplus2", new Action(this.AAddIndirectRelation), "");
              }
            }
            else
            {
              bool flag13 = CEditor.API.Pawn == this.SelectedPawn;
              if (flag13)
              {
                this.SelectedPawn = null;
              }
              bool flag14 = this.SelectedPawn != null;
              if (flag14)
              {
                SZWidgets.ButtonImage(new Rect((float)(x + 120), (float)(y + 35), 20f, 20f), "bplus2", new Action(this.AAddRelation), "");
              }
            }
          }
          this.CreateDirect(x + 5, y + num + 110, 190, h - 130);
          this.CreateIndirect(x + 200, y + num + 110, 190, h - 130);
        }

        // Token: 0x06000962 RID: 2402 RVA: 0x00052AC1 File Offset: 0x00050CC1
        private void AOnParent2Selected()
        {
          WindowTool.Open(new DialogChoosePawn(this, 2, this.selectedGender2));
        }

        // Token: 0x06000963 RID: 2403 RVA: 0x00052AD7 File Offset: 0x00050CD7
        private void AOnParent3Selected()
        {
          WindowTool.Open(new DialogChoosePawn(this, 3, this.selectedGender3));
        }

        // Token: 0x06000964 RID: 2404 RVA: 0x00052AED File Offset: 0x00050CED
        private void AOnParent4Selected()
        {
          WindowTool.Open(new DialogChoosePawn(this, 4, this.selectedGender4));
        }

        // Token: 0x06000965 RID: 2405 RVA: 0x00052B04 File Offset: 0x00050D04
        private void DrawUpper(int x, int y, int w, int h)
        {
          bool flag = !CEditor.InStartingScreen;
          if (flag)
          {
            bool flag2 = CEditor.API.Pawn.MentalState == null;
            if (flag2)
            {
              this.selectedMentalState = null;
            }
            else
            {
              bool flag3 = CEditor.API.Pawn.MentalState != null && CEditor.API.Pawn.MentalState.def != this.selectedMentalState;
              if (flag3)
              {
                this.selectedMentalState = CEditor.API.Pawn.MentalState.def;
              }
            }
            bool flag4 = CEditor.API.Pawn.Inspiration == null;
            if (flag4)
            {
              this.selectedInspiration = null;
            }
            else
            {
              bool flag5 = CEditor.API.Pawn.Inspiration != null && CEditor.API.Pawn.Inspiration.def != this.selectedInspiration;
              if (flag5)
              {
                this.selectedInspiration = CEditor.API.Pawn.Inspiration.def;
              }
            }
            SZWidgets.FloatMenuOnButtonImage<MentalStateDef>(new Rect((float)(x + 400 - 35), (float)y, 30f, 30f), ContentFinder<Texture2D>.Get("bmental", true), this.lOfMentalStates, this.FGetMentalLabel, new Action<MentalStateDef>(this.AChangeMentalState), CEditor.API.Pawn.GetMentalStateTooltip());
            SZWidgets.FloatMenuOnLabel<MentalStateDef>(new Rect((float)(x + 400 - 195), (float)y, 160f, 30f), ColorTool.colDarkDimGray, this.lOfMentalStates, this.FGetMentalLabel, this.selectedMentalState, new Action<MentalStateDef>(this.AChangeMentalState), CEditor.API.Pawn.GetMentalStateTooltip());
            SZWidgets.FloatMenuOnButtonImage<InspirationDef>(new Rect((float)(x + 400 - 35), (float)(y + 33), 30f, 30f), ContentFinder<Texture2D>.Get("binspire", true), this.lOfInspirations, this.FGetInspirationLabel, new Action<InspirationDef>(this.AChangeInspiration), CEditor.API.Pawn.GetMentalStateTooltip());
            SZWidgets.FloatMenuOnLabel<InspirationDef>(new Rect((float)(x + 400 - 195), (float)(y + 33), 160f, 30f), ColorTool.colDarkDimGray, this.lOfInspirations, this.FGetInspirationLabel, this.selectedInspiration, new Action<InspirationDef>(this.AChangeInspiration), CEditor.API.Pawn.GetInspirationTooltip());
          }
          SZWidgets.ButtonImage(new Rect((float)(x + 400 - 70), (float)(y + 66), 30f, 30f), "bminus2", new Action(this.AToggleRemove), "");
          bool flag6 = this.selectedPawnToSwap != null;
          if (flag6)
          {
            SZWidgets.ButtonImage(new Rect((float)(x + 400 - 105), (float)(y + 66), 30f, 30f), "UI/Buttons/DragHash", new Action(this.ASelectOtherPawn), Label.SWAP_TO_PAWN);
          }
          SZWidgets.ButtonImage(new Rect((float)(x + 400 - 35), (float)(y + 66), 30f, 30f), "bmemory", new Action(this.AAddThought), "");
        }

        // Token: 0x0400075E RID: 1886
        private const int LIST_OBJ_H = 196;

        // Token: 0x0400075F RID: 1887
        private const int LIST_OBJ_W = 140;

        // Token: 0x04000760 RID: 1888
        private const int LIST_SELECTED_H = 180;

        // Token: 0x04000761 RID: 1889
        private const int widthLeft = 400;

        // Token: 0x04000762 RID: 1890
        private bool bShowRemove;

        // Token: 0x04000763 RID: 1891
        private DirectPawnRelation dpr;

        // Token: 0x04000764 RID: 1892
        private Vector2 imgSize;

        // Token: 0x04000765 RID: 1893
        private List<PawnRelationDef> lOfIndirectRelations;

        // Token: 0x04000766 RID: 1894
        private List<InspirationDef> lOfInspirations;

        // Token: 0x04000767 RID: 1895
        private List<MentalStateDef> lOfMentalStates;

        // Token: 0x04000768 RID: 1896
        private List<Pawn> lOfRelatedPawns;

        // Token: 0x04000769 RID: 1897
        private List<PawnRelationDef> lOfRelations;

        // Token: 0x0400076A RID: 1898
        private Vector2 scrollDirectRelated = default(Vector2);

        // Token: 0x0400076B RID: 1899
        private Vector2 scrollIndirectRelated = default(Vector2);

        // Token: 0x0400076C RID: 1900
        private Gender selectedGender;

        // Token: 0x0400076D RID: 1901
        private Gender selectedGender2;

        // Token: 0x0400076E RID: 1902
        private Gender selectedGender3;

        // Token: 0x0400076F RID: 1903
        private Gender selectedGender4;

        // Token: 0x04000770 RID: 1904
        private PawnRelationDef selectedIndirectRelationDef;

        // Token: 0x04000771 RID: 1905
        private InspirationDef selectedInspiration;

        // Token: 0x04000772 RID: 1906
        private MentalStateDef selectedMentalState;

        // Token: 0x04000773 RID: 1907
        private Pawn selectedPawnToSwap;

        // Token: 0x04000774 RID: 1908
        private PawnRelationDef selRelation1;

        // Token: 0x04000775 RID: 1909
        private PawnRelationDef selRelation2;

        // Token: 0x04000776 RID: 1910
        private PawnRelationDef selRelation3;

        // Token: 0x04000777 RID: 1911
        private PawnRelationDef selRelation4;

        // Token: 0x0400077C RID: 1916
        private bool allowGender2 = false;

        // Token: 0x0400077D RID: 1917
        private bool allowGender3 = false;

        // Token: 0x0400077E RID: 1918
        private bool allowGender4 = false;

        // Token: 0x0400077F RID: 1919
        private bool showPawn3 = true;

        // Token: 0x04000780 RID: 1920
        private bool showPawn4 = true;

        // Token: 0x04000781 RID: 1921
        private bool canAddRelation = true;
      }

      // Token: 0x020000E0 RID: 224
      private class BlockPerson
      {
        private Vector2 scrollPos;
        private bool isPrimaryColor;
        private bool isPrimarySkinColor;
        private Apparel apparelCurrent;
        private bool bIsBodyOpen;
        private bool bIsHairOpen;
        private bool bIsHeadOpen;
        private bool bIsEquipmentOpen;
        private bool bShowClothes;
        private bool bShowHat;
        private object deftest;
        private bool isAlien;
        private bool isApparelConfigOpen;
        private bool isBeardConfigOpen;
        private bool isBodyTattooConfigOpen;
        private bool isEyeConfigOpen;
        private bool isFaceTattooConfigOpen;
        private bool isHaircolorConfigOpen;
        //private bool isHaircolorGeneConfigOpen;
        private bool isHairConfigOpen;
        private bool isSkinConfigOpen;

        private bool isWeaponConfigOpen;
        private int iTickRemoveDeadLogo;
        private int iTickTool;
        private List<int> lHeadAddons;
        private List<BeardDef> lOfBeardDefs;
        private List<TattooDef> lOfBodyTattooDefs;
        private List<TattooDef> lOfFaceTattooDefs;
        private List<HairDef> lOfHairDefs;
        private Color randomDeadColor;
        private string selectedModName;
        private ThingWithComps weaponCurrent;
        private int x;
        private int y;
        private int w;
        private int h;

        internal BlockPerson()
        {
          this.iTickRemoveDeadLogo = 0;
          this.iTickTool = 0;
          this.bIsBodyOpen = false;
          this.bIsHairOpen = false;
          this.bIsHeadOpen = false;
          this.bIsEquipmentOpen = false;
          this.bShowClothes = true;
          this.bShowHat = true;
          this.isAlien = false;
          this.isApparelConfigOpen = false;
          this.isBeardConfigOpen = false;
          this.isBodyTattooConfigOpen = false;
          this.isEyeConfigOpen = false;
          this.isFaceTattooConfigOpen = false;
          this.isHaircolorConfigOpen = false;
          //this.isHaircolorGeneConfigOpen = false;
          this.isHairConfigOpen = false;
          this.isPrimaryColor = true;
          this.isPrimarySkinColor = true;
          this.isSkinConfigOpen = false;
          this.isWeaponConfigOpen = false;
          this.randomDeadColor = Color.clear;
          this.lHeadAddons = null;
          this.apparelCurrent = null;
          this.weaponCurrent = null;
          this.selectedModName = null;
          this.lOfHairDefs = HairTool.GetHairList(this.selectedModName);
          this.lOfBeardDefs = StyleTool.GetBeardList(this.selectedModName);
          this.lOfFaceTattooDefs = StyleTool.GetFaceTattooList(this.selectedModName);
          this.lOfBodyTattooDefs = StyleTool.GetBodyTattooList(this.selectedModName);
        }

        private Dictionary<string, Faction> DicFactions => CEditor.API.Get<Dictionary<string, Faction>>(EType.Factions);

        private Rect RectFullSolid => new Rect(this.x, this.y, this.w, 24f);

        internal void Draw(CEditor.EditorUI.coord c)
        {
          this.x = c.x;
          this.y = c.y;
          this.w = c.w;
          this.h = c.h;
          bool flag = CEditor.API.Pawn == null;
          if (!flag)
          {
            this.isAlien = CEditor.API.Pawn.IsAlienRace();
            this.lHeadAddons = (this.isAlien ? CEditor.API.Pawn.GetListHeadAddons() : null);
            this.apparelCurrent = CEditor.API.Pawn.ThisOrFirstWornApparel(this.apparelCurrent);
            this.weaponCurrent = CEditor.API.Pawn.ThisOrFirstWeapon(this.weaponCurrent);
            this.DrawTop();
            this.DrawImage();
            this.DrawMainIcons();
            this.y += 300;
            this.DrawHair();
            this.DrawHead();
            this.DrawBody();
            this.DrawEquipment();
            this.DrawDeadLogo();
          }
        }

        private void ASelectedModName(string val)
        {
          this.selectedModName = val;
          this.lOfHairDefs = HairTool.GetHairList(this.selectedModName);
          this.lOfBeardDefs = StyleTool.GetBeardList(this.selectedModName);
        }

        /* TOP */
        private void DrawTop()
        {
          Text.Font = GameFont.Small;
          Widgets.Label(new Rect(this.x + 5, this.y + 3, this.w, 24f), CEditor.API.Pawn.GetPawnName(false));
          this.y += 2;
          if (CEditor.IsRandom)
          {
            Widgets.DrawBoxSolid(new Rect((float)this.x, (float)(this.y - 2), (float)(this.x + this.w - 10), 26f), new Color(0.2f, 0.2f, 0.2f));
            Rect rect = new Rect((float)(this.x + this.w - 238), (float)(this.y + 25), 24f, 24f);
            SZWidgets.ButtonImageCol(rect, "bconfig", delegate ()
            {
              CEditor.API.ConfigEditor();
            }, Color.white, "");
            Rect rect2 = new Rect((float)(this.x + this.w - 23), (float)(this.y + 25), 24f, 24f);
            SZWidgets.ButtonImageCol(rect2, "bplus2", new Action(this.AAddPawn), Color.white, Label.TIP_ADD_PAWN);
            Rect rect3 = new Rect((float)(this.x + this.w - 23), (float)(this.y + 52), 24f, 24f);
            SZWidgets.ButtonImageCol(rect3, "bminus2", new Action(this.ARemovePawn), Color.white, Label.TIP_DELETE_PAWN);
            Rect rect4 = new Rect((float)(this.x + this.w - 49), (float)this.y, 22f, 22f);
            SZWidgets.ButtonImageCol(rect4, "brandom", new Action(this.ARandomizePawn), Color.white, (this.iTickTool <= 0) ? Label.TIP_RANDOMIZE_PAWN : "");
            Rect rect5 = new Rect((float)(this.x + this.w - 76), (float)this.y, 22f, 22f);
            SZWidgets.ButtonImageCol(rect5, "breplace", new Action(this.ARandomizePawnKeepRace), Color.white, (this.iTickTool <= 0) ? Label.TIP_RANDOMIZE_PAWNKEEPRACE : "");
            Rect rect6 = new Rect((float)(this.x + this.w - 103), (float)this.y, 22f, 22f);
            SZWidgets.ButtonImageCol(rect6, "bgender", new Action(this.ARandomizeBodyParts), Color.white, (this.iTickTool <= 0) ? Label.TIP_RANDOMIZE_BODYPARTS : "");
            Rect rect7 = new Rect((float)(this.x + this.w - 130), (float)this.y, 22f, 22f);
            SZWidgets.ButtonImageCol(rect7, "barmory", new Action(this.ARandomizeEquip), Color.white, (this.iTickTool <= 0) ? Label.TIP_RANDOMIZE_EQUIP : "");
            Rect rect8 = new Rect((float)(this.x + this.w - 157), (float)this.y, 22f, 22f);
            SZWidgets.ButtonImageCol(rect8, "bskills", new Action(this.ARandomizeBio), Color.white, (this.iTickTool <= 0) ? Label.TIP_RANDOMIZE_BIO : "");
            Rect rect9 = new Rect((float)(this.x + this.w - 184), (float)this.y, 22f, 22f);
            SZWidgets.ButtonImageCol(rect9, "bresurrect", new Action(this.AQuickResurrect), Color.white, (this.iTickTool <= 0) ? Label.TIP_QUICKHEAL : "");
            Rect rect10 = new Rect((float)(this.x + this.w - 211), (float)this.y, 22f, 22f);
            SZWidgets.ButtonImage(rect10, "bclone", new Action(this.AClonePawn), CEditor.InStartingScreen ? Label.TIP_CLONE.SubstringTo("\n", true) : Label.TIP_CLONE);
            Rect rect11 = new Rect((float)(this.x + this.w - 238), (float)this.y, 22f, 22f);
            SZWidgets.ButtonImage(rect11, "UI/Buttons/DevRoot/OpenInspector", new Action(this.AFindPawn), "");
            if (this.iTickTool > 0)
            {
              this.iTickTool--;
            }
          }
          SZWidgets.ButtonImage((float)(this.x + this.w - 24), (float)this.y, 24f, 24f, CEditor.IsRandom ? "bractive" : "brinactive", new Action(this.AToggleR), Label.SHOWCREATION, CEditor.IsRandom);
          if (CEditor.InStartingScreen)
          {
            SZWidgets.ButtonImage((float)this.x, (float)(this.y + 50), 24f, 24f, "bmoveup", new Action(this.AMoveUp), "");
            SZWidgets.ButtonImage((float)this.x, (float)(this.y + 75), 24f, 24f, "bmovedown", new Action(this.AMoveDown), "");
          }
        }

        // - TOP
        private void AAddPawn()
        {
          Faction value = this.DicFactions.GetValue(CEditor.ListName);
          List<PawnKindDef> lpkd = PawnKindTool.ListOfPawnKindDef(this.DicFactions.GetValue(CEditor.ListName), CEditor.ListName, this.selectedModName);
          PawnxTool.AddOrCreateNewPawn(CEditor.PKD.ThisOrFromList(lpkd), value, CEditor.RACE, null, default(IntVec3));
        }

        // - TOP
        private void ARemovePawn()
        {
          CEditor.API.Pawn.Delete(false);
        }

        // - TOP
        private void ABeginTeleportSelectPawn()
        {
          CEditor.API.EditorMoveRight();
          bool control = Event.current.control;
          if (control)
          {
            PlacingTool.BeginTeleportCustomPawn();
          }
          else
          {
            PlacingTool.BeginTeleportPawn(CEditor.API.Pawn);
          }
        }

        // - TOP
        private void AClonePawn()
        {
          PresetPawn ppn = CEditor.API.Pawn.ClonePawn();
          PawnxTool.AddOrCreateExistingPawn(ppn);
        }

        // - TOP
        private void AMoveDown()
        {
          int num = CEditor.API.ListOf<Pawn>(EType.Pawns).IndexOf(CEditor.API.Pawn);
          int num2 = CEditor.API.ListOf<Pawn>(EType.Pawns).Count - 1;
          num = ((num < num2) ? (num + 1) : num2);
          CEditor.API.ListOf<Pawn>(EType.Pawns).Remove(CEditor.API.Pawn);
          CEditor.API.ListOf<Pawn>(EType.Pawns).Insert(num, CEditor.API.Pawn);
          PawnxTool.Notify_CheckStartPawnsListChanged();
        }

        // - TOP
        private void AMoveUp()
        {
          int num = CEditor.API.ListOf<Pawn>(EType.Pawns).IndexOf(CEditor.API.Pawn);
          num = ((num > 0) ? (num - 1) : 0);
          CEditor.API.ListOf<Pawn>(EType.Pawns).Remove(CEditor.API.Pawn);
          CEditor.API.ListOf<Pawn>(EType.Pawns).Insert(num, CEditor.API.Pawn);
          PawnxTool.Notify_CheckStartPawnsListChanged();
        }

        // - TOP
        private void AQuickResurrect()
        {
          bool alt = Event.current.alt;
          if (alt)
          {
            HealthUtility.HealNonPermanentInjuriesAndRestoreLegs(CEditor.API.Pawn);
          }
          bool shift = Event.current.shift;
          if (shift)
          {
            CEditor.API.Pawn.Medicate();
          }
          bool control = Event.current.control;
          if (control)
          {
            CEditor.API.Pawn.Anaesthetize();
          }
          bool capsLock = Event.current.capsLock;
          if (capsLock)
          {
            CEditor.API.Pawn.DamageUntilDeath();
          }
          bool flag = !Event.current.alt && !Event.current.shift && !Event.current.control && !Event.current.capsLock;
          if (flag)
          {
            CEditor.API.Pawn.ResurrectAndHeal();
          }
          CEditor.API.UpdateGraphics();
        }

        // - TOP
        private void ARandomizeBio()
        {
          this.iTickTool = 100;
          CEditor.API.Pawn.Name = PawnBioAndNameGenerator.GeneratePawnName(CEditor.API.Pawn, NameStyle.Full, null);
          CEditor.API.Pawn.SetBackstory(true, true, true, false);
          CEditor.API.Pawn.SetBackstory(true, true, false, false);
          CEditor.API.Pawn.SetBioAge(CEditor.zufallswert.Next(CEditor.API.Pawn.RaceProps.Animal ? 14 : 70));
          CEditor.API.Pawn.SetChrAge(CEditor.zufallswert.Next(2000));
          bool flag = CEditor.API.Pawn.skills != null;
          if (flag)
          {
            foreach (SkillRecord skillRecord in CEditor.API.Pawn.skills.skills)
            {
              bool flag2 = !skillRecord.TotallyDisabled;
              if (flag2)
              {
                int maxValue = CEditor.zufallswert.Next(0, 21);
                skillRecord.Level = CEditor.zufallswert.Next(0, maxValue);
                skillRecord.passion = (Passion)CEditor.zufallswert.Next(0, 3);
              }
            }
          }
          bool flag3 = CEditor.API.Pawn.story != null;
          if (flag3)
          {
            CEditor.API.Pawn.story.traits.allTraits.Clear();
            //int num = CEditor.zufallswert.Next(0, 11);
            int num = CEditor.zufallswert.Next(2, 4);
            for (int i = 0; i < num; i++)
            {
              CEditor.API.Pawn.AddTrait(null, null, true, true, null);
            }
          }
        }

        // - TOP
        private void ARandomizeBodyParts()
        {
          this.iTickTool = 100;
          bool alt = Event.current.alt;
          if (alt)
          {
            CEditor.API.Pawn.gender = Gender.Female;
          }
          else
          {
            bool capsLock = Event.current.capsLock;
            if (capsLock)
            {
              CEditor.API.Pawn.gender = Gender.Male;
            }
            else
            {
              CEditor.API.Pawn.gender = ((CEditor.zufallswert.Next(100) > 50) ? Gender.Male : Gender.Female);
            }
          }
          CEditor.API.Pawn.SetBody(true, true);
          bool flag = CEditor.API.Pawn.story != null;
          if (flag)
          {
            bool flag2 = Event.current.alt || Event.current.capsLock;
            if (flag2)
            {
              PawnxTool.ForceGenderizedBodyTypeDef(CEditor.API.Pawn.gender);
            }
            bool flag3 = !CEditor.API.Pawn.story.bodyType.IsFromMod("Alien Vs Predator");
            if (flag3)
            {
              CEditor.API.Pawn.SetHair(true, true, null);
              this.ARandomHairColor();
            }
          }
          bool flag4 = CEditor.API.Pawn.HasStyleTracker();
          if (flag4)
          {
            int num = CEditor.zufallswert.Next(100);
            bool flag5 = num > 50 || CEditor.API.Pawn.gender == Gender.Female;
            if (flag5)
            {
              CEditor.API.Pawn.SetBeard(BeardDefOf.NoBeard);
            }
            else
            {
              CEditor.API.Pawn.SetBeard(true, true);
            }
            CEditor.API.Pawn.SetFaceTattoo(true, true);
            CEditor.API.Pawn.SetBodyTattoo(true, true);
          }
          CEditor.API.UpdateGraphics();
        }

        // - TOP
        private void ARandomizePawn()
        {
          this.iTickTool = 100;
          Faction value = this.DicFactions.GetValue(CEditor.ListName);
          IntVec3 position = CEditor.API.Pawn.Position;
          CEditor.API.Pawn.Delete(false);
          PawnxTool.AddOrCreateNewPawn(CEditor.PKD.ThisOrFromList(this.GetPawnKindDefs()), value, CEditor.RACE, null, position);
        }

        // - TOP
        private List<PawnKindDef> GetPawnKindDefs()
        {
          return PawnKindTool.ListOfPawnKindDef(this.DicFactions.GetValue(CEditor.ListName), CEditor.ListName, this.selectedModName);
        }

        // - TOP
        private void ARandomizePawnKeepRace()
        {
          this.iTickTool = 100;
          Faction value = this.DicFactions.GetValue(CEditor.ListName);
          bool alt = Event.current.alt;
          if (alt)
          {
            PawnxTool.ReplacePawnWithPawnOfSameRace(Gender.Female, value);
          }
          else
          {
            bool capsLock = Event.current.capsLock;
            if (capsLock)
            {
              PawnxTool.ReplacePawnWithPawnOfSameRace(Gender.Male, value);
            }
            else
            {
              PawnxTool.ReplacePawnWithPawnOfSameRace(Gender.None, value);
            }
          }
        }

        // - TOP
        private void AToggleR()
        {
          CEditor.IsRandom = !CEditor.IsRandom;
        }

        /* IMAGE */
        private void DrawImage()
        {
          SZWidgets.ButtonImage((float)this.x, (float)(this.y + 200), 22f, 22f, "bbackward", new Action(this.AChoosePrevPawn), "");
          SZWidgets.ButtonImage((float)(this.x + this.w - 22), (float)(this.y + 200), 22f, 22f, "bforward", new Action(this.AChooseNextPawn), "");
          SZWidgets.ButtonInvisible(new Rect((float)(this.x + 30), 60f, (float)(this.w - 60), 85f), new Action(this.AChangeHairUI), "");
          SZWidgets.ButtonInvisibleVar<Apparel>(new Rect((float)(this.x + 30), 145f, (float)(this.w - 60), 100f), new Action<Apparel>(this.AChangeApparelUI), null, "");
          GUI.color = Color.white;
          CEditor.API.Get<Capturer>(EType.Capturer).DrawPawnImage(CEditor.API.Pawn, this.x + 21, this.y + 20);
        }

        // - IMAGE 
        private void AChooseNextPawn()
        {
          int index = CEditor.API.ListOf<Pawn>(EType.Pawns).IndexOf(CEditor.API.Pawn);
          index = CEditor.API.ListOf<Pawn>(EType.Pawns).NextOrPrevIndex(index, true, false);
          CEditor.API.Pawn = CEditor.API.ListOf<Pawn>(EType.Pawns)[index];
        }

        // - IMAGE
        private void AChoosePrevPawn()
        {
          int index = CEditor.API.ListOf<Pawn>(EType.Pawns).IndexOf(CEditor.API.Pawn);
          index = CEditor.API.ListOf<Pawn>(EType.Pawns).NextOrPrevIndex(index, false, false);
          CEditor.API.Pawn = CEditor.API.ListOf<Pawn>(EType.Pawns)[index];
        }

        /* MAIN ICONS */
        private void DrawMainIcons()
        {
          SZWidgets.ButtonImage((float)(this.x + 2), 260f, 24f, 24f, "UI/Buttons/Dev/Reload", new Action(this.ALoadPawn), Label.TIP_LOAD_PAWN_FROM_SLOT);
          SZWidgets.ButtonImage((float)(this.x + 28), 260f, 24f, 24f, "bsave", new Action(this.ASavePawn), Label.TIP_SAVE_PAWN_TO_SLOT);
          SZWidgets.ButtonImage((float)(this.x + 56), 260f, 24f, 24f, "UI/Buttons/DragHash", new Action(this.AJumpToPawn), "");
          bool flag = !CEditor.InStartingScreen;
          if (flag)
          {
            SZWidgets.ButtonImage((float)(this.x + 84), 260f, 24f, 24f, "bteleport", new Action(this.ABeginTeleportSelectPawn), Label.TIP_TELEPORT);
          }
          bool flag2 = !this.lHeadAddons.NullOrEmpty<int>();
          if (flag2)
          {
            SZWidgets.ButtonImage((float)(this.x + 109), 260f, 26f, 26f, "bheadaddon", new Action(this.AChangeHeadAddons), "");
          }
          Pawn pawn = CEditor.API.Pawn;
          if (pawn == null)
          {
            return;
          }

          bool buttonBool = false;
          Gender newGender = Gender.None;
          switch (pawn.gender)
          {
            case Gender.Male:
              buttonBool = Widgets.ButtonImage(new Rect((float)(this.x + 132), 259f, 28f, 28f), ContentFinder<Texture2D>.Get("bmale", true), true);
              newGender = Gender.Female;
              break;
            case Gender.Female:
              buttonBool = Widgets.ButtonImage(new Rect((float)(this.x + 132), 259f, 28f, 28f), ContentFinder<Texture2D>.Get("bfemale", true), true);
              newGender = Gender.Male;
              break;
            default:
              buttonBool = Widgets.ButtonImage(new Rect((float)(this.x + 132), 259f, 28f, 28f), ContentFinder<Texture2D>.Get("bnone", true), true);
              newGender = Rand.Chance(0.5f) ? Gender.Male : Gender.Female;
              break;

          }
          if (buttonBool)
          {
            RaceProperties raceProps = pawn.RaceProps;
            bool? raceHasGendersNullCheck = raceProps != null ? new bool?(raceProps.hasGenders) : null;
            pawn.SetPawnGender(raceHasGendersNullCheck == false ? Gender.None : newGender);
          }

          SZWidgets.ButtonImageCol((float)(this.x + 160), 262f, 24f, 24f, "bnoclothes", new Action<Color>(this.AToggleNude), this.bShowClothes ? Color.white : Color.gray, "Toggle clothes");
          SZWidgets.ButtonImageCol((float)(this.x + 184), 260f, 24f, 24f, "bnohats", new Action<Color>(this.AToggleHats), this.bShowHat ? Color.white : Color.gray, "Toggle hat");
          SZWidgets.ButtonImageCol((float)(this.x + 210), 262f, 24f, 24f, "brotate", new Action<Color>(this.ARotate), Color.white, "Rotate");
          if (CEditor.IsPsychologyActive)
          {
            SZWidgets.ButtonImage((float)(this.x + 210), 232f, 24f, 24f, "bpsychology", new Action(this.AStartPsychologyUI), "Psychology tab");
          }
          if (CEditor.IsFacialStuffActive)
          {
            SZWidgets.ButtonImage((float)(this.x + 2), 232f, 24f, 24f, "bfacial", new Action(this.AStartFacialEditorUI), "Facial Stuff");
          }
        }

        // - MAIN ICONS
        private void AFindPawn()
        {
          WindowTool.Open(new DialogFindPawn());
        }

        // - MAIN ICONS
        private void AJumpToPawn()
        {
          CEditor.API.Get<CEditor.EditorUI>(EType.EditorUI).windowRect.position = new Vector2((float)(UI.screenWidth / 2 + 200), (float)(UI.screenHeight / 2) - CEditor.API.Get<CEditor.EditorUI>(EType.EditorUI).InitialSize.y / 2f);
          CameraJumper.TryJumpAndSelect(CEditor.API.Pawn);
        }

        // - MAIN ICONS
        private void ALoadPawn()
        {
          List<FloatMenuOption> list = new List<FloatMenuOption>();
          int numSlots = CEditor.API.NumSlots;
          for (int i = 0; i < numSlots; i++)
          {
            int currentSlot = i;
            FloatMenuOption item = new FloatMenuOption(this.SlotLabel(currentSlot, false), delegate ()
            {
              //int currentSlot = currentSlot;
              PresetPawn presetPawn = new PresetPawn();
              presetPawn.LoadPawn(currentSlot, true, "");
            }, MenuOptionPriority.Default, null, null, 0f, null, null, true, 0);
            list.Add(item);
          }
          WindowTool.Open(new FloatMenu(list));
        }

        // - MAIN ICONS
        private void ASavePawn()
        {
          List<FloatMenuOption> list = new List<FloatMenuOption>();
          int numSlots = CEditor.API.NumSlots;
          for (int i = 0; i < numSlots; i++)
          {
            int currentSlot = i;
            list.Add(new FloatMenuOption(this.SlotLabel(currentSlot, true), delegate ()
            {
              //int currentSlot = currentSlot;
              bool control = Event.current.control;
              if (control)
              {
                CEditor.API.SetSlot(currentSlot, "", true);
              }
              else
              {
                PresetPawn presetPawn = new PresetPawn();
                presetPawn.SavePawn(CEditor.API.Pawn, currentSlot);
              }
            }, MenuOptionPriority.Default, null, null, 0f, null, null, true, 0));
          }
          WindowTool.Open(new FloatMenu(list));
        }

        // - MAIN ICONS
        private void ARotate(Color col)
        {
          CEditor.API.Get<Capturer>(EType.Capturer).RotateAndCapture(CEditor.API.Pawn);
        }

        // - MAIN ICONS
        private void AStartFacialEditorUI()
        {
          WindowTool.Open(new DialogFacialStuff());
        }

        // - MAIN ICONS
        private void AStartPsychologyUI()
        {
          WindowTool.Open(new DialogPsychology());
        }

        // - MAIN ICONS
        private void AToggleHats(Color col)
        {
          Capturer capturer = CEditor.API.Get<Capturer>(EType.Capturer);
          bool bHats = capturer.bHats;
          if (bHats)
          {
            List<ApparelLayerDef> list = ApparelTool.ListOfApparelLayerDefs(false);
            list = (from td in list
                    where !td.defName.NullOrEmpty() && td.defName.ToLower().Contains("head")
                    select td).ToList<ApparelLayerDef>();
            foreach (ApparelLayerDef layerOnly in list)
            {
              CEditor.API.Pawn.MoveDressToInv(layerOnly);
            }
          }
          else
          {
            List<ApparelLayerDef> list2 = ApparelTool.ListOfApparelLayerDefs(false);
            list2 = (from td in list2
                     where !td.defName.NullOrEmpty() && td.defName.ToLower().Contains("head")
                     select td).ToList<ApparelLayerDef>();
            foreach (ApparelLayerDef layerOnly2 in list2)
            {
              CEditor.API.Pawn.MoveDressFromInv(layerOnly2);
            }
          }
          capturer.ToggleHatAndCapture(CEditor.API.Pawn);
          this.bShowHat = capturer.bHats;
        }

        // - MAIN ICONS
        private void AToggleNude(Color col)
        {
          Capturer capturer = CEditor.API.Get<Capturer>(EType.Capturer);
          bool bNude = capturer.bNude;
          if (bNude)
          {
            CEditor.API.Pawn.MoveDressToInv(null);
          }
          else
          {
            CEditor.API.Pawn.MoveDressFromInv(null);
          }
          capturer.ToggleNudeAndCapture(CEditor.API.Pawn);
          this.bShowClothes = capturer.bNude;
        }

        // - MAIN ICONS
        private string SlotLabel(int slot, bool isSave)
        {
          string text = (isSave ? Label.SAVESLOT : Label.LOADSLOT) + slot.ToString() + " ";
          string slot2 = CEditor.API.GetSlot(slot);
          bool flag = slot2.Contains("*");
          if (flag)
          {
            text += slot2.SubstringTo("*", true);
          }
          else
          {
            text += slot2.SubstringTo(",", true);
          }
          return text;
        }

        /* HAIR */
        private void DrawHair()
        {
          if (CEditor.API.Pawn.HasStoryTracker())
          {
            // ToDo: add randomize hair option here
            //SZWidgets.NavSelectorImageBox(this.RectFullSolid, new Action(this.AChangeHairUI), new Action(ARandomHairAll), null, null, null, new Action(this.AOnHairOpen), Label.HAIR, "Open window to select color", null, null, null, default(Color), toggle: this.bIsHairOpen, isSectionHeader: true);

            SZWidgets.NavSelectorImageBoxSectionHeader(this.RectFullSolid, new Action(this.AOnHairOpen), new Action(ARandomHairAll), new Action(this.AOnHairOpen), Label.HAIR, tipRandom: "Randomize all aspects of hair", toggle: this.bIsHairOpen);
            this.y += 30;
            if (this.bIsHairOpen)
            {
              this.DrawHairDefSelector();
              this.DrawBeardSelector();
              this.DrawHairColorGeneSelector();
              this.DrawHairColorOverrideSelector();
              this.DrawGradientSelector();
            }
          }
        }

        // - HAIR
        private void AOnHairOpen()
        {
          this.bIsHairOpen = !this.bIsHairOpen;
        }

        // - HAIR
        private void ARandomHairAll()
        {
          this.ARandomHairDef();
          this.ARandomBeard();
          this.ARandomHairColor();
          this.ARandomHairColorGene();
          this.ARandomGradient();
          CEditor.API.UpdateGraphics();
        }

        // - HAIR
        private void AChangeHairUI()
        {
          WindowTool.Open(new DialogColorPicker(ColorType.HairColor, this.isPrimaryColor, null, null));
        }

        /* HAIR DEF */
        private void DrawHairDefSelector()
        {
          SZWidgets.NavSelectorImageBox(this.RectFullSolid, new Action(this.AChooseHairDefCustom), new Action(this.ARandomHairDef), new Action(this.ASetPrevHairDef), new Action(this.ASetNextHairDef), null, new Action(this.AConfigHair), Label.FRISUR + ": " + CEditor.API.Pawn.GetHairName(), null, Label.TIP_RANDOM_HAIR, null, null, default(Color), this.isHairConfigOpen);
          this.y += 30;
          if (this.isHairConfigOpen)
          {
            SZWidgets.FloatMenuOnButtonText<string>(new Rect(this.x + 16, this.y, this.w - 32, 25f), this.selectedModName ?? Label.ALL, CEditor.API.Get<List<string>>(EType.ModsHairDef), (string s) => s ?? Label.ALL, new Action<string>(this.ASelectedModName), "");
            //SZWidgets.ListView<HairDef>(new Rect((float)(this.x + 16), (float)(this.y + 25), (float)(this.w - 32), 360f), this.lOfHairDefs, (HairDef hd) => hd.LabelCap, (HairDef hd) => hd.description, (HairDef hairA, HairDef hairB) => hairA == hairB, ref CEditor.API.Pawn.story.hairDef, ref this.scrollPos, false, new Action<HairDef>(this.AHairSelected), true, false, false, false);
            SZWidgets.ListView<HairDef>(this.x + 16, this.y + 25, this.w - 32, 360f, this.lOfHairDefs, (HairDef hd) => hd.LabelCap, (HairDef hd) => hd.description, (HairDef hairA, HairDef hairB) => hairA == hairB, ref CEditor.API.Pawn.story.hairDef, ref this.scrollPos, false, new Action<HairDef>(this.AHairSelected), true, false, false, false);
            this.y += 387;
          }
        }

        // - HAIR DEF
        private void AChooseHairDefCustom()
        {
          SZWidgets.FloatMenuOnRect<HairDef>(DefTool.ListByMod<HairDef>(null), (HairDef s) => s.LabelCap, new Action<HairDef>(this.ASetHairDefCustom));
        }

        // - HAIR DEF
        private void ARandomHairDef()
        {
          if (this.isHairConfigOpen)
          {
            string text = this.selectedModName;
          }
          CEditor.API.Pawn.SetHair(true, true, this.selectedModName);

        }

        // - HAIR DEF
        private void AConfigHair()
        {
          this.isHairConfigOpen = !this.isHairConfigOpen;
        }

        // - HAIR DEF
        private void AHairSelected(HairDef h)
        {
          CEditor.API.Pawn.SetHair(h);
          CEditor.API.UpdateGraphics();
        }

        // - HAIR DEF
        private void ASetHairDefCustom(HairDef hairDef)
        {
          CEditor.API.Pawn.SetHair(hairDef);
          CEditor.API.UpdateGraphics();
        }

        // - HAIR DEF
        private void ASetNextHairDef()
        {
          WindowTool.TryRemove<DialogColorPicker>();
          CEditor.API.Pawn.SetHair(true, false, null);
          CEditor.API.UpdateGraphics();
        }

        // - HAIR DEF
        private void ASetPrevHairDef()
        {
          WindowTool.TryRemove<DialogColorPicker>();
          CEditor.API.Pawn.SetHair(false, false, null);
          CEditor.API.UpdateGraphics();
        }

        /* HAIR BEARD */
        private void DrawBeardSelector()
        {
          bool flag = !CEditor.API.Pawn.HasStyleTracker();
          if (!flag)
          {
            SZWidgets.NavSelectorImageBox(this.RectFullSolid, new Action(this.AChooseBeardCustom), new Action(this.ARandomBeard), new Action(this.ASetPrevBeard), new Action(this.ASetNextBeard), null, new Action(this.AConfigBeard), Label.BEARD + CEditor.API.Pawn.GetBeardName(), null, Label.TIP_RANDOM_BEARD, null, null, default(Color), this.isBeardConfigOpen);
            this.y += 30;
            bool flag2 = this.isBeardConfigOpen;
            if (flag2)
            {
              SZWidgets.FloatMenuOnButtonText<string>(new Rect((float)(this.x + 16), (float)this.y, (float)(this.w - 32), 25f), this.selectedModName ?? Label.ALL, CEditor.API.ListOf<string>(EType.ModsBeardDef), (string s) => s ?? Label.ALL, new Action<string>(this.ASelectedModName), "");
              SZWidgets.ListView<BeardDef>(this.x + 16, this.y + 25, this.w - 32, 330f, this.lOfBeardDefs, (BeardDef hd) => hd.LabelCap, (BeardDef hd) => hd.description, (BeardDef beardA, BeardDef beardB) => beardA == beardB, ref CEditor.API.Pawn.style.beardDef, ref this.scrollPos, false, new Action<BeardDef>(this.ABeardSelected), true, false, false, false);
              this.y += 357;
            }
          }
        }

        // - HAIR BEARD
        private void ABeardSelected(BeardDef b)
        {
          CEditor.API.Pawn.SetBeard(b);
          CEditor.API.UpdateGraphics();
        }

        // - HAIR BEARD
        private void AChooseBeardCustom()
        {
          SZWidgets.FloatMenuOnRect<BeardDef>(StyleTool.GetBeardList(null), (BeardDef s) => s.LabelCap, new Action<BeardDef>(this.ASetBeardCustom));
        }

        // - HAIR BEARD
        private void AConfigBeard()
        {
          this.isBeardConfigOpen = !this.isBeardConfigOpen;
        }

        // - HAIR BEARD
        private void ARandomBeard()
        {
          CEditor.API.Pawn.SetBeard(true, true);
          CEditor.API.UpdateGraphics();
        }

        // - HAIR BEARD
        private void ASetBeardCustom(BeardDef beardDef)
        {
          CEditor.API.Pawn.SetBeard(beardDef);
          CEditor.API.UpdateGraphics();
        }

        // - HAIR BEARD
        private void ASetNextBeard()
        {
          CEditor.API.Pawn.SetBeard(true, false);
          CEditor.API.UpdateGraphics();
        }

        // - HAIR BEARD
        private void ASetPrevBeard()
        {
          CEditor.API.Pawn.SetBeard(false, false);
          CEditor.API.UpdateGraphics();
        }





        // - HAIR COLOR: GENE
        private void DrawHairColorGeneSelector()
        {
          if (!CEditor.API.Pawn.HasGeneTracker())
          {
            return;
          }
          // ToDo: turn tips into Label and translations
          SZWidgets.NavSelectorImageBox(this.RectFullSolid, new Action(this.AChooseHairColorGeneCustom), new Action(this.ARandomHairColorGene), new Action(this.ASetPrevHairColorGene), new Action(this.ASetNextHairColorGene), null, null, Label.GENE + ": " + CEditor.API.Pawn.GetHairColorGeneDefLabel(), tipLabel: "Hair color genes determine the natural hair color of characters and their offspring. The actual hair color can be changed by hair dye.", tipRandom: "Randomize hair color gene.", null, null, default(Color));
          this.y += 30;
        }

        // - HAIR COLOR: GENE
        private void AChooseHairColorGeneCustom()
        {
          SZWidgets.FloatMenuOnRect<GeneDef>(CEditor.API.Pawn.GetHairColorGeneDefList(), (GeneDef hairGene) => CEditor.API.Pawn.GetHairColorGeneDefLabel(hairGene), new Action<GeneDef>(this.ASetHairColorGeneCustom));
        }

        // - HAIR COLOR: GENE
        private void ARandomHairColorGene()
        {
          CEditor.API.Pawn.SetHairColorGene(true, true);
          CEditor.API.UpdateGraphics();
        }

        // - HAIR COLOR: GENE
        private void ASetHairColorGeneCustom(GeneDef hairGene)
        {
          CEditor.API.Pawn.SetHairColorGeneDef(hairGene, false);
          CEditor.API.UpdateGraphics();
        }

        // - HAIR COLOR: GENE
        private void ASetPrevHairColorGene()
        {
          CEditor.API.Pawn.SetHairColorGene(false, false);
          CEditor.API.UpdateGraphics();
        }

        // - HAIR COLOR: GENE
        private void ASetNextHairColorGene()
        {
          CEditor.API.Pawn.SetHairColorGene(true, false);
          CEditor.API.UpdateGraphics();
        }

        // - HAIR COLOR: DYE
        private void DrawHairDyeSelector()
        {
          SZWidgets.ColorBox(new Rect(this.x + 25, this.y, this.w - 50, 95f), CEditor.API.Pawn.GetHairColor(this.isPrimaryColor), new Action<Color>(this.AOnHairColorChanged), false);
          this.y += 95;
        }


        /* HAIR DYE */
        private void DrawHairColorOverrideSelector()
        {
          //SZWidgets.NavSelectorImageBox(this.RectFullSolid, new Action(this.AChangeHairUI), new Action(this.ARandomHairColor), new Action(this.AToggleColor), new Action(this.AToggleColor), null, new Action(this.AConfigHaircolor), Label.HAIRCOLOR + (this.isPrimaryColor ? Label.COLORA : Label.COLORB), null, Label.TIP_RANDOM_HAIRCOLOR, null, null, default(Color), this.isHaircolorConfigOpen);
          SZWidgets.NavSelectorImageBox(this.RectFullSolid, new Action(this.AChangeHairUI), new Action(this.ARandomHairColor), null, null, null, new Action(this.AConfigHaircolor), "Hair dye", null, Label.TIP_RANDOM_HAIRCOLOR, null, null, default(Color), this.isHaircolorConfigOpen);
          this.y += 30;
          if (this.isHaircolorConfigOpen)
          {
            this.DrawHairDyeSelector();
          }
        }

        // - HAIR DYE
        private void AConfigHaircolor()
        {
          this.isHaircolorConfigOpen = !this.isHaircolorConfigOpen;
        }

        // - HAIR DYE
        private void AOnHairColorChanged(Color col)
        {
          CEditor.API.Pawn.SetHairColor(this.isPrimaryColor, col);
          CEditor.API.UpdateGraphics();
        }

        // - HAIR DYE
        private void ARandomHairColor()
        {
          bool flag = !Event.current.alt && !Event.current.shift;
          bool flag2 = flag || Event.current.shift;
          if (flag2)
          {
            CEditor.API.Pawn.SetHairColor(false, Event.current.control ? ColorTool.RandomAlphaColor : ColorTool.RandomColor);
          }
          bool flag3 = flag || Event.current.alt;
          if (flag3)
          {
            CEditor.API.Pawn.SetHairColor(true, Event.current.control ? ColorTool.RandomAlphaColor : ColorTool.RandomColor);
          }
          CEditor.API.UpdateGraphics();
        }

        // - HAIR DYE
        private void AToggleColor()
        {
          this.isPrimaryColor = !this.isPrimaryColor;
        }

        /* HAIR GRADIENT */
        private void DrawGradientSelector()
        {
          bool isGradientHairActive = CEditor.IsGradientHairActive;
          if (isGradientHairActive)
          {
            SZWidgets.NavSelectorImageBox(this.RectFullSolid, new Action(this.AChooseGradientCustom), new Action(this.ARandomGradient), new Action(this.ASetPrevGradient), new Action(this.ASetNextGradient), null, null, CEditor.API.Pawn.GetGradientMask(), null, null, null, null, default(Color));
            this.y += 30;
          }
        }

        private void AChooseGradientCustom()
        {
          SZWidgets.FloatMenuOnRect<string>(HairTool.GetAllGradientHairs(), (string s) => s, new Action<string>(this.ASetHairCustom));
        }

        private void ARandomGradient()
        {
          CEditor.API.Pawn.RandomizeGradientMask();
        }

        private void ASetHairCustom(string val)
        {
          CEditor.API.Pawn.SetGradientMask(val);
        }

        private void ASetNextGradient()
        {
          List<string> allGradientHairs = HairTool.GetAllGradientHairs();
          int index = allGradientHairs.IndexOf(CEditor.API.Pawn.GetGradientMask());
          index = allGradientHairs.NextOrPrevIndex(index, true, false);
          CEditor.API.Pawn.SetGradientMask(allGradientHairs[index]);
        }

        private void ASetPrevGradient()
        {
          List<string> allGradientHairs = HairTool.GetAllGradientHairs();
          int index = allGradientHairs.IndexOf(CEditor.API.Pawn.GetGradientMask());
          index = allGradientHairs.NextOrPrevIndex(index, false, false);
          CEditor.API.Pawn.SetGradientMask(allGradientHairs[index]);
        }

        /* DRAW HEAD */
        private void DrawHead()
        {
          if (CEditor.API.Pawn.HasStoryTracker())
          {
            //SZWidgets.NavSelectorImageBox(this.RectFullSolid, new Action(this.AOnHeadOpen), null, null, null, null, new Action(this.AOnHeadOpen), BodyPartDefOf.Head.label.CapitalizeFirst(), null, null, null, null, default(Color), this.bIsHeadOpen);
            SZWidgets.NavSelectorImageBoxSectionHeader(this.RectFullSolid, new Action(this.AOnHeadOpen), null, new Action(this.AOnHeadOpen), BodyPartDefOf.Head.label.CapitalizeFirst(), toggle: this.bIsHeadOpen);

            this.y += 30;
            if (this.bIsHeadOpen)
            {
              this.DrawFaceTattooSelector();
              this.deftest = CEditor.API.Pawn.FA_GetCurrentDef(FacialTool.FACE);
              bool flag3 = this.deftest == null;
              if (flag3)
              {
                SZWidgets.NavSelectorImageBox(this.RectFullSolid, new Action(this.AChooseHeadCustom), new Action(this.ARandomHead), new Action(this.ASetPrevHead), new Action(this.ASetNextHead), null, null, BodyPartDefOf.Head.label.CapitalizeFirst() + ": " + CEditor.API.Pawn.GetHeadName(null), null, Label.TIP_RANDOM_HEAD, null, null, default(Color));
                //SZWidgets.NavSelectorImageBox(this.RectFullSolid, new Action(this.AChooseHeadCustom), new Action(this.ARandomHead), new Action(this.ASetPrevHead), new Action(this.ASetNextHead), null, null, BodyPartDefOf.Head.label.CapitalizeFirst() + ": " + CEditor.API.Pawn.story?.headType?.label?.ToStringSafe(), null, Label.TIP_RANDOM_HEAD, null, null, default(Color));
                this.y += 30;
              }
              else
              {
                SZWidgets.NavSelectorImageBox(this.RectFullSolid, new Action(this.AFACustomHead), new Action(this.AFARandomHead), new Action(this.AFASetPrevHead), new Action(this.AFASetNextHead), null, null, BodyPartDefOf.Head.label.CapitalizeFirst() + ": " + CEditor.API.Pawn.FA_GetCurrentDefName(FacialTool.FACE), null, Label.TIP_RANDOM_HEAD, null, null, default(Color));
                this.y += 30;
                SZWidgets.NavSelectorImageBox(this.RectFullSolid, new Action(this.AFACustomEye), new Action(this.AFARandomEye), new Action(this.AFASetPrevEye), new Action(this.AFASetNextEye), null, null, Label.HB_Eye + ": " + CEditor.API.Pawn.FA_GetCurrentDefName(FacialTool.EYE), null, null, null, null, default(Color));
                this.y += 30;
                this.DrawEyeColorSelection();
                SZWidgets.NavSelectorImageBox(this.RectFullSolid, new Action(this.AFACustomLid), new Action(this.AFARandomLid), new Action(this.AFASetPrevLid), new Action(this.AFASetNextLid), null, null, Label.LID + ": " + CEditor.API.Pawn.FA_GetCurrentDefName(FacialTool.LID), null, null, null, null, default(Color));
                this.y += 30;
                SZWidgets.NavSelectorImageBox(this.RectFullSolid, new Action(this.AFACustomBrow), new Action(this.AFARandomBrow), new Action(this.AFASetPrevBrow), new Action(this.AFASetNextBrow), null, null, Label.BROW + ": " + CEditor.API.Pawn.FA_GetCurrentDefName(FacialTool.BROW), null, null, null, null, default(Color));
                this.y += 30;
                SZWidgets.NavSelectorImageBox(this.RectFullSolid, new Action(this.AFACustomMouth), new Action(this.AFARandomMouth), new Action(this.AFASetPrevMouth), new Action(this.AFASetNextMouth), null, null, Label.MOUTH + ": " + CEditor.API.Pawn.FA_GetCurrentDefName(FacialTool.MOUTH), null, null, null, null, default(Color));
                this.y += 30;
                SZWidgets.NavSelectorImageBox(this.RectFullSolid, new Action(this.AFACustomSkin), new Action(this.AFARandomSkin), new Action(this.AFASetPrevSkin), new Action(this.AFASetNextSkin), null, null, Label.SKIN + CEditor.API.Pawn.FA_GetCurrentDefName(FacialTool.SKIN), null, null, null, null, default(Color));
                this.y += 30;
              }
            }
          }
        }

        private void AChangeHeadAddons()
        {
          WindowTool.Open(new DialogChangeHeadAddons());
        }

        private void AOnHeadOpen()
        {
          this.bIsHeadOpen = !this.bIsHeadOpen;
        }

        private void AFACustomSkin()
        {
          SZWidgets.FloatMenuOnRect<string>(CEditor.API.Pawn.FA_GetDefStringList(FacialTool.SKIN), (string s) => s, new Action<string>(this.AFASetCustomSkin));
        }

        private void AFARandomSkin()
        {
          CEditor.API.Pawn.FA_SetDef(FacialTool.SKIN, true, true);
          CEditor.API.UpdateGraphics();
        }

        private void AFASetCustomSkin(string val)
        {
          CEditor.API.Pawn.FA_SetDefByName(FacialTool.SKIN, val);
          CEditor.API.UpdateGraphics();
        }

        private void AFASetNextSkin()
        {
          CEditor.API.Pawn.FA_SetDef(FacialTool.SKIN, true, false);
          CEditor.API.UpdateGraphics();
        }

        private void AFASetPrevSkin()
        {
          CEditor.API.Pawn.FA_SetDef(FacialTool.SKIN, false, false);
          CEditor.API.UpdateGraphics();
        }

        private void AFACustomMouth()
        {
          SZWidgets.FloatMenuOnRect<string>(CEditor.API.Pawn.FA_GetDefStringList(FacialTool.MOUTH), (string s) => s, new Action<string>(this.AFASetCustomMouth));
        }

        private void AFARandomMouth()
        {
          CEditor.API.Pawn.FA_SetDef(FacialTool.MOUTH, true, true);
          CEditor.API.UpdateGraphics();
        }

        private void AFASetCustomMouth(string val)
        {
          CEditor.API.Pawn.FA_SetDefByName(FacialTool.MOUTH, val);
          CEditor.API.UpdateGraphics();
        }

        private void AFASetNextMouth()
        {
          CEditor.API.Pawn.FA_SetDef(FacialTool.MOUTH, true, false);
          CEditor.API.UpdateGraphics();
        }

        private void AFASetPrevMouth()
        {
          CEditor.API.Pawn.FA_SetDef(FacialTool.MOUTH, false, false);
          CEditor.API.UpdateGraphics();
        }

        private void AFACustomBrow()
        {
          SZWidgets.FloatMenuOnRect<string>(CEditor.API.Pawn.FA_GetDefStringList(FacialTool.BROW), (string s) => s, new Action<string>(this.AFASetCustomBrow));
        }

        private void AFARandomBrow()
        {
          CEditor.API.Pawn.FA_SetDef(FacialTool.BROW, true, true);
          CEditor.API.UpdateGraphics();
        }

        private void AFASetCustomBrow(string val)
        {
          CEditor.API.Pawn.FA_SetDefByName(FacialTool.BROW, val);
          CEditor.API.UpdateGraphics();
        }

        private void AFASetNextBrow()
        {
          CEditor.API.Pawn.FA_SetDef(FacialTool.BROW, true, false);
          CEditor.API.UpdateGraphics();
        }

        private void AFASetPrevBrow()
        {
          CEditor.API.Pawn.FA_SetDef(FacialTool.BROW, false, false);
          CEditor.API.UpdateGraphics();
        }

        private void AFACustomLid()
        {
          SZWidgets.FloatMenuOnRect<string>(CEditor.API.Pawn.FA_GetDefStringList(FacialTool.LID), (string s) => s, new Action<string>(this.AFASetCustomLid));
        }

        private void AFARandomLid()
        {
          CEditor.API.Pawn.FA_SetDef(FacialTool.LID, true, true);
          CEditor.API.UpdateGraphics();
        }

        private void AFASetCustomLid(string val)
        {
          CEditor.API.Pawn.FA_SetDefByName(FacialTool.LID, val);
          CEditor.API.UpdateGraphics();
        }

        private void AFASetNextLid()
        {
          CEditor.API.Pawn.FA_SetDef(FacialTool.LID, true, false);
          CEditor.API.UpdateGraphics();
        }

        private void AFASetPrevLid()
        {
          CEditor.API.Pawn.FA_SetDef(FacialTool.LID, false, false);
          CEditor.API.UpdateGraphics();
        }

        private void AFACustomEye()
        {
          SZWidgets.FloatMenuOnRect<string>(CEditor.API.Pawn.FA_GetDefStringList(FacialTool.EYE), (string s) => s, new Action<string>(this.AFASetCustomEye));
        }

        private void AFARandomEye()
        {
          CEditor.API.Pawn.FA_SetDef(FacialTool.EYE, true, true);
          CEditor.API.UpdateGraphics();
        }

        private void AFASetCustomEye(string val)
        {
          CEditor.API.Pawn.FA_SetDefByName(FacialTool.EYE, val);
          CEditor.API.UpdateGraphics();
        }

        private void AFASetNextEye()
        {
          CEditor.API.Pawn.FA_SetDef(FacialTool.EYE, true, false);
          CEditor.API.UpdateGraphics();
        }

        private void AFASetPrevEye()
        {
          CEditor.API.Pawn.FA_SetDef(FacialTool.EYE, false, false);
          CEditor.API.UpdateGraphics();
        }

        private void AFACustomHead()
        {
          SZWidgets.FloatMenuOnRect<string>(CEditor.API.Pawn.FA_GetDefStringList(FacialTool.FACE), (string s) => s, new Action<string>(this.AFASetCustomFace));
        }

        private void AFARandomHead()
        {
          CEditor.API.Pawn.FA_SetDef(FacialTool.FACE, true, true);
          CEditor.API.UpdateGraphics();
        }

        private void AFASetCustomFace(string val)
        {
          CEditor.API.Pawn.FA_SetDefByName(FacialTool.FACE, val);
          CEditor.API.UpdateGraphics();
        }

        private void AFASetNextHead()
        {
          CEditor.API.Pawn.FA_SetDef(FacialTool.FACE, true, false);
          CEditor.API.UpdateGraphics();
        }

        private void AFASetPrevHead()
        {
          CEditor.API.Pawn.FA_SetDef(FacialTool.FACE, false, false);
          CEditor.API.UpdateGraphics();
        }

        private void AChooseHeadCustom()
        {
          //SZWidgets.FloatMenuOnRect<string>(CEditor.API.Pawn.GetHeadList(), (string s) => CEditor.API.Pawn.GetHeadName(s), new Action<string>(this.ASetHeadCustom));
          SZWidgets.FloatMenuOnRect(CEditor.API.Pawn.GetSortedHeadList(), (HeadTypeDef h) => CEditor.API.Pawn.GetHeadName(h), new Action<HeadTypeDef>(this.ASetHeadCustom));
        }

        private void ARandomHead()
        {
          CEditor.API.Pawn.SetHead(true, true);
          CEditor.API.UpdateGraphics();
        }

        private void ASetHeadCustom(HeadTypeDef headTypeDef)
        {
          //CEditor.API.Pawn.SetHeadPath(val, true);
          //CEditor.API.Pawn.SetCrown();
          CEditor.API.Pawn.SetHeadTypeDef(headTypeDef);
          CEditor.API.UpdateGraphics();
        }

        private void ASetNextHead()
        {
          CEditor.API.Pawn.SetHead(true, false);
          CEditor.API.UpdateGraphics();
        }

        private void ASetPrevHead()
        {
          CEditor.API.Pawn.SetHead(false, false);
          CEditor.API.UpdateGraphics();
        }

        private void DrawEyeColorSelection()
        {
          SZWidgets.NavSelectorImageBox(this.RectFullSolid, new Action(this.AChangeEyeUI), new Action(this.ARandomEyeColor), null, null, null, new Action(this.AConfigEyeColor), Label.EYECOLOR, null, null, null, null, default(Color));
          this.y += 30;
          bool flag = this.isEyeConfigOpen;
          if (flag)
          {
            SZWidgets.ColorBox(new Rect((float)(this.x + 25), (float)this.y, (float)(this.w - 50), 95f), CEditor.API.Pawn.GetEyeColor(), new Action<Color>(this.AOnEyeColorChanged), false);
            this.y += 95;
          }
        }

        private void AChangeEyeUI()
        {
          WindowTool.Open(new DialogColorPicker(ColorType.EyeColor, true, null, null));
        }

        private void AConfigEyeColor()
        {
          this.isEyeConfigOpen = !this.isEyeConfigOpen;
        }

        private void AOnEyeColorChanged(Color col)
        {
          CEditor.API.Pawn.SetEyeColor(col);
          CEditor.API.UpdateGraphics();
        }

        private void ARandomEyeColor()
        {
          CEditor.API.Pawn.SetEyeColor(ColorTool.RandomColor);
          CEditor.API.UpdateGraphics();
        }

        private void DrawFaceTattooSelector()
        {
          bool flag = !CEditor.API.Pawn.HasStyleTracker();
          if (!flag)
          {
            SZWidgets.NavSelectorImageBox(this.RectFullSolid, new Action(this.AChooseFaceTattooCustom), new Action(this.ARandomFaceTattoo), new Action(this.ASetPrevFaceTattoo), new Action(this.ASetNextFaceTattoo), null, null, Label.TATTOO + CEditor.API.Pawn.GetFaceTattooName(), null, Label.TIP_RANDOM_FACETATTOO, null, null, default(Color));
            this.y += 30;
          }
        }

        private void AChooseFaceTattooCustom()
        {
          SZWidgets.FloatMenuOnRect<TattooDef>(StyleTool.GetFaceTattooList(null), (TattooDef s) => s.LabelCap, new Action<TattooDef>(this.ASetFaceTattooCustom));
        }

        private void AConfigFaceTattoo()
        {
          this.isFaceTattooConfigOpen = !this.isFaceTattooConfigOpen;
        }

        private void AFaceTattooSelected(TattooDef tattooDef)
        {
          CEditor.API.Pawn.SetFaceTattoo(tattooDef);
          CEditor.API.UpdateGraphics();
        }

        private void ARandomFaceTattoo()
        {
          CEditor.API.Pawn.SetFaceTattoo(true, true);
          CEditor.API.UpdateGraphics();
        }

        private void ASetFaceTattooCustom(TattooDef tattooDef)
        {
          CEditor.API.Pawn.SetFaceTattoo(tattooDef);
          CEditor.API.UpdateGraphics();
        }

        private void ASetNextFaceTattoo()
        {
          CEditor.API.Pawn.SetFaceTattoo(true, false);
          CEditor.API.UpdateGraphics();
        }

        private void ASetPrevFaceTattoo()
        {
          CEditor.API.Pawn.SetFaceTattoo(false, false);
          CEditor.API.UpdateGraphics();
        }

        /* BODY */
        private void DrawBody()
        {
          if (CEditor.API.Pawn.HasStoryTracker())
          {
            //SZWidgets.NavSelectorImageBox(this.RectFullSolid, new Action(this.AOnBodyOpen), null, null, null, null, new Action(this.AOnBodyOpen), BodyPartDefOf.Body.label.CapitalizeFirst(), null, null, null, null, default(Color), this.bIsBodyOpen);
            SZWidgets.NavSelectorImageBoxSectionHeader(this.RectFullSolid, new Action(this.AOnBodyOpen), null, new Action(this.AOnBodyOpen), BodyPartDefOf.Body.label.CapitalizeFirst(), toggle: this.bIsBodyOpen);
            this.y += 30;
            if (this.bIsBodyOpen)
            {
              this.DrawBodySelector();
              this.DrawSkinColorGeneSelector();
              this.DrawSkinColorOverrideSelector();
              this.DrawBodyTattooSelector();
              // ToDo: add fur option here
            }
          }
        }

        // - BODY
        private void AOnBodyOpen()
        {
          this.bIsBodyOpen = !this.bIsBodyOpen;
        }

        // BODY TYPE DEF
        private void DrawBodySelector()
        {
          SZWidgets.NavSelectorImageBox(this.RectFullSolid, new Action(this.AChooseBodyCustom), new Action(this.ARandomBody), new Action(this.ASetPrevBody), new Action(this.ASetNextBody), null, null, Label.FORM + ": " + CEditor.API.Pawn.GetBodyTypeDefLabel(), null, Label.TIP_RANDOM_BODY, null, null, default(Color));
          this.y += 30;
        }

        // - BODY TYPE DEF
        private void AChooseBodyCustom()
        {
          SZWidgets.FloatMenuOnRect<BodyTypeDef>(CEditor.API.Pawn.GetBodyList(), (BodyTypeDef b) => CEditor.API.Pawn.GetBodyTypeDefLabel(b), new Action<BodyTypeDef>(this.ASetBodyCustom));
        }

        // - BODY TYPE DEF
        private void ARandomBody()
        {
          CEditor.API.Pawn.SetBody(true, true);
          CEditor.API.UpdateGraphics();
        }

        // - BODY TYPE DEF
        private void ASetBodyCustom(BodyTypeDef b)
        {
          CEditor.API.Pawn.SetBody(b);
          CEditor.API.UpdateGraphics();
        }

        // - BODY TYPE DEF
        private void ASetNextBody()
        {
          CEditor.API.Pawn.SetBody(true, false);
          CEditor.API.UpdateGraphics();
        }

        // - BODY TYPE DEF
        private void ASetPrevBody()
        {
          CEditor.API.Pawn.SetBody(false, false);
          CEditor.API.UpdateGraphics();
        }











        // SKIN COLOR GENE
        private void DrawSkinColorGeneSelector()
        {
          if (CEditor.API.Pawn.HasGeneTracker())
          {
            // ToDo: turn tips into Label and translations
            SZWidgets.NavSelectorImageBox(this.RectFullSolid, new Action(this.AChooseSkinColorGeneCustom), new Action(this.ARandomSkinColorGene), new Action(this.ASetPrevSkinColorGene), new Action(this.ASetNextSkinColorGene), null, null, Label.GENE + ": " + CEditor.API.Pawn.GetSkinColorGeneDefLabel(), tipLabel: "Skin color genes determine the natural skin color of characters and their offspring.", tipRandom: "Randomize skin color gene.", null, null, default(Color));
            this.y += 30;
          }
        }

        // - SKIN COLOR: GENE
        private void AChooseSkinColorGeneCustom()
        {
          SZWidgets.FloatMenuOnRect<GeneDef>(CEditor.API.Pawn.GetSkinColorGeneDefList(), (GeneDef hairGene) => CEditor.API.Pawn.GetSkinColorGeneDefLabel(hairGene), new Action<GeneDef>(this.ASetSkinColorGeneCustom));
        }

        // - SKIN COLOR: GENE
        private void ARandomSkinColorGene()
        {
          CEditor.API.Pawn.SetSkinColorGene(true, true);
          CEditor.API.UpdateGraphics();
        }

        // - SKIN COLOR: GENE
        private void ASetSkinColorGeneCustom(GeneDef skinColorGeneDef)
        {
          CEditor.API.Pawn.SetSkinColorGeneDef(skinColorGeneDef, false);
          CEditor.API.UpdateGraphics();
        }

        // - SKIN COLOR: GENE
        private void ASetPrevSkinColorGene()
        {
          CEditor.API.Pawn.SetSkinColorGene(false, false);
          CEditor.API.UpdateGraphics();
        }

        // - SKIN COLOR: GENE
        private void ASetNextSkinColorGene()
        {
          CEditor.API.Pawn.SetSkinColorGene(true, false);
          CEditor.API.UpdateGraphics();
        }

        // - SKIN COLOR: OVERRIDE
        private void DrawSkinColorOverrideSelector()
        {
          //SZWidgets.NavSelectorImageBox(this.RectFullSolid, new Action(this.AChangeSkinUI), new Action(this.ARandomSkinColor), new Action(this.AToggleSkinColor), new Action(this.AToggleSkinColor), null, new Action(this.AConfigSkincolor), Label.SKIN + (this.isPrimarySkinColor ? Label.COLORA : Label.COLORB), "Overide the skin color determined by genetics.", Label.TIP_RANDOM_SKINCOLOR, null, null, default(Color), this.isSkinConfigOpen);
          Action onClicked = this.isAlien ? new Action(AChangeSkinUI) : new Action(this.AConfigSkincolor);

          SZWidgets.NavSelectorImageBox(this.RectFullSolid, onClicked, new Action(this.ARandomSkinColor), null, null, null, new Action(this.AConfigSkincolor), "Skin color override", "Overide the skin color determined by genetics.", Label.TIP_RANDOM_SKINCOLOR, null, null, default(Color), this.isSkinConfigOpen);

          // ToDo: translate label and tooltip here
          this.y += 30;
          if (this.isSkinConfigOpen)
          {
            SZWidgets.ColorBox(new Rect(this.x + 25, this.y, this.w - 50, 95f), CEditor.API.Pawn.GetSkinColor(this.isPrimarySkinColor), new Action<Color>(this.AOnSkinColorChanged), false);
            this.y += 95;
            //if (this.isAlien)
            //{
            //  SZWidgets.ColorBox(new Rect((float)(this.x + 25), (float)this.y, (float)(this.w - 50), 95f), CEditor.API.Pawn.GetSkinColor(this.isPrimarySkinColor), new Action<Color>(this.AOnSkinColorChanged), false);
            //  this.y += 95;
            //}
            //else
            //{

            //  //SZWidgets.SingleSlinder(new Rect((float)(this.x + 25), (float)this.y, (float)(this.w - 50), 30f), CEditor.API.Pawn.story.melanin, 0f, 1f, new Action<float>(this.AOnMelaninChanged));
            //  this.y += 30;
            //}
          }
        }

        // - SKIN COLOR: OVERRIDE
        private void AChangeSkinUI()
        {
          WindowTool.Open(new DialogColorPicker(ColorType.SkinColor, this.isPrimaryColor, null, null));
        }

        // - SKIN COLOR: OVERRIDE
        private void AConfigSkincolor()
        {
          this.isSkinConfigOpen = !this.isSkinConfigOpen;
        }

        //// - SKIN COLOR: OVERRIDE
        //private void AOnMelaninChanged(float val)
        //{
        //  //CEditor.API.Pawn.story.melanin = val;
        //  CEditor.API.UpdateGraphics();
        //}

        // - SKIN COLOR: OVERRIDE
        private void AOnSkinColorChanged(Color col)
        {
          CEditor.API.Pawn.SetSkinColor(this.isPrimarySkinColor, col);
          CEditor.API.UpdateGraphics();
        }

        // - SKIN COLOR: OVERRIDE
        private void ARandomSkinColor()
        {
          if (Event.current.alt || Event.current.control)
          {
            CEditor.API.Pawn.SetSkinColor(true, ColorTool.RandomAlphaColor);
          }
          else
          {
            CEditor.API.Pawn.SetSkinColor(true, ColorTool.RandomColor);
          }
          CEditor.API.UpdateGraphics();

          //bool flag = !Event.current.alt && !Event.current.shift;
          //bool flag2 = flag || Event.current.alt;
          //if (flag2)
          //{
          //  bool flag3 = CEditor.API.Pawn.story != null;
          //  if (flag3)
          //  {
          //    CEditor.API.Pawn.story.melanin = (float)CEditor.zufallswert.NextDouble();
          //  }
          //  bool flag4 = this.isAlien;
          //  if (flag4)
          //  {
          //    bool control = Event.current.control;
          //    if (control)
          //    {
          //      CEditor.API.Pawn.SetSkinColor(true, ColorTool.RandomAlphaColor);
          //    }
          //    else
          //    {
          //      CEditor.API.Pawn.SetSkinColor(true, ColorTool.RandomColor);
          //    }
          //  }
          //}
          //bool flag5 = flag || Event.current.shift;
          //if (flag5)
          //{
          //  if (this.isAlien)
          //  {
          //    if (Event.current.control)
          //    {
          //      CEditor.API.Pawn.SetSkinColor(false, ColorTool.RandomAlphaColor);
          //    }
          //    else
          //    {
          //      CEditor.API.Pawn.SetSkinColor(false, ColorTool.RandomColor);
          //    }
          //  }
          //}
          //CEditor.API.UpdateGraphics();
        }

        //private void AToggleSkinColor()
        //{
        //  this.isPrimarySkinColor = !this.isPrimarySkinColor;
        //}

        // BODY TATTOO 
        private void DrawBodyTattooSelector()
        {
          bool flag = !CEditor.API.Pawn.HasStyleTracker();
          if (!flag)
          {
            SZWidgets.NavSelectorImageBox(this.RectFullSolid, new Action(this.AChooseBodyTattooCustom), new Action(this.ARandomBodyTattoo), new Action(this.ASetPrevBodyTattoo), new Action(this.ASetNextBodyTattoo), null, null, Label.TATTOO + CEditor.API.Pawn.GetBodyTattooName(), null, Label.TIP_RANDOM_BODYTATTOO, null, null, default(Color));
            this.y += 30;
          }
        }

        private void ABodyTattooSelected(TattooDef tattooDef)
        {
          CEditor.API.Pawn.SetBodyTattoo(tattooDef);
          CEditor.API.UpdateGraphics();
        }

        private void AChooseBodyTattooCustom()
        {
          SZWidgets.FloatMenuOnRect<TattooDef>(StyleTool.GetBodyTattooList(null), (TattooDef s) => s.LabelCap, new Action<TattooDef>(this.ASetBodyTattooCustom));
        }

        private void AConfigBodyTattoo()
        {
          this.isBodyTattooConfigOpen = !this.isBodyTattooConfigOpen;
        }

        private void ARandomBodyTattoo()
        {
          CEditor.API.Pawn.SetBodyTattoo(true, true);
          CEditor.API.UpdateGraphics();
        }

        private void ASetBodyTattooCustom(TattooDef tattooDef)
        {
          CEditor.API.Pawn.SetBodyTattoo(tattooDef);
          CEditor.API.UpdateGraphics();
        }

        private void ASetNextBodyTattoo()
        {
          CEditor.API.Pawn.SetBodyTattoo(true, false);
          CEditor.API.UpdateGraphics();
        }

        private void ASetPrevBodyTattoo()
        {
          CEditor.API.Pawn.SetBodyTattoo(false, false);
          CEditor.API.UpdateGraphics();
        }


        /* DRAW EQUIPMENT */
        private void DrawEquipment()
        {
          //SZWidgets.NavSelectorImageBox(this.RectFullSolid, new Action(this.AOnEquipmentOpen), new Action(this.ARandomizeEquip), null, null, null, new Action(this.AOnEquipmentOpen), "Equipment", null, null, null, null, default(Color), this.bIsEquipmentOpen);
          SZWidgets.NavSelectorImageBoxSectionHeader(this.RectFullSolid, new Action(this.AOnEquipmentOpen), new Action(this.ARandomizeEquip), new Action(this.AOnEquipmentOpen), "Equipment", tipRandom: "Randomize weapons and apparel.", toggle: this.bIsEquipmentOpen);
          this.y += 30;
          if (this.bIsEquipmentOpen)
          {
            this.DrawWeaponSelector();
            this.DrawApparelSelector();
          }
        }

        private void AOnEquipmentOpen()
        {
          this.bIsEquipmentOpen = !this.bIsEquipmentOpen;
        }

        private void ARandomizeEquip()
        {
          this.iTickTool = 100;
          bool flag = !Event.current.alt && !Event.current.shift;
          bool flag2 = Event.current.alt || flag;
          if (flag2)
          {
            CEditor.API.Pawn.Redress(null, false, -1, false);
          }
          bool flag3 = Event.current.shift || flag;
          if (flag3)
          {
            CEditor.API.Pawn.Reequip(null, -1, false);
          }
          bool control = Event.current.control;
          if (control)
          {
            Pawn_ApparelTracker apparel = CEditor.API.Pawn.apparel;
            bool flag4 = apparel != null && apparel.WornApparelCount > 0;
            if (flag4)
            {
              foreach (Apparel apparel2 in CEditor.API.Pawn.apparel.WornApparel)
              {
                apparel2.DrawColor = ColorTool.RandomAlphaColor;
              }
            }
          }
          CEditor.API.UpdateGraphics();
        }

        private void DrawApparelSelector()
        {
          bool flag = !CEditor.API.Pawn.HasApparelTracker() || CEditor.API.Pawn.apparel.WornApparel.NullOrEmpty<Apparel>();
          if (!flag)
          {
            try
            {
              List<Apparel> list = (from ap in CEditor.API.Pawn.apparel.WornApparel
                                    orderby this.GetDrawOrder(ap) descending
                                    select ap).ToList<Apparel>();
              for (int i = 0; i < list.Count; i++)
              {
                Apparel apparel = list[i];
                SZWidgets.NavSelectorImageBox2<Apparel>(this.RectFullSolid, apparel, new Action<Apparel>(this.AChangeApparelUI), new Action<Apparel>(this.ARandomApparel), new Action<Apparel>(this.ASetPrevApparel), new Action<Apparel>(this.ASetNextApparel), new Action<Apparel>(this.AOnTextureApparel), new Action<Apparel>(this.AConfigApparelcolor), apparel.def.label.CapitalizeFirst(), apparel.GetTooltip().text, Label.TIP_RANDOM_APPAREL, null, null, default(Color));
                this.y += 30;
                bool flag2 = this.isApparelConfigOpen && this.apparelCurrent == apparel;
                if (flag2)
                {
                  bool flag3 = apparel.TryGetComp<CompColorable>() != null;
                  if (flag3)
                  {
                    SZWidgets.ColorBox(new Rect((float)(this.x + 25), (float)this.y, (float)(this.w - 50), 95f), apparel.DrawColor, new Action<Color>(this.AOnApparelColorChanged), true);
                    this.y += 95;
                  }
                }
              }
            }
            catch
            {
            }
          }
        }

        /* DRAW DEAD LOGO */
        private void DrawDeadLogo()
        {
          bool o = CEditor.API.GetO(OptionB.SHOWDEADLOGO);
          if (o)
          {
            bool flag = CEditor.API.Pawn != null && CEditor.API.Pawn.Dead && this.iTickRemoveDeadLogo == 0;
            if (flag)
            {
              GUI.color = this.randomDeadColor;
              SZWidgets.ButtonImage(new Rect((float)(this.x + 45), 60f, 150f, 150f), "bdead", new Action(this.ARemoveDeadLogo), "");
            }
            else
            {
              bool flag2 = this.iTickRemoveDeadLogo > 0;
              if (flag2)
              {
                this.iTickRemoveDeadLogo--;
              }
            }
          }
        }




























        private void AChangeApparelUI(Apparel a)
        {
          WindowTool.Open(new DialogColorPicker(ColorType.ApparelColor, true, a, null));
        }

        private void AConfigApparelcolor(Apparel a)
        {
          if (this.apparelCurrent == a)
          {
            this.isApparelConfigOpen = !this.isApparelConfigOpen;
          }
          else
          {
            this.apparelCurrent = a;
            this.isApparelConfigOpen = true;
          }
        }

        // Token: 0x060009F8 RID: 2552 RVA: 0x00056A4F File Offset: 0x00054C4F
        private void AOnApparelColorChanged(Color col)
        {
          this.apparelCurrent.DrawColor = col;
          CEditor.API.UpdateGraphics();
        }

        // Token: 0x060009F9 RID: 2553 RVA: 0x00056A6A File Offset: 0x00054C6A
        private void AOnTextureApparel(Apparel a)
        {
          WindowTool.Open(new DialogArmory(a));
        }

        // Token: 0x060009FA RID: 2554 RVA: 0x00056A79 File Offset: 0x00054C79
        private void ARandomApparel(Apparel a)
        {
          this.NextOrRandomApparel(a, true, true, false);
        }

        // Token: 0x060009FB RID: 2555 RVA: 0x00056A87 File Offset: 0x00054C87
        private void ASetNextApparel(Apparel a)
        {
          this.NextOrRandomApparel(a, true, false, false);
        }

        // Token: 0x060009FC RID: 2556 RVA: 0x00056A95 File Offset: 0x00054C95
        private void ASetPrevApparel(Apparel a)
        {
          this.NextOrRandomApparel(a, false, false, false);
        }

        // Token: 0x060009FD RID: 2557 RVA: 0x00056AA4 File Offset: 0x00054CA4
        private ApparelLayerDef GetBestLayer(List<ApparelLayerDef> l)
        {
          return l.NullOrEmpty<ApparelLayerDef>() ? null : (l.Contains(ApparelLayerDefOf.Shell) ? ApparelLayerDefOf.Shell : (l.Contains(ApparelLayerDefOf.Middle) ? ApparelLayerDefOf.Middle : l.LastOrDefault<ApparelLayerDef>()));
        }

        // Token: 0x060009FE RID: 2558 RVA: 0x00056AF0 File Offset: 0x00054CF0
        private int GetDrawOrder(Apparel ap)
        {
          ApparelLayerDef bestLayer = this.GetBestLayer(ap.def.apparel.layers);
          return (bestLayer == null) ? 0 : bestLayer.drawOrder;
        }

        // Token: 0x060009FF RID: 2559 RVA: 0x00056B28 File Offset: 0x00054D28
        private ApparelLayerDef GetFreeLayer(List<ApparelLayerDef> lUsedLayer, Apparel a)
        {
          ApparelLayerDef apparelLayerDef = this.GetBestLayer(a.def.apparel.layers);
          bool flag = lUsedLayer.Contains(apparelLayerDef);
          if (flag)
          {
            foreach (ApparelLayerDef apparelLayerDef2 in a.def.apparel.layers)
            {
              bool flag2 = !lUsedLayer.Contains(apparelLayerDef2);
              if (flag2)
              {
                apparelLayerDef = apparelLayerDef2;
              }
            }
          }
          return apparelLayerDef;
        }

        // Token: 0x06000A00 RID: 2560 RVA: 0x00056BC0 File Offset: 0x00054DC0
        private List<ApparelLayerDef> GetUsedLayers(Apparel a)
        {
          List<ApparelLayerDef> list = new List<ApparelLayerDef>();
          foreach (Apparel apparel in CEditor.API.Pawn.apparel.WornApparel)
          {
            bool flag = apparel != a;
            if (flag)
            {
              ApparelLayerDef bestLayer = this.GetBestLayer(apparel.def.apparel.layers);
              bool flag2 = !list.Contains(bestLayer);
              if (flag2)
              {
                list.Add(bestLayer);
              }
            }
          }
          return list;
        }

        // Token: 0x06000A01 RID: 2561 RVA: 0x00056C6C File Offset: 0x00054E6C
        private void NextOrRandomApparel(Apparel a, bool next, bool random, bool doSkip = false)
        {
          List<ApparelLayerDef> usedLayers = this.GetUsedLayers(a);
          ApparelLayerDef freeLayer = this.GetFreeLayer(usedLayers, a);
          bool flag = a.IsForNeck();
          bool flag2 = a.IsForLegs();
          bool flag3 = a.IsForEyes();
          bool flag4 = false;
          bool flag5 = usedLayers.Contains(ApparelLayerDefOf.Middle) && flag2;
          if (flag5)
          {
            flag4 = true;
          }
          bool flag6 = usedLayers.Contains(ApparelLayerDefOf.Overhead);
          if (flag6)
          {
            flag4 = true;
          }
          BodyPartGroupDef bodyPartGroupDef = flag2 ? BodyPartGroupDefOf.Legs : (flag ? DefTool.BodyPartGroupDef("Neck") : (flag3 ? DefTool.BodyPartGroupDef("Eyes") : a.def.apparel.bodyPartGroups.FirstOrDefault<BodyPartGroupDef>()));
          List<ThingDef> hashSet = ApparelTool.ListOfApparel(freeLayer, null, flag4 ? bodyPartGroupDef : null);
          int num = 0;
          foreach (ThingDef thingDef in hashSet)
          {
            bool flag7 = thingDef.defName == a.def.defName;
            if (flag7)
            {
              break;
            }
            num++;
          }
          num = hashSet.NextOrPrevIndex(num, next, random);
          CEditor.API.Pawn.apparel.Remove(a);
          int count = hashSet.Count;
          for (int i = 0; i < count; i++)
          {
            bool flag8 = !CEditor.API.Pawn.apparel.CanWearWithoutDroppingAnything(hashSet.At(num)) || !CEditor.API.Pawn.ApparalGraphicTest2(hashSet.At(num), false);
            if (!flag8)
            {
              break;
            }
            num = hashSet.NextOrPrevIndex(num, next, random);
          }
          ThingDef thingDef2 = hashSet.At(num);
          bool devMode = Prefs.DevMode;
          if (devMode)
          {
            MessageTool.Show(string.Concat(new string[]
            {
              "wear... ",
              thingDef2.defName,
              " ",
              (num + 1).ToString(),
              "/",
              hashSet.Count.ToString()
            }), null);
          }
          this.WearSelectedApparel(Selected.ByThingDef(thingDef2), a.DrawColor);
        }

        // Token: 0x06000A02 RID: 2562 RVA: 0x00056EA8 File Offset: 0x000550A8
        private void WearSelectedApparel(Selected s, Color oldColor)
        {
          Apparel apparel = ApparelTool.GenerateApparel(s);
          bool alt = Event.current.alt;
          if (alt)
          {
            apparel.DrawColor = oldColor;
          }
          else
          {
            bool shift = Event.current.shift;
            if (shift)
            {
              apparel.DrawColor = ColorTool.RandomColor;
            }
            else
            {
              bool control = Event.current.control;
              if (control)
              {
                apparel.DrawColor = ColorTool.RandomAlphaColor;
              }
            }
          }
          CEditor.API.Pawn.WearThatApparel(apparel);
          CEditor.API.UpdateGraphics();
        }

        // Token: 0x06000A03 RID: 2563 RVA: 0x00056F28 File Offset: 0x00055128

        // Token: 0x06000A04 RID: 2564 RVA: 0x000570E0 File Offset: 0x000552E0
        private void AChangeWeaponUI(ThingWithComps wp)
        {
          WindowTool.Open(new DialogColorPicker(ColorType.WeaponColor, true, null, wp));
        }

        // Token: 0x06000A05 RID: 2565 RVA: 0x000570F2 File Offset: 0x000552F2
        private void AConfigWeaponcolor(ThingWithComps wp)
        {
          this.isWeaponConfigOpen = !this.isWeaponConfigOpen;
          this.weaponCurrent = wp;
        }

        // Token: 0x06000A06 RID: 2566 RVA: 0x0005710B File Offset: 0x0005530B
        private void AOnTextureWeapon(ThingWithComps wp)
        {
          WindowTool.Open(new DialogWeaponry(wp));
        }

        // Token: 0x06000A07 RID: 2567 RVA: 0x0005711A File Offset: 0x0005531A
        private void AOnWeaponColorChanged(Color col)
        {
          this.weaponCurrent.DrawColor = col;
          CEditor.API.UpdateGraphics();
        }

        // Token: 0x06000A08 RID: 2568 RVA: 0x00057135 File Offset: 0x00055335
        private void ARandomWeapon(ThingWithComps wp)
        {
          this.NextOrRandomWeapon(wp, true, true);
        }

        // Token: 0x06000A09 RID: 2569 RVA: 0x00057142 File Offset: 0x00055342
        private void ASetNextWeapon(ThingWithComps wp)
        {
          this.NextOrRandomWeapon(wp, true, false);
        }

        // Token: 0x06000A0A RID: 2570 RVA: 0x0005714F File Offset: 0x0005534F
        private void ASetPrevWeapon(ThingWithComps wp)
        {
          this.NextOrRandomWeapon(wp, false, false);
        }

        // Token: 0x06000A0B RID: 2571 RVA: 0x0005715C File Offset: 0x0005535C
        private void EquipSelectedWeapon(Selected selectedWeapon, bool primary)
        {
          CEditor.API.Pawn.Reequip(selectedWeapon, primary ? 0 : 1, false);
          CEditor.API.UpdateGraphics();
        }

        // Token: 0x06000A0C RID: 2572 RVA: 0x00057184 File Offset: 0x00055384
        private void NextOrRandomWeapon(ThingWithComps wp, bool next, bool random)
        {
          List<ThingDef> hashSet = WeaponTool.ListOfWeapons(null, null, WeaponType.Melee);
          List<ThingDef> other = WeaponTool.ListOfWeapons(null, null, WeaponType.Ranged);
          hashSet.AddRange(other);
          int num = 0;
          foreach (ThingDef thingDef in hashSet)
          {
            bool flag = thingDef.defName == wp.def.defName;
            if (flag)
            {
              break;
            }
            num++;
          }
          num = hashSet.NextOrPrevIndex(num, next, random);
          ThingDef thingDef2 = hashSet.At(num);
          bool devMode = Prefs.DevMode;
          if (devMode)
          {
            MessageTool.Show(string.Concat(new string[]
            {
              "equip... ",
              thingDef2.defName,
              " ",
              (num + 1).ToString(),
              "/",
              hashSet.Count.ToString()
            }), null);
          }
          this.EquipSelectedWeapon(Selected.ByThingDef(thingDef2), wp == CEditor.API.Pawn.equipment.Primary);
        }

        private void ARemoveDeadLogo()
        {
          this.randomDeadColor = ColorTool.RandomColor;
          this.iTickRemoveDeadLogo = 180;
        }

        //private void AEquipmentRandom()
        //{
        //  if (CEditor.API.Pawn.HasApparelTracker())
        //  {
        //    try
        //    {
        //      foreach (Apparel apparel in CEditor.API.Pawn.apparel.WornApparel)
        //      {
        //        this.ARandomApparel(apparel);
        //      }
        //    }
        //    catch
        //    {
        //    }
        //  }
        //  if (CEditor.API.Pawn.HasEquipmentTracker())
        //  {
        //    try
        //    {
        //      foreach (ThingWithComps thingWithComps in CEditor.API.Pawn.equipment.AllEquipmentListForReading)
        //      {
        //        this.ARandomWeapon(thingWithComps);
        //      }
        //    }
        //    catch
        //    {
        //    }
        //  }
        //}

        private void DrawWeaponSelector()
        {
          bool flag = !CEditor.API.Pawn.HasEquipmentTracker() || this.weaponCurrent == null;
          if (!flag)
          {
            try
            {
              List<ThingWithComps> allEquipmentListForReading = CEditor.API.Pawn.equipment.AllEquipmentListForReading;
              for (int i = 0; i < allEquipmentListForReading.Count; i++)
              {
                ThingWithComps thingWithComps = allEquipmentListForReading[i];
                SZWidgets.NavSelectorImageBox2<ThingWithComps>(this.RectFullSolid, thingWithComps, new Action<ThingWithComps>(this.AChangeWeaponUI), new Action<ThingWithComps>(this.ARandomWeapon), new Action<ThingWithComps>(this.ASetPrevWeapon), new Action<ThingWithComps>(this.ASetNextWeapon), new Action<ThingWithComps>(this.AOnTextureWeapon), new Action<ThingWithComps>(this.AConfigWeaponcolor), thingWithComps.def.label.CapitalizeFirst(), thingWithComps.GetTooltip().text, Label.TIP_RANDOMIZE_EQUIP, null, null, default(Color));
                this.y += 30;
                bool flag2 = this.isWeaponConfigOpen && this.weaponCurrent == thingWithComps;
                if (flag2)
                {
                  bool flag3 = thingWithComps.TryGetComp<CompColorable>() != null;
                  if (flag3)
                  {
                    SZWidgets.ColorBox(new Rect((float)(this.x + 25), (float)this.y, (float)(this.w - 50), 95f), thingWithComps.DrawColor, new Action<Color>(this.AOnWeaponColorChanged), true);
                    this.y += 95;
                  }
                  else
                  {
                    thingWithComps.def.AddCompColorable();
                    thingWithComps.InitializeComps();
                  }
                }
              }
            }
            catch
            {
            }
          }
        }




      }

      // Token: 0x020000E1 RID: 225
      private class BlockPawnList
      {
        // Token: 0x06000A0F RID: 2575 RVA: 0x000572CC File Offset: 0x000554CC
        internal BlockPawnList()
        {
          this.bShowRemovePawn = false;
          this.colParam = "n.a.";
          this.capturer = CEditor.API.Get<Capturer>(EType.Capturer);
          this.lraces = new List<ThingDef>();
          this.lraces.Add(null);
        }

        // Token: 0x170000A5 RID: 165
        // (get) Token: 0x06000A10 RID: 2576 RVA: 0x0005731D File Offset: 0x0005551D
        private List<PawnKindDef> ListOfPawnKinds
        {
          get
          {
            return CEditor.API.ListOf<PawnKindDef>(EType.PawnKindListed);
          }
        }

        // Token: 0x170000A6 RID: 166
        // (get) Token: 0x06000A11 RID: 2577 RVA: 0x0005732B File Offset: 0x0005552B
        private List<Pawn> ListOfPawns
        {
          get
          {
            return CEditor.API.ListOf<Pawn>(EType.Pawns);
          }
        }

        // Token: 0x170000A7 RID: 167
        // (get) Token: 0x06000A12 RID: 2578 RVA: 0x00057339 File Offset: 0x00055539
        private Dictionary<string, Faction> DicFactions
        {
          get
          {
            return CEditor.API.Get<Dictionary<string, Faction>>(EType.Factions);
          }
        }

        // Token: 0x170000A8 RID: 168
        // (get) Token: 0x06000A13 RID: 2579 RVA: 0x00057346 File Offset: 0x00055546
        private bool IsPlayerFaction
        {
          get
          {
            return CEditor.ListName == Label.COLONISTS;
          }
        }

        // Token: 0x06000A14 RID: 2580 RVA: 0x00057358 File Offset: 0x00055558
        internal void Draw(CEditor.EditorUI.coord c)
        {
          int x = c.x;
          int y = c.y;
          int w = c.w;
          int h = c.h;
          bool flag = w <= 0;
          if (!flag)
          {
            this.CheckPawnFromSelector();
            this.DrawListSelector(x, ref y, w);
            this.DrawOnMap(x, y, w);
            this.DrawListCount(x, y, w);
            this.DrawTopBottons(x, ref y, w);
            this.DrawList(x, y, w, h);
          }
        }

        // Token: 0x06000A15 RID: 2581 RVA: 0x000573D0 File Offset: 0x000555D0
        private void DrawListSelector(int x, ref int y, int w)
        {
          Text.Font = GameFont.Tiny;
          SZWidgets.FloatMenuOnButtonText<string>(new Rect((float)x, (float)y, (float)w, 25f), CEditor.ListName, this.DicFactions.Keys.ToList<string>(), (string s) => s, delegate (string listname)
          {
            this.ChangeList(listname);
          });
          y += 25;
          bool isRandom = CEditor.IsRandom;
          if (isRandom)
          {
            SZWidgets.FloatMenuOnButtonText<ThingDef>(new Rect((float)x, (float)y, (float)w, 25f), CEditor.RACENAME(CEditor.RACE), this.lraces, CEditor.RACENAME, new Action<ThingDef>(this.ARaceChanged), "");
            y += 25;
            SZWidgets.FloatMenuOnButtonText<PawnKindDef>(new Rect((float)x, (float)y, (float)w, 25f), CEditor.PKDNAME(CEditor.PKD), this.ListOfPawnKinds, CEditor.PKDNAME, new Action<PawnKindDef>(this.APKDChanged));
            y += 25;
          }
        }

        // Token: 0x06000A16 RID: 2582 RVA: 0x000574E0 File Offset: 0x000556E0
        private void DrawOnMap(int x, int y, int w)
        {
          bool flag = !CEditor.InStartingScreen;
          if (flag)
          {
            SZWidgets.ButtonImageCol(new Rect((float)(x + 2), (float)(y + 4), 16f, 16f), "bworld", new Action(this.AChangedOnMap), CEditor.OnMap ? Color.grey : Color.white, Label.ONMAP);
          }
        }

        // Token: 0x06000A17 RID: 2583 RVA: 0x00057540 File Offset: 0x00055740
        private void DrawListCount(int x, int y, int w)
        {
          Listing_X listing_X = new Listing_X();
          listing_X.Begin(new Rect((float)(CEditor.InStartingScreen ? x : (x + 24)), (float)(y + 2), 88f, (float)(CEditor.InStartingScreen ? 40 : 20)));
          bool flag = CEditor.InStartingScreen && this.IsPlayerFaction && !Find.GameInitData.startingAndOptionalPawns.NullOrEmpty<Pawn>();
          if (flag)
          {
            listing_X.AddIntSection("", "max" + Find.GameInitData.startingAndOptionalPawns.Count.ToString(), ref this.colParam, ref Find.GameInitData.startingPawnCount, 1, Find.GameInitData.startingAndOptionalPawns.Count, true, "");
          }
          else
          {
            bool flag2 = !this.ListOfPawns.NullOrEmpty<Pawn>();
            if (flag2)
            {
              listing_X.Label(0f, 0f, 80f, 20f, this.ListOfPawns.Count.ToString());
            }
          }
          listing_X.End();
        }

        // Token: 0x06000A18 RID: 2584 RVA: 0x00057650 File Offset: 0x00055850
        private void DrawTopBottons(int x, ref int y, int w)
        {
          bool flag = CEditor.IsRandom || this.ListOfPawns.NullOrEmpty<Pawn>();
          if (flag)
          {
            x += 25;
            SZWidgets.ButtonImage((float)(w - x), (float)y, 25f, 25f, "UI/Buttons/Dev/Add", new Action(this.AAddStartPawn), "");
            x += 25;
            SZWidgets.ButtonImage((float)(w - x), (float)y, 25f, 25f, "bminus", new Action(this.AAllowRemovePawn), CEditor.InStartingScreen ? Label.TIP_REMOVE_PAWN.SubstringTo("\n", true) : Label.TIP_REMOVE_PAWN);
            x += 25;
          }
          y += (CEditor.InStartingScreen ? 40 : 26);
        }

        // Token: 0x06000A19 RID: 2585 RVA: 0x00057714 File Offset: 0x00055914
        private void DrawList(int x, int y, int w, int h)
        {
          bool flag = this.ListOfPawns.NullOrEmpty<Pawn>();
          if (!flag)
          {
            Text.Font = GameFont.Small;
            float num = 112f;
            Rect outRect = new Rect(0f, (float)y, (float)w, (float)(h - y));
            Rect rect = new Rect(0f, (float)y, outRect.width - 16f, (float)this.ListOfPawns.Count * num);
            Widgets.BeginScrollView(outRect, ref this.scrollPos, rect, true);
            Rect rect2 = rect.ContractedBy(4f);
            rect2.height = rect.height;
            Listing_X listing_X = new Listing_X();
            listing_X.Begin(rect2);
            try
            {
              int num2 = 0;
              for (int i = 0; i < this.ListOfPawns.Count; i++)
              {
                bool flag2 = listing_X.CurY + num > this.scrollPos.y && listing_X.CurY - 700f < this.scrollPos.y;
                if (flag2)
                {
                  Pawn pawn = this.ListOfPawns[i];
                  Color backColor = (pawn.Faction == null) ? Color.white : pawn.Faction.Color;
                  bool flag3 = CEditor.InStartingScreen && this.IsPlayerFaction;
                  if (flag3)
                  {
                    num2++;
                    backColor = ((num2 > Find.GameInitData.startingPawnCount) ? Color.white : pawn.Faction.Color);
                  }
                  int num3 = listing_X.Selectable(pawn.LabelShort, false, "", this.capturer.GetRenderTexture(pawn, true), null, null, default(Vector2), this.bShowRemovePawn, 100f, backColor, ColorTool.colLightGray, false);
                  bool dead = pawn.Dead;
                  if (dead)
                  {
                    bool o = CEditor.API.GetO(OptionB.SHOWDEADLOGO);
                    if (o)
                    {
                      Rect position = new Rect(0f, listing_X.CurY - 100f, rect.width, 50f);
                      GUI.DrawTexture(position, ContentFinder<Texture2D>.Get("bdead", true));
                    }
                  }
                  bool flag4 = num3 == 1;
                  if (flag4)
                  {
                    CEditor.API.Pawn = pawn;
                  }
                  else
                  {
                    bool flag5 = num3 == 2;
                    if (flag5)
                    {
                      pawn.Delete(false);
                    }
                  }
                }
                listing_X.CurY += num;
              }
            }
            catch
            {
            }
            listing_X.End();
            Widgets.EndScrollView();
          }
        }

        // Token: 0x06000A1A RID: 2586 RVA: 0x000579AC File Offset: 0x00055BAC
        private void CheckPawnFromSelector()
        {
          bool flag = !CEditor.InStartingScreen;
          if (flag)
          {
            Selector selector = Find.Selector;
            Pawn pawn = (selector != null) ? selector.FirstPawnFromSelector() : null;
            bool flag2 = pawn != null && CEditor.API.Pawn != pawn;
            if (flag2)
            {
              CEditor.API.Pawn = pawn;
            }
          }
          bool flag3 = CEditor.API.Pawn == null;
          if (flag3)
          {
            CEditor.API.Pawn = this.ListOfPawns.FirstOrFallback(null);
          }
        }

        // Token: 0x06000A1B RID: 2587 RVA: 0x00057A28 File Offset: 0x00055C28
        private void AChangedOnMap()
        {
          SoundTool.PlayThis(SoundDefOf.Click);
          CEditor.OnMap = !CEditor.OnMap;
          this.ReloadList();
        }

        // Token: 0x06000A1C RID: 2588 RVA: 0x00057A4C File Offset: 0x00055C4C
        internal void ChangeList(string listname)
        {
          CEditor.ListName = (listname.NullOrEmpty() ? Label.COLONISTS : listname);
          this.DicFactions.Clear();
          this.DicFactions.Merge(FactionTool.GetDicOfFactions(true, true, true));
          this.ListOfPawns.Clear();
          List<Pawn> pawnList = PawnxTool.GetPawnList(listname, CEditor.OnMap, this.DicFactions.GetValue(listname));
          bool flag = pawnList != null;
          if (flag)
          {
            this.ListOfPawns.AddRange(pawnList);
          }
          this.UpdateRaceList();
          bool flag2 = CEditor.API.Pawn == null;
          if (flag2)
          {
            CEditor.API.Pawn = this.ListOfPawns.FirstOrFallback(null);
          }
        }

        // Token: 0x06000A1D RID: 2589 RVA: 0x00057AF8 File Offset: 0x00055CF8
        internal void ReloadList()
        {
          this.ChangeList(CEditor.ListName);
        }

        // Token: 0x06000A1E RID: 2590 RVA: 0x00057B08 File Offset: 0x00055D08
        private void UpdateRaceList()
        {
          bool nonhumanlike = CEditor.ListName == Label.COLONYANIMALS || CEditor.ListName == Label.WILDANIMALS;
          bool humanlike = CEditor.ListName == Label.HUMANOID || CEditor.ListName == Label.COLONISTS;
          this.lraces.Clear();
          this.lraces.Add(null);
          this.lraces.AddRange(PawnKindTool.ListOfRaces(humanlike, nonhumanlike));
          this.ARaceChanged(null);
        }

        // Token: 0x06000A1F RID: 2591 RVA: 0x00057B94 File Offset: 0x00055D94
        private void ARaceChanged(ThingDef race)
        {
          CEditor.RACE = race;
          bool nonhumanlike = CEditor.ListName == Label.COLONYANIMALS || CEditor.ListName == Label.WILDANIMALS;
          bool humanlike = CEditor.ListName == Label.HUMANOID || CEditor.ListName == Label.COLONISTS;
          this.ListOfPawnKinds.Clear();
          this.ListOfPawnKinds.Add(null);
          this.ListOfPawnKinds.AddRange(PawnKindTool.ListOfPawnKindDefByRace(race, humanlike, nonhumanlike));
          this.APKDChanged(null);
        }

        // Token: 0x06000A20 RID: 2592 RVA: 0x00057C26 File Offset: 0x00055E26
        private void APKDChanged(PawnKindDef pkd)
        {
          CEditor.PKD = pkd;
        }

        // Token: 0x06000A21 RID: 2593 RVA: 0x00057C30 File Offset: 0x00055E30
        private void AAllowRemovePawn()
        {
          bool flag = !CEditor.InStartingScreen && Event.current.alt;
          if (flag)
          {
            CEditor.API.EditorMoveRight();
            PlacingTool.DeletePawnFromCustomPosition();
          }
          else
          {
            this.bShowRemovePawn = !this.bShowRemovePawn;
          }
        }

        // Token: 0x06000A22 RID: 2594 RVA: 0x00057C7C File Offset: 0x00055E7C
        private void AAddStartPawn()
        {
          Faction value = this.DicFactions.GetValue(CEditor.ListName);
          PawnxTool.AddOrCreateNewPawn(CEditor.PKD.ThisOrFromList(this.ListOfPawnKinds), value, CEditor.RACE, null, default(IntVec3));
          bool flag = value.IsZombie();
          if (flag)
          {
            this.ReloadList();
          }
        }

        // Token: 0x040007A4 RID: 1956
        private Vector2 scrollPos;

        // Token: 0x040007A5 RID: 1957
        private bool bShowRemovePawn;

        // Token: 0x040007A6 RID: 1958
        private string colParam;

        // Token: 0x040007A7 RID: 1959
        private Capturer capturer;

        // Token: 0x040007A8 RID: 1960
        private List<ThingDef> lraces;
      }
    }
  }
}
